<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Home
#======================================================
*/

class ad_home {

	#=======================================
	# @ Auto Run
	# Function that is run automatically
	# when the file is required.
	#=======================================

	public function auto_run()
	{
		$this->trellis->load_functions('admin');
		$this->trellis->load_functions('tickets');
		$this->trellis->ad_load_lang('home');
		
		switch( $this->trellis->input['act'] )
		{
			case 'donotes':
				$this->ajax_save_notes();
			break;

			default:
				$this->show_home();
			break;
		}
	}

	#=======================================
	# @ Show Home
	#=======================================

	public function show_home()
	{
		#=============================
		# Security Check
		#=============================
		
		if ( file_exists( HD_PATH .'install/install.lock' ) )
		{
			$alert = '{lang.alert_install_dir_exists}';
		}
		elseif ( is_dir( HD_PATH .'install' ) )
		{
			$error = '{lang.alert_install_locked}';
		}
		
		#=============================
		# Table Columns
		#=============================

		$columns = unserialize( $this->trellis->user['columns_tm'] );

		if ( empty( $columns ) )
		{
			$columns = array( 'id' => '6%', 'subject' => '31%', 'priority' => '14%', 'department' => '19%', 'reply' => '17%', 'status' => '13%' );
		}

		$lang_columns = array(
							  'id'			=> '{lang.id}',
							  'mask'		=> '{lang.mask}',
							  'subject'		=> '{lang.subject}',
							  'priority'	=> '{lang.priority}',
							  'department'	=> '{lang.department}',
							  'date'		=> '{lang.submitted}',
							  'reply'		=> '{lang.last_reply}',
							  'replystaff'	=> '{lang.last_staff_reply}',
							  'lastuname'	=> '{lang.last_replier}',
							  'submitter'	=> '{lang.submitter}',
							  'email'		=> '{lang.email}',
							  'replies'		=> '{lang.replies}',
							  'status'		=> '{lang.status}',
							  );

		$dark_columns = array( 'subject', 'date', 'last_reply' );
		$normal_columns = array( 'dname', 'date', 'last_reply' );

		$sql_select = array();
		$sql_columns = array();
		$sql_join = array();

		#=============================
		# Default Sort / Limits
		#=============================

		if ( ! $this->trellis->input['sort'] )
		{
			if ( isset( $columns[ $this->trellis->user['sort_tm'] ] ) ) $this->trellis->input['sort'] = $this->trellis->user['sort_tm'];
		}

		$column_sort = array( 'reply', 'date', 'mask', 'replystaff', 'subject', 'priority', 'department', 'mname', 'lastuname', 'email', 'status', 'replies' );

		for ( $i = 0; ! $this->trellis->input['sort'] && $i < count( $column_sort ); $i++ )
		{
			if ( $columns[ $column_sort[ $i ] ] ) $this->trellis->input['sort'] = $column_sort[ $i ];
		}

		if ( ! $this->trellis->input['sort'] ) $this->trellis->input['sort'] = 'id';

		if ( ! $this->trellis->input['order'] )
		{
			( $this->trellis->user['order_tm'] ) ? $this->trellis->input['order'] = 'desc' : $this->trellis->input['order'] = 'asc';
		}
		
		#=============================
		# Sort
		#=============================

		foreach( $columns as $name => $width )
		{
			if ( $name == $this->trellis->input['sort'] )
			{
				if ( $this->trellis->input['order'] == 'desc' )
				{
					$link_order = 'asc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_up.gif" alt="{lang.up}" />';
					$sql_order = 'desc';
				}
				else
				{
					$link_order = 'desc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_down.gif" alt="{lang.down}" />';
					$sql_order = 'asc';
				}

				if ( $name == 'department' )
				{
					$sql_sort_table = 'd';
					$sql_sort_field = 'name';
				}
				elseif ( $name == 'priority' )
				{
					$sql_sort_table = 'p';
					$sql_sort_field = 'position';
				}
				elseif ( $name == 'reply' )
				{
					$sql_sort_table = 't';
					$sql_sort_field = 'last_reply';
				}
				elseif ( $name == 'replystaff' )
				{
					$sql_sort_table = 't';
					$sql_sort_field = 'last_reply_staff';
				}
				elseif ( $name == 'lastuname' )
				{
					$sql_sort_table = 'ulr';
					$sql_sort_field = 'name';
				}
				elseif ( $name == 'status' )
				{
					$sql_sort_table = 's';
					$sql_sort_field = 'name_staff';
				}
				elseif ( $name == 'submitter' )
				{
					$sql_sort_table = 'u';
					$sql_sort_field = 'name';
				}
				elseif ( strpos( $name, 'cfd' ) === 0 || strpos( $name, 'cfp' ) === 0 )
				{
					$sql_sort_table = $name;
					$sql_sort_field = 'data';
				}
				else
				{
					$sql_sort_table = 't';
					$sql_sort_field = $name;
				}
			}
			else
			{
				$link_order = 'asc';
				$img_order = '';
			}
			
			if ( strpos( $name, 'cfd' ) === 0 )
			{
				$lang_columns[ $name ] = $this->trellis->core->cache['dfields'][ substr( $name, 3) ]['name'];
			}
			elseif ( strpos( $name, 'cfp' ) === 0 )
			{
				$lang_columns[ $name ] = $this->trellis->core->cache['pfields'][ substr( $name, 3) ]['name'];
			}

			if ( $name == 'department' )
			{
				$sql_select['d'] = array( array( 'name' => 'dname' ) );

				$sql_join[] = array( 'from' => array( 'd' => 'departments' ), 'where' => array( 't' => 'did', '=', 'd' => 'id' ) );
			}
			elseif ( $name == 'priority' )
			{
				$sql_select['p'] = array( array( 'name' => 'pname' ), 'icon_regular', 'icon_assigned' );

				$sql_join[] = array( 'from' => array( 'p' => 'priorities' ), 'where' => array( 't' => 'priority', '=', 'p' => 'id' ) );
			}
			elseif ( $name == 'status' )
			{
				$sql_select['s'] = array( 'name_staff', 'abbr_staff' );

				$sql_join[] = array( 'from' => array( 's' => 'statuses' ), 'where' => array( 't' => 'status', '=', 's' => 'id' ) );
			}
			elseif ( $name == 'submitter' )
			{
				$sql_select['u'] = array( array( 'name' => 'uname' ) );

				$sql_join[] = array( 'from' => array( 'u' => 'users' ), 'where' => array( 't' => 'uid', '=', 'u' => 'id' ) );

				$sql_columns[] = 'uid';
			}
			elseif ( $name == 'lastuname' )
			{
				$sql_select['ulr'] = array( array( 'name' => 'last_uname' ) );

				$sql_join[] = array( 'from' => array( 'ulr' => 'users' ), 'where' => array( 't' => 'last_uid', '=', 'ulr' => 'id' ) );

				$sql_columns[] = 'last_uid';
			}
			elseif ( strpos( $name, 'cfd' ) === 0 )
			{
				$sql_select[ $name ] = array( array( 'data' => $name ) );

				$sql_join[] = array( 'from' => array( $name => 'depart_fields_data' ), 'where' => array( array( 't' => 'id', '=', $name => 'tid' ), array( $name => 'fid', '=', substr( $name, 3 ) ) ) );
			}
			elseif ( strpos( $name, 'cfp' ) === 0 )
			{
				$sql_select[ $name ] = array( array( 'data' => $name ) );

				$sql_join[] = array( 'from' => array( $name => 'profile_fields_data' ), 'where' => array( array( 't' => 'uid', '=', $name => 'uid' ), array( $name => 'fid', '=', substr( $name, 3 ) ) ) );
			}
			else
			{
				if ( $name == 'reply' )
				{
					$name = 'last_reply';
				}
				elseif ( $name == 'replystaff' )
				{
					$name = 'last_reply_staff';
				}

				$sql_columns[] = $name;
			}
		}

		#=============================
		# Filter
		#=============================
		
		$this->trellis->input['fstatus'] = unserialize( $this->trellis->user['dfilters_status'] );
		
		$this->trellis->input['fdepart'] = unserialize( $this->trellis->user['dfilters_depart'] );
		
		$this->trellis->input['fpriority'] = unserialize( $this->trellis->user['dfilters_priority'] );

		$filters = array();
		$sql_where = array();

		/*if ( $this->trellis->input['my'] )
		{
			$filters[] = array( array( 't' => 'auid' ), '=', $this->trellis->input['my'] );
		}*/

		if ( is_array( $this->trellis->input['fstatus'] ) )
		{
			$filters[] = array( array( 't' => 'status' ), 'in', $this->trellis->input['fstatus'] );
		}

		if ( is_array( $this->trellis->input['fdepart'] ) )
		{
			$filters[] = array( array( 't' => 'did' ), 'in', $this->trellis->input['fdepart'] );
		}

		if ( is_array( $this->trellis->input['fpriority'] ) )
		{
			$filters[] = array( array( 't' => 'priority' ), 'in', $this->trellis->input['fpriority'] );
		}

		#=============================
		# Permissions
		#=============================
		
		$this->trellis->user['g_acp_depart_perm'] = unserialize( $this->trellis->user['g_acp_depart_perm'] );

		if ( $this->trellis->user['id'] != 1 )
		{
			$perms = array();

			if( is_array( $this->trellis->user['g_acp_depart_perm'] ) )
			{
				foreach( $this->trellis->user['g_acp_depart_perm'] as $did => $dperm )
				{
					if ( $dperm['v'] ) $perms[] = $did;
				}
			}
			
			if ( empty( $perms ) ) $perms[] = 0;

			$filters[] = array( array( 't' => 'did' ), 'in', $perms );
		}

		#=============================
		# Grab Tickets
		#=============================

		foreach( $filters as $fdata )
		{
			if ( ! empty( $sql_where ) ) $fdata[] = 'and';

			$sql_where[] = $fdata;
		}

		$sql_columns[] = 'escalated';

		if ( ! in_array( 'id', $sql_columns ) ) $sql_columns[] = 'id';

		$sql_select['t'] = $sql_columns;

		$ticket_rows = '';

		$tickets = $this->trellis->tickets->get( array(
													   'select'	=> $sql_select,
													   'from'	=> array( 't' => 'tickets' ),
													   'join'	=> $sql_join,
													   'where'	=> $sql_where,
													   'order'	=> array( $sql_sort_field => array( $sql_sort_table => $sql_order ) ),
													   'limit'	=> array( $this->trellis->input['st'], 8 ),
												)	   );

		if ( count( $tickets ) && $this->trellis->input['field'] == 'id' )
		{
			$this->trellis->input['id'] = $tickets[0]['id'];

			$this->show_ticket();
		}

		if ( count( $tickets ) == 1 && $this->trellis->input['field'] == 'mask' )
		{
			$this->trellis->input['id'] = $tickets[0]['id'];

			$this->show_ticket();
		}

		if ( ! $tickets )
		{
			$ticket_rows .= "<tr><td class='bluecell-light' colspan='". ( count( $columns ) + 1 ) ."'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=add'>{lang.no_tickets}</a></strong></td></tr>";
		}
		else
		{
			foreach( $tickets as $t )
			{
				if ( $t['date'] ) $t['date'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'short' ) );
				if ( $t['last_reply'] ) $t['last_reply'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'short' ) );
				( $t['last_reply_staff'] ) ? $t['last_reply_staff'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply_staff'], 'format' => 'short' ) ) : $t['last_reply_staff'] = '';

				if ( $t['uname'] ) $t['uname'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['uid']}'>{$t['uname']}</a>";
				if ( $t['last_uname'] ) $t['last_uname'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['last_uid']}'>{$t['last_uname']}</a>";

				$ticket_rows .= "<tr>";

				foreach( $columns as $name => $width )
				{
					if ( $name == 'department' )
					{
						$name = 'dname';
					}
					elseif ( $name == 'priority' )
					{
						$name = 'pname';
					}
					elseif ( $name == 'reply' )
					{
						$name = 'last_reply';
					}
					elseif ( $name == 'replystaff' )
					{
						$name = 'last_reply_staff';
					}
					elseif ( $name == 'submitter' )
					{
						$name = 'uname';
					}
					elseif ( $name == 'lastuname' )
					{
						$name = 'last_uname';
					}
					elseif ( $name == 'status' )
					{
						( $t['abbr_staff'] ) ? $name = 'abbr_staff' : $name = 'name_staff';
					}

					( in_array( $name, $dark_columns ) ) ? $dark = 1 : $dark = 0;
					( in_array( $name, $normal_columns ) ) ? $normal = 1 : $normal = 0;

					$ticket_rows .= "<td class='bluecell-";

					if ( $dark )
					{
						$ticket_rows .= "dark";
					}
					else
					{
						$ticket_rows .= "light";
					}

					$ticket_rows .= "'";

					if ( $normal ) $ticket_rows .= " style='font-weight: normal'";

					$ticket_rows .= " width='". $width ."'>";

					if ( $name == 'id' || $name == 'mask' || $name == 'subject' ) $ticket_rows .= "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=view&amp;id={$t['id']}'>";

					if ( $name == 'id' ) $ticket_rows .= "<strong>";

					if ( $name == 'subject' )
					{
						if ( $t['escalated'] ) $ticket_rows .= "<img src='<! IMG_DIR !>/icon_escalate.png' alt='E' style='vertical-align:middle;margin-bottom:2px' />&nbsp;";
					}

					if ( $name == 'pname' )
					{
						if ( $t['auid'] == $this->trellis->user['id'] )
						{
							$ticket_rows .= "<img src='<! UPLD_URL !>/priorities/{$t['icon_assigned']}' alt='{$t['pname']}' class='prioritybox' />&nbsp;&nbsp;";
						}
						else
						{
							$ticket_rows .= "<img src='<! UPLD_URL !>/priorities/{$t['icon_regular']}' alt='{$t['pname']}' class='prioritybox' />&nbsp;&nbsp;";
						}
					}

					if ( strpos( $name, 'cfd' ) === 0 || strpos( $name, 'cfp' ) === 0 )
					{
						if ( strpos( $name, 'cfd' ) === 0 )
						{
							$f = $this->trellis->core->cache['dfields'][ substr( $name, 3 ) ];
						}
						elseif ( strpos( $name, 'cfp' ) === 0 )
						{
							$f = $this->trellis->core->cache['pfields'][ substr( $name, 3 ) ];
						}

						if ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
						{
							$f['extra'] = unserialize( $f['extra'] );

							$t[ $name ] = $f['extra'][ $t[ $name ] ];
						}
					}

					$ticket_rows .= $t[ $name ];

					if ( $name == 'id' ) $ticket_rows .= "</strong>";

					if ( $name == 'id' || $name == 'subject' ) $ticket_rows .= "</a>";

					$ticket_rows .= "</td>";
				}

				$ticket_rows .= "</tr>";
			}
		}

		#=============================
		# Grab Logs
		#=============================

		$this->output .= "<div class='slatebox'>{lang.ticket_history}</div>
					    	<div class='rollhistory'>
								<table width='100%' cellpadding='0' cellspacing='0'>";

		$this->trellis->core->db->construct( array(
												   'select'	=> array(
												   					 'l' => 'all',
												   					 'u' => array( array( 'name' => 'uname' ) ),
												   					 ),
												   'from'	=> array( 'l' => 'logs' ),
												   'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'l' => 'uid', '=', 'u' => 'id' ) ) ),
												   'where'	=> array( array( 'l' => 'type' ), '=', 2 ),
												   'order'	=> array( 'date' => array( 'l' => 'desc' ) ),
												   'limit'	=> array( 0, 5 ),
											)	   );

		$this->trellis->core->db->execute();
		
		$log_rows = "";

		while( $l = $this->trellis->core->db->fetch_row() )
		{
			$l['date'] = $this->trellis->td_timestamp( array( 'time' => $l['date'], 'format' => 'short' ) );
			
			if ( $l['level'] == 2 )
			{
				$fontcolor_start = "<font color='#790000'>";
				$fontcolor_end = "<font color='#790000'>";
			}
			else
			{
				$fontcolor_start = "";
				$fontcolor_end = "";
			}

			$log_rows .= "<tr>
								<td class='bluecell-light' width='45%'>{$fontcolor_start}{$l['action']}{$fontcolor_end}</td>
								<td class='bluecell-dark' width='18%' style='font-weight:normal'>{$fontcolor_start}{$l['date']}{$fontcolor_end}</td>
								<td class='bluecell-light' width='20%'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$l['uid']}'>{$fontcolor_start}{$l['uname']}{$fontcolor_end}</a></td>
								<td class='bluecell-light' width='17%' style='font-weight:normal'>{$fontcolor_start}{$l['ipadd']}{$fontcolor_end}</td>
							</tr>";
		}

		#=============================
		# Version Check
		#=============================
		
		$version_check = $this->trellis->admin->version_check();
		
		if ( $version_check == 1 )
		{
			$version_img_url = '<! IMG_DIR !>/vc_update_available.jpg';
		}
		elseif ( $version_check == 2 )
		{
			$version_img_url = '<! IMG_DIR !>/vc_up_to_date.jpg';
		}
		else
		{
			$version_img_url = '<! IMG_DIR !>/vc_unable_to_check.jpg';
		}

		#=============================
		# Sidebar Menu
		#=============================
		
		$mysql_version = mysql_get_server_info();
		
		if ( strpos( $mysql_version, '-' ) )
		{
			$mysql_version = substr( $mysql_version, 0, strpos( $mysql_version, '-' ) );
		}
		
		if ( $this->trellis->core->cache['misc']['vcheck_time'] )
		{
			$vcheck_date = $this->trellis->td_timestamp( array( 'time' => $this->trellis->core->cache['misc']['vcheck_time'], 'format' => 'date' ) );
		}
		else
		{
			$vcheck_date = '{lang.check_now}';
		}
		
		$system_status_html = "<table width='100%' border='0' cellspacing='0' cellpadding='0' class='blockstatus'>
					<tr>
						<td colspan='2' class='statusbadge'><a href='http://www.accord5.com/trellis'><img src='{$version_img_url}' alt='{lang.version_check}' /></a></td>
					</tr>
					<tr>
						<td class='statusleft'><strong>{lang.version_check}</strong></td>
						<td class='statusright'><a href='<! HD_URL !>/admin.php?section=admin&amp;vcheck=1' title='{lang.check_now}'>". $vcheck_date ."</a></td>
					</tr>
					<tr>
						<td class='statusleft'><strong>{lang.product_version}</strong></td>
						<td class='statusright'>{$this->trellis->vershort} ({$this->trellis->vernum})</td>
					</tr>
						<td class='statusleft'><strong>{lang.php_version}</strong></td>
						<td class='statusright'>". phpversion() ."</td>

					</tr>
					<tr>
						<td class='statusleft'><strong>{lang.mysql_version}</strong></td>
						<td class='statusright'>". $mysql_version ."</td>
					</tr>
				</table>";
		
		$this->trellis->skin->add_sidebar_block( '{lang.system_status}', $system_status_html );

		$notes_items = array(
							"<textarea id='notes' name='notes' cols='4' rows='8' style='width:99%' class='notesbox'>{$this->trellis->core->cache['misc']['acp_notes']}</textarea>",
							"<input name='save_notes' id='save_notes' type='submit' value='{lang.button_save_notes}' class='buttonmini' /> <span id='save_notes_status' class='ajax_update_button'>{lang.saved}</span>",
							);
		
		$this->trellis->skin->add_sidebar_list( '{lang.admin_notepad}', $notes_items );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$error = "<div class='critical'>{$error}</div>";
		}
		elseif ( $alert )
		{
			$error = "<div class='alert'>{$alert}</div>";
		}

		$acp_content = "{$error}
		<script type='text/javascript'></script>
				<div id='ticketroll'>
				<div class='orangebox'>{lang.common_acp_sections}</div>
				<div class='rolldefault'>
					<table width='100%' cellspacing='0' cellpadding='0'>
					<tr>
						<td class='orangecell-light' width='25%'><a href='<! HD_URL !>/admin.php?section=manage'><img src='<! IMG_DIR !>/icon_buoy.png' width='16' height='16' alt='{lang.tickets}' />{lang.tickets}</a></td>
						<td class='orangecell-dark' width='25%'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news'><img src='<! IMG_DIR !>/icon_balloon.png' width='16' height='16' alt='{lang.news}' />{lang.news}</a></td>
						<td class='orangecell-light' width='25%'><a href='<! HD_URL !>/admin.php?section=look'><img src='<! IMG_DIR !>/icon_color.png' width='16' height='16' alt='{lang.skins}' />{lang.skins}</a></td>
						<td class='orangecell-dark' width='25%'><a href='<! HD_URL !>/admin.php?section=tools'><img src='<! IMG_DIR !>/icon_settings.png' width='16' height='16' alt='{lang.settings}' />{lang.settings}</a></td>
					</tr>
					<tr>
						<td class='orangecell-light' width='25%'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users'><img src='<! IMG_DIR !>/icon_addressbook.png' width='16' height='16' alt='{lang.users}' />{lang.users}</a></td>
						<td class='orangecell-dark' width='25%'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=articles'><img src='<! IMG_DIR !>/icon_book.png' width='16' height='16' alt='{lang.kb_articles}' />{lang.kb_articles}</a></td>
						<td class='orangecell-light' width='25%'><a href='<! HD_URL !>/admin.php?section=look&amp;page=langs'><img src='<! IMG_DIR !>/icon_alphabet.png' width='16' height='16' alt='{lang.languages}' />{lang.languages}</a></td>
						<td class='orangecell-dark' width='25%'><a href='http://docs.accord5.com/' target='_blank'><img src='<! IMG_DIR !>/icon_question.png' width='16' height='16' alt='{lang.documentation}' />{lang.documentation}</a></td>
					</tr>
					</table>
				</div>
				<div class='groupbox'>{lang.tickets_awaiting_action}</div>
				<div class='rolldefault'>
					<table width='100%' cellpadding='0' cellspacing='0'>
					". $ticket_rows ."
					</table>
				</div>
						
				<div class='groupbox'>{lang.last_5_admin_actions}</div>
				<div class='rolldefault'>
					<table width='100%' cellpadding='0' cellspacing='0'>
					". $log_rows ."
					</table>
				</div>
				</div>
				<script type='text/javascript'>
				//<![CDATA[
				$('#save_notes').bind('click', function () {
					$.post('admin.php?section=admin&act=donotes',
						{ notes: $('#notes').val() },
						function(data) {
							if (data != 0) $('#save_notes_status').stop(true).fadeIn().animate({opacity: 1.0}, {duration: 2000}).fadeOut('slow');
						});
				});
				//]]>
				</script>";

		$this->trellis->skin->add_output( $acp_content );

		$this->trellis->skin->do_output( array( 'title' => 'System Overview' ) );
	}

	#=======================================
	# @ AJAX Save Notes
	#=======================================

	function ajax_save_notes()
	{
		$this->trellis->core->add_cache( 'misc', array( 'acp_notes' => $this->trellis->input['notes'] ) );
		
		$this->trellis->skin->ajax_output( '1' );
	}

}

?>