<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Languages
#======================================================
*/

class ad_lang {

	#=======================================
	# @ Auto Run
	# Function that is run automatically
	# when the file is required.
	#=======================================

	function auto_run()
	{
		if ( ! $this->trellis->user['acp']['look_lang'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->skin->set_section( 'Look &amp; Feel' );
		$this->trellis->skin->set_description( 'Manage the presentation of your helpdesk with skins and languages.' );

		switch( $this->trellis->input['code'] )
	    {
	    	case 'list':
				$this->list_langs();
	    	break;
	    	case 'email':
				$this->list_email();
	    	break;
	    	case 'prop':
				$this->show_prop();
	    	break;
	    	case 'show':
				$this->show_lang();
	    	break;
	    	case 'edit':
	    		$this->edit_lang();
	    	break;
	    	case 'editemail':
	    		$this->edit_email();
	    	break;
	    	case 'tools':
	    		$this->show_tools();
	    	break;
    		case 'import':
    			$this->show_import();
    		break;
    		case 'export':
    			$this->list_langs('', '', 'export');
    		break;

	    	case 'doprop':
				$this->do_prop();
	    	break;
    		case 'doadd':
    			$this->do_add();
    		break;
    		case 'doedit':
    			$this->do_edit();
    		break;
    		case 'doemail':
    			$this->do_email();
    		break;
    		case 'delete':
    			$this->do_delete();
    		break;
    		case 'doimport':
    			$this->do_import();
    		break;
    		case 'dotools':
    			$this->do_tools();
    		break;
    		case 'doexport':
    			$this->do_export();
    		break;
    		case 'default':
    			$this->do_default();
    		break;

    		default:
    			$this->list_langs();
    		break;
		}
	}

	#=======================================
	# @ List Languages
	# Show a list of available languages.
	#=======================================

	function list_langs($error='', $alert='', $instr='')
	{
		#=============================
		# Grab Languages
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$lang_rows = ""; // Initialize for Security
		$row_count = 0; // Initialize for Security

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		while( $l = $this->trellis->core->db->fetch_row() )
		{
			$row_count ++;

			( $row_count & 1 ) ? $row_class = 'option1-med' : $row_class = 'option2-med';

			if ( $l['default'] )
			{
				$l['default'] = "<span class='disabled'>Default</span>";
				$l['delete'] = "<span class='disabled'><img src='<! HD_URL !>/images/default/button_delete_disabled.gif' alt='Delete' /></span>";
			}
			else
			{
				$l['default'] = "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=default&amp;id={$l['id']}'>Make Default</a>";
				$l['delete'] = "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=delete&amp;id={$l['id']}' onclick='return sure_delete()'><img src='<! HD_URL !>/images/default/button_delete.gif' alt='Delete' /></a>";
			}

			$lang_rows .= "<tr>
								<td class='{$row_class}'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=show&amp;id={$l['id']}'>{$l['lkey']}</a></td>
								<td class='{$row_class}'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=show&amp;id={$l['id']}'>{$l['name']}</a></td>
								<td class='{$row_class}' align='center'>{$l['default']}</td>
								<td class='{$row_class}' align='center'>{$l['users']}</td>
								<td class='{$row_class}' align='center'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=doexport&amp;id={$l['id']}'><img src='<! HD_URL !>/images/default/button_export.gif' alt='Export' /></a></td>
								<td class='{$row_class}' align='center'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=show&amp;id={$l['id']}'>Language</a> | <a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=prop&amp;id={$l['id']}'>Properties</a></td>
								<td class='{$row_class}' align='center'>{$l['delete']}</td>
							</tr>";
		}

		if ( $instr == 'export' )
		{
			$add_txt = "<div class='option1'>To export a language pack, simply click the Export link next to the appropriate language pack.</div>";
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$error = "<div class='critical'>{$error}</div>";
		}
		elseif ( $alert )
		{
			$error = "<div class='alert'>{$alert}</div>";
		}

		$this->output = "<script type='text/javascript'>

							function sure_delete()
							{
								if ( confirm('Are you sure you want to delete this language pack?') )
								{
									return true;
								}
								else
								{
									return false;
								}
							}

						</script>
						{$error}
						<div class='groupbox'>Language List</div>
						{$add_txt}
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<th width='6%' align='left'>Key</th>
							<th width='22%' align='left'>Name</th>
							<th width='15%'>Default</th>
							<th width='11%'>Users</th>
							<th width='11%'>Export</th>
							<th width='24%'>Edit</th>
							<th width='11%'>Delete</th>
						</tr>
						". $lang_rows ."
						</table>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   "List Languages",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ List Email
	#=======================================

	function list_email($error='', $alert='')
	{
		#=============================
		# Grab Languages
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'lkey', 'name' ),
											  	 'from'		=> 'languages',
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$lang_rows = ""; // Initialize for Security
		$row_count = 0; // Initialize for Security

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		while( $l = $this->trellis->core->db->fetch_row() )
		{
			$row_count ++;

			( $row_count & 1 ) ? $row_class = 'option1-med' : $row_class = 'option2-med';

			$lang_rows .= "<tr>
								<td class='{$row_class}'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=editemail&amp;id={$l['id']}'>{$l['lkey']}</a></td>
								<td class='{$row_class}'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=editemail&amp;id={$l['id']}'>{$l['name']}</a></td>
								<td class='{$row_class}' align='center'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=editemail&amp;id={$l['id']}'><img src='<! HD_URL !>/images/default/button_edit.gif' alt='Edit' /></a></td>
							</tr>";
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$error = "<div class='critical'>{$error}</div>";
		}
		elseif ( $alert )
		{
			$error = "<div class='alert'>{$alert}</div>";
		}

		$this->output = "{$error}
						<div class='groupbox'>Language List</div>
						<div class='option1'>To edit email templates, please select a language below.</div>
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<th width='6%' align='left'>Key</th>
							<th width='70%' align='left'>Name</th>
							<th width='24%'>Edit</th>
						</tr>
						". $lang_rows ."
						</table>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   "Email Templates",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Email Templates' ) );
	}

	#=======================================
	# @ Show Prop
	# Show edit properties form.
	#=======================================

	function show_prop($error="")
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'lkey', 'name' ),
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		#=============================
		# Output
		#=============================

		if ( $error )
		{
			$lkey = $this->trellis->input['lkey'];
			$name = $this->trellis->input['name'];

			$error = "<div class='critical'>{$error}</div>";
		}
		else
		{
			$lkey = $l['lkey'];
			$name = $l['name'];
		}

		$this->output = "{$error}
						<div class='groupbox'>Edit Properties</div>
						<form action='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=doprop&amp;id={$l['id']}' method='post'>
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<td class='option1' width='20%'><label for='name'>Name</label></td>
							<td class='option1' width='80%'><input type='text' name='name' id='name' value='{$name}' size='35' /></td>
						</tr>
						<tr>
							<td class='option2'><label for='lkey'>Key</label></td>
							<td class='option2'><input type='text' name='lkey' id='lkey' value='{$lkey}' size='5' /></td>
						</tr>
						</table>
						<div class='formtail'><input type='submit' name='submit' id='edit' value='Edit Properties' class='button' /></div>
						</form>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=skin'>Languages</a>",
						   "Edit Properties",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ Do Prop
	# Update properties.
	#=======================================

	function do_prop()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		if ( ! $this->trellis->input['name'] )
		{
			$this->show_prop('Please enter a name.');
		}

		if ( ! $this->trellis->input['lkey'] )
		{
			$this->show_prop('Please enter a key.');
		}

		if ( ! $this->key_check( $this->trellis->input['lkey'] ) )
		{
			$this->show_prop('Your key must be alphanumeric, lowercase, and contain no spaces.');
		}

		if ( strlen( $this->trellis->input['lkey'] ) > 3 )
		{
			$this->show_prop('Your key must be no more than 3 characters long.');
		}


		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id' ),
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( array( 'lkey|lower', '=', $this->trellis->input['lkey'] ), array( 'id', '!=', $this->trellis->input['id'], 'and' ) ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			$this->show_prop('That key is already in use.  Please choose another.');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'lkey', 'name' ),
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_skin');
		}

		$l = $this->trellis->core->db->fetch_row();

		#=============================
		# Rename Folder
		#=============================

		if ( $this->trellis->input['lkey'] != $l['lkey'] )
		{
			if ( ! @ rename( HD_PATH .'language/'. $l['lkey'], HD_PATH .'language/'. $this->trellis->input['lkey'] ) )
			{
				$this->show_prop('folder_rename');
			}
		}

		#=============================
		# Update Properties
		#=============================

		$db_array = array(
						  'lkey'			=> $this->trellis->input['lkey'],
						  'name'			=> $this->trellis->input['name'],
						  );

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'languages',
											  	 'set'		=> $db_array,
							 				  	 'where'	=> array( 'id', '=', $l['id'] ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->rebuild_lang_cache();

		$this->trellis->log( 'admin', "Language Properites Updated &#039;". $l['name'] ."&#039;" );

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang', 'prop_lang_success' );
		$this->list_langs( '', 'The language has been successfully updated.' );
	}

	#=======================================
	# @ Show Tools
	# Show a list of available tools.
	#=======================================

	function show_tools()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_tools'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$lang_drop = $this->trellis->build_lang_drop();

		$this->output = "<div class='groupbox'>Language Tools</div>
						<form action='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=dotools' method='post'>
						<div class='option1'>Switch ALL users to language: <select name='all_lang' id='all_lang'>{$lang_drop}</select> <input type='submit' name='all_users' id='all_users' value='Switch' /></div>
						<div class='option2'>Users using language <select name='first_lang' id='first_lang'>{$lang_drop}</select> switch to <select name='sec_lang' id='sec_lang'>{$lang_drop}</select> <input type='submit' name='some_users' id='some_users' value='Switch' /></div>
						</form>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   "Language Tools",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ Do Tools
	# Perform specified action.
	#=======================================

	function do_tools()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_tools'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		if ( $this->trellis->input['all_users'] )
		{
			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'users',
												  	 'set'		=> array( 'lang' => $this->trellis->input['all_lang'] ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();
		}
		elseif ( $this->trellis->input['some_users'] )
		{
			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'users',
												  	 'set'		=> array( 'lang' => $this->trellis->input['sec_lang'] ),
												  	 'where'	=> array( 'lang', '=', $this->trellis->input['first_lang'] ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();
		}

		$this->trellis->log( 'admin', "Language Tools Ran" );

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang&code=tools', 'switch_lang_success' );
		$this->list_langs( '', 'The users\' languages have been successfully updated.');
	}

	#=======================================
	# @ Show Language
	# Show a list editable language files.
	#=======================================

	function show_lang($error="")
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		#=============================
		# Grab Files
		#=============================

		$row_count = 0; // Initialize for Security

		$handle = opendir( HD_PATH. "language/". $l['lkey'] ."/" );

		while( $file = readdir( $handle ) )
		{
			if ( $file != '.' && $file != '..' && $file != 'index.html' && $file != 'lang_email_content.php' )
			{
				$lang_files[] = $file;
			}
		}

		sort( $lang_files );

		while ( list( , $file ) = each( $lang_files ) )
		{
			$row_count ++;

			( $row_count & 1 ) ? $row_class = 'option1-med' : $row_class = 'option2-med';

			$short_file = str_replace( '.php', "", $file );

			if ( $human_names[ $file ] )
			{
				$file_name = $human_names[ $file ];
			}
			else
			{
				$file_name = $file;
			}

			$lang_rows .= "<tr>
								<td class='{$row_class}'><a href='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=edit&amp;lkey={$l['lkey']}&amp;file={$short_file}'>{$file_name}</a></td>
							</tr>";
		}

		$this->output = "<div class='groupbox'>Language Files List</div>
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<th align='left'>File Name (Click to Edit)</th>
						</tr>
						". $lang_rows ."
						</table>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   $l['name'],
						   "List Languages",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ Edit Language
	# Show edit language form.
	#=======================================

	function edit_lang($error="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'lkey', '=', $this->trellis->input['lkey'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		if ( ! is_file( HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php" ) )
		{
			$this->trellis->skin->error('no_lang');
		}

		require HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php";

		#=============================
		# Do Output
		#=============================

		$row_count = 0; // Initialize for Security

		while ( list( $key, $replacement ) = each( $lang ) )
		{
			$replacement = $this->trellis->html_safe( stripslashes( $replacement ) );

			$r_field = "<textarea name='l_{$key}' cols='55' rows='4' style='width: 98%; height: 40px;'>{$replacement}</textarea>";

			$row_count ++;

			( $row_count & 1 ) ? $row_class = 'option1-med' : $row_class = 'option2-med';

			$lang_rows .= "<tr>
								<td class='{$row_class}'>{$key}</td>
								<td class='{$row_class}'>{$r_field}</td>
							</tr>";
		}

		unset( $lang );

		$this->output = "<div class='groupbox'>Edit Language</div>
						<form action='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=doedit&amp;lkey={$l['lkey']}&amp;file={$this->trellis->input['file']}' method='post'>
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<th width='25%' align='left'>Key</th>
							<th width='75%' align='left'>Replacement</th>
						</tr>
						". $lang_rows ."
						</table>
						<div class='formtail'><input type='submit' name='submit' id='edit' value='Edit Language File' class='button' /></div>
						</form>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   $l['name'],
						   "Edit Language",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ Edit Email
	#=======================================

	function edit_email($error="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		if ( ! is_file( HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php" ) )
		{
			$this->trellis->skin->error('no_lang');
		}

		require HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php";

		#=============================
		# Do Output
		#=============================
		
		$descriptions = array(
							  'header'						=> array( 'Header', 'This goes at the beginning of every email.' ),
							  'footer'						=> array( 'Footer', 'This goes at the end of every email.' ),
							  'new_user_val_email'			=> array( 'Email Validation (New Account)', 'Activate account email (includes activation / validation link) sent when <b>only email validation</b> is required for account activation.' ),
							  'new_user_val_admin'			=> array( 'Admin Approval Required (New Account)', 'Email sent when <b>only admin validation</b> is required for account activation.' ),
							  'new_user_val_both'			=> array( 'Activate Account (Both)', 'Activate account email (includes activation / validation link) sent when <b>both email and admin validation</b> are required for account activation.' ),
							  'acc_almost_accivated'		=> array( 'Account Awaiting Admin Approval', 'Email sent when user has validated their email address (new account), but admin validation is still required for account activation.' ),
							  'acc_almost_approved'			=> array( 'Account Awaiting Email Validation', 'Email sent when an admin has approved user (new account), but that user must still verify their email before their account is activated.' ),
							  'new_user_admin_val'			=> array( 'Admin Account Awaiting Approval Notification', 'Email sent to admin when there is a new account awaiting admin validation / approval.' ),
							  'acc_accivated'				=> array( 'Account Activated Notification', 'Email sent to new account when it has been activated (usually after successfull email validation).' ),
							  'acc_approved'				=> array( 'Account Approved Notification', 'Email sent to new account when it has been approved (and activated) by an administrator.' ),
							  'change_email_val'			=> array( 'Email Change Validation', 'Email sent to new email address when a user has requested that their email address be changed.' ),
							  'reset_pass_val'				=> array( 'Password Reset', 'Email sent to user when they have requested to reset their forgotten password.' ),
							  'new_ticket'					=> array( 'New Ticket Notification', 'Email sent to user when they have created a new ticket.' ),
							  'staff_new_ticket'			=> array( 'Staff New Ticket Notification', 'Email sent to staff when a new ticket has been created in their department.' ),
							  'new_guest_ticket'			=> array( 'New Guest Ticket Notification', 'Email sent to guest when they have created a new guest ticket.' ),
							  'staff_new_guest_ticket'		=> array( 'Staff New Guest Ticket Notification', 'Email sent to staff when a new guest ticket has been created in their department.' ),
							  'ticket_escl'					=> array( 'Ticket Escalated Notification', 'Email sent to user when their ticket has been escalated.' ),
							  'ticket_close'				=> array( 'Ticket Closed Notification', 'Email sent to user when their ticket has been closed.' ),
							  'ticket_move'					=> array( 'Ticket Moved Notification', 'Email sent to user when their ticket has been moved to another department.' ),
							  'ticket_reply'				=> array( 'Ticket Reply Notification', 'Email sent to user when their ticket has recieved a staff reply.' ),
							  'staff_reply_ticket'			=> array( 'Staff Ticket Reply Notification', 'Email sent to staff when a user has replied to a ticket in their department.' ),
							  'announcement'				=> array( 'Announcement', 'Email sent out to users when a new news item has been created.' ),
							  'ticket_pipe_rejected'		=> array( 'Ticket / Email Rejected (Pipe)', 'Email sent out to user when their ticket / email has not been accepted because they do not have permission to create tickets.' ),
							  );

		$row_count = 0;
		$key_count = -1;
		$color_count = 0;
		$info_count = 0;

		while ( list( $key, $replacement ) = each( $lang ) )
		{
			$replacement = $this->trellis->html_safe( stripslashes( $replacement ) );
			
			$raw_key = str_replace( '_sub', "", $key );
			$raw_key = str_replace( '_html', "", $raw_key );

			if ( substr( $key, -4, 4) == '_sub' )
			{
				$r_field = "<input name='l_{$key}' size='40' value='{$replacement}' /> (Email Subject)";
			}
			else
			{
				$r_field = "<textarea name='l_{$key}' cols='55' rows='4' style='width: 98%; height: 150px;'>\n{$replacement}</textarea>";
			}

			$row_count ++;
			
			if ( $raw_key == 'header' )
			{
				$row_class = 'option1-med';
			}
			elseif ( $raw_key == 'footer' )
			{
				$row_class = 'option2-med';
			}
			else
			{
				if ( $key_count < 2 )
				{
					$key_count ++;
				}
				else
				{
					$color_count ++;
				
					$key_count = 0;
				}

				( $color_count & 1 ) ? $row_class = 'option2-med' : $row_class = 'option1-med';
			}
			
			if ( substr( $key, -5, 5 ) == '_html' )
			{
				$html_info = '<br /><br /><b>(HTML Version)</b>';
			}
			else
			{
				$html_info = '';
			}

			$lang_rows .= "<tr>
								<td class='{$row_class}'>{$key}{$html_info}</td>
								<td class='{$row_class}'>{$r_field}</td>
							</tr>";
			if ( $descriptions[ $raw_key ] && substr( $key, -5, 5 ) == '_html' )
			{
				$info_count ++;
				
				$lang_rows .= "<tr>
							<td colspan='2'>									
								<div class='infopop'>
									<a onclick=\"javascript:Effect.toggle('info{$info_count}','blind',{duration: 0.5});\" class='fake_link'><img src='images/default/toggle.gif' alt='+' /> Toggle information</a>
									<div id='info{$info_count}' style='display: none;'>
									<div>
										<b>". $descriptions[ $raw_key ][0] ."</b> - ". $descriptions[ $raw_key ][1] ."
									</div>
									</div>
								</div>
							</td>
							</tr>";
			}
		}

		unset( $lang );

		$this->output = "<div class='groupbox'>Edit Email Templates</div>
						<form action='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=doemail&amp;id={$l['id']}' method='post'>
						<table width='100%' cellpadding='0' cellspacing='0'>
						<tr>
							<th width='25%' align='left'>Key</th>
							<th width='75%' align='left'>Replacement</th>
						</tr>
						". $lang_rows ."
						</table>
						<div class='formtail'><input type='submit' name='submit' id='edit' value='Edit Email Templates' class='button' /></div>
						</form>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   $l['name'],
						   "Edit Email Templates",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Edit Email Templates' ) );
	}

	#=======================================
	# @ Do Edit
	# Edit a language.
	#=======================================

	function do_edit()
	{
		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'lkey', '=', $this->trellis->input['lkey'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		if ( ! is_file( HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php" ) )
		{
			$this->trellis->skin->error('no_lang');
		}

		require HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php";

		$file = $this->trellis->input['file'] .".php";

		#=============================
		# Generate File
		#=============================

		if ( $file == 'lang_email_content.php' )
		{
			$data = "<?php\n\n/*\n#======================================================\n";
			$data .= "|    | Trellis Desk Language File\n";
			$data .= "|    | ". $file ."\n";
			$data .= "#======================================================\n*/\n\n";

			while ( list( $key, ) = each( $lang ) )
			{
				if ( substr( $key, -4, 4) == '_sub' )
				{
					$data .= "\$lang['". $key ."'] = \"". str_replace( "'", "\'", $this->trellis->convert_html( $this->trellis->input[ 'l_'. $key ], 0, 0 ) ) ."\";\n\n";
				}
				else
				{
					$data .= "\$lang['". $key ."'] = <<<EOF\n". $this->trellis->convert_html( $this->trellis->input[ 'l_'. $key ], 0, 0 ) ."\nEOF;\n\n";
				}
			}

			$data .= "?>";
		}
		else
		{
			$data = "<?php\n\n/*\n#======================================================\n";
			$data .= "|    | Trellis Desk Language File\n";
			$data .= "|    | ". $file ."\n";
			$data .= "#======================================================\n*/\n\n";
			$data .= "\$lang = array(\n\n";

			while ( list( $key, ) = each( $lang ) )
			{
				$data .= "'{$key}' => '". str_replace( "'", "\'", $this->trellis->convert_html( $this->trellis->input[ 'l_'. $key ], 0, 0 ) ) ."',\n";
			}

			$data .= "\n);\n\n?>";
		}

		unset( $lang );

		#=============================
		# Save File
		#=============================

		if ( ! is_writable( ! HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php" ) )
		{
			$this->trellis->skin->error('not_writable');
		}

		if ( ! $handle = fopen( HD_PATH. "language/". $l['lkey'] ."/". $this->trellis->input['file'] .".php", 'wb' ) )
		{
			$this->trellis->skin->error('no_open_file');
		}

		if ( fwrite( $handle, $data ) === false )
		{
			$this->trellis->skin->error('not_writable');
		}

		@fclose( $handle );

		$this->trellis->log( 'admin', "Language File &#039;". $this->trellis->input['file'] ."&#039; Edited", 1, $l['id'] );

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang&code=show&id='. $l['id'], 'edit_lang_success' );
		$this->list_langs( '', 'The language file has been successfully updated.' );
	}

	#=======================================
	# @ Do Email
	#=======================================

	function do_email()
	{
		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		if ( ! is_file( HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php" ) )
		{
			$this->trellis->skin->error('no_lang');
		}

		require HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php";

		#=============================
		# Generate File
		#=============================

		
		$data = "<?php\n\n/*\n#======================================================\n";
		$data .= "|    | Trellis Desk Language File\n";
		$data .= "|    | lang_email_content.php\n";
		$data .= "#======================================================\n*/\n\n";

		while ( list( $key, ) = each( $lang ) )
		{
			if ( substr( $key, -4, 4) == '_sub' )
			{
				$data .= "\$lang['". $key ."'] = \"". str_replace( "'", "\'", $this->trellis->convert_html( $this->trellis->input[ 'l_'. $key ], 0, 0 ) ) ."\";\n\n";
			}
			else
			{
				$data .= "\$lang['". $key ."'] = <<<EOF\n". $this->trellis->convert_html( $this->trellis->sanitize_data( $_POST[ 'l_'. $key ], 0, 1 ), 0, 0 ) ."\nEOF;\n\n";
			}
		}

		$data .= "?>";

		unset( $lang );

		#=============================
		# Save File
		#=============================

		if ( ! is_writable( ! HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php" ) )
		{
			$this->trellis->skin->error('not_writable');
		}

		if ( ! $handle = fopen( HD_PATH. "language/". $l['lkey'] ."/lang_email_content.php", 'wb' ) )
		{
			$this->trellis->skin->error('no_open_file');
		}

		if ( fwrite( $handle, $data ) === false )
		{
			$this->trellis->skin->error('not_writable');
		}

		@fclose( $handle );

		$this->trellis->log( 'admin', "Email Templates &#039;". $l['lkey'] ."&#039; Edited", 1, $l['id'] );

		#=============================
		# Redirect
		#=============================

		$this->list_email( '', 'The email templates have been successfully updated.' );
	}

	#=======================================
	# @ Show Import
	# Display import language file page.
	#=======================================

	function show_import()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_import'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		#=============================
		# Do Output
		#=============================

		$this->output = "<script type='text/javascript'>

							function validate_form(form)
							{
								if ( ! form.lang_file.value )
								{
									alert('Please select a file to upload.');
									form.lang_file.focus();
									return false;
								}
							}

						</script>
						<div class='groupbox'>Import a Language</div>
						<div class='subbox'>Please select a valid Trellis Desk XML Language File to import.</div>
						<form enctype='multipart/form-data' action='<! HD_URL !>/admin.php?section=look&amp;act=lang&amp;code=doimport' method='post' onsubmit='return validate_form(this)'>
						<div class='option1'><input type='file' name='lang_file' id='lang_file' size='40' /></div>
						<div class='formtail'><input type='submit' name='upload' id='upload' value='Import' class='button' /></div>
						</form>";

		$this->trellis->skin->add_output( $this->output );

		$this->nav = array(
						   "<a href='<! HD_URL !>/admin.php?section=look'>Look &amp; Feel</a>",
						   "<a href='<! HD_URL !>/admin.php?section=look&amp;act=lang'>Languages</a>",
						   "Import Language",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Manage Languages' ) );
	}

	#=======================================
	# @ Do Import
	# Uploads the specified XML file and
	# attempts to parse it, then finally
	# create the new language pack.
	#=======================================

	function do_import()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['acp']['look_lang_import'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		#=============================
		# Upload File
		#=============================

		if ( ! $_FILES['lang_file']['size'] )
		{
			$this->trellis->skin->error('no_upload_size');
		}

		if ( $_FILES['lang_file']['type'] != 'text/xml' )
		{
			$this->trellis->skin->error('no_upload_lang_xml');
		}

		$data = $this->trellis->parseFile( $_FILES['lang_file']['tmp_name'] );

		#=============================
		# Format
		#=============================

		while ( list( , $info ) = each( $data ) )
		{
			while ( list( $key, $value ) = each( $info ) )
			{
				if ( $key == 'lang_file' )
				{
					$temp_file = $value;
				}
				elseif ( $key == 'lang_key' )
				{
					$temp_key = $value;
				}
				elseif ( $key == 'lang_replace' )
				{
					$temp_replace = $value;
				}

				if ( $temp_file && $temp_key && $temp_replace )
				{
					$new_data[ $temp_file ][ $temp_key ] = $temp_replace;

					$temp_file = "";
					$temp_key = "";
					$temp_replace = "";
				}
			}
		}

		#=============================
		# Create Files
		#=============================

		$i = "";

		while ( is_dir( HD_PATH. "language/". $this->trellis->xml_lang_abbr . $i ) )
		{
			if ( ! $i ) $this->trellis->xml_lang_abbr = substr( $this->trellis->xml_lang_abbr, 0, 2 );

			$i++;
		}

		if ( ! @mkdir( HD_PATH. "language/". $this->trellis->xml_lang_abbr . $i, 0777 ) )
		{
			$this->trellis->skin->error('no_create_lang');
		}

		while ( list( $file, $sog ) = each( $new_data ) )
		{
			if ( $file == 'lang_email_content.php' )
			{
				$file_data = "<?php\n\n/*\n#======================================================\n";
				$file_data .= "|    | Trellis Desk Language File\n";
				$file_data .= "|    | ". $file ."\n";
				$file_data .= "#======================================================\n*/\n\n";

				while ( list( $aka, $ohnine ) = each( $sog ) )
				{
					if ( substr( $aka, -4, 4) == '_sub' )
					{
						$file_data .= "\$lang['". $aka ."'] = \"". $ohnine ."\";\n\n";
					}
					else
					{
						$file_data .= "\$lang['". $aka ."'] = <<<EOF\n". $ohnine ."\nEOF;\n\n";
					}
				}

				$file_data .= "?>";
			}
			else
			{
				$file_data = "<?php\n\n/*\n#======================================================\n";
				$file_data .= "|    | Trellis Desk Language File\n";
				$file_data .= "|    | ". $file ."\n";
				$file_data .= "#======================================================\n*/\n\n";
				$file_data .= "\$lang = array(\n\n";

				while ( list( $aka, $ohnine ) = each( $sog ) )
				{
					$file_data .= "'". $aka ."' => '". addslashes( $ohnine ) ."',\n";
				}

				$file_data .= "\n);\n\n?>";
			}

			if ( ! $handle = @fopen( HD_PATH. "language/". $this->trellis->xml_lang_abbr . $i ."/". $file, 'w' ) )
			{
				$this->trellis->skin->error('no_create_lang');
			}

			if ( @fwrite( $handle, $file_data ) === false )
			{
				$this->trellis->skin->error('no_create_lang');
			}

			@fclose($handle);
		}

		$db_array = array(
						  'lkey'		=> $this->trellis->xml_lang_abbr . $i,
						  'name'		=> $this->trellis->xml_lang_name,
						 );

		$this->trellis->core->db->construct( array(
											  	 'insert'	=> 'languages',
											  	 'set'		=> $db_array,
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->log( 'admin', "Language Pack &#039;". $this->trellis->xml_lang_name ."&#039; Imported" );

		$this->trellis->rebuild_lang_cache();

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang', 'import_lang_success' );
		$this->list_langs( '', 'The language has been successfully imported.' );
	}

	#=======================================
	# @ Do Default
	# Sets the specified language pack as
	# default.
	#=======================================

	function do_default()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$s = $this->trellis->core->db->fetch_row();

		#=============================
		# Revert Old Default
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id' ),
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'default', '=', 1 ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$l = $this->trellis->core->db->fetch_row();

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'languages',
											  	 'set'		=> array( 'default' => 0 ),
							 				  	 'where'	=> array( 'id', '=', $l['id'] ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		#=============================
		# Set New Default
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'languages',
											  	 'set'		=> array( 'default' => 1 ),
							 				  	 'where'	=> array( 'id', '=', $s['id'] ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->rebuild_lang_cache();

		$this->trellis->log( 'admin', "Language Pack &#039;". $s['name'] ."&#039; Set as Default" );

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang', 'default_lang_success' );
		$this->list_langs( '', 'The language has been successfully set as default.' );
	}

	#=======================================
	# @ Do Export
	# Exports a specified language pack and
	# generates an XML file.
	#=======================================

	function do_export()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_export'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		#=============================
		# Grab Files
		#=============================

		$file_data = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<language_pack abbr=\"". chunk_split( base64_encode( $l['lkey'] ) ) ."\" name=\"". chunk_split( base64_encode( $l['name'] ) ) ."\">\n";

		$handle = opendir( HD_PATH. "language/". $l['lkey'] ."/" );

		while( $file = readdir( $handle ) )
		{
			if ( $file != '.' && $file != '..' && $file != 'index.html' )
			{
				$lang_files[] = $file;
			}
		}

		sort( $lang_files );

		#=============================
		# Generate XML
		#=============================

		while ( list( , $file ) = each( $lang_files ) )
		{
			$file_data .= "\t<lang_file name=\"". chunk_split( base64_encode( $file ) ) ."\">\n";

			require HD_PATH. "language/". $l['lkey'] ."/". $file;

			while ( list( $key, $replace ) = each( $lang ) )
			{
				$file_data .= "\t\t<lang_bit>\n";

				$file_data .= "\t\t\t<lang_key>". chunk_split( base64_encode( $key ) ) ."</lang_key>\n";
				$file_data .= "\t\t\t<lang_replace>". chunk_split( base64_encode( $replace ) ) ."</lang_replace>\n";

				$file_data .= "\t\t</lang_bit>\n";
			}

			$file_data .= "\t</lang_file>\n";
		}

		$this->trellis->log( 'admin', "Language Pack &#039;". $l['name'] ."&#039; Exported" );

		$file_data .= "</language_pack>";

		header('Content-type: text/xml');

		header('Content-Disposition: attachment; filename="lang_'. $l['lkey'] .'_td.xml"');

		print $file_data;
	}

	#=======================================
	# @ Do Delete
	# Delete the language pack. :'( WHY?!?!
	#=======================================

	function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( ! $this->trellis->user['acp']['look_lang_manage'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0,1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_lang');
		}

		$l = $this->trellis->core->db->fetch_row();

		if ( $l['default'] )
		{
			$this->trellis->skin->error('no_delete_default_lang');
		}

		#=============================
		# Grab Files & Delete
		#=============================

		$handle = opendir( HD_PATH. "language/". $l['lkey'] ."/" );

		while( $file = readdir( $handle ) )
		{
			if ( $file != '.' && $file != '..' )
			{
				unlink( HD_PATH. "language/". $l['lkey'] ."/". $file );
			}
		}

		rmdir( HD_PATH. "language/". $l['lkey'] );

		#=============================
		# Delete
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'delete'	=> 'languages',
							 				  	 'where'	=> array( 'id', '=', $l['id'] ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->log( 'admin', "Language Pack &#039;". $l['name'] ."&#039; Deleted", 2, $l['id'] );

		$this->trellis->rebuild_lang_cache();

		#=============================
		# Redirect
		#=============================

		#$this->trellis->skin->redirect( '?section=look&act=lang', 'delete_lang_success' );
		$this->list_langs( 'The language has been successfully deleted.' );
	}

	#=======================================
	# @ Key Check
	# Checks to see if profile key is valid.
	#=======================================

	function key_check($key)
	{
		if ( preg_match( '/^[a-z0-9]*$/', $key ) )
		{
			return TRUE;
		}

		return FALSE;
	}

}

?>