<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Source: Groups
#======================================================
*/

class ad_groups {

	private $output = "";
	private $protected_groups = array( 1, 2, 3, 4, 5 );

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		$this->trellis->check_perm( 'manage', 'groups' );

		$this->trellis->load_functions('groups');
		$this->trellis->ad_load_lang('groups');

		$this->trellis->skin->set_active_link( 2 );

		switch( $this->trellis->input['act'] )
	    {
	    	case 'list':
				$this->list_groups();
	    	break;
	    	case 'acpperm':
				$this->list_groups( '', '', 'acpperm' );
	    	break;
	    	case 'add':
	    		$this->add_group();
	    	break;
	    	case 'edit':
	    		$this->edit_group();
	    	break;
	    	case 'delete':
	    		$this->delete_group();
	    	break;

    		case 'doadd':
    			$this->do_add();
    		break;
    		case 'doedit':
    			$this->do_edit();
    		break;
    		case 'dodel':
    			$this->do_delete();
    		break;

    		default:
    			$this->list_groups();
    		break;
		}
	}

	#=======================================
	# @ List Groups
	#=======================================

	private function list_groups($error='', $alert='')
	{
		#=============================
		# Grab Groups
		#=============================

		$group_table_rows = '';

		$groups = $this->trellis->groups->get( array( 'select' => array( 'g_id', 'g_name', 'g_users' ), 'order' => array( 'g_id' => 'asc' ) ) );

		foreach( $groups as $gid => $g )
		{
			( in_array( $gid, $this->protected_groups ) ) ? $delete_button = "" : $delete_button = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=delete&amp;id={$g['g_id']}'><img src='<! IMG_DIR !>/button_delete.gif' alt='{lang.delete}' /></a>";

			$group_table_rows .= "<tr>
								<td class='bluecellthin-light'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=user&amp;act=list&amp;group={$g['g_id']}'><strong>{$g['g_id']}</strong></a></td>
								<td class='bluecellthin-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=user&amp;act=list&amp;group={$g['g_id']}'>{$g['g_name']}</a></td>
								<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=user&amp;act=list&amp;group={$g['g_id']}'><strong>{$g['g_users']}</strong></a></td>
								<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=edit&amp;id={$g['g_id']}'><img src='<! IMG_DIR !>/button_edit.gif' alt='{lang.edit}' /></a></td>
								<td class='bluecellthin-light' align='center'>{$delete_button}</td>
							</tr>";
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
		}
		elseif ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.group_list}' ) ."
						<tr>
							<th class='bluecellthin-th' width='2%' align='left'>{lang.id}</th>
							<th class='bluecellthin-th' width='72%' align='left'>{lang.name}</th>
							<th class='bluecellthin-th' width='20%' align='center'>{lang.users}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.edit}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.delete}</th>
						</tr>
						". $group_table_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=add' ),
							array( 'compile', '{lang.menu_cache}', '<! HD_URL !>/admin.php?section=tools&amp;page=cache&amp;act=rebuild&amp;id=groups' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_group_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_groups_title}', '{lang.help_about_groups_msg}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add Group Form
	#=======================================

	private function add_group($error='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'add' );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;

			#=============================
			# Permissions
			#=============================

			if ( $this->trellis->user['id'] == 1 )
			{
				if ( is_array( $this->trellis->input['acp_perm'] ) )
				{
					while ( list( , $perm ) = each( $this->trellis->input['acp_perm'] ) )
					{
						$g_acp_perm[ $perm ] = 1;
					}
				}
			}
		}

		$depart_perms_html = "<table width='100%' cellpadding='0' cellspacing='0'>";
		$depart_count = 0;
		$depart_total = count( $this->trellis->core->cache['departs'] );

		foreach( $this->trellis->core->cache['departs'] as $did => $d )
		{
			$depart_count ++;

			if ( $depart_count > 2 ) $padding = " style='padding-top:5px'";

			if ( $depart_count & 1 )
			{
				if ( $depart_count == $depart_total )
				{
					$depart_perms_html .= "<tr><td colspan='2'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'] ) ."</td></tr>";
				}
				else
				{
					$depart_perms_html .= "<tr><td width='35%'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'] ) ."</td>";
				}
			}
			else
			{
				$depart_perms_html .= "<td width='65%'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'] ) ."</td></tr>";
			}
		}

		$depart_perms_html .= "</table>";

		$this->output .= "<script type='text/javascript'>

						function ckCol(type)
						{
							$('input:checkbox').each( function() {
								if ( this.name.search('^adp_' + type + '_') != -1 ) this.checked = 1
							} );
						}

						function unckCol(type)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_' + type + '_') != -1 ) this.checked = 0
							} );
						}

						function ckRow(did)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_[a-z]+_' + did + '$') != -1 ) this.checked = 1
							} );
						}

						function unckRow(did)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_[a-z]+_' + did + '$') != -1 ) this.checked = 0
							} );
						}

						</script>
						<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=doadd", 'add_group', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.adding_group}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.name}', 			$this->trellis->skin->textfield( 'g_name' ),							'a', '30%', '70%' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.ticket_center}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.ticket_center_access}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_access' ),			'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.create_new_tickets}', 	$this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_create', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['new_tickets'], 'for' => 1, 'msg' => '{lang.warn_ticket_create}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.can_escalate_tickets}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_escalate', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['escalate'], 'for' => 1, 'msg' => '{lang.warn_ticket_escalate}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_tickets}', 		$this->trellis->skin->yes_no_radio( 'g_ticket_edit' ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.close_own_tickets}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_close' ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.reopen_own_tickets}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_reopen' ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_replies}', 		$this->trellis->skin->yes_no_radio( 'g_reply_edit' ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_replies}', 	$this->trellis->skin->yes_no_radio( 'g_reply_delete' ),			'a' );

		if ( $g['g_id'] != 2 ) $this->output .= $this->trellis->skin->group_table_row( '{lang.rate_staff_replies}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_reply_rate', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['rating'], 'for' => 1, 'msg' => '{lang.warn_ticket_rating}' ) ) ), 'a' );

		$this->output .= $this->trellis->skin->group_table_row( '{lang.allow_attachments}', 		$this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_attach', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['attachments'], 'for' => 1, 'msg' => '{lang.warn_attachments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.max_upload_size} '. $this->trellis->skin->help_tip('{lang.tip_max_upload_size}'), $this->trellis->skin->textfield( 'g_upload_size_max', '', '', 0, 6 ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.department_permissions} '. $this->trellis->skin->help_tip('{lang.tip_depart_perms}'), $depart_perms_html, 		'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.knowledge_base}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.knowledge_base_access}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_access', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['enable'], 'for' => 1, 'msg' => '{lang.warn_kb_access}' ) ) ), 'a' );

		if ( $g['g_id'] != 2 )
		{
			$this->output .= $this->trellis->skin->group_table_row( '{lang.comment_on_articles}',			$this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_comment', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['comments'], 'for' => 1, 'msg' => '{lang.warn_kb_comments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_edit' ),					'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_delete' ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.rate_articles}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_rate', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['rating'], 'for' => 1, 'msg' => '{lang.warn_kb_rating}' ) ) ),	'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.news}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.comment_on_news}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_news_comment', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_news_comments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_edit' ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_delete' ),			'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.profile}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.change_skin}', 					$this->trellis->skin->yes_no_radio( array( 'name' => 'g_change_skin', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['look']['change_skin'], 'for' => 1, 'msg' => '{lang.warn_skin_change}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.change_language}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_change_lang', 'alert' => array( 'check' => $this->trellis->core->cache['settings']['look']['change_lang'], 'for' => 1, 'msg' => '{lang.warn_lang_change}' ) ) ),					'a' );
		}

		if ( $this->trellis->user['id'] == 1 && $g['g_id'] != 2 )
		{
			$this->output .= $this->trellis->skin->group_table_sub( '{lang.staff_permissions}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_original_ticket_msgs} '. $this->trellis->skin->help_tip('{lang.tip_edit_ticket_msgs}'), $this->trellis->skin->yes_no_radio( 'g_ticket_msg_edit' ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_all_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_edit_all' ),			'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_all_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_delete_all' ),		'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_all_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_edit_all' ),		'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_all_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_delete_all' ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.grant_acp_access}', 				$this->trellis->skin->yes_no_radio( 'g_acp_access' ),					'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.acp_permissions}', 		"<select name='acp_perm[]' id='acp_perm' size='10' multiple='multiple'>". $this->acp_perm_drop($g_acp_perm) ."</select>", 'a' );

			foreach( $this->trellis->core->cache['departs'] as $did => $d )
			{
				$depart_rows .= "<tr>
									<td class='bluecellthin-light'><div style='float:right'><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='cursor:pointer' onclick=\"ckRow('". $d['id'] ."')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='cursor:pointer' onclick=\"unckRow('". $d['id'] ."')\" /></div>{$d['name']}</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_v_'. $d['id'], 'V' ), '{lang.tip_ticket_view}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_r_'. $d['id'], 'R' ), '{lang.tip_ticket_reply}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_et_'. $d['id'], 'T' ), '{lang.tip_ticket_edit}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_er_'. $d['id'], 'R' ), '{lang.tip_reply_edit}' ) ."</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_mv_'. $d['id'], 'M' ), '{lang.tip_ticket_move}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_es_'. $d['id'], 'E' ), '{lang.tip_ticket_escalate}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_as_'. $d['id'], 'S' ), '{lang.tip_assign_self}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_aa_'. $d['id'], 'A' ), '{lang.tip_assign_all}' ) ."</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_c_'. $d['id'], 'C' ), '{lang.tip_ticket_close}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_ro_'. $d['id'], 'RO' ), '{lang.tip_ticket_reopen}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_dt_'. $d['id'], 'T' ), '{lang.tip_ticket_delete}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_dr_'. $d['id'], 'R' ), '{lang.tip_reply_delete}' ) ."</td>
								</tr>";
			}

			$this->output .= $this->trellis->skin->end_group_table( 'a' ) ."
						<div id='acp_depart_perm' style='margin-top:12px'>
						". $this->trellis->skin->start_group_table( '{lang.staff_depart_perms}' ) ."
						<tr>
							<th class='bluecellthin-th' width='28%' align='left'>{lang.department}</th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.view_reply}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('v')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('v')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('r')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('r')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.edit}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('et')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('et')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('er')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('er')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.move}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('mv')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('mv')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('es')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('es')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.assign}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('as')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('as')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('aa')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('aa')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.close}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('c')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('c')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('ro')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('ro')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.delete}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('dt')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('dt')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('dr')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('dr')\" /></th>
						</tr>
						". $depart_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_add_group}' ) );
		}
		else
		{
			$this->output .= $this->trellis->skin->end_group_table( 'a' );
		}

		$this->output .= "</div>";

		$validate_fields = array(
								 'g_name'				=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_group_name}' ) ) ),
								 'g_upload_size_max'	=> array( array( 'type' => 'number', 'params' => array( 'int_only' => 1, 'not_num_msg' => '{lang.lv_not_num}', 'not_int_msg' => '{lang.lv_not_int}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('g_name');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_group_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit Group Form
	#=======================================

	private function edit_group($error='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'edit' );

		if ( ! $g = $this->trellis->groups->get_single_by_id( 'all', $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_group');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;

			#=============================
			# Permissions
			#=============================

			if ( $this->trellis->user['id'] == 1 )
			{
				if ( is_array( $this->trellis->input['acp_perm'] ) )
				{
					while ( list( , $perm ) = each( $this->trellis->input['acp_perm'] ) )
					{
						$g_acp_perm[ $perm ] = 1;
					}
				}
			}
		}
		else
		{
			$g_m_depart_perm = unserialize( $g['g_depart_perm'] );

			if ( $this->trellis->user['id'] == 1 )
			{
				$g_acp_perm = unserialize( $g['g_acp_perm'] );
			}

			$g_acp_depart_perm = unserialize( $g['g_acp_depart_perm'] );
		}

		$depart_perms_html = "<table width='100%' cellpadding='0' cellspacing='0'>";
		$depart_count = 0;
		$depart_total = count( $this->trellis->core->cache['departs'] );

		foreach( $this->trellis->core->cache['departs'] as $did => $d )
		{
			$depart_count ++;

			if ( $depart_count > 2 ) $padding = " style='padding-top:5px'";

			if ( $depart_count & 1 )
			{
				if ( $depart_count == $depart_total )
				{
					$depart_perms_html .= "<tr><td colspan='2'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'], $g_m_depart_perm[ $d['id'] ] ) ."</td></tr>";
				}
				else
				{
					$depart_perms_html .= "<tr><td width='35%'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'], $g_m_depart_perm[ $d['id'] ] ) ."</td>";
				}
			}
			else
			{
				$depart_perms_html .= "<td width='65%'{$padding}>". $this->trellis->skin->checkbox( 'dp_'. $d['id'], $d['name'], $g_m_depart_perm[ $d['id'] ] ) ."</td></tr>";
			}
		}

		$depart_perms_html .= "</table>";

		$this->output = "<script type='text/javascript'>

						function ckCol(type)
						{
							$('input:checkbox').each( function() {
								if ( this.name.search('^adp_' + type + '_') != -1 ) this.checked = 1
							} );
						}

						function unckCol(type)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_' + type + '_') != -1 ) this.checked = 0
							} );
						}

						function ckRow(did)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_[a-z]+_' + did + '$') != -1 ) this.checked = 1
							} );
						}

						function unckRow(did)
						{
							$('input:checkbox').each( function(e) {
								if ( this.name.search('^adp_[a-z]+_' + did + '$') != -1 ) this.checked = 0
							} );
						}

						</script>
						<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=doedit&amp;id={$g['g_id']}", 'edit_group', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.editing_group} '. $g['g_name'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.name}', 			$this->trellis->skin->textfield( 'g_name', $g['g_name'] ),									'a', '30%', '70%' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.ticket_center}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.ticket_center_access}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_access', $g['g_ticket_access'] ),			'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.create_new_tickets}', 	$this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_create', 'value' => $g['g_ticket_create'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['new_tickets'], 'for' => 1, 'msg' => '{lang.warn_ticket_create}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.can_escalate_tickets}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_escalate', 'value' => $g['g_ticket_escalate'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['escalate'], 'for' => 1, 'msg' => '{lang.warn_ticket_escalate}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_tickets}', 		$this->trellis->skin->yes_no_radio( 'g_ticket_edit', $g['g_ticket_edit'] ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.close_own_tickets}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_close', $g['g_ticket_close'] ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.reopen_own_tickets}', 	$this->trellis->skin->yes_no_radio( 'g_ticket_reopen', $g['g_ticket_reopen'] ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_replies}', 		$this->trellis->skin->yes_no_radio( 'g_reply_edit', $g['g_reply_edit'] ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_replies}', 	$this->trellis->skin->yes_no_radio( 'g_reply_delete', $g['g_reply_delete'] ),			'a' );

		if ( $g['g_id'] != 2 ) $this->output .= $this->trellis->skin->group_table_row( '{lang.rate_staff_replies}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_reply_rate', 'value' => $g['g_reply_rate'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['rating'], 'for' => 1, 'msg' => '{lang.warn_ticket_rating}' ) ) ), 'a' );

		$this->output .= $this->trellis->skin->group_table_row( '{lang.allow_attachments}', 		$this->trellis->skin->yes_no_radio( array( 'name' => 'g_ticket_attach', 'value' => $g['g_ticket_attach'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['ticket']['attachments'], 'for' => 1, 'msg' => '{lang.warn_attachments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.max_upload_size} '. $this->trellis->skin->help_tip('{lang.tip_max_upload_size}'), $this->trellis->skin->textfield( 'g_upload_size_max', $g['g_upload_size_max'], '', 0, 6 ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.department_permissions} '. $this->trellis->skin->help_tip('{lang.tip_depart_perms}'), $depart_perms_html, 		'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.knowledge_base}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.knowledge_base_access}', $this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_access', 'value' => $g['g_kb_access'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['enable'], 'for' => 1, 'msg' => '{lang.warn_kb_access}' ) ) ), 'a' );

		if ( $g['g_id'] != 2 )
		{
			$this->output .= $this->trellis->skin->group_table_row( '{lang.comment_on_articles}',			$this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_comment', 'value' => $g['g_kb_comment'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['comments'], 'for' => 1, 'msg' => '{lang.warn_kb_comments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_edit', $g['g_kb_com_edit'] ),					'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_delete', $g['g_kb_com_delete'] ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.rate_articles}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_kb_rate', 'value' => $g['g_kb_rate'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['kb']['rating'], 'for' => 1, 'msg' => '{lang.warn_kb_rating}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.news}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.comment_on_news}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_news_comment', 'value' => $g['g_news_comment'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_news_comments}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_own_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_edit', $g['g_news_com_edit'] ),				'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_own_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_delete', $g['g_news_com_delete'] ),			'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.profile}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.change_skin}', 					$this->trellis->skin->yes_no_radio( array( 'name' => 'g_change_skin', 'value' => $g['g_change_skin'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['look']['change_skin'], 'for' => 1, 'msg' => '{lang.warn_skin_change}' ) ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.change_language}', 				$this->trellis->skin->yes_no_radio( array( 'name' => 'g_change_lang', 'value' => $g['g_change_lang'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['look']['change_lang'], 'for' => 1, 'msg' => '{lang.warn_lang_change}' ) ) ), 'a' );
		}

		if ( $this->trellis->user['id'] == 1 && $g['g_id'] != 2 )
		{
			$this->output .= $this->trellis->skin->group_table_sub( '{lang.staff_permissions}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_original_ticket_msgs} '. $this->trellis->skin->help_tip('{lang.tip_edit_ticket_msgs}'), $this->trellis->skin->yes_no_radio( 'g_ticket_msg_edit', $g['g_ticket_msg_edit'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_all_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_edit_all', $g['g_kb_com_edit_all'] ),			'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_all_article_comments}', 	$this->trellis->skin->yes_no_radio( 'g_kb_com_delete_all', $g['g_kb_com_delete_all'] ),		'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.edit_all_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_edit_all', $g['g_news_com_edit_all'] ),		'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.delete_all_news_comments}', 		$this->trellis->skin->yes_no_radio( 'g_news_com_delete_all', $g['g_news_com_delete_all'] ),	'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.grant_acp_access}', 				$this->trellis->skin->yes_no_radio( 'g_acp_access', $g['g_acp_access'] ),					'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.acp_permissions}', 		"<select name='acp_perm[]' id='acp_perm' size='10' multiple='multiple'>". $this->acp_perm_drop($g_acp_perm) ."</select>", 'a' );

			$depart_rows = '';

			foreach( $this->trellis->core->cache['departs'] as $did => $d )
			{
				$depart_rows .= "<tr>
									<td class='bluecellthin-light'><div style='float:right'><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='cursor:pointer' onclick=\"ckRow('". $d['id'] ."')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='cursor:pointer' onclick=\"unckRow('". $d['id'] ."')\" /></div>{$d['name']}</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_v_'. $d['id'], 'V', $g_acp_depart_perm[ $d['id'] ]['v'] ), '{lang.tip_ticket_view}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_r_'. $d['id'], 'R', $g_acp_depart_perm[ $d['id'] ]['r'] ), '{lang.tip_ticket_reply}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_et_'. $d['id'], 'T', $g_acp_depart_perm[ $d['id'] ]['et'] ), '{lang.tip_ticket_edit}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_er_'. $d['id'], 'R', $g_acp_depart_perm[ $d['id'] ]['er'] ), '{lang.tip_reply_edit}' ) ."</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_mv_'. $d['id'], 'M', $g_acp_depart_perm[ $d['id'] ]['mv'] ), '{lang.tip_ticket_move}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_es_'. $d['id'], 'E', $g_acp_depart_perm[ $d['id'] ]['es'] ), '{lang.tip_ticket_escalate}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_as_'. $d['id'], 'S', $g_acp_depart_perm[ $d['id'] ]['as'] ), '{lang.tip_assign_self}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_aa_'. $d['id'], 'A', $g_acp_depart_perm[ $d['id'] ]['aa'] ), '{lang.tip_assign_all}' ) ."</td>
									<td class='bluecellthin-dark' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_c_'. $d['id'], 'C', $g_acp_depart_perm[ $d['id'] ]['c'] ), '{lang.tip_ticket_close}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_ro_'. $d['id'], 'RO', $g_acp_depart_perm[ $d['id'] ]['ro'] ), '{lang.tip_ticket_reopen}' ) ."</td>
									<td class='bluecellthin-light' align='center'>". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_dt_'. $d['id'], 'T', $g_acp_depart_perm[ $d['id'] ]['dt'] ), '{lang.tip_ticket_delete}' ) ." ". $this->trellis->skin->text_tip( $this->trellis->skin->checkbox( 'adp_dr_'. $d['id'], 'R', $g_acp_depart_perm[ $d['id'] ]['dr'] ), '{lang.tip_reply_delete}' ) ."</td>
								</tr>";
			}

			$this->output .= $this->trellis->skin->end_group_table( 'a' ) ."
						<div id='acp_depart_perm' style='margin-top:12px'>
						". $this->trellis->skin->start_group_table( '{lang.staff_depart_perms}' ) ."
						<tr>
							<th class='bluecellthin-th' width='28%' align='left'>{lang.department}</th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.view_reply}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('v')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('v')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('r')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('r')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.edit}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('et')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('et')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('er')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('er')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.move}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('mv')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('mv')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('es')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('es')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.assign}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('as')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('as')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('aa')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('aa')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.close}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('c')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('c')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('ro')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('ro')\" /></th>
							<th class='bluecellthin-th' width='12%' align='center'>{lang.delete}<br /><img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('dt')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('dt')\" />&nbsp;&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_plus_sm.png' alt='+' style='vertical-align:bottom;cursor:pointer' onclick=\"ckCol('dr')\" />&nbsp;&nbsp;<img src='<! IMG_DIR !>/icon_minus_sm.png' alt='-' style='vertical-align:bottom;cursor:pointer' onclick=\"unckCol('dr')\" /></th>
						</tr>
						". $depart_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_group}' ) );
		}
		else
		{
			$this->output .= $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_group}' ) );
		}

		$this->output .= "</div>";

		$validate_fields = array(
								 'g_name'				=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_group_name}' ) ) ),
								 'g_upload_size_max'	=> array( array( 'type' => 'number', 'params' => array( 'int_only' => 1, 'not_num_msg' => '{lang.lv_not_num}', 'not_int_msg' => '{lang.lv_not_int}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=add' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_group_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Delete Group Form
	#=======================================

	function delete_group()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'delete' );

		if ( ! $g = $this->trellis->groups->get_single_by_id( array( 'g_id', 'g_name' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_group');

		#=============================
		# Do Output
		#=============================

		$this->trellis->load_functions('drop_downs');

		$this->output = "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=dodel&amp;id={$g['g_id']}", 'delete_group', 'post' ) ."
						". $this->trellis->skin->group_title( '{lang.deleting_group} '. $g['g_name'] ) ."
						". $this->trellis->skin->group_sub( '{lang.delete_group_users_qs}' ) ."
						<div class='option1'><input type='radio' name='action' id='action1' value='1' checked='checked' /> <label for='action1'>{lang.move_users_to_group}</label> <select name='moveto'>". $this->trellis->drop_downs->group_drop( 0, $g['g_id'] ) ."</select></div>
						<div class='option2'><input type='radio' name='action' id='action2' value='2' /> <label for='action2'>{lang.delete_users}</label></div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'delete', '{lang.button_delete_group}' ) ) ."
						</div>";

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=groups&amp;act=add' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_group_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Add Group
	#=======================================

	private function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'add' );

		if ( ! $this->trellis->input['g_name'] ) $this->add_group('no_group_name');

		#=============================
		# Generate Permissions
		#=============================

		$depart_perm = array();

		foreach ( $this->trellis->core->cache['departs'] as $did => $d )
		{
			$depart_perm[ $did ] = intval( $this->trellis->input[ 'dp_'. $did ] );
		}

		if ( $this->trellis->user['id'] == 1 )
		{
			if ( is_array( $this->trellis->input['acp_perm'] ) )
			{
				while ( list( , $perm ) = each( $this->trellis->input['acp_perm'] ) )
				{
					$acp_perm[ $perm ] = 1;
				}
			}

			$acp_depart_perm = array();

			foreach ( $this->trellis->core->cache['departs'] as $did => $d )
			{
				$acp_depart_perm[ $did ]['v'] = intval( $this->trellis->input[ 'adp_v_'. $did ] );
				$acp_depart_perm[ $did ]['r'] = intval( $this->trellis->input[ 'adp_r_'. $did ] );
				$acp_depart_perm[ $did ]['et'] = intval( $this->trellis->input[ 'adp_et_'. $did ] );
				$acp_depart_perm[ $did ]['er'] = intval( $this->trellis->input[ 'adp_er_'. $did ] );
				$acp_depart_perm[ $did ]['mv'] = intval( $this->trellis->input[ 'adp_mv_'. $did ] );
				$acp_depart_perm[ $did ]['es'] = intval( $this->trellis->input[ 'adp_es_'. $did ] );
				$acp_depart_perm[ $did ]['as'] = intval( $this->trellis->input[ 'adp_as_'. $did ] );
				$acp_depart_perm[ $did ]['aa'] = intval( $this->trellis->input[ 'adp_aa_'. $did ] );
				$acp_depart_perm[ $did ]['c'] = intval( $this->trellis->input[ 'adp_c_'. $did ] );
				$acp_depart_perm[ $did ]['ro'] = intval( $this->trellis->input[ 'adp_ro_'. $did ] );
				$acp_depart_perm[ $did ]['dt'] = intval( $this->trellis->input[ 'adp_dt_'. $did ] );
				$acp_depart_perm[ $did ]['dr'] = intval( $this->trellis->input[ 'adp_dr_'. $did ] );
			}
		}

		#=============================
		# Add Group
		#=============================

		$db_array = array(
						  'g_name'					=> $this->trellis->input['g_name'],
						  'g_ticket_access'			=> $this->trellis->input['g_ticket_access'],
						  'g_ticket_create'			=> $this->trellis->input['g_ticket_create'],
						  'g_ticket_edit'			=> $this->trellis->input['g_ticket_edit'],
						  'g_ticket_escalate'		=> $this->trellis->input['g_ticket_escalate'],
						  'g_ticket_close'		    => $this->trellis->input['g_ticket_close'],
						  'g_ticket_reopen'		    => $this->trellis->input['g_ticket_reopen'],
						  'g_reply_edit'			=> $this->trellis->input['g_reply_edit'],
						  'g_reply_delete'			=> $this->trellis->input['g_reply_delete'],
						  'g_reply_rate'			=> $this->trellis->input['g_reply_rate'],
						  'g_ticket_attach'			=> $this->trellis->input['g_ticket_attach'],
						  'g_upload_size_max'		=> $this->trellis->input['g_upload_size_max'],
						  'g_kb_access'				=> $this->trellis->input['g_kb_access'],
						  'g_kb_comment'			=> $this->trellis->input['g_kb_comment'],
						  'g_kb_com_edit'			=> $this->trellis->input['g_kb_com_edit'],
						  'g_kb_com_delete'			=> $this->trellis->input['g_kb_com_delete'],
						  'g_kb_rate'				=> $this->trellis->input['g_kb_rate'],
						  'g_news_comment'			=> $this->trellis->input['g_news_comment'],
						  'g_news_com_edit'			=> $this->trellis->input['g_news_com_edit'],
						  'g_news_com_delete'		=> $this->trellis->input['g_news_com_delete'],
						  'g_change_skin'			=> $this->trellis->input['g_change_skin'],
						  'g_change_lang'			=> $this->trellis->input['g_change_lang'],
						  'g_ticket_msg_edit'		=> $this->trellis->input['g_ticket_msg_edit'],
						  'g_kb_com_edit_all'		=> $this->trellis->input['g_kb_com_edit_all'],
						  'g_kb_com_delete_all'		=> $this->trellis->input['g_kb_com_delete_all'],
						  'g_news_com_edit_all'		=> $this->trellis->input['g_news_com_edit_all'],
						  'g_news_com_delete_all'	=> $this->trellis->input['g_news_com_delete_all'],
						  'g_depart_perm'			=> $depart_perm,
						  'g_acp_access'			=> $this->trellis->input['g_acp_access'],
						 );

		if ( $this->trellis->user['id'] == 1 )
		{
			$db_array['g_acp_perm'] = $acp_perm;
			$db_array['g_acp_depart_perm'] = $acp_depart_perm;
		}

		$group_id = $this->trellis->groups->add( $db_array );

		$this->trellis->log( 'admin', "Group Added &#039;". $this->trellis->input['g_name'] ."&#039;", 1, $group_id );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->groups_cache();
		$this->trellis->rebuild->staff_cache(); # Necessary?

		#=============================
		# Output
		#=============================

		$this->list_groups( '', 'group_added' );
	}

	#=======================================
	# @ Do Edit Group
	#=======================================

	private function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'edit' );

		if ( ! $this->trellis->input['g_name'] ) $this->edit_group('no_group_name');

		#=============================
		# Generate Permissions
		#=============================

		$depart_perm = array();

		foreach ( $this->trellis->core->cache['departs'] as $did => $d )
		{
			$depart_perm[ $did ] = intval( $this->trellis->input[ 'dp_'. $did ] );
		}

		if ( $this->trellis->user['id'] == 1 )
		{
			if ( is_array( $this->trellis->input['acp_perm'] ) )
			{
				while ( list( , $perm ) = each( $this->trellis->input['acp_perm'] ) )
				{
					$acp_perm[ $perm ] = 1;
				}
			}

			$acp_depart_perm = array();

			foreach ( $this->trellis->core->cache['departs'] as $did => $d )
			{
				$acp_depart_perm[ $did ]['v'] = intval( $this->trellis->input[ 'adp_v_'. $did ] );
				$acp_depart_perm[ $did ]['r'] = intval( $this->trellis->input[ 'adp_r_'. $did ] );
				$acp_depart_perm[ $did ]['et'] = intval( $this->trellis->input[ 'adp_et_'. $did ] );
				$acp_depart_perm[ $did ]['er'] = intval( $this->trellis->input[ 'adp_er_'. $did ] );
				$acp_depart_perm[ $did ]['mv'] = intval( $this->trellis->input[ 'adp_mv_'. $did ] );
				$acp_depart_perm[ $did ]['es'] = intval( $this->trellis->input[ 'adp_es_'. $did ] );
				$acp_depart_perm[ $did ]['as'] = intval( $this->trellis->input[ 'adp_as_'. $did ] );
				$acp_depart_perm[ $did ]['aa'] = intval( $this->trellis->input[ 'adp_aa_'. $did ] );
				$acp_depart_perm[ $did ]['c'] = intval( $this->trellis->input[ 'adp_c_'. $did ] );
				$acp_depart_perm[ $did ]['ro'] = intval( $this->trellis->input[ 'adp_ro_'. $did ] );
				$acp_depart_perm[ $did ]['dt'] = intval( $this->trellis->input[ 'adp_dt_'. $did ] );
				$acp_depart_perm[ $did ]['dr'] = intval( $this->trellis->input[ 'adp_dr_'. $did ] );
			}
		}

		#=============================
		# Update Group
		#=============================

		$db_array = array(
						  'g_name'					=> $this->trellis->input['g_name'],
						  'g_ticket_access'			=> $this->trellis->input['g_ticket_access'],
						  'g_ticket_create'			=> $this->trellis->input['g_ticket_create'],
						  'g_ticket_edit'			=> $this->trellis->input['g_ticket_edit'],
						  'g_ticket_escalate'		=> $this->trellis->input['g_ticket_escalate'],
						  'g_ticket_close'		    => $this->trellis->input['g_ticket_close'],
						  'g_ticket_reopen'		    => $this->trellis->input['g_ticket_reopen'],
						  'g_reply_edit'			=> $this->trellis->input['g_reply_edit'],
						  'g_reply_delete'			=> $this->trellis->input['g_reply_delete'],
						  'g_reply_rate'			=> $this->trellis->input['g_reply_rate'],
						  'g_ticket_attach'			=> $this->trellis->input['g_ticket_attach'],
						  'g_upload_size_max'		=> $this->trellis->input['g_upload_size_max'],
						  'g_kb_access'				=> $this->trellis->input['g_kb_access'],
						  'g_kb_comment'			=> $this->trellis->input['g_kb_comment'],
						  'g_kb_com_edit'			=> $this->trellis->input['g_kb_com_edit'],
						  'g_kb_com_delete'			=> $this->trellis->input['g_kb_com_delete'],
						  'g_kb_rate'				=> $this->trellis->input['g_kb_rate'],
						  'g_news_comment'			=> $this->trellis->input['g_news_comment'],
						  'g_news_com_edit'			=> $this->trellis->input['g_news_com_edit'],
						  'g_news_com_delete'		=> $this->trellis->input['g_news_com_delete'],
						  'g_change_skin'			=> $this->trellis->input['g_change_skin'],
						  'g_change_lang'			=> $this->trellis->input['g_change_lang'],
						  'g_ticket_msg_edit'		=> $this->trellis->input['g_ticket_msg_edit'],
						  'g_kb_com_edit_all'		=> $this->trellis->input['g_kb_com_edit_all'],
						  'g_kb_com_delete_all'		=> $this->trellis->input['g_kb_com_delete_all'],
						  'g_news_com_edit_all'		=> $this->trellis->input['g_news_com_edit_all'],
						  'g_news_com_delete_all'	=> $this->trellis->input['g_news_com_delete_all'],
						  'g_depart_perm'			=> $depart_perm,
						  'g_acp_access'			=> $this->trellis->input['g_acp_access'],
						 );

		if ( $this->trellis->user['id'] == 1 )
		{
			$db_array['g_acp_perm'] = $acp_perm;
			$db_array['g_acp_depart_perm'] = $acp_depart_perm;
		}

		$this->trellis->groups->edit( $db_array, $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "Group Edited &#039;". $this->trellis->input['g_name'] ."&#039;", 1, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->groups_cache();
		$this->trellis->rebuild->staff_cache(); # Necessary?

		#=============================
		# Output
		#=============================

		$this->list_groups( '', 'group_updated' );
	}

	#=======================================
	# @ Do Delete Group
	#=======================================

	private function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'groups', 'delete' );

		#=============================
		# DELETE Group *MwhaAaAaAaAa*
		#=============================

		$this->trellis->groups->delete( $this->trellis->input['id'], $this->trellis->input['action'], $this->trellis->input['moveto'] );

		$this->trellis->log( 'admin', "Group Deleted &#039;". $this->trellis->core->cache['groups'][ $this->trellis->input['id'] ]['g_name'] ."&#039;", 2, intval( $this->trellis->input['id'] ) );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->groups_cache();
		$this->trellis->rebuild->staff_cache(); # Necessary?

		#=============================
		# Output
		#=============================

		$this->list_groups( 'group_deleted' );
	}

	#=======================================
	# @ ACP Permissions Drop-Down
	#=======================================

	private function acp_perm_drop($selected="")
	{
		$acp_titles = array(); // Initialize for Security
		$acp_pages = array(); // Initialize for Security
		$acp_subs = array(); // Initialize for Security

		$acp_titles['admin'] = 'Administration';
		$acp_titles['manage'] = 'Management';
		$acp_titles['look'] = 'Look &amp; Feel';
		$acp_titles['tools'] = 'Tools';

		$acp_pages['admin']['logs'] = 'Log Center';
		$acp_pages['manage']['ticket'] = 'Ticket Control';
		$acp_pages['manage']['canned'] = 'Canned Replies';
		$acp_pages['manage']['depart'] = 'Department Control';
		$acp_pages['manage']['news'] = 'News Control';
		$acp_pages['manage']['user'] = 'User Control';
		$acp_pages['manage']['group'] = 'Group Control';
		$acp_pages['manage']['article'] = 'Article Control';
		$acp_pages['manage']['cat'] = 'Category Control';
		$acp_pages['manage']['pages'] = 'Pages Control';
		$acp_pages['manage']['settings'] = 'System Settings';
		$acp_pages['look']['skin'] = 'Skins';
		$acp_pages['look']['lang'] = 'Languages';
		$acp_pages['tools']['maint'] = 'Maintenance';
		$acp_pages['tools']['backup'] = 'Backup';

		$acp_subs['logs']['admin'] = 'Admin Logs';
		$acp_subs['logs']['user'] = 'User Logs';
		$acp_subs['logs']['email'] = 'Email Logs';
		$acp_subs['logs']['error'] = 'Error Logs';
		$acp_subs['logs']['security'] = 'Security Logs';
		$acp_subs['logs']['ticket'] = 'Ticket Logs';
		$acp_subs['logs']['prune'] = 'Prune Logs';
		$acp_subs['ticket']['reply'] = 'Reply';
		$acp_subs['ticket']['assign_self'] = 'Assign to Self';
		$acp_subs['ticket']['assign_any'] = 'Assign to Any';
		$acp_subs['ticket']['hold'] = 'Put On Hold';
		$acp_subs['ticket']['escalate'] = 'Escalate';
		$acp_subs['ticket']['move'] = 'Move';
		$acp_subs['ticket']['close'] = 'Close';
		$acp_subs['ticket']['delete'] = 'Delete';
		$acp_subs['ticket']['reopen'] = 'Reopen';
		$acp_subs['canned']['add'] = 'Add';
		$acp_subs['canned']['edit'] = 'Edit';
		$acp_subs['canned']['delete'] = 'Delete';
		$acp_subs['depart']['add'] = 'Add';
		$acp_subs['depart']['edit'] = 'Edit';
		$acp_subs['depart']['delete'] = 'Delete';
		$acp_subs['depart']['reorder'] = 'Reorder';
		$acp_subs['depart']['cfields'] = 'Custom Fields';
		$acp_subs['news']['add'] = 'Add';
		$acp_subs['news']['edit'] = 'Edit';
		$acp_subs['news']['delete'] = 'Delete';
		$acp_subs['user']['add'] = 'Add';
		$acp_subs['user']['edit'] = 'Edit';
		$acp_subs['user']['delete'] = 'Delete';
		$acp_subs['user']['approve'] = 'Approve';
		$acp_subs['user']['cfields'] = 'Custom Fields';
		$acp_subs['group']['add'] = 'Add';
		$acp_subs['group']['edit'] = 'Edit';
		$acp_subs['group']['delete'] = 'Delete';
		$acp_subs['article']['add'] = 'Add';
		$acp_subs['article']['edit'] = 'Edit';
		$acp_subs['article']['delete'] = 'Delete';
		$acp_subs['cat']['add'] = 'Add';
		$acp_subs['cat']['edit'] = 'Edit';
		$acp_subs['cat']['delete'] = 'Delete';
		$acp_subs['pages']['add'] = 'Add';
		$acp_subs['pages']['edit'] = 'Edit';
		$acp_subs['pages']['delete'] = 'Delete';
		$acp_subs['settings']['update'] = 'Update';
		$acp_subs['skin']['manage'] = 'Manage Sets';
		$acp_subs['skin']['tools'] = 'Tools';
		$acp_subs['skin']['import'] = 'Import';
		$acp_subs['skin']['export'] = 'Export';
		$acp_subs['lang']['manage'] = 'Manage';
		$acp_subs['lang']['tools'] = 'Tools';
		$acp_subs['lang']['import'] = 'Import';
		$acp_subs['lang']['export'] = 'Export';
		$acp_subs['maint']['recount'] = 'Recount';
		$acp_subs['maint']['clean'] = 'Clean';
		$acp_subs['maint']['optm'] = 'Optimize';
		$acp_subs['maint']['syscheck'] = 'System Check';

		$html = ""; // Initialize for Security

		while ( list( $section, $stitle ) = each( $acp_titles ) )
		{
			if ( $selected[ $section ] )
			{
				$html .= "<option value='{$section}' selected='selected'>{$stitle}</option>\n";
			}
			else
			{
				$html .= "<option value='{$section}'>{$stitle}</option>\n";
			}

			if ( is_array( $acp_pages[ $section ] ) )
			{
				while ( list( $page, $ptitle ) = each( $acp_pages[ $section ] ) )
				{
					if ( $selected[ $section .'_'. $page ] )
					{
						$html .= "<option value='{$section}_{$page}' selected='selected'>&nbsp;&nbsp;&#0124;-- {$ptitle}</option>\n";
					}
					else
					{
						$html .= "<option value='{$section}_{$page}'>&nbsp;&nbsp;&#0124;-- {$ptitle}</option>\n";
					}

					if ( is_array( $acp_subs[ $page ] ) )
					{
						while ( list( $sub, $btitle ) = each( $acp_subs[ $page ] ) )
						{
							if ( $selected[ $section .'_'. $page .'_'. $sub ] )
							{
								$html .= "<option value='{$section}_{$page}_{$sub}' selected='selected'>&nbsp;&nbsp;&#0124;---- {$btitle}</option>\n";

							}
							else
							{
								$html .= "<option value='{$section}_{$page}_{$sub}'>&nbsp;&nbsp;&#0124;---- {$btitle}</option>\n";
							}
						}
					}
				}
			}
		}

		return $html;
	}

}

?>