<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Source: News
#======================================================
*/

class ad_news {

	private $output = "";

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		if ( ! $this->trellis->core->cache['settings']['news']['enable'] ) $this->trellis->skin->error('news_disabled');

		$this->trellis->check_perm( 'manage', 'news' );

		$this->trellis->load_functions('news');
		$this->trellis->ad_load_lang('news');

		$this->trellis->skin->set_active_link( 2 );

		switch( $this->trellis->input['act'] )
    	{
    		case 'list':
				$this->list_news();
    		break;
			case 'view':
				$this->view_news();
			break;
    		case 'add':
    			$this->add_news();
    		break;
    		case 'edit':
    			$this->edit_news();
    		break;

    		case 'togglecomments':
    			$this->do_toggle_comments();
    		break;

    		case 'doadd':
    			$this->do_add();
    		break;
    		case 'doedit':
    			$this->do_edit();
    		break;
    		case 'dodel':
    			$this->do_delete();
    		break;

			case 'doaddcomment':
				$this->do_add_comment();
			break;
			case 'doeditcomment':
				$this->do_edit_comment();
			break;
			case 'dodelcomment':
				$this->do_delete_comment();
			break;

			case 'getcomment':
				$this->ajax_get_comment();
			break;

    		default:
    			$this->list_news();
    		break;
		}
	}

	#=======================================
	# @ List News
	#=======================================

	private function list_news($error='', $alert='')
	{
		#=============================
		# Sorting Options
		#=============================

		if ( $this->trellis->input['sort'] )
		{
			$sort = $this->trellis->input['sort'];
		}
		else
		{
			$sort = 'id';
		}

		$order_var = "order_". $sort;
		$img_var = "img_". $sort;

		if ( $this->trellis->input['order'] )
		{
			$order = $this->trellis->input['order'];
		}
		elseif ( $sort == 'id' )
		{
			$order = 'desc';
		}

		if ( $order == 'desc' )
		{
			$$order_var = "&amp;order=asc";
			$$img_var = "&nbsp;<img src='<! IMG_DIR !>/arrow_up.gif' alt='{lang.up}' />";
		}
		else
		{
			$$order_var = "&amp;order=desc";
			$$img_var = "&nbsp;<img src='<! IMG_DIR !>/arrow_down.gif' alt='{lang.down}' />";
		}

		$link_id = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;sort=id". $order_id ."'>{lang.id}". $img_id ."</a>";
		$link_title = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;sort=title". $order_title ."'>{lang.title}". $img_title ."</a>";

		#=============================
		# Grab News
		#=============================

		$news_rows = '';

		if ( ! $news = $this->trellis->news->get( array( 'select' => array( 'id', 'title', 'content', 'excerpt' ), 'order' => array( $sort => $order ) ) ) )
		{
			$news_rows .= "<tr><td class='bluecell-light' colspan='5'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=add'>{lang.no_news}</a></strong></td></tr>";
		}
		else
		{
			foreach( $news as $nid => $n )
			{
				if ( $n['excerpt'] )
				{
					$n['content'] = $this->trellis->prepare_output( $n['excerpt'] );
				}
				else
				{
					if ( $this->trellis->core->cache['settings']['news']['rte'] )
					{
						$n['content'] = $this->trellis->shorten_str( $this->trellis->remove_html( $this->trellis->remove_dbl_spaces( $this->trellis->convert_html( $n['content'] ) ) ), 80, 1 );
					}
					else
					{
						$n['content'] = $this->trellis->shorten_str( $n['excerpt'], 80, 1 );
					}
				}

				$news_rows .= "<tr>
									<td class='bluecellthin-light'><strong>{$n['id']}</strong></td>
									<td class='bluecellthin-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=view&amp;id={$n['id']}'>{$n['title']}</a></td>
									<td class='bluecellthin-light' style='font-weight: normal'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=view&amp;id={$n['id']}'>{$n['content']}</a></td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=edit&amp;id={$n['id']}'><img src='<! IMG_DIR !>/button_edit.gif' alt='{lang.edit}' /></a></td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=dodel&amp;id={$n['id']}' onclick='return confirmDelete({$n['id']})'><img src='<! IMG_DIR !>/button_delete.gif' alt='{lang.delete}' /></a></td>
								</tr>";
			}
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
		}
		elseif ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<script type='text/javascript'>
						function confirmDelete(nid) {
							dialogConfirm({
								title: '{lang.dialog_delete_news_title}',
								message: '{lang.dialog_delete_news_msg}',
								yesButton: '{lang.dialog_delete_news_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=news&act=dodel&id='+nid) },
								noButton: '{lang.cancel}',
								width: 350
							}); return false;
						}
						</script>
						<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.news_list}' ) ."
						<tr>
							<th class='bluecellthin-th' width='6%' align='left'>{$link_id}</th>
							<th class='bluecellthin-th' width='28%' align='left'>{$link_title}</th>
							<th class='bluecellthin-th' width='60%' align='left'>{lang.description}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.edit}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.delete}</th>
						</tr>
						". $news_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=add' ),
							array( 'mails_arrow', '{lang.menu_mass_email}', '<! HD_URL !>/admin.php?section=tools&amp;page=email&amp;act=mass' ),
							array( 'compile', '{lang.menu_cache}', '<! HD_URL !>/admin.php?section=tools&amp;page=cache&amp;act=rebuild&amp;id=news' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=news' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_news_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_news_title}', '{lang.help_about_news_msg}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ View News
	#=======================================

	private function view_news($params=array())
	{
		#=============================
		# Grab News
		#=============================

		$n = $this->trellis->core->db->get_single( array(
						        						 'select'	=> array(
						        							   				 'n' => array( 'id', 'uid', 'title', 'excerpt', 'content', 'views', 'comments', 'html', 'date', 'allow_comments' ),
						        						   					 'u' => array( array( 'name' => 'uname' ) ),
								        					   			     ),
	        											 'from'	    => array( 'n' => 'news' ),
			        									 'join'	    => array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'n' => 'uid', '=', 'u' => 'id' ) ) ),
					        							 'where'	=> array( array( 'n' => 'id' ), '=', $this->trellis->input['id'] ),
							        					 'limit'	=> array( 0, 1 ),
                                                  )      );

		if ( ! $n ) $this->trellis->skin->error('no_news');

		#=============================
		# Grab Comments
		#=============================

		# New get() db function

		$comments = $this->trellis->core->db->get( array(
														 'select'	=> array(
													   				    	 'c' => 'all',
												   					    	 'u' => array( array( 'name' => 'uname' ) ),
													   			    		 ),
														 'from'	    => array( 'c' => 'news_comments' ),
														 'join'	    => array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'c' => 'uid', '=', 'u' => 'id' ) ) ),
														 'where'	=> array( array( 'c' => 'nid' ), '=', $n['id'] ),
														 'order'    => array( 'date' => array( 'c' => 'asc' ) ),
                                                  ), 'id' );

		#=============================
		# Format
		#=============================

		$n['date_human'] = $this->trellis->td_timestamp( array( 'time' => $n['date'], 'format' => 'long' ) );

		if ( ! $n['excerpt'] ) $n['excerpt'] = '<i>{lang.no_excerpt}</i>';

		( $n['allow_comments'] ) ? $n['comments_status'] = '({lang.enabled})' : $n['comments_status'] = '({lang.disabled})';

		$noutput_params = array( 'urls' => 1 );

		( $n['html'] ) ? $noutput_params['html'] = 1 : $noutput_params['nl2br'] = 1;

		$n['content'] = $this->trellis->prepare_output( $n['content'], $noutput_params );

		#=============================
		# Do Output
		#=============================

		if ( $params['error'] )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $params['error'] .'}' );
			$this->trellis->skin->preserve_input = 1;
		}
		elseif ( $params['alert'] )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $params['alert'] .'}' );
		}

		$this->output .= "<script type='text/javascript'>
						//<![CDATA[
						function confirmDeleteNews(aid) {
							dialogConfirm({
								title: '{lang.dialog_delete_news_title}',
								message: '{lang.dialog_delete_news_msg}',
								yesButton: '{lang.dialog_delete_news_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=news&act=dodel&id='+aid) },
								noButton: '{lang.cancel}',
								width: 350
							}); return false;
						}
						function confirmDeleteComment(cid) {
							dialogConfirm({
								title: '{lang.dialog_delete_comment_title}',
								message: '{lang.dialog_delete_comment_msg}',
								yesButton: '{lang.dialog_delete_comment_button}',
								yesAction: function() { inlineCommentDelete(cid); },
								noButton: '{lang.cancel}'
							}); return false;
						}
						//]]>
						</script>
						". $this->trellis->skin->start_ticket_details( '{lang.news_num}'. $n['id'] .': '. $n['title'] ) ."
						<input type='hidden' id='nid' name='nid' value='{$n['id']}' />
						<table width='100%' border='0' cellspacing='0' cellpadding='0'>
							<tr>
								<td class='cardcell-light' width='20%'>{lang.news_id}</td>
								<td class='cardcell-dark' width='30%'>{$n['id']}</td>
								<td class='cardcell-light' width='20%'>{lang.views}</td>
								<td class='cardcell-dark' width='30%'>{$n['views']}</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.date}</td>
								<td class='cardcell-dark'>{$n['date_human']}</td>
								<td class='cardcell-light'>{lang.comments}</td>
								<td class='cardcell-dark'>{$n['comments']}&nbsp;&nbsp;{$n['comments_status']}". $this->trellis->skin->setting_alert( array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_comments}' ) ) ."</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.excerpt}</td>
								<td class='cardcell-dark' colspan='3'>{$n['excerpt']}</td>
							</tr>
						</table>
						". $this->trellis->skin->end_ticket_details() ."
						<div id='ticketroll'>
							". $this->trellis->skin->group_title('{lang.news_content}') ."
							<div class='rollstart'>
								{$n['content']}
							</div>";

		if ( ! empty( $comments ) )
		{
			foreach( $comments as $c )
			{
				( $c['staff'] ) ? $cclass = 'staff': $cclass = 'customer';

				$c['date'] = $this->trellis->td_timestamp( array( 'time' => $c['date'], 'format' => 'long' ) );

				$coutput_params = array( 'urls' => 1 );

				( $c['html'] ) ? $coutput_params['html'] = 1 : $coutput_params['nl2br'] = 1;

				$c['message'] = $this->trellis->prepare_output( $c['message'], $coutput_params );

				/*if ( $c['signature'] ) $c['message'] .= '<br /><br />'. $this->trellis->prepare_output( $c['usignature'], array( 'html' => $c['sig_html'] ) );*/

				$this->output .= "<div id='cc{$c['id']}'>
								<div class='bar{$cclass}'>";

				$comment_edit = 0;
				$comment_delete = 0;
				$comment_javascript_html = '';

				if ( $c['html'] ) $comment_javascript_html = 'Html';

				if ( $this->trellis->user['g_news_com_edit_all'] || ( $this->trellis->user['g_news_com_edit'] && $c['uid'] == $this->trellis->user['id'] ) ) $comment_edit = 1;
				if ( $this->trellis->user['g_news_com_delete_all'] || ( $this->trellis->user['g_news_com_delete'] && $c['uid'] == $this->trellis->user['id'] ) ) $comment_delete = 1;

				if ( $comment_edit || $comment_delete ) $this->output .= "<div class='barright'>";

				if ( $comment_edit ) $this->output .= "<span id='cedit_". $c['id'] ."' style='cursor:pointer' onclick='inlineCommentEdit{$comment_javascript_html}(". $c['id'] .")'><img src='<! IMG_DIR !>/icon_page_edit.png' alt='{lang.edit}' />{lang.edit}</span><span id='csave_". $c['id'] ."' style='display:none;cursor:pointer' onclick='inlineCommentSave{$comment_javascript_html}(". $c['id'] .")'><img src='<! IMG_DIR !>/icon_page_edit.png' alt='{lang.save_edit}' />{lang.save_edit}</span>";

				if ( $comment_delete )
				{
					if ( $comment_edit ) $this->output .= " &nbsp; ";

					$this->output .= "<span id='cdelete_". $c['id'] ."' style='cursor:pointer' onclick='return confirmDeleteComment(". $c['id'] .")'><img src='<! IMG_DIR !>/icon_page_delete.png' alt='{lang.delete}' />{lang.delete}</span>";
				}

				if ( $comment_edit || $comment_delete ) $this->output .= "</div>";

				$this->output .= "<strong>{$c['uname']}</strong> -- {$c['date']}</div>
								<div class='roll{$cclass}' id='c{$c['id']}'>
				                	{$c['message']}
				                </div>
							</div>";
			}
		}

		if ( $this->trellis->core->cache['settings']['news']['comments'] && $n['allow_comments'] && $this->trellis->user['g_news_comment'] )
		{
			if ( $this->trellis->user['rte_enable'] && $this->trellis->core->cache['settings']['news']['rte'] )
			{
				$this->output .= $this->trellis->skin->tinymce_js( 'message' );

				$html = 1;
			}
			else
			{
				$html = 0;
			}

			if ( $params['comment_error'] )
			{
				$this->output .= '<br />'. $this->trellis->skin->error_wrap( '{lang.error_'. $params['comment_error'] .'}' );
			}

			#( $this->trellis->user['sig_auto'] ) ? $sig_checked = " checked='yes'" : $sig_checked = '';

			$this->output .= "<form action='<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=doaddcomment&amp;id={$n['id']}' method='post'>
								<input type='hidden' id='html' name='html' value='{$html}' />
								<div class='slatebox'>{lang.post_a_comment}</div>
								<div class='rollpost'>
								". $this->trellis->skin->textarea( array( 'name' => 'message', 'cols' => 80, 'rows' => 8, 'width' => '98%', 'height' => '200px' ) ) ."
								</div>
								<div class='formtail'>". $this->trellis->skin->submit_button( 'add_comment', '{lang.button_add_comment}' ) ."</div>
								</form>";
		}

		$this->output .= "</div>
			<script language='javascript' type='text/javascript'>
			//<![CDATA[
			function inlineCommentEditHtml(cid) {
				$.get('admin.php?section=manage&page=news&act=getcomment',
					{ id: cid },
					function(data) {
						if (data != 0) {
							tinyMCE.init({
								mode : 'exact',
								theme : 'advanced',
								elements : 'c'+cid,
								plugins : 'inlinepopups,safari,spellchecker',
								dialog_type : 'modal',
								forced_root_block : false,
								force_br_newlines : true,
								force_p_newlines : false,
								theme_advanced_toolbar_location : 'top',
								theme_advanced_toolbar_align : 'left',
								theme_advanced_path_location : 'bottom',
								theme_advanced_disable : 'styleselect,formatselect',
								theme_advanced_buttons1 : 'bold,italic,underline,strikethrough,separator,forecolor,backcolor,separator,bullist,numlist,separator,outdent,indent,separator,link,unlink,image,separator,undo,redo,separator,spellchecker,separator,removeformat,cleanup,code',
								theme_advanced_buttons2 : '',
								theme_advanced_buttons3 : '',
								theme_advanced_resize_horizontal : false,
								theme_advanced_resizing : true,
								setup: function(ed) {
									ed.onInit.add( function(ed) {
										ed.setContent(data);
									});
								}
							});

							$('#cedit_'+cid).hide();
							$('#cdelete_'+cid).hide();
							$('#csave_'+cid).show();
						}
					});
			}
			function inlineCommentSaveHtml(cid) {
				$.post('admin.php?section=manage&page=news&act=doeditcomment',
					{ id: cid, message: tinyMCE.get('c'+cid).getContent(), html: 1 },
					function(data) {
						if (data != 0) {
							tinyMCE.get('c'+cid).setContent(data);
							tinyMCE.get('c'+cid).remove();

							$('#csave_'+cid).hide();
							$('#cedit_'+cid).show();
							$('#cdelete_'+cid).show();
						}
					});
			}
			function inlineCommentEdit(cid) {
				$.get('admin.php?section=manage&page=news&act=getcomment',
					{ id: cid },
					function(data) {
						if (data != 0) {
							$('#c'+cid).html(\"<textarea id='ce\"+cid+\"' name='ce\"+cid+\"' cols='80' rows='7' style='width:98%'>\"+data+\"</textarea>\");

							$('#cedit_'+cid).hide();
							$('#cdelete_'+cid).hide();
							$('#csave_'+cid).show();
						}
					});
			}
			function inlineCommentSave(cid) {
				$.post('admin.php?section=manage&page=news&act=doeditcomment',
					{ id: cid, message: $('#ce'+cid).val() },
					function(data) {
						if (data != 0) {
							$('#c'+cid).html(data);

							$('#csave_'+cid).hide();
							$('#cedit_'+cid).show();
							$('#cdelete_'+cid).show();
						}
					});
			}
			function inlineCommentDelete(cid) {
				$.post('admin.php?section=manage&page=news&act=dodelcomment',
					{ id: cid },
					function(data) {
						if (data != 0) {
							$('#cc'+cid).hide('blind');
						}
					});
			}
			//]]>
			</script>";

		$menu_items = array( array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=news' ) );

		#if ( $this->trellis->check_perm( 'manage', 'news', 'add' ) ) $menu_items[] = array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=add' );
		if ( $this->trellis->check_perm( 'manage', 'news', 'edit' ) ) $menu_items[] = array( 'edit', '{lang.menu_edit}', '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=edit&amp;id='. $n['id'] );

		# Repeated code below... clean up

		if ( $this->trellis->check_perm( 'manage', 'news', 'edit' ) )
		{
		    if ( $n['allow_comments'] )
		    {
		        $menu_items[] = array( 'balloon', '{lang.menu_disable_comments}'. $this->trellis->skin->setting_alert( array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_comments}' ) ), '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=togglecomments&amp;id='. $n['id'] );
		    }
		    else
		    {
		        $menu_items[] = array( 'balloon', '{lang.menu_enable_comments}'. $this->trellis->skin->setting_alert( array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_comments}' ) ), '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=togglecomments&amp;id='. $n['id'] );
		    }
		}

		if ( $this->trellis->check_perm( 'manage', 'news', 'delete' ) ) $menu_items[] = array( 'circle_delete', '{lang.menu_delete}', '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=dodel&amp;id='. $n['id'], 'return confirmDeleteNews('. $n['id'] .')' );
		if ( $this->trellis->check_perm( 'manage', 'settings' ) ) $menu_items[] = array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=news' );

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_news_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add News Form
	#=======================================

	private function add_news($error='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'add' );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;
		}

		if ( $this->trellis->user['rte_enable'] && $this->trellis->core->cache['settings']['news']['rte'] )
		{
			$this->output .= $this->trellis->skin->tinymce_js( 'content' );

			$html = 1;
		}
		else
		{
			$html = 0;
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=doadd", 'add_news', 'post' ) ."
						<input type='hidden' id='html' name='html' value='{$html}' />
						". $this->trellis->skin->start_group_table( '{lang.adding_news}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.title}', $this->trellis->skin->textfield( 'title' ), 'a', '20%', '80%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.excerpt} '. $this->trellis->skin->help_tip('{lang.tip_excerpt}'), $this->trellis->skin->textarea( 'excerpt', '', '', 0, 60, 2 ), 'a' ) ."
						<tr>
							<td class='option1'>{lang.options}</td>
							<td class='option1' style='font-weight: normal'>
								". $this->trellis->skin->checkbox( array( 'name' => 'allow_comments', 'title' => '{lang.allow_comments}', 'value' => 1, 'alert' => array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_comments}' ) ) ) ."&nbsp;&nbsp;
								". $this->trellis->skin->checkbox( 'email_users', '{lang.email_users} '. $this->trellis->skin->help_tip('{lang.tip_email_users}') ) ."
							</td>
						</tr>
						<tr>
							<td colspan='2' class='option2'>". $this->trellis->skin->textarea( array( 'name' => 'content', 'cols' => 80, 'rows' => 10, 'width' => '98%', 'height' => '230px' ) ) ."</td>
						</tr>
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_add_news}' ) ) ."
						</div>";

		$validate_fields = array(
								 'title'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_title}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('title');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=news' ),
							array( 'mails_arrow', '{lang.menu_mass_email}', '<! HD_URL !>/admin.php?section=tools&amp;page=email&amp;act=mass' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=news' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_news_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit News Form
	#=======================================

	private function edit_news($error='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'edit' );

		if ( ! $n = $this->trellis->news->get_single_by_id( 'all', $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_news');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;

			$content = $this->trellis->input['content'];
		}
		else
		{
			$content = $n['content'];
		}

		if ( $this->trellis->user['rte_enable'] && $this->trellis->core->cache['settings']['news']['rte'] )
		{
			$this->output .= $this->trellis->skin->tinymce_js( 'content' );

			$html = 1;
		}
		else
		{
			$html = 0;
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=doedit&amp;id={$n['id']}", 'edit_news', 'post' ) ."
						<input type='hidden' id='html' name='html' value='{$html}' />
						". $this->trellis->skin->start_group_table( '{lang.editing_news} '. $n['title'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.title}', $this->trellis->skin->textfield( 'title', $n['title'] ), 'a', '20%', '80%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.excerpt} '. $this->trellis->skin->help_tip('{lang.tip_excerpt}'), $this->trellis->skin->textarea( 'excerpt', $n['excerpt'], '', 0, 60, 2 ), 'a' ) ."
						<tr>
							<td class='option1'>{lang.options}</td>
							<td class='option1' style='font-weight: normal'>
								". $this->trellis->skin->checkbox( array( 'name' => 'allow_comments', 'title' => '{lang.allow_comments}', 'value' => $n['allow_comments'], 'alert' => array( 'check' => $this->trellis->core->cache['settings']['news']['comments'], 'for' => 1, 'msg' => '{lang.warn_comments}' ) ) ) ."
							</td>
						</tr>
						<tr>
							<td colspan='2' class='option2'>". $this->trellis->skin->textarea( array( 'name' => 'content', 'value' => $n['content'], 'cols' => 80, 'rows' => 10, 'width' => '98%', 'height' => '230px' ) ) ."</td>
						</tr>
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_news}' ) ) ."
						</div>";

		$validate_fields = array(
								 'title'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_title}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=news' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=news&amp;act=add' ),
							array( 'mails_arrow', '{lang.menu_mass_email}', '<! HD_URL !>/admin.php?section=tools&amp;page=email&amp;act=mass' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=news' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_news_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Add News
	#=======================================

	private function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'add' );

		if ( ! $this->trellis->input['title'] ) $this->add_news('no_title');
		if ( ! $this->trellis->remove_extra_lbs( $this->trellis->input['content'] ) ) $this->add_news('no_content');

		#=============================
		# Add News
		#=============================

		$db_array = array(
						  'uid'				=> $this->trellis->user['id'],
						  'title'			=> $this->trellis->input['title'],
						  'excerpt'			=> $this->trellis->input['excerpt'],
						  'content'			=> $this->trellis->input['content'],
						  'email'			=> $this->trellis->input['email_users'],
						  'allow_comments'	=> $this->trellis->input['allow_comments'],
						  'html'	        => $this->trellis->input['html'],
						  'date'			=> time(),
						  'ipadd'			=> $this->trellis->input['ip_address'],
						 );

		$news_id = $this->trellis->news->add( $db_array );

		$this->trellis->log( 'admin', "News Added &#039;". $this->trellis->input['title'] ."&#039;", 1, $news_id );

		#=============================
		# Send Email
		#=============================

		// TO BE COMPLETED

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->news_cache();

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $news_id;

		$this->view_news( array( 'alert' => 'news_added' ) );
	}

	#=======================================
	# @ Do Edit News
	#=======================================

	private function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'edit' );

		if ( ! $this->trellis->input['title'] ) $this->edit_news('no_title');
		if ( ! $this->trellis->remove_extra_lbs( $this->trellis->input['content'] ) ) $this->edit_news('no_content');

		#=============================
		# Update News
		#=============================

		$db_array = array(
						  'uid'				=> $this->trellis->user['id'],
						  'title'			=> $this->trellis->input['title'],
						  'excerpt'			=> $this->trellis->input['excerpt'],
						  'content'			=> $this->trellis->input['content'],
						  'allow_comments'	=> $this->trellis->input['allow_comments'],
						  'html'	        => $this->trellis->input['html'],
						 );

		$this->trellis->news->edit( $db_array, $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "News Edited &#039;". $this->trellis->input['title'] ."&#039;", 1, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->news_cache();

		#=============================
		# Do Output
		#=============================

		$this->view_news( array( 'alert' => 'news_updated' ) );
	}

	#=======================================
	# @ Do Delete News
	#=======================================

	private function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'delete' );

		#=============================
		# DELETE News
		#=============================

		$this->trellis->news->delete( $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "News Deleted &#039;". $this->trellis->core->cache['news'][ $this->trellis->input['id'] ]['title'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->news_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_news( 'news_deleted' );
	}

	#=======================================
	# @ Do Toggle Comments
	#=======================================

	private function do_toggle_comments()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'news', 'edit' );

		if ( ! $n = $this->trellis->news->get_single_by_id( array( 'id', 'title', 'allow_comments' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_news');

		#=============================
		# Edit New
		#=============================

		( $n['allow_comments'] ) ? $allow_comments = 0 : $allow_comments = 1;

		$this->trellis->news->edit( array( 'allow_comments' => $allow_comments ), $n['id'] );

		$this->trellis->log( 'admin', "News Item Comments State Modified &#039;". $n['title'] ."&#039;", 1, $n['id'] );

		#=============================
		# Do Output
		#=============================

		$this->view_news( array( 'alert' => 'news_updated' ) );
	}

	#=======================================
	# @ Do Add Comment
	#=======================================

	private function do_add_comment()
	{
		#=============================
		# Security Checks
		#=============================

		if ( $this->trellis->input['html'] )
		{
			$this->trellis->input['message'] = $this->trellis->remove_extra_lbs( $this->trellis->input['message'] );
		}

		if ( ! $this->trellis->input['message'] ) $this->view_news( array( 'comment_error' => 'no_message' ) );

		if ( ! $n = $this->trellis->news->get_single_by_id( array( 'id', 'title', 'allow_comments' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_news');

		if ( ! $this->trellis->core->cache['settings']['news']['comments'] || ! $n['allow_comments'] || ! $this->trellis->user['g_news_comment'] ) $this->trellis->skin->error('no_perm');

		#=============================
		# Add Comment
		#=============================

		$db_array = array(
						  'nid'			=> $n['id'],
						  'uid'			=> $this->trellis->user['id'],
						  'message'		=> $this->trellis->input['message'],
						  'staff'		=> 1,
						  'html'		=> $this->trellis->input['html'],
						  'date'		=> time(),
						  'ipadd'		=> $this->trellis->input['ip_address'],
						 );

		$comment_id = $this->trellis->news->add_comment( $db_array, $n['id'] );

		$this->trellis->log( 'admin', "News Item Comment Added &#039;". $n['title'] ."&#039;", 1, $n['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $n['id'];

		$this->view_news( array( 'comment' => $comment_id ) );
	}

	#=======================================
	# @ Do Edit Comment
	#=======================================

	private function do_edit_comment()
	{
		#=============================
		# Security Checks
		#=============================

		if ( $this->trellis->input['html'] )
		{
			$this->trellis->input['message'] = $this->trellis->remove_extra_lbs( $this->trellis->input['message'] );
		}

		if ( ! $this->trellis->input['message'] ) $this->trellis->skin->ajax_output( '0' );

		$c = $this->trellis->core->db->get_single( array(
						        						 'select'	=> array(
						        							   				 'c' => array( 'id', 'uid' ),
						        						   					 'n' => array( 'title' ),
								        					   			     ),
	        											 'from'	    => array( 'c' => 'news_comments' ),
			        									 'join'	    => array( array( 'from' => array( 'n' => 'news' ), 'where' => array( 'c' => 'nid', '=', 'n' => 'id' ) ) ),
					        							 'where'	=> array( array( 'c' => 'id' ), '=', $this->trellis->input['id'] ),
							        					 'limit'	=> array( 0, 1 ),
                                                  )      );

		if ( ! $c ) $this->trellis->skin->ajax_output( '0' );

		# Double Check Permission Logic Below...

		if ( ! $this->trellis->user['g_news_com_edit_all'] && ! ( $this->trellis->user['g_news_com_edit'] && $c['uid'] == $this->trellis->user['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		#=============================
		# Edit Reply
		#=============================

		$db_array = array(
						  'message'		=> $this->trellis->input['message'],
						  'html'		=> $this->trellis->input['html'],
						 );

		$this->trellis->news->edit_comment( $db_array, $c['id'] );

		$this->trellis->log( 'admin', "News Item Comment Edited &#039;". $c['title'] ."&#039;", 1, $c['nid'] );

		#=============================
		# Do Output
		#=============================

		$coutput_params = array( 'urls' => 1 );

		( $this->trellis->input['html'] ) ? $coutput_params['html'] = 1 : $coutput_params['nl2br'] = 1;

		$rmessage = $this->trellis->prepare_output( $this->trellis->input['message'], $coutput_params );

		/*if ( $r['signature'] )
		{
			$rmessage .= '<br /><br />'. $this->trellis->prepare_output( $r['usignature'], array( 'html' => $r['sig_html'] ) );
		}*/

		$this->trellis->skin->ajax_output( $rmessage );
	}

	#=======================================
	# @ Do Delete Comment
	#=======================================

	private function do_delete_comment()
	{
		#=============================
		# Security Checks
		#=============================

		$c = $this->trellis->core->db->get_single( array(
						        						 'select'	=> array(
						        							   				 'c' => array( 'id','nid', 'uid' ),
						        						   					 'n' => array( 'title' ),
								        					   			     ),
	        											 'from'	    => array( 'c' => 'news_comments' ),
			        									 'join'	    => array( array( 'from' => array( 'n' => 'news' ), 'where' => array( 'c' => 'nid', '=', 'n' => 'id' ) ) ),
					        							 'where'	=> array( array( 'c' => 'id' ), '=', $this->trellis->input['id'] ),
							        					 'limit'	=> array( 0, 1 ),
                                                  )      );

		if ( ! $c ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->trellis->user['g_news_com_delete_all'] && ! ( $this->trellis->user['g_news_com_delete'] && $c['uid'] == $this->trellis->user['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		#=============================
		# DELETE Comment
		#=============================

		$this->trellis->news->delete_comment( $c['id'], array( 'nid' => $c['nid'] ) );

		$this->trellis->log( 'admin', "News Item Comment Deleted &#039;". $c['title'] ."&#039;", 2, $c['nid'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->ajax_output( '1' );
	}

	#=======================================
	# @ AJAX Get Comment
	#=======================================

	private function ajax_get_comment()
	{
		$c = $this->trellis->news->get_single_comment_by_id( array( 'id', 'uid', 'message', 'html' ), $this->trellis->input['id'] );

		if ( ! $c ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->trellis->user['g_news_com_edit_all'] && ! ( $this->trellis->user['g_news_com_edit'] && $c['uid'] == $this->trellis->user['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		$this->trellis->skin->ajax_output( $this->trellis->prepare_output( $c['message'], array( 'html' => $c['html'] ) ) );
	}

}

?>