<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Source: Priorities
#======================================================
*/

class ad_priorities {

	private $output = "";

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		$this->trellis->check_perm( 'manage', 'priorities' );

		$this->trellis->load_functions('priorities');
		$this->trellis->ad_load_lang('priorities');

		$this->trellis->skin->set_active_link( 2 );

		switch( $this->trellis->input['act'] )
	    {
	    	case 'list':
				$this->list_priorities();
	    	break;
	    	case 'add':
	    		$this->add_priority();
	    	break;
	    	case 'edit':
	    		$this->edit_priority();
	    	break;
	    	case 'delete':
	    		$this->delete_priority();
	    	break;
	    	case 'reorder':
	    		$this->reorder_priorities();
	    	break;

	    	case 'upload':
	    		$this->do_upload();
	    	break;
	    	case 'imglist':
	    		$this->get_img_list();
	    	break;

	    	case 'doadd':
	    		$this->do_add();
	    	break;
	    	case 'doedit':
	    		$this->do_edit();
	    	break;
	    	case 'dodel':
	    		$this->do_delete();
	    	break;
	    	case 'default':
	    		$this->do_default();
	    	break;
	    	case 'doreorder':
	    		$this->do_reorder();
	    	break;

	    	default:
	    		$this->list_priorities();
	    	break;
		}
	}

	#=======================================
	# @ List Priorities
	#=======================================

	private function list_priorities($error='', $alert='')
	{
		#=============================
		# Grab Priorities
		#=============================

		$priority_rows = "";

		if ( ! $priorities = $this->trellis->priorities->get( array( 'select' => array( 'id', 'name', 'icon_regular', 'default' ), 'order' => array( 'position' => 'asc' ) ) ) )
		{
			$priority_rows .= "<tr><td class='bluecell-light' colspan='5'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add'>{lang.no_priorities}</a></strong></td></tr>";
		}
		else
		{
			foreach( $priorities as $pid => $p )
			{
				if ( ! $p['default'] )
				{
					$p['default_button'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=default&amp;id={$p['id']}'>{$p['default']}</a>";
					$p['delete_button'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=delete&amp;id={$p['id']}'><img src='<! IMG_DIR !>/button_delete.gif' alt='{lang.delete}' /></a>";
				}

				$priority_rows .= "<tr>
									<td class='bluecellthin-light'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;fpriority". urlencode('[]') ."={$p['id']}'><strong>{$p['id']}</strong></a></td>
									<td class='bluecellthin-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;fpriority". urlencode('[]') ."={$p['id']}'><img src='<! UPLD_URL !>/priorities/{$p['icon_regular']}' alt='{$p['name']}' class='prioritybox' />&nbsp;&nbsp;{$p['name']}</a></td>
									<td class='bluecellthin-light' align='center'>{$p['default_button']}</td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=edit&amp;id={$p['id']}'><img src='<! IMG_DIR !>/button_edit.gif' alt='{lang.edit}' /></a></td>
									<td class='bluecellthin-light' align='center'>{$p['delete_button']}</td>
								</tr>";
			}
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
		}
		elseif ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.priorities_list}' ) ."
						<tr>
							<th class='bluecellthin-th' width='2%' align='left'>{lang.id}</th>
							<th class='bluecellthin-th' width='89%' align='left'>{lang.name}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.default}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.edit}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.delete}</th>
						</tr>
						". $priority_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add' ),
							array( 'arrow_switch', '{lang.menu_reorder}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=reorder' ),
							array( 'compile', '{lang.menu_cache}', '<! HD_URL !>/admin.php?section=tools&amp;page=cache&amp;act=rebuild&amp;id=priorities' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_priorities_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_priorities_title}', '{lang.help_about_priorities_msg}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add Priority
	#=======================================

	private function add_priority($error='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'add' );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;
		}

		$img_html = "<table width='100%' cellpadding='0' cellspacing='0'>
					<tr>
						<td width='25%' valign='top'>
							{lang.icon_regular}<br />
							<select name='icon_regular' id='icon_regular' style='margin-top:6px'>". $this->icon_drop_down( $this->trellis->input['icon_regular'] ) ."</select>
							<div id='regular_preview' style='margin-top:12px'>
								<span id='regular_preview_img'></span>&nbsp;<span id='regular_preview_text'></span>
							</div>
						</td>
						<td width='25%' valign='top'>
							{lang.icon_assigned}<br />
							<select name='icon_assigned' id='icon_assigned' style='margin-top:6px'>". $this->icon_drop_down( $this->trellis->input['icon_assigned'] ) ."</select>
							<div id='assigned_preview' style='margin-top:12px'>
								<span id='assigned_preview_img'></span>&nbsp;<span id='assigned_preview_text'></span>
							</div>
						</td>
						<td width='50%' valign='top'>
							<div id='icon_regular_upload'></div>
							<div id='upload_msg' style='display:none;margin-top:12px'>{lang.upload_success}</div>
						</td>
					</tr>
					</table>";

		$this->output .= "<script src='includes/uploadify/jquery.uploadify.js' type='text/javascript'></script>
						<script type='text/javascript'>
						$(function() {
							updateRegularPreview();
							updateAssignedPreview();

							$('#name').keyup(function() {
								updateRegularPreview();
								updateAssignedPreview();
							});

							$('#icon_regular').change(function() {
								updateRegularPreview();
							});

							$('#icon_assigned').change(function() {
								updateAssignedPreview();
							});
						});

						function updateRegularPreview() {
							$('#regular_preview_img').html(\"<img src='<! UPLD_URL !>/priorities/\"+$('#icon_regular').val()+\"' alt='*' class='prioritybox' />\");
							if ( $('#name').val() ) $('#regular_preview_text').text( $('#name').val() );
						}

						function updateAssignedPreview() {
							$('#assigned_preview_img').html(\"<img src='<! UPLD_URL !>/priorities/\"+$('#icon_assigned').val()+\"' alt='*' class='prioritybox' />\");
							if ( $('#name').val() ) $('#assigned_preview_text').text( $('#name').val() );
						}

						$(function() {
							$('#icon_regular_upload').fileUpload({
								'uploader': 'includes/uploadify/uploader.swf',
								'script': 'admin.php',
								'cancelImg': '<! IMG_DIR !>/icon_cross.png',
								'scriptData': {
									'section': 'manage',
									'page': 'priorities',
									'act': 'upload',
									'session_id': '". $this->trellis->user['s_id'] ."'
								},
								'auto': true,
								'fileDesc': 'Image Files(*.gif, *.jpg, *.jpeg, *.png, *.svg, *.tiff)',
								'fileExt': '*.gif;*.jpg;*.jpeg;*.png;*.svg;*.tiff',
								'simUploadLimit': 1,
								'buttonImg': '<! IMG_DIR !>/button_upload.gif',
								'hideButton': true,
								'width': '90px',
								'height': '22px',
								'wmode': 'transparent',
								'onComplete': function(event,queueID,fileObj,response,data) {
									$('#icon_regular').append(\"<option value='\"+response+\"'>\"+response+\"</option>\");
									$('#icon_assigned').append(\"<option value='\"+response+\"'>\"+response+\"</option>\");
									$('#upload_msg').show('blind');
									$('#upload_msg').animate({opacity: 1.0}, 5000);
									$('#upload_msg').hide('blind');
								}
							});
						});
						</script>
						<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=doadd", 'add_priority', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.adding_priority}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.name}', $this->trellis->skin->textfield( 'name' ), 'a', '16%', '84%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.icon} '. $this->trellis->skin->help_tip('{lang.tip_icon}'), $img_html, 'a' ) ."
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_add_priority}' ) ) ."
						</div>";

		$validate_fields = array(
								 'name'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_name}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('name');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_priorities_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit Priority
	#=======================================

	private function edit_priority($error="")
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'edit' );

		#=============================
		# Grab Priority
		#=============================

		if ( ! $p = $this->trellis->priorities->get_single_by_id( array( 'id', 'name', 'icon_regular', 'icon_assigned' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_priority');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;

			$icon_regular = $this->trellis->input['icon_regular'];
			$icon_assigned = $this->trellis->input['icon_assigned'];
		}
		else
		{
			$icon_regular = $p['icon_regular'];
			$icon_assigned = $p['icon_assigned'];
		}

		$img_html = "<table width='100%' cellpadding='0' cellspacing='0'>
					<tr>
						<td width='25%' valign='top'>
							{lang.icon_regular}<br />
							<select name='icon_regular' id='icon_regular' style='margin-top:6px'>". $this->icon_drop_down( $icon_regular ) ."</select>
							<div id='regular_preview' style='margin-top:12px'>
								<span id='regular_preview_img'></span>&nbsp;<span id='regular_preview_text'></span>
							</div>
						</td>
						<td width='25%' valign='top'>
							{lang.icon_assigned}<br />
							<select name='icon_assigned' id='icon_assigned' style='margin-top:6px'>". $this->icon_drop_down( $icon_assigned ) ."</select>
							<div id='assigned_preview' style='margin-top:12px'>
								<span id='assigned_preview_img'></span>&nbsp;<span id='assigned_preview_text'></span>
							</div>
						</td>
						<td width='50%' valign='top'>
							<div id='icon_regular_upload'></div>
							<div id='upload_msg' style='display:none;margin-top:12px'>{lang.upload_success}</div>
						</td>
					</tr>
					</table>";

		$this->output .= "<script src='includes/uploadify/jquery.uploadify.js' type='text/javascript'></script>
						<script type='text/javascript'>
						$(function() {
							updateRegularPreview();
							updateAssignedPreview();

							$('#name').keyup(function() {
								updateRegularPreview();
								updateAssignedPreview();
							});

							$('#icon_regular').change(function() {
								updateRegularPreview();
							});

							$('#icon_assigned').change(function() {
								updateAssignedPreview();
							});
						});

						function updateRegularPreview() {
							$('#regular_preview_img').html(\"<img src='<! UPLD_URL !>/priorities/\"+$('#icon_regular').val()+\"' alt='*' class='prioritybox' />\");
							if ( $('#name').val() ) $('#regular_preview_text').text( $('#name').val() );
						}

						function updateAssignedPreview() {
							$('#assigned_preview_img').html(\"<img src='<! UPLD_URL !>/priorities/\"+$('#icon_assigned').val()+\"' alt='*' class='prioritybox' />\");
							if ( $('#name').val() ) $('#assigned_preview_text').text( $('#name').val() );
						}

						$(function() {
							$('#icon_regular_upload').fileUpload({
								'uploader': 'includes/uploadify/uploader.swf',
								'script': 'admin.php',
								'cancelImg': '<! IMG_DIR !>/icon_cross.png',
								'scriptData': {
									'section': 'manage',
									'page': 'priorities',
									'act': 'upload',
									'session_id': '". $this->trellis->user['s_id'] ."'
								},
								'auto': true,
								'fileDesc': 'Image Files(*.gif, *.jpg, *.jpeg, *.png, *.svg, *.tiff)',
								'fileExt': '*.gif;*.jpg;*.jpeg;*.png;*.svg;*.tiff',
								'simUploadLimit': 1,
								'buttonImg': '<! IMG_DIR !>/button_upload.gif',
								'hideButton': true,
								'width': '90px',
								'height': '22px',
								'wmode': 'transparent',
								'onComplete': function(event,queueID,fileObj,response,data) {
									$('#icon_regular').append(\"<option value='\"+response+\"'>\"+response+\"</option>\");
									$('#icon_assigned').append(\"<option value='\"+response+\"'>\"+response+\"</option>\");
									$('#upload_msg').show('blind');
									$('#upload_msg').animate({opacity: 1.0}, 5000);
									$('#upload_msg').hide('blind');
								}
							});
						});
						</script>
						<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=doedit&amp;id={$p['id']}", 'edit_priority', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.editing_priority}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.name}', $this->trellis->skin->textfield( 'name', $p['name'] ), 'a', '16%', '84%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.icon} '. $this->trellis->skin->help_tip('{lang.tip_icon}'), $img_html, 'a' ) ."
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_priority}' ) ) ."
						</div>";

		$validate_fields = array(
								 'name'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_name}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_priorities_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Delete Priority Form
	#=======================================

	private function delete_priority()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'delete' );

		if ( ! $p = $this->trellis->priorities->get_single_by_id( array( 'id', 'name' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_priority');

		#=============================
		# Do Output
		#=============================

		$this->trellis->load_functions('drop_downs');

		$this->output = "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=dodel&amp;id={$p['id']}", 'delete_priority', 'post' ) ."
						". $this->trellis->skin->group_title( '{lang.deleting_priority} '. $p['name'] ) ."
						". $this->trellis->skin->group_sub( '{lang.delete_priority_tickets_qs}' ) ."
						<div class='option1'><input type='radio' name='action' id='action1' value='1' checked='checked' /> <label for='action1'>{lang.change_tickets_to_priority}</label> <select name='changeto'>". $this->trellis->drop_downs->priority_drop( array( 'exclude' => $p['id'] ) ) ."</select></div>
						<div class='option2'><input type='radio' name='action' id='action2' value='2' /> <label for='action2'>{lang.delete_tickets}</label></div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'delete', '{lang.button_delete_priority}' ) ) ."
						</div>";

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_priorities_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Reorder Priorities
	#=======================================

	private function reorder_priorities()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'reorder' );

		#=============================
		# Do Output
		#=============================

		$this->output = "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=doreorder", 'reorder_priorities', 'post' ) ."
						". $this->trellis->skin->group_title( '{lang.reordering_priorities}' ) ."
						". $this->trellis->skin->group_sub( '{lang.reorder_priorities_msg}' ) ."
						<input type='hidden' name='order' id='order' value='' />";

		if ( ! $priorities = $this->trellis->priorities->get( array( 'select' => array( 'id', 'name', 'icon_regular' ), 'order' => array( 'position' => 'asc' ) ) ) )
		{
			$this->output .= "<div class='bluecell-light'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add'>{lang.no_priorities}</a></strong></div>";
		}
		else
		{
			$this->output .= "<ul class='draggable' id='sortable'>";

			foreach( $priorities as $pid => $p )
			{
				$this->output .= "<li class='bluecell-light' id='p_{$p['id']}'><img src='<! UPLD_URL !>/priorities/{$p['icon_regular']}' alt='{$p['name']}' />&nbsp;&nbsp;{$p['name']}</li>";
			}

			$this->output .= "</ul>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'reorder', '{lang.button_reorder_priorities}' ) ) ."
						</div>
						<script type='text/javascript' language='javascript'>
							$(function() {
								$('#sortable').sortable({
									stop: function() {
										$('#order').val( $('#sortable').sortable('serialize') );
									}
								});
							});
						</script>";
		}

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=priorities&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_priorities_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Add Priority
	#=======================================

	private function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'add' );

		if ( ! $this->trellis->input['name'] ) $this->add_priority('no_name');

		#=============================
		# Add Priority
		#=============================

		$db_array = array(
						  'name'			=> $this->trellis->input['name'],
						  'icon_regular'	=> $this->trellis->input['icon_regular'],
						  'icon_assigned'	=> $this->trellis->input['icon_assigned'],
						  );

		$priority_id = $this->trellis->priorities->add( $db_array );

		$this->trellis->log( 'admin', "Ticket Priority Added &#039;". $this->trellis->input['name'] ."&#039;", 1, $priority_id );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->priorities_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_priorities( NULL, 'priority_added' );
	}

	#=======================================
	# @ Do Edit Priority
	#=======================================

	private function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'edit' );

		if ( ! $this->trellis->input['name'] ) $this->edit_priority('no_name');

		#=============================
		# Update Priority
		#=============================

		$db_array = array(
						  'name'			=> $this->trellis->input['name'],
						  'icon_regular'	=> $this->trellis->input['icon_regular'],
						  'icon_assigned'	=> $this->trellis->input['icon_assigned'],
						  );

		$this->trellis->priorities->edit( $db_array, $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "Ticket Priority Updated &#039;". $this->trellis->input['name'] ."&#039;", 1, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->priorities_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_priorities( NULL, 'priority_updated' );
	}

	#=======================================
	# @ Do Delete Priority
	#=======================================

	private function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'delete' );

		if ( $this->trellis->core->cache['priorities'][ $this->trellis->input['id'] ]['default'] ) $this->list_priorities( 'cannot_delete_default' );

		#=============================
		# DELETE Priority
		#=============================

		$this->trellis->priorities->delete( $this->trellis->input['id'], $this->trellis->input['action'], $this->trellis->input['changeto'] );

		$this->trellis->log( 'admin', "Ticket Priority Deleted &#039;". $this->trellis->core->cache['priorities'][ $this->trellis->input['id'] ]['name'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->priorities_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_priorities( 'priority_deleted' );
	}

	#=======================================
	# @ Do Default Priority
	#=======================================

	private function do_default()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities' );

		#=============================
		# Default Priority
		#=============================

		$this->trellis->priorities->set_default( $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "Ticket Priority &#039;". $p['name'] ."&#039; Set As Default", 1, $p['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->priorities_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_priorities( NULL, 'priority_default' );
	}

	#=======================================
	# @ Do Reorder Priorities
	#=======================================

	private function do_reorder()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities', 'reorder' );

		#=============================
		# Reorder Priorities
		#=============================

		parse_str( str_replace( '&amp;', '&', $this->trellis->input['order'] ), $order );

		if ( empty( $order['p'] ) ) $this->list_priorities( 'no_reorder' );

		if ( $priorities = $this->trellis->priorities->get( array( 'select' => array( 'id', 'position' ) ) ) )
		{
			foreach ( $order['p'] as $position => $pid )
			{
				$position ++;

				if ( $position != $priorities[ $pid ]['position'] )
				{
					$this->trellis->priorities->edit( array( 'position' => $position ), $pid );
				}
			}
		}

		$this->trellis->log( 'admin', "Priorities Reordered" );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->priorities_cache();

		#=============================
		# Do Output
		#=============================

		$this->list_priorities( NULL, 'priorities_reordered');
	}

	#=======================================
	# @ Do Upload Priority
	#=======================================

	private function do_upload()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'priorities' );

		if ( ! $_FILES['Filedata'] )
		{
			header('HTTP/1.1 500 Internal Server Error');
			die("0");
		}

		$allowed_exts = array( '.gif', '.jpg', '.jpeg', '.png', '.svg', '.tiff' );

		$file_ext = strrchr( $_FILES['Filedata']['name'], "." );

		if ( ! in_array( $file_ext, $allowed_exts ) )
		{
			header('HTTP/1.1 500 Internal Server Error');
			die("0");
		}

		#=============================
		# Upload Image
		#=============================

		$file_name = $this->sanitize_name( $_FILES['Filedata']['name'] );
		$upload_location = $this->trellis->core->cache['settings']['general']['upload_dir'] .'/priorities/'. $file_name;

		if ( ! @move_uploaded_file( $_FILES['Filedata']['tmp_name'], $upload_location ) )
		{
			header('HTTP/1.1 500 Internal Server Error');
			die("0");
		}

		@chmod( $upload_location, 0777 );

		#=============================
		# Do Output
		#=============================

		print $file_name;

		exit();
	}

	#=======================================
	# @ Sanitize Name
	#=======================================

	private function sanitize_name($name)
	{
		$name = str_replace( " ", "_", $name );

		return ereg_replace( "[^A-Za-z0-9_\.]", "", $name );
	}

	#=======================================
	# @ Icon Drop Down
	#=======================================

	private function icon_drop_down($select)
	{
		$html = "";

		if ( @ $files = scandir( $this->trellis->core->cache['settings']['general']['upload_dir'] .'/priorities' ) )
		{
			foreach( $files as $fid => $fname )
			{
				if ( $fname != '.' && $fname != '..' )
				{
					if ( $fname == $select )
					{
						$html .= "<option value='". $fname ."' selected='yes'>". $fname ."</option>";
					}
					else
					{
						$html .= "<option value='". $fname ."'>". $fname ."</option>";
					}
				}
			}
		}

		return $html;
	}

}

?>