<?php

/*
#======================================================
|	Trellis Desk
|	=====================================
|	By DJ Tarazona (dj@accord5.com)
|	(c) 2010 ACCORD5
|	http://www.trellisdesk.com/
|	=====================================
|	Email: sales@accord5.com
#======================================================
|	@ Version: v2.0 Aplha 1 Build 20011028
|	@ Version Int: 200.1.1.028
|	@ Version Num: 20011028
|	@ Build: 0028
#======================================================
|	| Admin Source: Tickets
#======================================================
*/

class ad_tickets {

	private $output = "";

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		$this->trellis->check_perm( 'manage', 'tickets' );

		$this->trellis->load_functions('tickets');
		$this->trellis->ad_load_lang('tickets');

		$this->trellis->skin->set_active_link( 2 );

		// ACP Department Permissions
		$this->trellis->user['g_acp_depart_perm'] = unserialize( $this->trellis->user['g_acp_depart_perm'] );

		switch( $this->trellis->input['act'] )
		{
			case 'list':
				$this->list_tickets();
			break;
			case 'view':
				$this->view_ticket();
			break;
			case 'add':
				$this->add_ticket();
			break;
			case 'edit':
				$this->edit_ticket();
			break;

			case 'doaddassign':
				$this->ajax_add_assign();
			break;
			case 'doaddflag':
				$this->ajax_add_flag();
			break;
			case 'dodelassign':
				$this->ajax_delete_assign();
			break;
			case 'dodelflag':
				$this->ajax_delete_flag();
			break;
			case 'donotes':
				$this->ajax_save_notes();
			break;
			case 'dodefaults':
				$this->ajax_save_defaults();
			break;

			case 'getstatus':
				$this->ajax_get_status();
			break;
			case 'getrt':
				$this->ajax_get_reply_template();
			break;

			case 'doaccept':
				$this->do_accept();
			break;
			case 'doescalate':
				$this->do_escalate();
			break;
			case 'dormvescalate':
				$this->do_rmvescalate();
			break;
			case 'dohold':
				$this->do_hold();
			break;
			case 'dormvhold':
				$this->do_rmvhold();
			break;
			case 'domove':
				$this->do_move();
			break;
			case 'doclose':
				$this->do_close();
			break;
			case 'doreopen':
				$this->do_reopen();
			break;

			case 'dopriority':
				$this->do_priority();
			break;
			case 'dostatus':
				$this->do_status();
			break;

			case 'doadd':
				$this->do_add();
			break;
			case 'doedit':
				$this->do_edit();
			break;
			case 'dodel':
				$this->do_delete();
			break;

			case 'doaddreply':
				$this->do_add_reply();
			break;
			case 'doeditreply':
				$this->do_edit_reply();
			break;
			case 'dodelreply':
				$this->do_delete_reply();
			break;

			case 'getreply':
				$this->ajax_get_reply();
			break;

			default:
				$this->list_tickets();
			break;
		}
	}

	#=======================================
	# @ List Tickets
	#=======================================

	private function list_tickets($error='', $alert='')
	{
		#=============================
		# Table Columns
		#=============================

		$columns = unserialize( $this->trellis->user['columns_tm'] );

		if ( empty( $columns ) )
		{
			$columns = array( 'id' => '6%', 'subject' => '31%', 'priority' => '14%', 'department' => '19%', 'reply' => '17%', 'status' => '13%' );
		}

		$lang_columns = array(
							  'id'			=> '{lang.id}',
							  'mask'		=> '{lang.mask}',
							  'subject'		=> '{lang.subject}',
							  'priority'	=> '{lang.priority}',
							  'department'	=> '{lang.department}',
							  'date'		=> '{lang.submitted}',
							  'reply'		=> '{lang.last_reply}',
							  'replystaff'	=> '{lang.last_staff_reply}',
							  'lastuname'	=> '{lang.last_replier}',
							  'submitter'	=> '{lang.submitter}',
							  'email'		=> '{lang.email}',
							  'replies'		=> '{lang.replies}',
							  'status'		=> '{lang.status}',
							  );

		$dark_columns = array( 'subject', 'date', 'last_reply' );
		$normal_columns = array( 'dname', 'date', 'last_reply' );

		$sql_select = array();
		$sql_columns = array();
		$sql_join = array();

		#=============================
		# Default Sort / Limits
		#=============================

		if ( ! $this->trellis->input['sort'] )
		{
			if ( isset( $columns[ $this->trellis->user['sort_tm'] ] ) ) $this->trellis->input['sort'] = $this->trellis->user['sort_tm'];
		}

		$column_sort = array( 'reply', 'date', 'mask', 'replystaff', 'subject', 'priority', 'department', 'mname', 'lastuname', 'email', 'status', 'replies' );

		for ( $i = 0; ! $this->trellis->input['sort'] && $i < count( $column_sort ); $i++ )
		{
			if ( $columns[ $column_sort[ $i ] ] ) $this->trellis->input['sort'] = $column_sort[ $i ];
		}

		if ( ! $this->trellis->input['sort'] ) $this->trellis->input['sort'] = 'id';

		if ( ! $this->trellis->input['order'] )
		{
			( $this->trellis->user['order_tm'] ) ? $this->trellis->input['order'] = 'desc' : $this->trellis->input['order'] = 'asc';
		}

		#=============================
		# Prepare Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
		}
		elseif ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.tickets_list}' ) ."
						<tr>";

		#=============================
		# Sort
		#=============================

		foreach( $columns as $name => $width )
		{
			if ( $name == $this->trellis->input['sort'] )
			{
				if ( $this->trellis->input['order'] == 'desc' )
				{
					$link_order = 'asc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_up.gif" alt="{lang.up}" />';
					$sql_order = 'desc';
				}
				else
				{
					$link_order = 'desc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_down.gif" alt="{lang.down}" />';
					$sql_order = 'asc';
				}

				if ( $name == 'department' )
				{
					$sql_sort_table = 'd';
					$sql_sort_field = 'name';
				}
				elseif ( $name == 'priority' )
				{
					$sql_sort_table = 'p';
					$sql_sort_field = 'position';
				}
				elseif ( $name == 'reply' )
				{
					$sql_sort_table = 't';
					$sql_sort_field = 'last_reply';
				}
				elseif ( $name == 'replystaff' )
				{
					$sql_sort_table = 't';
					$sql_sort_field = 'last_reply_staff';
				}
				elseif ( $name == 'lastuname' )
				{
					$sql_sort_table = 'ulr';
					$sql_sort_field = 'name';
				}
				elseif ( $name == 'status' )
				{
					$sql_sort_table = 's';
					$sql_sort_field = 'name_staff';
				}
				elseif ( $name == 'submitter' )
				{
					$sql_sort_table = 'u';
					$sql_sort_field = 'name';
				}
				elseif ( strpos( $name, 'cfd' ) === 0 || strpos( $name, 'cfp' ) === 0 )
				{
					$sql_sort_table = $name;
					$sql_sort_field = 'data';
				}
				else
				{
					$sql_sort_table = 't';
					$sql_sort_field = $name;
				}
			}
			else
			{
				$link_order = 'asc';
				$img_order = '';
			}

			if ( strpos( $name, 'cfd' ) === 0 )
			{
				$lang_columns[ $name ] = $this->trellis->core->cache['dfields'][ substr( $name, 3) ]['name'];
			}
			elseif ( strpos( $name, 'cfp' ) === 0 )
			{
				$lang_columns[ $name ] = $this->trellis->core->cache['pfields'][ substr( $name, 3) ]['name'];
			}

			$this->output .= "<th class='bluecellthin-th' width='{$width}%' align='left'><a href='". $this->generate_url( array( 'sort' => $name, 'order' => $link_order ) ) ."'>{$lang_columns[ $name ]}{$img_order}</a></th>";

			if ( $name == 'department' )
			{
				$sql_select['d'] = array( array( 'name' => 'dname' ) );

				$sql_join[] = array( 'from' => array( 'd' => 'departments' ), 'where' => array( 't' => 'did', '=', 'd' => 'id' ) );
			}
			elseif ( $name == 'priority' )
			{
				$sql_select['p'] = array( array( 'name' => 'pname' ), 'icon_regular', 'icon_assigned' );

				$sql_join[] = array( 'from' => array( 'p' => 'priorities' ), 'where' => array( 't' => 'priority', '=', 'p' => 'id' ) );
			}
			elseif ( $name == 'status' )
			{
				$sql_select['s'] = array( 'name_staff', 'abbr_staff' );

				$sql_join[] = array( 'from' => array( 's' => 'statuses' ), 'where' => array( 't' => 'status', '=', 's' => 'id' ) );
			}
			elseif ( $name == 'submitter' )
			{
				$sql_select['u'] = array( array( 'name' => 'uname' ) );

				$sql_join[] = array( 'from' => array( 'u' => 'users' ), 'where' => array( 't' => 'uid', '=', 'u' => 'id' ) );

				$sql_columns[] = 'uid';
			}
			elseif ( $name == 'lastuname' )
			{
				$sql_select['ulr'] = array( array( 'name' => 'last_uname' ) );

				$sql_join[] = array( 'from' => array( 'ulr' => 'users' ), 'where' => array( 't' => 'last_uid', '=', 'ulr' => 'id' ) );

				$sql_columns[] = 'last_uid';
			}
			elseif ( strpos( $name, 'cfd' ) === 0 )
			{
				$sql_select[ $name ] = array( array( 'data' => $name ) );

				$sql_join[] = array( 'from' => array( $name => 'depart_fields_data' ), 'where' => array( array( 't' => 'id', '=', $name => 'tid' ), array( $name => 'fid', '=', substr( $name, 3 ) ) ) );
			}
			elseif ( strpos( $name, 'cfp' ) === 0 )
			{
				$sql_select[ $name ] = array( array( 'data' => $name ) );

				$sql_join[] = array( 'from' => array( $name => 'profile_fields_data' ), 'where' => array( array( 't' => 'uid', '=', $name => 'uid' ), array( $name => 'fid', '=', substr( $name, 3 ) ) ) );
			}
			else
			{
				if ( $name == 'reply' )
				{
					$name = 'last_reply';
				}
				elseif ( $name == 'replystaff' )
				{
					$name = 'last_reply_staff';
				}

				$sql_columns[] = $name;
			}
		}

		$this->output .= "<th class='bluecellthin-th' width='1%' align='center'><input name='checkall' id='checkall' type='checkbox' value='1' /></th>
						</tr>";

		#=============================
		# Filter
		#=============================

		if ( ! $this->trellis->input['cf'] )
		{
			if ( ! is_array( $this->trellis->input['fstatus'] ) )
			{
				$this->trellis->input['fstatus'] = unserialize( $this->trellis->user['dfilters_status'] );
			}

			if ( ! is_array( $this->trellis->input['fdepart'] ) )
			{
				$this->trellis->input['fdepart'] = unserialize( $this->trellis->user['dfilters_depart'] );
			}

			if ( ! is_array( $this->trellis->input['fpriority'] ) )
			{
				$this->trellis->input['fpriority'] = unserialize( $this->trellis->user['dfilters_priority'] );
			}
		}

		$filters = array();
		$sql_where = array();

		/*if ( $this->trellis->input['my'] )
		{
			$filters[] = array( array( 't' => 'auid' ), '=', $this->trellis->input['my'] );
		}*/

		if ( $this->trellis->input['field'] )
		{
			$strict_fields = array( 'id', 'uid' );

			if ( in_array( $this->trellis->input['field'], $strict_fields) )
			{
				$filters[] = array( array( 't' => $this->trellis->input['field'] ), '=', $this->trellis->input['search'] );
			}
			else
			{
				$filters[] = array( array( 't' => $this->trellis->input['field'] ), 'like', '%'. addcslashes( $this->trellis->input['search'], '%_' ) .'%' );
			}
		}

		if ( is_array( $this->trellis->input['fstatus'] ) )
		{
			$filters[] = array( array( 't' => 'status' ), 'in', $this->trellis->input['fstatus'] );
		}

		if ( is_array( $this->trellis->input['fdepart'] ) )
		{
			$filters[] = array( array( 't' => 'did' ), 'in', $this->trellis->input['fdepart'] );
		}

		if ( is_array( $this->trellis->input['fpriority'] ) )
		{
			$filters[] = array( array( 't' => 'priority' ), 'in', $this->trellis->input['fpriority'] );
		}

		#=============================
		# Permissions
		#=============================

		if ( $this->trellis->user['id'] != 1 )
		{
			$perms = array();

			if( is_array( $this->trellis->user['g_acp_depart_perm'] ) )
			{
				foreach( $this->trellis->user['g_acp_depart_perm'] as $did => $dperm )
				{
					if ( $dperm['v'] ) $perms[] = $did;
				}
			}

			if ( empty( $perms ) ) $perms[] = 0;

			$filters[] = array( array( 't' => 'did' ), 'in', $perms );
		}

		#=============================
		# Grab Tickets
		#=============================

		foreach( $filters as $fdata )
		{
			if ( ! empty( $sql_where ) ) $fdata[] = 'and';

			$sql_where[] = $fdata;
		}

		$sql_columns[] = 'escalated';

		if ( ! in_array( 'id', $sql_columns ) ) $sql_columns[] = 'id';

		$sql_select['t'] = $sql_columns;

		$ticket_rows = '';

		$t_total = $this->trellis->tickets->get( array(
													   'select'	=> $sql_select,
													   'from'	=> array( 't' => 'tickets' ),
													   'join'	=> $sql_join,
													   'where'	=> $sql_where,
													   'order'	=> array( $sql_sort_field => array( $sql_sort_table => $sql_order ) ),
												)	   );

		$tickets = $this->trellis->tickets->get( array(
													   'select'	=> $sql_select,
													   'from'	=> array( 't' => 'tickets' ),
													   'join'	=> $sql_join,
													   'where'	=> $sql_where,
													   'order'	=> array( $sql_sort_field => array( $sql_sort_table => $sql_order ) ),
													   'limit'	=> array( $this->trellis->input['st'], 15 ),
												)	   );

		if ( count( $tickets ) && $this->trellis->input['field'] == 'id' )
		{
			$this->trellis->input['id'] = $tickets[0]['id'];

			$this->show_ticket();
		}

		if ( count( $tickets ) == 1 && $this->trellis->input['field'] == 'mask' )
		{
			$this->trellis->input['id'] = $tickets[0]['id'];

			$this->show_ticket();
		}

		if ( ! $tickets )
		{
			$ticket_rows .= "<tr><td class='bluecell-light' colspan='". ( count( $columns ) + 1 ) ."'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=add'>{lang.no_tickets}</a></strong></td></tr>";
		}
		else
		{
			foreach( $tickets as $t )
			{
				if ( $t['date'] ) $t['date'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'short' ) );
				if ( $t['last_reply'] ) $t['last_reply'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'short' ) );
				( $t['last_reply_staff'] ) ? $t['last_reply_staff'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply_staff'], 'format' => 'short' ) ) : $t['last_reply_staff'] = '';

				if ( $t['uname'] ) $t['uname'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['uid']}'>{$t['uname']}</a>";
				if ( $t['last_uname'] ) $t['last_uname'] = "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['last_uid']}'>{$t['last_uname']}</a>";

				$ticket_rows .= "<tr>";

				foreach( $columns as $name => $width )
				{
					if ( $name == 'department' )
					{
						$name = 'dname';
					}
					elseif ( $name == 'priority' )
					{
						$name = 'pname';
					}
					elseif ( $name == 'reply' )
					{
						$name = 'last_reply';
					}
					elseif ( $name == 'replystaff' )
					{
						$name = 'last_reply_staff';
					}
					elseif ( $name == 'submitter' )
					{
						$name = 'uname';
					}
					elseif ( $name == 'lastuname' )
					{
						$name = 'last_uname';
					}
					elseif ( $name == 'status' )
					{
						( $t['abbr_staff'] ) ? $name = 'abbr_staff' : $name = 'name_staff';
					}

					( in_array( $name, $dark_columns ) ) ? $dark = 1 : $dark = 0;
					( in_array( $name, $normal_columns ) ) ? $normal = 1 : $normal = 0;

					$ticket_rows .= "<td class='bluecellthin-";

					if ( $dark )
					{
						$ticket_rows .= "dark";
					}
					else
					{
						$ticket_rows .= "light";
					}

					$ticket_rows .= "'";

					if ( $normal ) $ticket_rows .= " style='font-weight: normal'";

					$ticket_rows .= ">";

					if ( $name == 'id' || $name == 'mask' || $name == 'subject' ) $ticket_rows .= "<a href='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=view&amp;id={$t['id']}'>";

					if ( $name == 'id' ) $ticket_rows .= "<strong>";

					if ( $name == 'subject' )
					{
						if ( $t['escalated'] ) $ticket_rows .= "<img src='<! IMG_DIR !>/icon_escalate.png' alt='E' style='vertical-align:middle;margin-bottom:2px' />&nbsp;";
					}

					if ( $name == 'pname' )
					{
						if ( $t['auid'] == $this->trellis->user['id'] )
						{
							$ticket_rows .= "<img src='<! UPLD_URL !>/priorities/{$t['icon_assigned']}' alt='{$t['pname']}' class='prioritybox' />&nbsp;&nbsp;";
						}
						else
						{
							$ticket_rows .= "<img src='<! UPLD_URL !>/priorities/{$t['icon_regular']}' alt='{$t['pname']}' class='prioritybox' />&nbsp;&nbsp;";
						}
					}

					if ( strpos( $name, 'cfd' ) === 0 || strpos( $name, 'cfp' ) === 0 )
					{
						if ( strpos( $name, 'cfd' ) === 0 )
						{
							$f = $this->trellis->core->cache['dfields'][ substr( $name, 3 ) ];
						}
						elseif ( strpos( $name, 'cfp' ) === 0 )
						{
							$f = $this->trellis->core->cache['pfields'][ substr( $name, 3 ) ];
						}

						if ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
						{
							$f['extra'] = unserialize( $f['extra'] );

							$t[ $name ] = $f['extra'][ $t[ $name ] ];
						}
					}

					$ticket_rows .= $t[ $name ];

					if ( $name == 'id' ) $ticket_rows .= "</strong>";

					if ( $name == 'id' || $name == 'subject' ) $ticket_rows .= "</a>";

					$ticket_rows .= "</td>";
				}

				$ticket_rows .= "<td class='bluecellthin-light'><input name='mat[]' id='mat_{$t['id']}' type='checkbox' value='{$t['id']}' class='matcb' /></td>
								</tr>";
			}
		}

		#=============================
		# Do Output
		#=============================

		$page_links = $this->trellis->page_links( array(
														'total'		=> count( $t_total ),
														'per_page'	=> 15,
														'url'		=> $this->generate_url(),
														) );

		$this->output .= $ticket_rows ."
						<tr>
							<td class='bluecellthin-th-pages' colspan='3' align='left'>". $page_links ."</td>
							<td class='bluecellthin-th' colspan='". ( count( $columns ) - 2 ) ."' align='right'>Mass-Action</td>
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$status_items = array();

		foreach( $this->trellis->core->cache['statuses'] as $s )
		{
			$status_items[ $s['id'] ] = "<input name='fstatus[]' id='fs_". $s['id'] ."' type='checkbox' class='fstatus' value='". $s['id'] ."'";

			if ( is_array( $this->trellis->input['fstatus'] ) )
			{
				if ( in_array( $s['id'], $this->trellis->input['fstatus'] ) ) $status_items[ $s['id'] ] .= " 'checked='yes'";
			}

			$status_items[ $s['id'] ] .= " />&nbsp;&nbsp;<label for='fs_". $s['id'] ."'>". $s['name_staff'] ."</label>";
		}

		$status_items[] = "<input name='save_status' id='save_status' type='submit' value='{lang.button_save_default}' class='buttontiny' /> <span id='save_status_status' class='ajax_update_button'>{lang.saved}</span>";

		$depart_items = array();

		foreach( $this->trellis->core->cache['departs'] as $d )
		{
			$depart_items[ $d['id'] ] = "<input name='fdepart[]' id='fd_". $d['id'] ."' type='checkbox' class='fdepart' value='". $d['id'] ."'";

			if ( is_array( $this->trellis->input['fdepart'] ) )
			{
				if ( in_array( $d['id'], $this->trellis->input['fdepart'] ) ) $depart_items[ $d['id'] ] .= " 'checked='yes'";
			}

			$depart_items[ $d['id'] ] .= " />&nbsp;&nbsp;<label for='fd_". $d['id'] ."'>". $d['name'] ."</label>";
		}

		$depart_items[] = "<input name='save_depart' id='save_depart' type='submit' value='{lang.button_save_default}' class='buttontiny' /> <span id='save_depart_status' class='ajax_update_button'>{lang.saved}</span>";

		$priority_items = array();

		foreach( $this->trellis->core->cache['priorities'] as $p )
		{
			$priority_items[ $p['id'] ] = "<input name='fpriority[]' id='fp_". $p['id'] ."' type='checkbox' class='fpriority' value='". $p['id'] ."'";

			if ( is_array( $this->trellis->input['fpriority'] ) )
			{
				if ( in_array( $p['id'], $this->trellis->input['fpriority'] ) ) $priority_items[ $p['id'] ] .= " 'checked='yes'";
			}

			$priority_items[ $p['id'] ] .= " />&nbsp;&nbsp;<label for='fp_". $p['id'] ."'><img src='<! UPLD_URL !>/priorities/{$p['icon_regular']}' alt='{$p['name']}' class='prioritybox' style='margin-right:8px' />". $p['name'] ."</label>";
		}

		$priority_items[] = "<input name='save_priority' id='save_priority' type='submit' value='{lang.button_save_default}' class='buttontiny' /> <span id='save_priority_status' class='ajax_update_button'>{lang.saved}</span>";

		$this->trellis->skin->preserve_input = 1;

		$other_items = array();

		$other_items[0] = "<form action='". $this->generate_url( array( 'search' => '', 'field' => '' ) ) ."' method='post'><input name='search' id='search' type='text' value='". $this->trellis->input['search'] ."' style='width:95%;margin-bottom:5px' /><br />";

		$search_fields = array( 'id' => '{lang.id}', 'mask' => '{lang.mask}', 'subject' => '{lang.subject}', 'uid' => '{lang.user_id}', 'uname' => '{lang.username}', 'email' => '{lang.email}' );

		$other_items[0] .= $this->trellis->skin->drop_down( 'field', $search_fields );

		$other_items[0] .= "&nbsp;&nbsp;<input name='go' id='go' type='submit' value='{lang.search}' /></form>";

		$other_items[1] = "<input name='my' id='fmy' type='checkbox' class='fmy' value='1'";

		if ( $this->trellis->input['my'] ) $other_items[1] .= " 'checked='yes'";

		$other_items[1] .= " />&nbsp;&nbsp;<label for='fmy'>{lang.my_assigned_tickets}</label>";

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_tickets_options}', $menu_items );
		$this->trellis->skin->add_sidebar_list( '{lang.filter_by_status}', $status_items, 'filter_status' );
		$this->trellis->skin->add_sidebar_list( '{lang.filter_by_department}', $depart_items, 'filter_depart' );
		$this->trellis->skin->add_sidebar_list( '{lang.filter_by_priority}', $priority_items, 'filter_priority' );
		$this->trellis->skin->add_sidebar_list( '{lang.other_filters}', $other_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_tickets_title}', '{lang.help_about_tickets_msg}' );

		$this->output .= $this->trellis->skin->toggle_js();

		$this->output .= "<script type='text/javascript'>
						//<![CDATA[
						$('.fstatus').bind('click', function() {
							goToUrl('". str_replace( '&amp;', '&', $this->generate_url( array( 'fstatus' => '', 'cf' => 1 ) ) ) ."&'+ $('.fstatus').serialize() );
						});
						$('.fdepart').bind('click', function() {
							goToUrl('". str_replace( '&amp;', '&', $this->generate_url( array( 'fdepart' => '', 'cf' => 1 ) ) ) ."&'+ $('.fdepart').serialize() );
						});
						$('.fpriority').bind('click', function() {
							goToUrl('". str_replace( '&amp;', '&', $this->generate_url( array( 'fpriority' => '', 'cf' => 1 ) ) ) ."&'+ $('.fpriority').serialize() );
						});
						$('.fmy').bind('click', function() {
							goToUrl('". str_replace( '&amp;', '&', $this->generate_url( array( 'my' => '' ) ) ) ."&'+ $('.fmy').serialize() );
						});
						$('#checkall').bind('click', function() {
							$('.matcb').attr('checked', this.checked);
						});
						$('#save_status').bind('click', function () {
							$.post('admin.php?section=manage&page=tickets&act=dodefaults&type=status',
								{ defaults: $('.fstatus').serialize() },
								function(data) {
									if (data == 1) $('#save_status_status').stop(true).fadeIn().animate({opacity: 1.0}, {duration: 2000}).fadeOut('slow');
								});
						});
						$('#save_depart').bind('click', function () {
							$.post('admin.php?section=manage&page=tickets&act=dodefaults&type=depart',
								{ defaults: $('.fdepart').serialize() },
								function(data) {
									if (data == 1) $('#save_depart_status').stop(true).fadeIn().animate({opacity: 1.0}, {duration: 2000}).fadeOut('slow');
								});
						});
						$('#save_priority').bind('click', function () {
							$.post('admin.php?section=manage&page=tickets&act=dodefaults&type=priority',
								{ defaults: $('.fpriority').serialize() },
								function(data) {
									if (data == 1) $('#save_priority_status').stop(true).fadeIn().animate({opacity: 1.0}, {duration: 2000}).fadeOut('slow');
								});
						});
						//]]>
						</script>";

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ View Ticket
	#=======================================

	private function view_ticket($params=array())
	{
		#=============================
		# Grab Ticket
		#=============================

		$t = $this->trellis->tickets->get_single_by_id( array(
															  'select'	=> array(
												   								 't' => 'all',
												   								 'u' => array( array( 'name' => 'uname' ), array( 'email' => 'uemail' ), 'ugroup' ),
												   								 'lr' => array( array( 'name' => 'last_uname' ) ),
												   								 ),
															  'from'	=> array( 't' => 'tickets' ),
															  'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 't' => 'uid', '=', 'u' => 'id' ) ), array( 'from' => array( 'lr' => 'users' ), 'where' => array( 't' => 'last_uid', '=', 'lr' => 'id' ) ) ),
													   ), $this->trellis->input['id'] );

		if ( ! $t ) $this->trellis->skin->error('no_ticket');

		#=============================
		# Permissions
		#=============================

		if ( ! $this->check_perm( $t['did'], 'v' ) )
		{
			if ( $params['new'] )
			{
				$this->trellis->skin->error('no_perm');
			}
			else
			{
				$this->trellis->skin->error('no_ticket');
			}
		}

		#=============================
		# Grab Replies
		#=============================

		$replies = $this->trellis->tickets->get( array(
													   'select'	=> array(
													   					 'r' => 'all',
												   						 'u' => array( array( 'name' => 'uname' ), array( 'signature' => 'usignature' ), 'sig_html' ),
													   					 ),
													   'from'	=> array( 'r' => 'replies' ),
													   'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'r' => 'uid', '=', 'u' => 'id' ) ) ),
													   'where'	=> array( array( 'r' => 'tid' ), '=', $t['id'] ),
													   'order'	=> array( 'date' => array( 'r' => 'asc' ) ),
												)	   );

		#=============================
		# Prepare Output
		#=============================

		if ( $params['alert'] )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $params['alert'] .'}' );
		}

		$custom_fields = array();
		$custom_fields_html = '';

		#=============================
		# Menu Items
		#=============================

		$reply_action_list = '';

		if ( $t['closed'] )
		{
			if ( $this->check_perm( $t['did'], 'et' ) ) $menu_items[] = array( 'status', '{lang.menu_status}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dostatus&amp;id='. $t['id'], 'return confirmStatus('. $t['id'] .')' );
			if ( $this->check_perm( $t['did'], 'ro' ) ) $menu_items[] = array( 'arrow_step_over', '{lang.menu_reopen}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doreopen&amp;id='. $t['id'], 'return confirmReopen('. $t['id'] .')' );
		}
		else
		{
			if ( $this->check_perm( $t['did'], 'r' ) && ! $t['accepted'] ) $menu_items = array( array( 'tick', '{lang.menu_accept}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doaccept&amp;id='. $t['id'] ) );
			if ( $this->check_perm( $t['did'], 'et' ) )
			{
				$menu_items[] = array( 'edit', '{lang.menu_edit}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=edit&amp;id='. $t['id'] );
				$menu_items[] = array( 'priority', '{lang.menu_priority}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dopriority&amp;id='. $t['id'], 'return confirmPriority('. $t['id'] .')' );
				$menu_items[] = array( 'status', '{lang.menu_status}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dostatus&amp;id='. $t['id'], 'return confirmStatus('. $t['id'] .')' );
			}

			if ( $this->check_perm( $t['did'], 'es' ) )
			{
				if ( $this->trellis->core->cache['settings']['ticket']['escalate'] && $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_enable'] && ! $t['escalated'] ) $menu_items[] = array( 'escalate', '{lang.menu_escalate}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doescalate&amp;id='. $t['id'], 'return confirmEscalate('. $t['id'] .')' );

				if ( $t['escalated'] ) $menu_items[] = array( 'rmvescalate', '{lang.menu_rmvescalate}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dormvescalate&amp;id='. $t['id'], 'return confirmRmvescalate('. $t['id'] .')' );

				$reply_action_list .= "<li id='reply_escalate'>{lang.reply_escalate}</li>";
			}

			if ( $this->check_perm( $t['did'], 'r' ) )
			{
				if ( $t['onhold'] )
				{
					$menu_items[] = array( 'hold_minus', '{lang.menu_rmvhold}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dormvhold&amp;id='. $t['id'] );
				}
				else
				{
					$menu_items[] = array( 'hold', '{lang.menu_hold}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dohold&amp;id='. $t['id'] );

					$reply_action_list .= "<li id='reply_hold'>{lang.reply_hold}</li>";
				}
			}
		}

		if ( $this->check_perm( $t['did'], 'mv' ) )
		{
			$menu_items[] = array( 'move', '{lang.menu_move}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=domove&amp;id='. $t['id'], 'return confirmMove('. $t['id'] .')' );

			$reply_action_list .= "<li id='reply_move'>{lang.reply_move}</li>";
		}

		if ( ! $t['closed'] && $this->check_perm( $t['did'], 'c' ) )
		{
			$menu_items[] = array( 'frame_tick', '{lang.menu_close}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doclose&amp;id='. $t['id'], 'return confirmClose('. $t['id'] .')' );

			$reply_action_list .= "<li id='reply_close'>{lang.reply_close}</li>";
		}

		if ( $this->check_perm( $t['did'], 'dt' ) ) $menu_items[] = array( 'circle_delete', '{lang.menu_delete}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=dodel&amp;id='. $t['id'], 'return confirmDeleteTicket('. $t['id'] .')' );

		$menu_items[] = array( 'print', '{lang.menu_print}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=print&amp;id='. $t['id'] );

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_tickets_options}', $menu_items );

		#=============================
		# Custom Profile Fields
		#=============================

		$this->trellis->load_functions('cpfields');

		if ( $cpfields = $this->trellis->cpfields->grab( $t['ugroup'], 1, 1 ) )
		{
			$fdata = $this->trellis->cpfields->get_data( $t['uid'] );

			foreach( $cpfields as $fid => $f )
			{
				if ( $f['type'] == 'checkbox' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cpf_'. $f['id'] .'_'. $key, 'title' => $name, 'value' => $fdata[ $f['id'] ][ $key ], 'disabled' => 1 ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$custom_fields[] = array( 'name' => $f['name'], 'data' => $checkbox_html );
				}
				elseif ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$custom_fields[] = array( 'name' => $f['name'], 'data' => $f['extra'][ $fdata[ $f['id'] ] ] );
				}
				else
				{
					$custom_fields[] = array( 'name' => $f['name'], 'data' => $fdata[ $f['id'] ] );
				}
			}
		}

		#=============================
		# Custom Department Fields
		#=============================

		$this->trellis->load_functions('cdfields');

		if ( $cdfields = $this->trellis->cdfields->grab( $t['did'] ) )
		{
			$fdata = $this->trellis->cdfields->get_data( $t['id'] );

			foreach( $cdfields as $fid => $f )
			{
				if ( $f['type'] == 'checkbox' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cdf_'. $f['id'] .'_'. $key, 'title' => $name, 'value' => $fdata[ $f['id'] ][ $key ], 'disabled' => 1 ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$custom_fields[] = array( 'name' => $f['name'], 'data' => $checkbox_html );
				}
				elseif ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$custom_fields[] = array( 'name' => $f['name'], 'data' => $f['extra'][ $fdata[ $f['id'] ] ] );
				}
				else
				{
					$custom_fields[] = array( 'name' => $f['name'], 'data' => $fdata[ $f['id'] ] );
				}
			}
		}

		#=============================
		# Combine Custom Fields
		#=============================

		$fields_current = 0;

		foreach( $custom_fields as $f )
		{
			$fields_current ++;

			if ( $fields_current & 1 ) $custom_fields_html .= "<tr>";

			if ( ! $f['data'] ) $f['data'] = '--';

			$custom_fields_html .= "<td class='cardcell-light'>{$f['name']}</td>
								<td class='cardcell-dark'>{$f['data']}</td>";

			if ( ! $fields_current & 1 ) $custom_fields_html .= "</tr>";
		}

		if ( count( $custom_fields ) & 1 )
		{
			$custom_fields_html .= "<td class='cardcell-light'>&nbsp;</td>
								<td class='cardcell-dark'>&nbsp;</td>
							</tr>";
		}

		#=============================
		# Ticket
		#=============================

		$this->trellis->load_functions('drop_downs');
		$this->trellis->load_functions('users');

		// Convert For Humans
		if ( 0 ) #Check for assigned
		{
			$t['priority_human'] = "<img src='<! UPLD_URL !>/priorities/{$this->trellis->core->cache['priorities'][ $t['priority'] ]['icon_assigned']}' alt='{$this->trellis->core->cache['priorities'][ $t['priority'] ]['name']}' class='prioritybox' />&nbsp;&nbsp;{$this->trellis->core->cache['priorities'][ $t['priority'] ]['name']}";
		}
		else
		{
			$t['priority_human'] = "<img src='<! UPLD_URL !>/priorities/{$this->trellis->core->cache['priorities'][ $t['priority'] ]['icon_regular']}' alt='{$this->trellis->core->cache['priorities'][ $t['priority'] ]['name']}' class='prioritybox' style='vertical-align:middle' />&nbsp;&nbsp;{$this->trellis->core->cache['priorities'][ $t['priority'] ]['name']}";
		}

		$t['status'] = $this->trellis->core->cache['statuses'][ $t['status'] ]['name_staff'];

		$t['dname'] = $this->trellis->core->cache['departs'][ $t['did'] ]['name'];

		$t['date'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'long' ) );

		$t['last_reply'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'long' ) );

		if ( $t['escalated'] ) $t['escalated_icon'] = "<img src='<! IMG_DIR !>/icon_escalate.png' alt='E' style='vertical-align:middle;margin-bottom:2px' />&nbsp;";

		$toutput_params = array( 'urls' => 1 );

		( $t['html'] ) ? $toutput_params['html'] = 1 : $toutput_params['nl2br'] = 1;

		$t['message'] = $this->trellis->prepare_output( $t['message'], $toutput_params );

		$this->output .= "<script type='text/javascript'>
						//<![CDATA[
						function confirmPriority(tid) {
							dialogConfirm({
								title: '{lang.dialog_priority_title}',
								message: \"{lang.dialog_priority_msg} <select name='tpriority' id='tpriority'>". $this->trellis->drop_downs->priority_drop( array( 'select' => $t['priority'] ) ) ."</select>\",
								yesButton: '{lang.dialog_priority_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=dopriority&id='+tid+'&pid='+$('#priority').val()) },
								noButton: '{lang.cancel}',
								beforeclose: function() { $('#priority').val( $('#tpriority').val() ) },
								width: 350
							}); return false;
						}
						function confirmStatus(tid) {
							$.get('admin.php?section=manage&page=tickets&act=getstatus',
								{ id: tid },
								function(data) {
									if (data != 0) {
										dialogConfirm({
											title: '{lang.dialog_status_title}',
											message: \"<p>{lang.dialog_status_msg_a}</p><p>{lang.dialog_status_msg_b} <select name='tstatus' id='tstatus'>\"+data+\"</select></p>\",
											yesButton: '{lang.dialog_status_button}',
											yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=dostatus&id='+tid+'&sid='+$('#status').val()) },
											noButton: '{lang.cancel}',
											beforeclose: function() { $('#status').val( $('#tstatus').val() ) },
											width: 350
										});
									}
								}); return false;
						}
						function confirmEscalate(tid) {
							dialogConfirm({
								title: '{lang.dialog_escalate_title}',
								message: '{lang.dialog_escalate_msg}',
								yesButton: '{lang.dialog_escalate_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=doescalate&id='+tid) },
								noButton: '{lang.cancel}',
								width: 350
							}); return false;
						}
						function confirmRmvescalate(tid) {
							dialogConfirm({
								title: '{lang.dialog_rmvescalate_title}',
								message: '{lang.dialog_rmvescalate_msg}',
								yesButton: '{lang.dialog_rmvescalate_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=dormvescalate&id='+tid) },
								noButton: '{lang.cancel}',
								width: 350
							}); return false;
						}
						function confirmMove(tid) {
							dialogConfirm({
								title: '{lang.dialog_move_title}',
								message: \"<p>{lang.dialog_move_msg_a}</p><p>{lang.dialog_move_msg_b} <select name='tmvdid' id='tmvdid'>". $this->trellis->drop_downs->dprt_drop( 0, $t['did'], 1 ) ."</select></p>\",
								yesButton: '{lang.dialog_move_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=domove&id='+tid+'&did='+$('#mvdid').val()) },
								noButton: '{lang.cancel}',
								beforeclose: function() { $('#mvdid').val( $('#tmvdid').val() ) },
								width: 350
							}); return false;
						}
						function confirmClose(tid) {
							dialogConfirm({
								title: '{lang.dialog_close_title}',
								message: '{lang.dialog_close_msg}',
								yesButton: '{lang.dialog_close_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=doclose&id='+tid) },
								noButton: '{lang.cancel}'
							}); return false;
						}
						function confirmReopen(tid) {
							dialogConfirm({
								title: '{lang.dialog_reopen_title}',
								message: '{lang.dialog_reopen_msg}',
								yesButton: '{lang.dialog_reopen_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=doreopen&id='+tid) },
								noButton: '{lang.cancel}'
							}); return false;
						}
						function confirmDeleteTicket(tid) {
							dialogConfirm({
								title: '{lang.dialog_delete_ticket_title}',
								message: '{lang.dialog_delete_ticket_msg}',
								yesButton: '{lang.dialog_delete_ticket_button}',
								yesAction: function() { goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=dodel&id='+tid) },
								noButton: '{lang.cancel}'
							}); return false;
						}
						function confirmDeleteReply(rid) {
							dialogConfirm({
								title: '{lang.dialog_delete_reply_title}',
								message: '{lang.dialog_delete_reply_msg}',
								yesButton: '{lang.dialog_delete_reply_button}',
								yesAction: function() { inlineReplyDelete(rid); },
								noButton: '{lang.cancel}'
							}); return false;
						}
						//]]>
						</script>
						<input type='hidden' id='tid' name='tid' value='{$t['id']}' />
						<input type='hidden' id='mvdid' name='mvdid' value='' />
						<input type='hidden' id='priority' name='priority' value='' />
						<input type='hidden' id='status' name='status' value='' />
						". $this->trellis->skin->start_ticket_details( '{lang.ticket_num}'. $t['id'] .': '. $t['subject'] ) ."
						<table width='100%' border='0' cellspacing='0' cellpadding='0'>
							<tr>
								<td class='cardcell-light' width='20%'>{lang.ticket_id}</td>
								<td class='cardcell-dark' width='30%'>{$t['escalated_icon']}{$t['id']}</td>
								<td class='cardcell-light' width='20%'>{lang.ticket_mask}</td>
								<td class='cardcell-dark' width='30%'>{$t['mask']}</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.priority}</td>
								<td class='cardcell-dark'>{$t['priority_human']}</td>
								<td class='cardcell-light'>{lang.replies}</td>
								<td class='cardcell-dark'>{$t['replies']}</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.department}</td>
								<td class='cardcell-dark'>{$t['dname']}</td>
								<td class='cardcell-light'>{lang.last_reply}</td>
								<td class='cardcell-dark'>{$t['last_reply']}</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.submitted_on}</td>
								<td class='cardcell-dark'>{$t['date']}</td>
								<td class='cardcell-light'>{lang.last_replier}</td>
								<td class='cardcell-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['last_uid']}'>{$t['last_uname']}</a></td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.submitted_by}</td>
								<td class='cardcell-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$t['uid']}'>{$t['uname']}</a></td>
								<td class='cardcell-light'>{lang.status}</td>
								<td class='cardcell-dark'>{$t['status']}</td>
							</tr>
							<tr>
								<td class='cardcell-light'>{lang.email}</td>
								<td class='cardcell-dark'>{$t['uemail']}</td>
								<td class='cardcell-light'>{lang.satisfaction}</td>
								<td class='cardcell-dark'><img src='<! IMG_DIR !>/star_full.gif' width='12' height='12' alt='Star' /><img src='<! IMG_DIR !>/star_full.gif' width='12' height='12' alt='Star' /><img src='<! IMG_DIR !>/star_full.gif' width='12' height='12' alt='Star' /><img src='<! IMG_DIR !>/star_half.gif' width='12' height='12' alt='Star' /><img src='<! IMG_DIR !>/star_empty.gif' width='12' height='12' alt='Star' /></td>
							</tr>
							". $custom_fields_html ."
						</table>
						". $this->trellis->skin->end_ticket_details() ."
						<div id='ticketroll'>
							". $this->trellis->skin->group_title('{lang.ticket_content}') ."
							<div class='rollstart'>
								{$t['message']}
							</div>";

		if ( ! empty( $replies ) )
		{
			foreach( $replies as $r )
			{
				if ( $r['secret'] )
				{
					$rclass = 'staffonly';
				}
				elseif ( $r['staff'] )
				{
					$rclass = 'staff';
				}
				else
				{
					$rclass = 'customer';
				}

				$r['date'] = $this->trellis->td_timestamp( array( 'time' => $r['date'], 'format' => 'long' ) );

				$routput_params = array( 'urls' => 1 );

				if ( $r['html'] )
				{
					$routput_params['html'] = 1;
				}
				else
				{
					$routput_params['nl2br'] = 1;
				}

				$r['message'] = $this->trellis->prepare_output( $r['message'], $routput_params );

				if ( $r['signature'] )
				{
					$r['message'] .= '<br /><br />'. $this->trellis->prepare_output( $r['usignature'], array( 'html' => $r['sig_html'] ) );
				}

				$this->output .= "<div id='rc{$r['id']}'>
								<div class='bar{$rclass}'>";

				$reply_edit = 0;
				$reply_delete = 0;
				$reply_javascript_html = '';

				if ( $r['html'] ) $reply_javascript_html = 'Html';

				if ( $this->check_perm( $t['did'], 'er' ) || ( $this->trellis->user['g_reply_edit'] && $r['uid'] == $this->trellis->user['id'] ) ) $reply_edit = 1;
				if ( $this->check_perm( $t['did'], 'dr' ) || ( $this->trellis->user['g_reply_delete'] && $r['uid'] == $this->trellis->user['id'] ) ) $reply_delete = 1;

				if ( $reply_edit || $reply_delete ) $this->output .= "<div class='barright'>";

				if ( $reply_edit ) $this->output .= "<span id='redit_". $r['id'] ."' style='cursor:pointer' onclick='inlineReplyEdit{$reply_javascript_html}(". $r['id'] .")'><img src='<! IMG_DIR !>/icon_page_edit.png' alt='{lang.edit}' />{lang.edit}</span><span id='rsave_". $r['id'] ."' style='display:none;cursor:pointer' onclick='inlineReplySave{$reply_javascript_html}(". $r['id'] .")'><img src='<! IMG_DIR !>/icon_page_edit.png' alt='{lang.save_edit}' />{lang.save_edit}</span>";

				if ( $reply_delete )
				{
					if ( $reply_edit ) $this->output .= " &nbsp; ";

					$this->output .= "<span id='rdelete_". $r['id'] ."' style='cursor:pointer' onclick='return confirmDeleteReply(". $r['id'] .")'><img src='<! IMG_DIR !>/icon_page_delete.png' alt='{lang.delete}' />{lang.delete}</span>";
				}

				if ( $reply_edit || $reply_delete ) $this->output .= "</div>";

				$this->output .= "<strong>{$r['uname']}</strong> -- {$r['date']}</div>
								<div class='roll{$rclass}' id='r{$r['id']}'>
				                	{$r['message']}
				                </div>
						</div>";
			}
		}

		if ( ! $t['closed'] && $this->check_perm( $t['did'], 'r') )
		{
			if ( $this->trellis->user['rte_enable'] && $this->trellis->core->cache['settings']['ticket']['rte'] )
			{
				$this->output .= $this->trellis->skin->tinymce_js( 'message' );

				$html = 1;
			}
			else
			{
				$html = 0;
			}

			if ( $params['reply_error'] )
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $params['reply_error'] .'}' );
			}

			( $this->trellis->user['sig_auto'] ) ? $sig_checked = " checked='yes'" : $sig_checked = '';

			$reply_action_button = '';

			if ( $reply_action_list ) $reply_action_list = "<span id='reply_action_button' class='fakebuttonslim'><img src='<! IMG_DIR !>/arrow_down.gif' alt='*' /></span><ul id='reply_action_list' class='fakedrop blockmenu'>". $reply_action_list ."</ul>";

			$rt_list = '';

			foreach( $this->trellis->core->cache['rtemplates'] as $rt )
			{
				$rt_list .= "<li id='rt{$rt['id']}' onclick='addRT({$rt['id']})'>{$rt['name']}</li>";
			}

			$this->output .= "<form action='<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doaddreply&amp;id={$t['id']}' method='post'>
								<input type='hidden' id='html' name='html' value='{$html}' />
								<div class='slatebox'>{lang.post_a_reply}</div>
								<div class='rollpost'>
								". $this->trellis->skin->textarea( array( 'name' => 'message', 'cols' => 80, 'rows' => 8, 'width' => '98%', 'height' => '200px' ) ) ."
								</div>
								<div class='formtail' style='text-align:left'>". $this->trellis->skin->submit_button( 'add_reply', '{lang.button_add_reply}' ) . $reply_action_list ."&nbsp;<input type='checkbox' name='secret' id='secret' value='1' style='margin-bottom:2px;' />&nbsp;<label for='secret'>{lang.staff_only_reply}</label>&nbsp;&nbsp;<input type='checkbox' name='signature' id='signature' value='1' style='margin-bottom:2px;'{$sig_checked} />&nbsp;<label for='signature'>{lang.append_signature}</label><div style='float:right;'><div id='add_rt' class='fakebutton' style='margin-top:2px;cursor:pointer'>{lang.reply_templates}&nbsp;<img src='<! IMG_DIR !>/arrow_down.gif' alt='*' /></div><ul id='add_rt_list' class='fakedrop blockmenu'>{$rt_list}</ul></div></div>

								</form>";
		}

		$this->output .= "<script language='javascript' type='text/javascript'>
			function inlineReplyEditHtml(rid) {
				$.get('admin.php?section=manage&page=tickets&act=getreply',
					{ id: rid },
					function(data) {
						if (data != 0) {
							tinyMCE.init({
								mode : 'exact',
								theme : 'advanced',
								elements : 'r'+rid,
								plugins : 'inlinepopups,safari,spellchecker',
								dialog_type : 'modal',
								forced_root_block : false,
								force_br_newlines : true,
								force_p_newlines : false,
								theme_advanced_toolbar_location : 'top',
								theme_advanced_toolbar_align : 'left',
								theme_advanced_path_location : 'bottom',
								theme_advanced_disable : 'styleselect,formatselect',
								theme_advanced_buttons1 : 'bold,italic,underline,strikethrough,separator,forecolor,backcolor,separator,bullist,numlist,separator,outdent,indent,separator,link,unlink,image,separator,undo,redo,separator,spellchecker,separator,removeformat,cleanup,code',
								theme_advanced_buttons2 : '',
								theme_advanced_buttons3 : '',
								theme_advanced_resize_horizontal : false,
								theme_advanced_resizing : true,
								setup: function(ed) {
									ed.onInit.add( function(ed) {
										ed.setContent(data);
									});
								}
							});

							$('#redit_'+rid).hide();
							$('#rdelete_'+rid).hide();
							$('#rsave_'+rid).show();
						}
					});
			}
			function inlineReplySaveHtml(rid) {
				$.post('admin.php?section=manage&page=tickets&act=doeditreply',
					{ id: rid, message: tinyMCE.get('r'+rid).getContent(), html: 1 },
					function(data) {
						if (data != 0) {
							tinyMCE.get('r'+rid).setContent(data);
							tinyMCE.get('r'+rid).remove();

							$('#rsave_'+rid).hide();
							$('#redit_'+rid).show();
							$('#rdelete_'+rid).show();
						}
					});
			}
			function inlineReplyEdit(rid) {
				$.get('admin.php?section=manage&page=tickets&act=getreply',
					{ id: rid },
					function(data) {
						if (data != 0) {
							$('#r'+rid).html(\"<textarea id='re\"+rid+\"' name='re\"+rid+\"' cols='80' rows='7' style='width:98%'>\"+data+\"</textarea>\");

							$('#redit_'+rid).hide();
							$('#rdelete_'+rid).hide();
							$('#rsave_'+rid).show();
						}
					});
			}
			function inlineReplySave(rid) {
				$.post('admin.php?section=manage&page=tickets&act=doeditreply',
					{ id: rid, message: $('#re'+rid).val() },
					function(data) {
						if (data != 0) {
							$('#r'+rid).html(data);

							$('#rsave_'+rid).hide();
							$('#redit_'+rid).show();
							$('#rdelete_'+rid).show();
						}
					});
			}
			function inlineReplyDelete(rid) {
				$.post('admin.php?section=manage&page=tickets&act=dodelreply',
					{ id: rid },
					function(data) {
						if (data != 0) {
							$('#rc'+rid).hide('blind');
						}
					});
			}
			</script>";

		#=============================
		# History
		#=============================

		$this->output .= "<div class='slatebox'>{lang.ticket_history}</div>
					    	<div class='rollhistory'>
								<table width='100%' cellpadding='0' cellspacing='0'>";

		$this->trellis->core->db->construct( array(
												   'select'	=> array(
												   					 'l' => 'all',
												   					 'u' => array( array( 'name' => 'uname' ) ),
												   					 ),
												   'from'	=> array( 'l' => 'logs' ),
												   'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'l' => 'uid', '=', 'u' => 'id' ) ) ),
												   'where'	=> array( array( array( 'l' => 'type' ), '=', 7 ), array( array( 'l' => 'extra' ), '=', $t['id'], 'and' ) ),
												   'order'	=> array( 'date' => array( 'l' => 'desc' ) ),
											)	   );

		$this->trellis->core->db->execute();

		while( $l = $this->trellis->core->db->fetch_row() )
		{
			$l['date'] = $this->trellis->td_timestamp( array( 'time' => $l['date'], 'format' => 'short' ) );

			if ( $l['level'] == 2 )
			{
				$fontcolor_start = "<font color='#790000'>";
				$fontcolor_end = "<font color='#790000'>";
			}
			else
			{
				$fontcolor_start = "";
				$fontcolor_end = "";
			}

			$this->output .= "<tr>
								<td class='slatecell-light' width='38%'>{$fontcolor_start}{$l['action']}{$fontcolor_end}</td>
								<td class='slatecell-dark' width='16%' style='font-weight:normal'>{$fontcolor_start}{$l['date']}{$fontcolor_end}</td>
								<td class='slatecell-light' width='19%'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$l['uid']}'>{$fontcolor_start}{$l['uname']}{$fontcolor_end}</a></td>
								<td class='slatecell-light' width='17%' style='font-weight:normal'>{$fontcolor_start}{$l['ipadd']}{$fontcolor_end}</td>
							</tr>";
		}

		$this->output .= "</table>
						</div>
					    </div>
					    <script type='text/javascript'>
					    //<![CDATA[
						$('#add_flag').bind('click', function () {
							$('#add_flag_list').toggle();
						});
						$('#add_assign').bind('click', function () {
							$('#add_assign_block').toggle();
						});
						$('#add_rt').bind('click', function () {
							$('#add_rt_list').toggle();
						});
						$('#reply_action_button').bind('click', function () {
							$('#reply_action_list').toggle();
						});
						$('#add_assign_input').autocomplete('<! HD_URL !>/admin.php?act=lookup&type=staff', {
							dataType: 'json',
							parse: function(data) {
								return $.map(data, function(row) {
									return {
										data: row,
										result: row.caption
									}
								});
							},
							formatItem: function(row, i, max) {
								return row.caption;
							}
						});
						$('#add_assign_input').result(function(event, data, formatted) {
							$('#add_assign_id').val(data['value']);
						});
						$('#save_notes').bind('click', function () {
							$.post('admin.php?section=manage&page=tickets&act=donotes&id='+$('#tid').val(),
								{ notes: $('#notes').val() },
								function(data) {
									if (data != 0) $('#save_notes_status').stop(true).fadeIn().animate({opacity: 1.0}, {duration: 2000}).fadeOut('slow');
								});
						});
						function addReply() {
							if ( $('#html').val() == 1 ) {
								reply_msg = tinyMCE.get('message').getContent();
							}
							else {
								reply_msg = $('#message').val();
							}
							$.post('admin.php?section=manage&page=tickets&act=doaddreply&id='+$('#tid').val(),
								{ message: reply_msg, html: $('#html').val(), secret: $('#secret:checked').val(), signature: $('#signature:checked').val(), ajax: 1 },
								function(data) {
									if (data == 0) return false;
								});

							return true;
						}
						$('#reply_escalate').bind('click', function () {
							if( addReply() ) confirmEscalate($('#tid').val());
						});
						$('#reply_hold').bind('click', function () {
							if( addReply() ) goToUrl('<! HD_URL !>/admin.php?section=manage&page=tickets&act=dohold&id='+$('#tid').val());
						});
						$('#reply_move').bind('click', function () {
							if( addReply() ) confirmMove($('#tid').val());
						});
						$('#reply_close').bind('click', function () {
							if( addReply() ) confirmClose($('#tid').val());
						});
						//]]>
						</script>";

		#=============================
		# Assignments
		#=============================

		$assign_items = '';
		$assign_used = 0;

		if ( $assignments = $this->trellis->tickets->get_assignments( $t['id'] ) )
		{
			foreach( $assignments as $a )
			{
				$assign_items .= "<li id='a{$a['uid']}'>{$a['uname']}";

				if ( 1 ) $assign_items .= "<img src='<! IMG_DIR !>/icon_cross.png' alt='X' id='ai{$a['uid']}' class='listdel' onclick='delAssign({$a['uid']},{$t['id']})' />";

				$assign_items .= "</li>";
			}

			$assign_used = 1;
		}

		$assign_items .= "<li id='not_assigned'";

		if ( $assign_used ) $assign_items .= " style='display:none'";

		$assign_items .= "><em>{lang.not_assigned}</em></li>";

		if ( $this->check_perm( $t['did'], 'aa' ) )
		{
			$assign_items .= "<li><input name='add_assign' id='add_assign' type='submit' value='{lang.button_add_assign}' class='buttonmini' />
							<div id='add_assign_block' class='fakedrop'><ul><li style='cursor:default'><input name='add_assign_id' id='add_assign_id' type='hidden' value='0' /><input name='add_assign_input' id='add_assign_input' type='text' value='' size='22' />&nbsp;&nbsp;<input name='add_assign_button' id='add_assign_button' type='submit' value='{lang.button_add}' class='buttonmini' onclick='addAssign({$t['id']})' /></li><li><em>{lang.add_assign_instructions}</em></li></ul></div></li>";
		}
		elseif ( $this->check_perm( $t['did'], 'as' ) )
		{
			$assign_items .= "<li><input name='add_assign_id' id='add_assign_id' type='hidden' value='". $this->trellis->user['id'] ."' /><input name='add_assign_button' id='add_assign_button' type='submit' value='{lang.button_assign_myself}' class='buttonmini' onclick='addAssign({$t['id']})' /></li>";
		}

		$this->trellis->skin->add_sidebar_list_custom( '{lang.ticket_assignments}', $assign_items, 'assign_list' );

		#=============================
		# Flags
		#=============================

		if ( ! empty( $this->trellis->core->cache['flags'] ) )
		{
			$flags_used = array();
			$flags_items = '';
			$flags_list = '';
			$flags_add_list = 0;

			if ( $flags = $this->trellis->tickets->get_flags( $t['id'] ) )
			{
				foreach( $flags as $f )
				{
					$flags_used[ $f['fid'] ] = 1;

					$flags_items .= "<li id='f{$f['fid']}'><img src='<! UPLD_URL !>/flags/{$f['icon']}' alt='{$f['name']}' class='flagicon' />{$f['name']}<img src='<! IMG_DIR !>/icon_cross.png' alt='X' id='fi{$f['fid']}' class='listdel' onclick='delFlag({$f['fid']},{$t['id']})' /></li>";
				}
			}

			$flags_items .= "<li id='no_flags'";

			if ( ! empty( $flags_used ) ) $flags_items .= " style='display:none'";

			$flags_items .= "><em>{lang.no_flags}</em></li>";

			foreach( $this->trellis->core->cache['flags'] as $f )
			{
				if ( ! $flags_used[ $f['id'] ] )
				{
					if ( ! $flags_add_list ) $flags_add_list = 1;

					$flags_list .= "<li id='af{$f['id']}' onclick='addFlag({$f['id']},{$t['id']})'><img src='<! UPLD_URL !>/flags/{$f['icon']}' alt='{$f['name']}' class='flagicon' />{$f['name']}</li>";
				}
			}

			$flags_list .= "<li id='noaddflags'";

			if ( $flags_add_list ) $flags_list .= " style='display:none'";

			$flags_list .= "><em>{lang.no_flags_to_add}</em></li>";

			$flags_items .= "<li><input name='add_flag' id='add_flag' type='button' value='{lang.button_add_flag}' class='buttonmini' /><ul id='add_flag_list' class='fakedrop'>{$flags_list}</ul></li>";

			$this->trellis->skin->add_sidebar_list_custom( '{lang.ticket_flags}', $flags_items, 'flags_list' );
		}

		#=============================
		# Do Output
		#=============================

		$notes_items = array(
							"<textarea id='notes' name='notes' cols='4' rows='6' style='width:99%' class='notesbox'>{$t['notes']}</textarea>",
							"<input name='save_notes' id='save_notes' type='submit' value='{lang.button_save_notes}' class='buttonmini' /> <span id='save_notes_status' class='ajax_update_button'>{lang.saved}</span>",
							);

		$this->trellis->skin->add_sidebar_list( '{lang.ticket_notes}', $notes_items );

		$this->trellis->skin->add_javascript( 'autocomplete.js' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add Ticket
	#=======================================

	private function add_ticket()
	{
		$this->trellis->check_perm( 'manage', 'tickets', 'new' );

		switch( $this->trellis->input['step'] )
    	{
    		case 1:
				$this->add_ticket_step_1();
    		break;
    		case 2:
				$this->add_ticket_step_2();
    		break;

    		default:
    			$this->add_ticket_step_1();
    		break;
		}
	}

	#=======================================
	# @ Add Ticket Step 1
	#=======================================

	private function add_ticket_step_1($error='')
	{
		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			$this->trellis->skin->preserve_input = 1;
		}

		$perms = unserialize( $this->trellis->user['g_depart_perm'] );

		$depart_list = "<table width='100%' cellpadding='0' cellspacing='0' class='departlist'>";

		foreach( $this->trellis->core->cache['departs'] as $id => $d )
		{
			if ( $perms[ $d['id'] ] ) $depart_list .= "<tr><td width='1%' valign='top'><input type='radio' name='did' id='d_{$id}' value='{$id}' /></td><td width='99%'><label for='d_{$id}'>{$d['name']}<br /><em>{$d['description']}</em></label></td></tr>";
		}

		$depart_list .= '</table>';

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=add&amp;step=2", 'add_ticket', 'post' ) ."
						<input name='uid' id='uid' type='hidden' value='{$this->trellis->input['uid']}' />
						". $this->trellis->skin->start_group_table( '{lang.submit_a_ticket}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.behalf_of_user}', $this->trellis->skin->textfield( 'uname' ), 'a', '20%', '80%' ) ."
						". $this->trellis->skin->end_group_table() ."
						". $this->trellis->skin->group_sub( '{lang.select_department}' ) ."
						". $this->trellis->skin->group_row( $depart_list, 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_step_2}' ) ) ."
						</div>";

		$this->trellis->skin->end_group( 'a' );

		$this->output .= "<script type='text/javascript'>
						//<![CDATA[
						$('#uname').autocomplete('<! HD_URL !>/admin.php?act=lookup&type=user', {
							dataType: 'json',
							parse: function(data) {
								return $.map(data, function(row) {
									return {
										data: row,
										result: row.caption
									}
								});
							},
							formatItem: function(row, i, max) {
								return row.caption;
							}
						});
						$('#uname').result(function(event, data, formatted) {
							$('#uid').val(data['value']);
						});
						//]]>
						</script>";

		$this->output .= $this->trellis->skin->focus_js('uname');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_tickets_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_javascript( 'autocomplete.js' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add Ticket Step 2
	#=======================================

	private function add_ticket_step_2($error='', $field='')
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['uid'] ) $this->add_ticket_step_1('no_user');
		if ( ! $this->trellis->input['did'] ) $this->add_ticket_step_1('no_depart');

		$perms = unserialize( $this->trellis->user['g_depart_perm'] );

		if ( ! $perms[ $this->trellis->input['did'] ] ) $this->add_ticket_step_1('no_perm'); // use more detailed msg

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			if ( $field )
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'} '. $field );
			}
			else
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			}

			$this->trellis->skin->preserve_input = 1;
		}

		$this->trellis->load_functions('drop_downs');
		$this->trellis->load_functions('cdfields');

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doadd", 'add_ticket', 'post' ) ."
						<input name='uid' id='uid' type='hidden' value='{$this->trellis->input['uid']}' />
						<input name='did' id='did' type='hidden' value='{$this->trellis->input['did']}' />
						". $this->trellis->skin->start_group_table( '{lang.submit_a_ticket}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.subject}', $this->trellis->skin->textfield( 'subject' ), 'a', '20%', '80%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.priority}', "<select name='priority'>". $this->trellis->drop_downs->priority_drop( array( 'select' => $this->trellis->input['priority'] ) ) ."</select>", 'a' );

		if ( $cfields = $this->trellis->cdfields->grab( $this->trellis->input['did'] ) )
		{
			foreach( $cfields as $fid => $f )
			{
				$f['extra'] = unserialize( $f['extra'] );

				if ( $f['type'] == 'textfield' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textfield( array( 'name' => 'cdf_'. $f['id'], 'length' => $f['extra']['size'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'textarea' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textarea( array( 'name' => 'cdf_'. $f['id'], 'cols' => $f['extra']['cols'], 'rows' => $f['extra']['rows'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'dropdown' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->drop_down( array( 'name' => 'cdf_'. $f['id'], 'options' => $f['extra'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'checkbox' )
				{
					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cdf_'. $f['id'] .'_'. $key, 'title' => $name ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $checkbox_html, 'a' );
				}
				elseif ( $f['type'] == 'radio' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->custom_radio( array( 'name' => 'cdf_'. $f['id'], 'options' => $f['extra'] ) ), 'a' );
				}
			}
		}

		$this->output .= $this->trellis->skin->end_group_table() ."
						". $this->trellis->skin->group_sub( '{lang.message}' ) ."
						". $this->trellis->skin->group_row( $this->trellis->skin->textarea( array( 'name' => 'message', 'cols' => '80', 'rows' => '10', 'width' => '98%', 'height' => '180px' ) ), 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_add_ticket}' ) ) ."
						</div>";

		$this->trellis->skin->end_group( 'a' );

		$validate_fields = array(
								 'subject'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_subject}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('subject');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_tickets_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit Ticket
	#=======================================

	private function edit_ticket($error="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'priority', 'message', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'et' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			if ( $field )
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'} '. $field );
			}
			else
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			}

			$this->trellis->skin->preserve_input = 1;

			$priority = $this->trellis->input['priority'];
		}
		else
		{
			$priority = $t['priority'];
		}

		$this->trellis->load_functions('drop_downs');
		$this->trellis->load_functions('cdfields');

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=doedit&amp;id={$t['id']}", 'edit_ticket', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.editing_ticket} '. $t['subject'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.subject}', $this->trellis->skin->textfield( array( 'name' => 'subject', 'value' => $t['subject'] ) ), 'a', '20%', '80%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.priority}', "<select name='priority'>". $this->trellis->drop_downs->priority_drop( array( 'select' => $priority ) ) ."</select>", 'a' );

		if ( $cfields = $this->trellis->cdfields->grab( $t['did'] ) )
		{
			$fdata = $this->trellis->cdfields->get_data( $t['id'] );

			foreach( $cfields as $fid => $f )
			{
				$f['extra'] = unserialize( $f['extra'] );

				if ( $f['type'] == 'textfield' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textfield( array( 'name' => 'cdf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'length' => $f['extra']['size'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'textarea' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textarea( array( 'name' => 'cdf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'cols' => $f['extra']['cols'], 'rows' => $f['extra']['rows'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'dropdown' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->drop_down( array( 'name' => 'cdf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'options' => $f['extra'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'checkbox' )
				{
					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cpf_'. $f['id'] .'_'. $key, 'title' => $name, 'value' => $fdata[ $f['id'] ][ $key ] ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $checkbox_html, 'a' );
				}
				elseif ( $f['type'] == 'radio' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->custom_radio( array( 'name' => 'cpf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'options' => $f['extra'] ) ), 'a' );
				}
			}
		}

		$this->output .= $this->trellis->skin->end_group_table() ."
						". $this->trellis->skin->group_sub( '{lang.message}' ) ."
						". $this->trellis->skin->group_row( $this->trellis->skin->textarea( array( 'name' => 'message', 'value' => $t['message'], 'cols' => '80', 'rows' => '10', 'width' => '98%', 'height' => '180px' ) ), 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_ticket}' ) ) ."
						</div>";

		$this->trellis->skin->end_group( 'a' );

		$validate_fields = array(
								 'subject'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_subject}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=tickets&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=ticket' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_tickets_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Accept
	#=======================================

	private function do_accept()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'accepted', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'r' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( $t['accepted'] ) $this->trellis->skin->error('ticket_already_accepted');

		#=============================
		# Accept Ticket
		#=============================

		$db_array = array(
						  'status'		=> $this->trellis->core->cache['status_defaults'][2],
						  'accepted'	=> 1,
						 );

		$this->trellis->tickets->edit( $db_array, $t['id'] );

		$this->trellis->log( 'admin', "Ticket Accepted &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Accepted &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_accepted' ) );
	}

	#=======================================
	# @ Do Escalate
	#=======================================

	private function do_escalate()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->core->cache['settings']['ticket']['escalate'] ) $this->trellis->skin->error('no_perm');

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'accepted', 'escalated', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'es' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( $t['escalated'] ) $this->trellis->skin->error('ticket_already_escalated');

		if ( ! $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_enable'] ) $this->trellis->skin->error('no_perm');

		#=============================
		# Escalate Ticket
		#=============================

		$this->trellis->tickets->escalate( $t['id'], array( 'did' => $t['did'], 'accepted' => $t['accepted'], 'staff' => 1 ) );

		$this->trellis->log( 'admin', "Ticket Escalated &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Escalated &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Move Ticket
		#=============================

		if ( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_depart'] ) $this->trellis->tickets->move( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_depart'], $t['id'], $t['did'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_escalated' ) );
	}

	#=======================================
	# @ Do Remove Escalate
	#=======================================

	private function do_rmvescalate()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'escalated', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'es' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( ! $t['escalated'] ) $this->trellis->skin->error('ticket_not_escalated');

		#=============================
		# Removae Escalated Status
		#=============================

		$this->trellis->tickets->rmvescalate( $t['id'] );

		$this->trellis->log( 'admin', "Ticket Escalated Status Removed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Escalated Status Removed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_rmvescalated' ) );
	}

	#=======================================
	# @ Do Move
	#=======================================

	private function do_move()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->core->cache['departs'][ $this->trellis->input['did'] ] ) $this->trellis->skin->error('no_depart');

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'mv' ) ) $this->trellis->skin->error('no_perm');

		#=============================
		# Move Ticket
		#=============================

		$this->trellis->tickets->move( $this->trellis->input['did'], $t['id'], $t['did'] );

		$this->trellis->log( 'admin', "Ticket Moved &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Moved &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Clear Assignments
		#=============================

		if ( $this->trellis->core->cache['settings']['ticket']['clear_assign_move'] ) $this->trellis->tickets->clear_assignments( $t['id'] );

		#=============================
		# Add Assignments
		#=============================

		if ( $this->trellis->core->cache['departs'][ $this->trellis->input['did'] ]['assign_move'] )
		{
			$assign = unserialize( $this->trellis->core->cache['departs'][ $this->trellis->input['did'] ]['assign_auto'] );

			if ( ! empty( $assign ) )
			{
				foreach( $assign as $auid )
				{
					$this->trellis->tickets->add_assignment( $auid, $t['id'], $this->trellis->core->cache['settings']['ticket']['clear_assign_move'] );
				}
			}
		}

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_moved' ) );
	}

	#=======================================
	# @ Do Hold
	#=======================================

	private function do_hold()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'accepted', 'aua', 'onhold', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'r' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( $t['onhold'] ) $this->trellis->skin->error('ticket_already_onhold');

		#=============================
		# Hold Ticket
		#=============================

		$this->trellis->tickets->hold( $t['id'], array( 'accepted' => $t['accepted'], 'aua' => $t['aua'] ) );

		$this->trellis->log( 'admin', "Ticket Put On Hold &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Put On Hold &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_hold' ) );
	}

	#=======================================
	# @ Do Remove Hold
	#=======================================

	private function do_rmvhold()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'aua', 'onhold', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'r' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( ! $t['onhold'] ) $this->trellis->skin->error('ticket_not_onhold');

		#=============================
		# Hold Ticket
		#=============================

		$this->trellis->tickets->rmvhold( $t['id'], array( 'aua' => $t['aua'] ) );

		$this->trellis->log( 'admin', "Ticket Hold Removed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Hold Removed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_rmvhold' ) );
	}

	#=======================================
	# @ Do Close
	#=======================================

	private function do_close()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'uid', 'subject', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'c' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Close Ticket
		#=============================

		$this->trellis->tickets->close( $t['id'], $t['uid'] );

		$this->trellis->log( 'admin', "Ticket Closed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Closed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_closed' ) );
	}

	#=======================================
	# @ Do Reopen
	#=======================================

	private function do_reopen()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'uid', 'subject', 'accepted', 'aua', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'ro' ) ) $this->trellis->skin->error('no_perm');

		if ( ! $t['closed'] ) $this->trellis->skin->error('ticket_not_closed');

		#=============================
		# Close Ticket
		#=============================

		$this->trellis->tickets->reopen( $t['id'], array( 'uid' => $t['uid'], 'aua' => $t['aua'], 'accepted' => $t['accepted'], 'staff' => 1 ) );

		$this->trellis->log( 'admin', "Ticket Reopened &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Reopened &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_reopened' ) );
	}

	#=======================================
	# @ Do Priority
	#=======================================

	private function do_priority()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['pid'] ) $this->edit_ticket('no_priority');

		if ( ! $this->trellis->core->cache['priorities'][ $this->trellis->input['pid'] ] ) $this->trellis->skin->error('no_priority');

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'et' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Change Priority
		#=============================

		$this->trellis->tickets->edit( array( 'priority' => $this->trellis->input['pid'] ), $t['id'] );

		$this->trellis->log( 'admin', "Ticket Priority Changed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Priority Changed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'priority_updated' ) );
	}

	#=======================================
	# @ Do Status
	#=======================================

	private function do_status()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['sid'] ) $this->edit_ticket('no_status');

		if ( ! $this->trellis->core->cache['statuses'][ $this->trellis->input['sid'] ] ) $this->trellis->skin->error('no_status');

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'status' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'et' ) ) $this->trellis->skin->error('no_perm');

		if ( $this->trellis->core->cache['statuses'][ $t['status'] ]['type'] != $this->trellis->core->cache['statuses'][ $this->trellis->input['sid'] ]['type'] ) $this->trellis->skin->error('no_perm');

		#=============================
		# Change Status
		#=============================

		$this->trellis->tickets->edit( array( 'status' => $this->trellis->input['sid'] ), $t['id'] );

		$this->trellis->log( 'admin', "Ticket Status Changed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Status Changed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'status_updated' ) );
	}

	#=======================================
	# @ Do Add
	#=======================================

	private function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['uid'] ) $this->add_ticket_step_1('no_user');
		if ( ! $this->trellis->input['did'] ) $this->add_ticket_step_1('no_depart');
		if ( ! $this->trellis->input['subject'] ) $this->add_ticket_step_2('no_subject');
		if ( ! $this->trellis->input['priority'] ) $this->add_ticket_step_2('no_priority');
		if ( ! $this->trellis->input['message'] ) $this->add_ticket_step_2('no_message');

		if ( ! $this->trellis->core->cache['departs'][ $this->trellis->input['did'] ] ) $this->trellis->skin->error('no_depart');

		$perms = unserialize( $this->trellis->user['g_depart_perm'] );

		if ( ! $perms[ $this->trellis->input['did'] ] ) $this->add_ticket_step_1('no_perm');

		#=============================
		# Grab User
		#=============================

		$this->trellis->load_functions('users');

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'email' ), $this->trellis->input['uid'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# Add Ticket
		#=============================

		$db_array = array(
						  'did'			=> $this->trellis->input['did'],
						  'uid'			=> $u['id'],
						  'email'		=> $u['email'],
						  'subject'		=> $this->trellis->input['subject'],
						  'priority'	=> intval( $this->trellis->input['priority'] ),
						  'message'		=> $this->trellis->input['message'],
						  'date'		=> time(),
						  'last_reply'	=> time(),
						  'last_uid'	=> $u['id'],
						  'ipadd'		=> $this->trellis->input['ip_address'],
						  'status'		=> $this->trellis->core->cache['status_defaults'][2],
						  'accepted'	=> 1,
						 );

		$this->trellis->load_functions('cdfields');

		if( ! $fdata = $this->trellis->cdfields->process_input( $this->trellis->input['did'] ) )
		{
			if ( $this->trellis->cdfields->required_field ) $this->add_ticket_step_2( 'no_field', $this->trellis->cdfields->required_field );
		}

		$ticket_id = $this->trellis->tickets->add( $db_array );

		if ( $fdata ) $this->trellis->cdfields->set_data( $fdata, $ticket_id, 1 );

		$this->trellis->log( 'admin', "Ticket Created &#039;". $this->trellis->input['subject'] ."&#039;", 1, $ticket_id );
		$this->trellis->log( 'ticket', "Ticket Created &#039;". $this->trellis->input['subject'] ."&#039;", 1, $ticket_id );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $ticket_id;

		$this->view_ticket( array( 'new' => $ticket_id ) );
	}

	#=======================================
	# @ Do Edit
	#=======================================

	private function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['subject'] ) $this->edit_ticket('no_subject');
		if ( ! $this->trellis->input['priority'] ) $this->edit_ticket('no_priority');
		if ( ! $this->trellis->input['message'] ) $this->edit_ticket('no_message');

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'et' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Edit Ticket
		#=============================

		$db_array = array(
						  'subject'		=> $this->trellis->input['subject'],
						  'priority'	=> intval( $this->trellis->input['priority'] ),
						  'message'		=> $this->trellis->input['message'],
						 );

		$this->trellis->load_functions('cdfields');

		if( ! $fdata = $this->trellis->cdfields->process_input( $t['did'] ) )
		{
			if ( $this->trellis->cdfields->required_field ) $this->edit_ticket( 'no_field', $this->trellis->cdfields->required_field );
		}

		$this->trellis->tickets->edit( $db_array, $t['id'] );

		if ( $fdata ) $this->trellis->cdfields->set_data( $fdata, $t['id'] );

		$this->trellis->log( 'admin', "Ticket Edited &#039;". $this->trellis->input['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Edited &#039;". $this->trellis->input['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		$this->view_ticket( array( 'alert' => 'ticket_updated' ) );
	}

	#=======================================
	# @ Do Delete
	#=======================================

	private function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'uid', 'subject', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'dt' ) ) $this->trellis->skin->error('no_perm');

		#=============================
		# DELETE Ticket
		#=============================

		$this->trellis->tickets->delete( $t['id'], array( 'did' => $t['did'], 'uid' => $t['uid'], 'closed' => $t['closed'] ) );

		$this->trellis->log( 'admin', "Ticket Deleted &#039;". $t['subject'] ."&#039;", 2, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->list_tickets( 'ticket_deleted' );
	}

	#=======================================
	# @ Do Add Reply
	#=======================================

	private function do_add_reply()
	{
		#=============================
		# Security Checks
		#=============================

		if ( $this->trellis->input['html'] )
		{
			$this->trellis->input['message'] = $this->trellis->remove_extra_lbs( $this->trellis->input['message'] );
		}

		if ( ! $this->trellis->input['message'] ) $this->view_ticket( array( 'reply_error' => 'no_message' ) );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did', 'subject', 'accepted', 'onhold', 'closed' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->check_perm( $t['did'], 'r' ) ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Add Reply
		#=============================

		$db_array = array(
						  'tid'			=> $t['id'],
						  'uid'			=> $this->trellis->user['id'],
						  'message'		=> $this->trellis->input['message'],
						  'signature'	=> $this->trellis->input['signature'],
						  'staff'		=> 1,
						  'html'		=> $this->trellis->input['html'],
						  'secret'		=> $this->trellis->input['secret'],
						  'date'		=> time(),
						  'ipadd'		=> $this->trellis->input['ip_address'],
						 );

		$reply_id = $this->trellis->tickets->add_reply( $db_array, $t['id'], array( 'accepted' => $t['accepted'], 'onhold' => $t['onhold'] ) );

		$this->trellis->log( 'admin', "Ticket Reply Added &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Reply Added &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $t['id'];

		if ( $this->trellis->input['ajax'] )
		{
			$this->trellis->skin->ajax_output( '1' );
		}
		else
		{
			$this->view_ticket( array( 'reply' => $reply_id ) );
		}
	}

	#=======================================
	# @ Do Edit Reply
	#=======================================

	private function do_edit_reply()
	{
		#=============================
		# Security Checks
		#=============================

		if ( $this->trellis->input['html'] )
		{
			$this->trellis->input['message'] = $this->trellis->remove_extra_lbs( $this->trellis->input['message'] );
		}

		if ( ! $this->trellis->input['message'] ) $this->trellis->skin->ajax_output( '0' );

		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => 'all',
												   							 't' => array( 'did', 'subject', 'closed' ),
												   							 'u' => array( array( 'signature' => 'usignature' ), 'sig_html' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ), array( 'from' => array( 'u' => 'users' ), 'where' => array( 'r' => 'uid', '=', 'u' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( ! $r ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $r['did'], 'er' ) && ( $r['uid'] != $this->trellis->user['id'] || ! $this->trellis->user['g_reply_edit'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $r['closed'] ) $this->trellis->skin->ajax_output( '0' );

		#=============================
		# Edit Reply
		#=============================

		$db_array = array(
						  'message'		=> $this->trellis->input['message'],
						  'html'		=> $this->trellis->input['html'],
						 );

		$this->trellis->tickets->edit_reply( $db_array, $r['id'] );

		$this->trellis->log( 'admin', "Ticket Reply Edited &#039;". $r['subject'] ."&#039;", 1, $r['tid'] );
		$this->trellis->log( 'ticket', "Ticket Reply Edited &#039;". $r['subject'] ."&#039;", 1, $r['tid'] );

		#=============================
		# Do Output
		#=============================

		$routput_params = array( 'urls' => 1 );

		if ( $this->trellis->input['html'] )
		{
			$routput_params['html'] = 1;
		}
		else
		{
			$routput_params['nl2br'] = 1;
		}

		$rmessage = $this->trellis->prepare_output( $this->trellis->input['message'], $routput_params );

		if ( $r['signature'] )
		{
			$rmessage .= '<br /><br />'. $this->trellis->prepare_output( $r['usignature'], array( 'html' => $r['sig_html'] ) );
		}

		$this->trellis->skin->ajax_output( $rmessage );
	}

	#=======================================
	# @ Do Delete Reply
	#=======================================

	private function do_delete_reply()
	{
		#=============================
		# Security Checks
		#=============================

		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => array( 'id', 'tid', 'uid', 'staff', 'secret', 'date' ),
												   							 't' => array( 'did', 'subject', 'last_reply', 'last_reply_staff', 'closed' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( ! $r ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $r['did'], 'dr' ) && ( $r['uid'] != $this->trellis->user['id'] || ! $this->trellis->user['g_reply_delete'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $r['closed'] ) $this->trellis->skin->ajax_output( '0' );

		#=============================
		# DELETE Reply
		#=============================

		$this->trellis->tickets->delete_reply( $r['id'], array( 'tid' => $r['tid'], 'secret' => $r['secret'], 'date' => $r['date'], 'last_reply' => $r['last_reply'], 'last_reply_staff' => $r['last_reply_staff'], 'staff' => $r['staff'] ) );

		$this->trellis->log( 'admin', "Ticket Reply Deleted &#039;". $r['subject'] ."&#039;", 2, $r['tid'] );
		$this->trellis->log( 'ticket', "Ticket Reply Deleted &#039;". $r['subject'] ."&#039;", 2, $r['tid'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->ajax_output( '1' );
	}

	#=======================================
	# @ Generate URL
	#=======================================

	private function generate_url($params=array())
	{
		$url = '<! HD_URL !>/admin.php?section=manage&amp;page=tickets';

		if ( ! isset( $params['sort'] ) ) $params['sort'] = $this->trellis->input['sort'];
		if ( ! isset( $params['order'] ) ) $params['order'] = $this->trellis->input['order'];
		if ( ! isset( $params['search'] ) ) $params['search'] = $this->trellis->input['search'];
		if ( ! isset( $params['field'] ) ) $params['field'] = $this->trellis->input['field'];
		if ( ! isset( $params['my'] ) ) $params['my'] = $this->trellis->input['my'];
		if ( ! isset( $params['fstatus'] ) ) $params['fstatus'] = $this->trellis->input['fstatus'];
		if ( ! isset( $params['fdepart'] ) ) $params['fdepart'] = $this->trellis->input['fdepart'];
		if ( ! isset( $params['fpriority'] ) ) $params['fpriority'] = $this->trellis->input['fpriority'];
		if ( ! isset( $params['cf'] ) ) $params['cf'] = $this->trellis->input['cf'];

		if ( $params['sort'] ) $url .= '&amp;sort='. $params['sort'];

		if ( $params['order'] ) $url .= '&amp;order='. $params['order'];

		if ( $params['search'] ) $url .= '&amp;search='. $params['search'];

		if ( $params['field'] ) $url .= '&amp;field='. $params['field'];

		if ( $params['my'] ) $url .= '&amp;my='. $params['my'];

		if ( is_array( $params['fstatus'] ) )
		{
			foreach( $params['fstatus'] as $sid )
			{
				$url .= '&amp;fstatus'. urlencode( '[]' ) .'='. $sid;
			}
		}

		if ( is_array( $params['fdepart'] ) )
		{
			foreach( $params['fdepart'] as $did )
			{
				$url .= '&amp;fdepart'. urlencode( '[]' ) .'='. $did;
			}
		}

		if ( is_array( $params['fpriority'] ) )
		{
			foreach( $params['fpriority'] as $fid )
			{
				$url .= '&amp;fpriority'. urlencode( '[]' ) .'='. $fid;
			}
		}

		if ( $params['cf'] ) $url .= '&amp;cf='. $params['cf'];

		return $url;
	}

	#=======================================
	# @ Check Permission
	#=======================================

	private function check_perm($did, $type)
	{
		if ( $this->trellis->user['id'] == 1 ) return true;

		if ( ! $this->trellis->user['g_acp_depart_perm'][ $did ][ $type ] )
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	#=======================================
	# @ AJAX Do Add Assignment
	#=======================================

	private function ajax_add_assign()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did' ), 'from' => 'tickets' ), $this->trellis->input['tid'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $t['did'], 'aa' ) && ( $this->trellis->input['uid'] != $this->trellis->user['id'] || ! $this->check_perm( $t['did'], 'as' ) ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $uname = $this->trellis->tickets->add_assignment( $this->trellis->input['uid'], $t['id'], 0 , 1 ) )
		{
			$this->trellis->skin->ajax_output( $uname );
		}
		else
		{
			$this->trellis->skin->ajax_output( '0' );
		}
	}

	#=======================================
	# @ AJAX Do Add Flag
	#=======================================

	private function ajax_add_flag()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did' ), 'from' => 'tickets' ), $this->trellis->input['tid'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $t['did'], 'v' ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $fid = $this->trellis->tickets->add_flag( $this->trellis->input['fid'], $t['id'] ) )
		{
			$this->trellis->skin->ajax_output( '1' );
		}
		else
		{
			$this->trellis->skin->ajax_output( '0' );
		}
	}

	#=======================================
	# @ AJAX Do Delete Assignment
	#=======================================

	private function ajax_delete_assign()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did' ), 'from' => 'tickets' ), $this->trellis->input['tid'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $t['did'], 'aa' ) && ( $this->trellis->input['uid'] != $this->trellis->user['id'] || ! $this->check_perm( $t['did'], 'as' ) ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $uname = $this->trellis->tickets->delete_assignment( $this->trellis->input['uid'], $t['id'] ) )
		{
			$this->trellis->skin->ajax_output( '1' );
		}
		else
		{
			$this->trellis->skin->ajax_output( '0' );
		}
	}

	#=======================================
	# @ AJAX Do Delete Flag
	#=======================================

	private function ajax_delete_flag()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did' ), 'from' => 'tickets' ), $this->trellis->input['tid'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $t['did'], 'v' ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $this->trellis->tickets->delete_flag( $this->trellis->input['fid'], $t['id'] ) )
		{
			$this->trellis->skin->ajax_output( '1' );
		}
		else
		{
			$this->trellis->skin->ajax_output( '0' );
		}
	}

	#=======================================
	# @ AJAX Do Save Notes
	#=======================================

	private function ajax_save_notes()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'did' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $t['did'], 'v' ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $this->trellis->tickets->edit( array( 'notes' => $this->trellis->input['notes'] ), $t['id'] ) )
		{
			$this->trellis->skin->ajax_output( '1' );
		}
		else
		{
			$this->trellis->skin->ajax_output( '0' );
		}
	}

	#=======================================
	# @ AJAX Do Save Defaults
	#=======================================

	private function ajax_save_defaults()
	{
		parse_str( str_replace( '&amp;', '&', $this->trellis->input['defaults'] ), $defaults );

		if ( $this->trellis->input['type'] == 'status' )
		{
			$db_array = array( 'dfilters_status' => serialize( $defaults['fstatus'] ) );
		}
		elseif ( $this->trellis->input['type'] == 'depart' )
		{
			$db_array = array( 'dfilters_depart' => serialize( $defaults['fdepart'] ) );
		}
		elseif ( $this->trellis->input['type'] == 'priority' )
		{
			$db_array = array( 'dfilters_priority' => serialize( $defaults['fpriority'] ) );
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'users_staff',
												   'set'	=> $db_array,
												   'where'	=> array( 'uid', '=', $this->trellis->user['id'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->skin->ajax_output( $this->trellis->core->db->get_affected_rows() );
	}

	#=======================================
	# @ AJAX Get Status
	#=======================================

	private function ajax_get_status()
	{
		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'status' ), 'from' => 'tickets' ), $this->trellis->input['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		$this->trellis->load_functions('drop_downs');

		$this->trellis->skin->ajax_output( $this->trellis->drop_downs->status_drop( array( 'type' => $this->trellis->core->cache['statuses'][ $t['status'] ]['type'] ) ) );
	}

	#=======================================
	# @ AJAX Get Reply Template
	#=======================================

	private function ajax_get_reply_template()
	{
		if ( ! $rt = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'content_html', 'content_plaintext' ), 'from' => 'reply_templates' ), $this->trellis->input['id'] ) ) $this->trellis->skin->ajax_output( '0' );

		if( $this->trellis->input['html'] )
		{
			$message = $this->trellis->prepare_output( $rt['content_html'], array( 'html' => 1 ) );
		}
		else
		{
			$message = $rt['content_plaintext'];
		}

		$this->trellis->skin->ajax_output( $message );
	}

	#=======================================
	# @ AJAX Get Reply
	#=======================================

	private function ajax_get_reply()
	{
		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => 'all',
												   							 't' => array( 'did', 'closed' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( ! $r ) $this->trellis->skin->ajax_output( '0' );

		if ( ! $this->check_perm( $r['did'], 'er' ) && ( $r['uid'] != $this->trellis->user['id'] || ! $this->trellis->user['g_reply_edit'] ) ) $this->trellis->skin->ajax_output( '0' );

		if ( $r['closed'] ) $this->trellis->skin->ajax_output( '0' );

		$this->trellis->skin->ajax_output( $this->trellis->prepare_output( $r['message'], array( 'html' => $r['html'] ) ) );
	}

}

?>