<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Source: Users
#======================================================
*/

class ad_users {

	private $output = "";

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		$this->trellis->check_perm( 'manage', 'users' );

		$this->trellis->load_functions('users');
		$this->trellis->ad_load_lang('users');

		$this->trellis->skin->set_active_link( 2 );

		switch( $this->trellis->input['act'] )
	    {
	    	case 'list':
				$this->list_users();
	    	break;
	    	case 'view':
				$this->view_user();
	    	break;
	    	case 'add':
	    		$this->add_user();
	    	break;
	    	case 'edit':
	    		$this->edit_user();
	    	break;
	    	case 'delete':
	    		$this->delete_user();
	    	break;
	    	case 'sig':
				$this->edit_signature();
	    	break;

	    	case 'doadd':
	    		$this->do_add();
	    	break;
	    	case 'doedit':
	    		$this->do_edit();
	    	break;
	    	case 'dodel':
	    		$this->do_delete();
	    	break;
	    	case 'dosig':
	    		$this->do_signature();
	    	break;

	    	default:
	    		$this->list_users();
	    	break;
		}
	}

	#=======================================
	# @ List Users
	#=======================================

	private function list_users($error='', $alert='')
	{
		#=============================
		# Sorting Options
		#=============================

		$sort = $this->trellis->generate_sql_sort( array(
														 'default_sort' => 'id',
														 'default_order' => 'asc',
														 'base_url' => '<! HD_URL !>/admin.php?section=manage&amp;page=users',
														 'options' => array(
														 					'id' => '{lang.id}',
														 					'name' => '{lang.name}',
														 					'tickets_open' => '{lang.open_tickets}',
														 					'tickets_total' => '{lang.total_tickets}',
														 					),
												  )		 );

		#=============================
		# Grab Users
		#=============================

		$user_rows = '';

		if ( ! $users = $this->trellis->users->get( array( 'select' => array( 'id', 'name', 'ugroup', 'tickets_total', 'tickets_open' ), 'order' => array( $sort['sort'] => $sort['order'] ) ) ) )
		{
			$user_rows .= "<tr><td class='bluecell-light' colspan='7'><strong><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add'>{lang.no_users}</a></strong></td></tr>";
		}
		else
		{
			foreach( $users as $uid => $u )
			{
				$user_rows .= "<tr>
									<td class='bluecellthin-light'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$u['id']}'><strong>{$u['id']}</strong></a></td>
									<td class='bluecellthin-dark'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=view&amp;id={$u['id']}'>{$u['name']}</a></td>
									<td class='bluecellthin-light' style='font-weight: normal'>". $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_name'] ."</td>
									<td class='bluecellthin-light' align='center'>{$u['tickets_open']}</td>
									<td class='bluecellthin-light' align='center'>{$u['tickets_total']}</td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=edit&amp;id={$u['id']}'><img src='<! IMG_DIR !>/button_edit.gif' alt='{lang.edit}' /></a></td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=delete&amp;id={$u['id']}'><img src='<! IMG_DIR !>/button_delete.gif' alt='{lang.delete}' /></a></td>
								</tr>";
			}
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
		}
		elseif ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.users_list}' ) ."
						<tr>
							<th class='bluecellthin-th' width='6%' align='left'>{$sort['link_id']}</th>
							<th class='bluecellthin-th' width='32%' align='left'>{$sort['link_name']}</th>
							<th class='bluecellthin-th' width='22%' align='left'>{lang.group}</th>
							<th class='bluecellthin-th' width='17%' align='center'>{$sort['link_tickets_open']}</th>
							<th class='bluecellthin-th' width='17%' align='center'>{$sort['link_tickets_total']}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.edit}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.delete}</th>
						</tr>
						". $user_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add' ),
							array( 'tick', '{lang.menu_approve}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=approve' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_users_title}', '{lang.help_about_users_msg}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ View User
	#=======================================

	private function view_user($alert='')
	{
		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'name', 'email', 'ugroup', 'title', 'joined', 'time_zone', 'time_dst', 'tickets_total', 'tickets_open' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# Do Output
		#=============================

		if ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->trellis->load_functions('cpfields');

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.viewing_user} '. $u['name'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.username}', $u['name'], 'a', '20%', '80%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email}', $u['email'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.title}', $u['title'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.group}', $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_name'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.time_zone}', $u['time_zone'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.local_time}', $this->trellis->td_timestamp( array( 'time' => time(), 'time_zone' => $u['time_zone'], 'dst' => $u['time_dst'], 'format' => 'long' ) ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.joined}', $this->trellis->td_timestamp( array( 'time' => $u['joined'], 'format' => 'long' ) ), 'a' );

		if ( $cfields = $this->trellis->cpfields->grab( $u['ugroup'], 1 ) )
		{
			$this->output .= $this->trellis->skin->group_table_sub( '{lang.additional_info}' );

			$fdata = $this->trellis->cpfields->get_data( $u['id'] );

			foreach( $cfields as $fid => $f )
			{
				if ( $f['type'] == 'checkbox' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cpf_'. $f['id'] .'_'. $key, 'title' => $name, 'value' => $fdata[ $f['id'] ][ $key ], 'disabled' => 1 ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $checkbox_html, 'a' );
				}
				elseif ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
				{
					$f['extra'] = unserialize( $f['extra'] );

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $f['extra'][ $fdata[ $f['id'] ] ], 'a' );
				}
				else
				{
					if ( ! $fdata[ $f['id'] ] ) $fdata[ $f['id'] ] = '--';

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $fdata[ $f['id'] ], 'a' );
				}
			}
		}

		$this->output .= $this->trellis->skin->group_table_sub( '{lang.statistics}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.open_tickets}', $u['tickets_open'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.total_tickets}', $u['tickets_total'], 'a' ) ."
						". $this->trellis->skin->end_group_table( 'a' ) ."
						</div>";

		$menu_items = array(
							array( 'buoy', '{lang.menu_user_tickets}', '#' ),
							array( 'buoy_plus', '{lang.menu_user_submit}', '#' ),
							array( 'signature', '{lang.menu_user_signature}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=sig&amp;id='. $u['id'] ),
							array( 'user_pencil', '{lang.menu_user_edit}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=edit&amp;id='. $u['id'] ),
							array( 'user_minus', '{lang.menu_user_delete}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=delete&amp;id='. $u['id'] ),
							);

		$this->trellis->skin->add_sidebar_menu( $u['name'], $menu_items );

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=users' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Add User
	#=======================================

	private function add_user($error='', $field='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'add' );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			if ( $field )
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'} '. $field );
			}
			else
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			}

			$this->trellis->skin->preserve_input = 1;
		}

		$this->trellis->load_functions('drop_downs');
		$this->trellis->load_functions('cpfields');

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=doadd", 'add_user', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.adding_user}', 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.username}', $this->trellis->skin->textfield( 'name' ), 'a', '25%', '75%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email}', $this->trellis->skin->textfield( 'email' ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.password}', $this->trellis->skin->textfield( 'password' ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.title} '. $this->trellis->skin->help_tip('{lang.tip_title}'), $this->trellis->skin->textfield( 'title' ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.group}', "<select name='ugroup' id='ugroup'>". $this->trellis->drop_downs->group_drop( array( 'select' => $this->trellis->input['ugroup'] ) ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.sub_groups} '. $this->trellis->skin->help_tip('{lang.tip_sub_groups}'), "<select name='ugroup_sub[]' id='ugroup_sub' multiple='yes'>". $this->trellis->drop_downs->group_drop( array( 'select' => $this->trellis->input['ugroup_sub'] ) ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.time_zone}', "<select name='time_zone' id='time_zone'>". $this->trellis->drop_downs->time_zone_drop( $this->trellis->input['time_zone'] ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.dst} '. $this->trellis->skin->help_tip('{lang.dst}'), $this->trellis->skin->custom_radio( 'time_dst', array( 0 => '{lang.inactive}', 1 => '{lang.active}', 2 => '{lang.auto}' ), 2 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.language}', "<select name='lang' id='lang'>". $this->trellis->drop_downs->lang_drop( $this->trellis->input['lang'] ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.skin}', "<select name='skin' id='skin'>". $this->trellis->drop_downs->skin_drop( $this->trellis->input['skin'] ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.rich_text_editor}', $this->trellis->skin->enabled_disabled_radio( 'rte_enable', 1 ), 'a' );

		if ( $cfields = $this->trellis->cpfields->grab( 0, 1 ) )
		{
			$this->output .= $this->trellis->skin->group_table_sub( '{lang.additional_info}' );

			foreach( $cfields as $fid => $f )
			{
				$f['extra'] = unserialize( $f['extra'] );

				if ( $f['type'] == 'textfield' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textfield( array( 'name' => 'cpf_'. $f['id'], 'length' => $f['extra']['size'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'textarea' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textarea( array( 'name' => 'cpf_'. $f['id'], 'cols' => $f['extra']['cols'], 'rows' => $f['extra']['rows'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'dropdown' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->drop_down( array( 'name' => 'cpf_'. $f['id'], 'options' => $f['extra'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'checkbox' )
				{
					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cpf_'. $f['id'] .'_'. $key, 'title' => $name ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $checkbox_html, 'a' );
				}
				elseif ( $f['type'] == 'radio' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->custom_radio( array( 'name' => 'cpf_'. $f['id'], 'options' => $f['extra'] ) ), 'a' );
				}
			}
		}

		$this->output .= $this->trellis->skin->group_table_sub( '{lang.user_email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_notifications}', $this->trellis->skin->enabled_disabled_radio( 'email_enable', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_ticket}', $this->trellis->skin->enabled_disabled_radio( 'email_ticket', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_reply}', $this->trellis->skin->enabled_disabled_radio( 'email_reply', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_news}', $this->trellis->skin->enabled_disabled_radio( 'email_news', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.staff_email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_notifications}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_enable', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_ticket}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_ticket', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_reply}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_reply', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_assign}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_assign', 1 ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.receive_for}', $this->trellis->skin->checkbox( array( 'name' => 'esn_unassigned', 'title' => '{lang.unassigned_tickets}', 'value' => 1 ) ) ."<br />". $this->trellis->skin->checkbox( array( 'name' => 'esn_assigned', 'title' => '{lang.assigned_tickets}', 'value' => 1 ) ) ."<br />". $this->trellis->skin->checkbox( array( 'name' => 'esn_assigned_to_me', 'title' => '{lang.tickets_assigned_to_me}', 'value' => 1 ) ), 'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_type}', $this->trellis->skin->custom_radio( 'email_type', array( 1 => '{lang.html}', 2 => '{lang.plain_text}' ), 1 ), 'a' ) ."
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'add', '{lang.button_add_user}' ) ) ."
						</div>";

		$validate_fields = array(
								 'name'		=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_name}' ) ) ),
								 'email'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_email}' ) ), array( 'type' => 'email', 'params' => array( 'fail_msg' => '{lang.lv_invalid_email}' ) ) ),
								 'password'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_password}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('name');

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=users' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit User
	#=======================================

	private function edit_user($error='', $field='')
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'edit' );

		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'name', 'email', 'ugroup', 'ugroup_sub', 'title', 'lang', 'skin', 'time_zone', 'time_dst', 'rte_enable', 'email_enable', 'email_ticket', 'email_reply', 'email_news', 'email_type' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# More Security Checks
		#=============================

		$staff = 0;

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] )
		{
			$this->trellis->check_perm( 'manage', 'users', 'acp' );

			$staff = 1;
		}

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] )
					{
						$this->trellis->check_perm( 'manage', 'users', 'acp' );

						$staff = 1;

						break;
					}
				}
			}
		}

		if ( $staff )
		{
			$us = $this->trellis->users->get_single_by_id_staff( array( 'email_staff_enable', 'email_staff_ticket', 'email_staff_reply', 'email_staff_assign', 'esn_unassigned', 'esn_assigned', 'esn_assigned_to_me' ), $u['id'] );

			if ( is_array( $us ) ) $u = array_merge( $us, $u );
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			if ( $field )
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'} '. $field );
			}
			else
			{
				$this->output .= $this->trellis->skin->error_wrap( '{lang.error_'. $error .'}' );
			}

			$this->trellis->skin->preserve_input = 1;

			$ugroup = $this->trellis->input['ugroup'];
			$ugroup_sub = $this->trellis->input['ugroup_sub'];
			$time_zone = $this->trellis->input['time_zone'];
			$lang = $this->trellis->input['lang'];
			$skin = $this->trellis->input['skin'];
		}
		else
		{
			$ugroup = $u['ugroup'];
			$ugroup_sub = $u['ugroup_sub'];
			$time_zone = $u['time_zone'];
			$lang = $u['lang'];
			$skin = $u['skin'];
		}

		$this->trellis->load_functions('drop_downs');
		$this->trellis->load_functions('cpfields');

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=doedit&amp;id={$u['id']}", 'edit_user', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.editing_user} '. $u['name'], 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.username}', $this->trellis->skin->textfield( 'name', $u['name'] ), 'a', '25%', '75%' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email}', $this->trellis->skin->textfield( 'email', $u['email'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.password} '. $this->trellis->skin->help_tip('{lang.tip_change_password}'), $this->trellis->skin->textfield( 'password' ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.title} '. $this->trellis->skin->help_tip('{lang.tip_title}'), $this->trellis->skin->textfield( 'title', $u['title'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.group}', "<select name='ugroup' id='ugroup'>". $this->trellis->drop_downs->group_drop( array( 'select' => $ugroup ) ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.sub_groups} '. $this->trellis->skin->help_tip('{lang.tip_sub_groups}'), "<select name='ugroup_sub[]' id='ugroup_sub' multiple='yes'>". $this->trellis->drop_downs->group_drop( array( 'select' => $ugroup_sub ) ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.time_zone}', "<select name='time_zone' id='time_zone'>". $this->trellis->drop_downs->time_zone_drop( $time_zone ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.dst} '. $this->trellis->skin->help_tip('{lang.dst}'), $this->trellis->skin->custom_radio( 'time_dst', array( 0 => '{lang.inactive}', 1 => '{lang.active}', 2 => '{lang.auto}' ), $u['time_dst'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.language}', "<select name='lang' id='lang'>". $this->trellis->drop_downs->lang_drop( $lang ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.skin}', "<select name='skin' id='skin'>". $this->trellis->drop_downs->skin_drop( $skin ) ."</select>", 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.rich_text_editor}', $this->trellis->skin->enabled_disabled_radio( 'rte_enable', $u['rte_enable'] ), 'a' );

		if ( $cfields = $this->trellis->cpfields->grab( 0, 1 ) )
		{
			$this->output .= $this->trellis->skin->group_table_sub( '{lang.additional_info}' );

			$fdata = $this->trellis->cpfields->get_data( $u['id'] );

			foreach( $cfields as $fid => $f )
			{
				$f['extra'] = unserialize( $f['extra'] );

				if ( $f['type'] == 'textfield' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textfield( array( 'name' => 'cpf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'length' => $f['extra']['size'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'textarea' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->textarea( array( 'name' => 'cpf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'cols' => $f['extra']['cols'], 'rows' => $f['extra']['rows'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'dropdown' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->drop_down( array( 'name' => 'cpf_'. $f['id'], 'value' => $fdata[ $f['id'] ], 'options' => $f['extra'] ) ), 'a' );
				}
				elseif ( $f['type'] == 'checkbox' )
				{
					$checkbox_html = '';

					foreach( $f['extra'] as $key => $name )
					{
						$checkbox_html .= $this->trellis->skin->checkbox( array( 'name' => 'cpf_'. $f['id'] .'_'. $key, 'title' => $name, 'value' => $fdata[ $f['id'] ][ $key ] ) ) .'&nbsp;&nbsp;&nbsp;';
					}

					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $checkbox_html, 'a' );
				}
				elseif ( $f['type'] == 'radio' )
				{
					$this->output .= $this->trellis->skin->group_table_row( $f['name'], $this->trellis->skin->custom_radio( array( 'name' => 'cpf_'. $f['id'], 'options' => $f['extra'], 'value' => $fdata[ $f['id'] ] ) ), 'a' );
				}
			}
		}

		$this->output .= $this->trellis->skin->group_table_sub( '{lang.user_email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_notifications}', $this->trellis->skin->enabled_disabled_radio( 'email_enable', $u['email_enable'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_ticket}', $this->trellis->skin->enabled_disabled_radio( 'email_ticket', $u['email_ticket'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_reply}', $this->trellis->skin->enabled_disabled_radio( 'email_reply', $u['email_reply'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_news}', $this->trellis->skin->enabled_disabled_radio( 'email_news', $u['email_news'] ), 'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.staff_email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_notifications}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_enable', $u['email_staff_enable'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_ticket}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_ticket', $u['email_staff_ticket'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_reply}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_reply', $u['email_staff_reply'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_assign}', $this->trellis->skin->enabled_disabled_radio( 'email_staff_assign', $u['email_staff_assign'] ), 'a' ) ."
						". $this->trellis->skin->group_table_row( '{lang.receive_for}', $this->trellis->skin->checkbox( array( 'name' => 'esn_unassigned', 'title' => '{lang.unassigned_tickets}', 'value' => $u['esn_unassigned'] ) ) ."<br />". $this->trellis->skin->checkbox( array( 'name' => 'esn_assigned', 'title' => '{lang.assigned_tickets}', 'value' => $u['esn_assigned'] ) ) ."<br />". $this->trellis->skin->checkbox( array( 'name' => 'esn_assigned_to_me', 'title' => '{lang.tickets_assigned_to_me}', 'value' => $u['esn_assigned_to_me'] ) ), 'a' ) ."
						". $this->trellis->skin->group_table_sub( '{lang.email_preferences}' ) ."
						". $this->trellis->skin->group_table_row( '{lang.email_type}', $this->trellis->skin->custom_radio( 'email_type', array( 1 => '{lang.html}', 2 => '{lang.plain_text}' ), $u['email_type'] ), 'a' ) ."
						". $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_user}' ) ) ."
						</div>";

		$validate_fields = array(
								 'name'		=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_name}' ) ) ),
								 'email'	=> array( array( 'type' => 'presence', 'params' => array( 'fail_msg' => '{lang.lv_no_email}' ) ), array( 'type' => 'email', 'params' => array( 'fail_msg' => '{lang.lv_invalid_email}' ) ) ),
								 );

		$this->output .= $this->trellis->skin->live_validation_js( $validate_fields );
		$this->output .= $this->trellis->skin->focus_js('name');

		$menu_items = array(
							array( 'signature', '{lang.menu_user_signature}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=sig&amp;id='. $u['id'] ),
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=users' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Delete User Form
	#=======================================

	private function delete_user()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'delete' );

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'name', 'ugroup', 'ugroup_sub' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );
				}
			}
		}

		#=============================
		# Do Output
		#=============================

		$this->output = "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=dodel&amp;id={$u['id']}", 'delete_user', 'post' ) ."
						". $this->trellis->skin->group_title( '{lang.deleting_user} '. $u['name'] ) ."
						". $this->trellis->skin->group_sub( '{lang.delete_user_options}' ) ."
						<div class='option1'>". $this->trellis->skin->checkbox( 'delete_tickets', '{lang.delete_user_tickets}', 1 ) ."</div>
						<div class='option2'>". $this->trellis->skin->checkbox( 'delete_replies', '{lang.delete_user_replies}', 1 ) ."</div>
						<div class='option1'>". $this->trellis->skin->checkbox( 'delete_comments', '{lang.delete_user_comments}', 1 ) ."</div>
						<div class='option2'>". $this->trellis->skin->checkbox( 'delete_ratings', '{lang.delete_user_ratings}', 1 ) ."</div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'delete', '{lang.button_delete_user}' ) ) ."
						</div>";

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=users' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit Signature
	#=======================================

	private function edit_signature()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'edit' );

		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'name', 'ugroup', 'ugroup_sub', 'signature', 'sig_auto' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# More Security Checks
		#=============================

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );
				}
			}
		}

		#=============================
		# Do Output
		#=============================

		if ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		if ( $this->trellis->user['rte_enable'] && $this->trellis->core->cache['settings']['tickets']['rte'] )
		{
			$this->output .= $this->trellis->skin->tinymce_js( 'signature' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=dosig&amp;id={$u['id']}", 'edit_signature', 'post' ) ."
						". $this->trellis->skin->group_title( '{lang.editing_signature} '. $u['name'] ) ."
						<div class='option1'>". $this->trellis->skin->textarea( array( 'name' => 'signature', 'value' => $u['signature'], 'cols' => 80, 'rows' => 6, 'width' => '98%', 'height' => '160px' ) ) ."</div>
						<div class='option2'>". $this->trellis->skin->checkbox( 'sig_auto', '{lang.auto_append_sig}', $u['sig_auto'] ) ."</div>
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_signature}' ) ) ."
						</div>";

		$menu_items = array(
							array( 'user_pencil', '{lang.menu_user_edit}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=edit&amp;id='. $u['id'] ),
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=manage&amp;page=users' ),
							array( 'circle_plus', '{lang.menu_add}', '<! HD_URL !>/admin.php?section=manage&amp;page=users&amp;act=add' ),
							array( 'settings', '{lang.menu_settings}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group=users' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_users_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Add User
	#=======================================

	private function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'add' );

		if ( ! $this->trellis->input['name'] ) $this->add_user('no_username');
		if ( ! $this->trellis->input['email'] ) $this->add_user('no_email');
		if ( ! $this->trellis->input['password'] ) $this->add_user('no_password');

		if ( ! $this->trellis->validate_email( $this->trellis->input['email'] ) ) $this->add_user('invalid_email');

		#=============================
		# Add User
		#=============================

		( ! empty( $this->trellis->input['ugroup_sub'] ) ) ? $ugroup_sub = serialize( $this->trellis->input['ugroup_sub'] ) : $ugroup_sub = '';

		$staff = 0;

		if ( $this->trellis->core->cache['groups'][ $this->trellis->input['ugroup'] ]['g_acp_access'] )
		{
			$staff = 1;
		}
		elseif ( ! empty( $this->trellis->input['ugroup_sub'] ) && ! $staff )
		{
			foreach( $this->trellis->input['ugroup_sub'] as $gid )
			{
				if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] )
				{
					$staff = 1;

					break;
				}
			}
		}

		$db_array = array(
						  'name'				=> $this->trellis->input['name'],
						  'email'				=> $this->trellis->input['email'],
						  'password'			=> $this->trellis->input['password'],
						  'ugroup'				=> $this->trellis->input['ugroup'],
						  'ugroup_sub'			=> $ugroup_sub,
						  'title'				=> $this->trellis->input['title'],
						  'joined'				=> time(),
						  'sig_auto'			=> 1,
						  'lang'				=> $this->trellis->input['lang'],
						  'skin'				=> $this->trellis->input['skin'],
						  'time_zone'			=> $this->trellis->input['time_zone'],
						  'time_dst'			=> $this->trellis->input['time_dst'],
						  'rte_enable'			=> $this->trellis->input['rte_enable'],
						  'email_enable'		=> $this->trellis->input['email_enable'],
						  'email_ticket'		=> $this->trellis->input['email_ticket'],
						  'email_reply'			=> $this->trellis->input['email_reply'],
						  'email_news'			=> $this->trellis->input['email_news'],
						  'email_staff_enable'	=> $this->trellis->input['email_staff_enable'],
						  'email_staff_ticket'	=> $this->trellis->input['email_staff_ticket'],
						  'email_staff_reply'	=> $this->trellis->input['email_staff_reply'],
						  'email_staff_assign'	=> $this->trellis->input['email_staff_assign'],
						  'esn_unassigned'		=> $this->trellis->input['esn_unassigned'],
						  'esn_assigned'		=> $this->trellis->input['esn_assigned'],
						  'esn_assigned_to_me'	=> $this->trellis->input['esn_assigned_to_me'],
						  'email_type'			=> $this->trellis->input['email_type'],
						  'val_email'			=> 1,
						  'val_admin'			=> 1,
						  'ipadd'				=> $this->trellis->input['ip_address'],
						  );

		$this->trellis->load_functions('cpfields');

		if( ! $fdata = $this->trellis->cpfields->process_input() )
		{
			if ( $this->trellis->cpfields->required_field ) $this->add_user( 'no_field', $this->trellis->cpfields->required_field );
		}
		else
		{
			$user_id = $this->trellis->users->add( $db_array, array( 'staff' => $staff ) );

			$this->trellis->cpfields->set_data( $fdata, $user_id, 1 );
		}

		$this->trellis->log( 'admin', "User Added &#039;". $this->trellis->input['name'] ."&#039;", 1, $user_id );

		#=============================
		# Update Staff Cache
		#=============================

		if ( $staff )
		{
			$this->trellis->load_functions('rebuild');

			$this->trellis->rebuild->staff_cache();
		}

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['id'] = $user_id;

		$this->view_user( 'user_added' );
	}

	#=======================================
	# @ Do Edit User
	#=======================================

	private function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'edit' );

		if ( ! $this->trellis->input['name'] ) $this->edit_user('no_username');
		if ( ! $this->trellis->input['email'] ) $this->edit_user('no_email');

		if ( ! $this->trellis->validate_email( $this->trellis->input['email'] ) ) $this->edit_user('invalid_email');

		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'ugroup', 'ugroup_sub' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# More Security Checks
		#=============================

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );
				}
			}
		}

		#=============================
		# Update User
		#=============================

		( ! empty( $this->trellis->input['ugroup_sub'] ) ) ? $ugroup_sub = serialize( $this->trellis->input['ugroup_sub'] ) : $ugroup_sub = '';

		$staff = 0;

		if ( $this->trellis->core->cache['groups'][ $this->trellis->input['ugroup'] ]['g_acp_access'] )
		{
			$staff = 1;
		}
		elseif ( ! empty( $this->trellis->input['ugroup_sub'] ) && ! $staff )
		{
			foreach( $this->trellis->input['ugroup_sub'] as $gid )
			{
				if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] )
				{
					$staff = 1;

					break;
				}
			}
		}

		$db_array = array(
						  'name'				=> $this->trellis->input['name'],
						  'email'				=> $this->trellis->input['email'],
						  'ugroup'				=> $this->trellis->input['ugroup'],
						  'ugroup_sub'			=> $ugroup_sub,
						  'title'				=> $this->trellis->input['title'],
						  'lang'				=> $this->trellis->input['lang'],
						  'skin'				=> $this->trellis->input['skin'],
						  'time_zone'			=> $this->trellis->input['time_zone'],
						  'time_dst'			=> $this->trellis->input['time_dst'],
						  'rte_enable'			=> $this->trellis->input['rte_enable'],
						  'email_enable'		=> $this->trellis->input['email_enable'],
						  'email_ticket'		=> $this->trellis->input['email_ticket'],
						  'email_reply'			=> $this->trellis->input['email_reply'],
						  'email_news'			=> $this->trellis->input['email_news'],
						  'email_staff_enable'	=> $this->trellis->input['email_staff_enable'],
						  'email_staff_ticket'	=> $this->trellis->input['email_staff_ticket'],
						  'email_staff_reply'	=> $this->trellis->input['email_staff_reply'],
						  'email_staff_assign'	=> $this->trellis->input['email_staff_assign'],
						  'esn_unassigned'		=> $this->trellis->input['esn_unassigned'],
						  'esn_assigned'		=> $this->trellis->input['esn_assigned'],
						  'esn_assigned_to_me'	=> $this->trellis->input['esn_assigned_to_me'],
						  'email_type'			=> $this->trellis->input['email_type'],
						  );

		$this->trellis->load_functions('cpfields');

		if( ! $fdata = $this->trellis->cpfields->process_input() )
		{
			if ( $this->trellis->cpfields->required_field ) $this->edit_user( 'no_field', $this->trellis->cpfields->required_field );
		}
		else
		{
			$this->trellis->users->edit( $db_array, $this->trellis->input['id'], array( 'staff' => $staff ) );

			$this->trellis->cpfields->set_data( $fdata, $this->trellis->input['id'] );
		}

		$this->trellis->log( 'admin', "User Updated &#039;". $this->trellis->input['name'] ."&#039;", 1, $this->trellis->input['id'] );

		#=============================
		# Change Password
		#=============================

		if ( $this->trellis->input['password'] )
		{
			$this->trellis->users->change_password( $this->trellis->input['password'], $this->trellis->input['id'] );

			$this->trellis->log( 'admin', "User Password Changed &#039;". $this->trellis->input['name'] ."&#039;", 1, $this->trellis->input['id'] );
		}

		#=============================
		# Update Staff Cache
		#=============================

		if ( $staff )
		{
			$this->trellis->load_functions('rebuild');

			$this->trellis->rebuild->staff_cache();
		}

		#=============================
		# Do Output
		#=============================

		$this->view_user( 'user_updated' );
	}

	#=======================================
	# @ Do Delete User
	#=======================================

	private function do_delete()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'delete' );

		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'ugroup', 'ugroup_sub' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# More Security Checks
		#=============================

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );
				}
			}
		}

		#=============================
		# DELETE User
		#=============================

		$this->trellis->users->delete( $this->trellis->input['id'], array( 'tickets' => $this->trellis->input['delete_tickets'], 'replies' => $this->trellis->input['delete_replies'], 'comments' => $this->trellis->input['delete_comments'], 'ratings' => $this->trellis->input['delete_ratings'] ) );

		$this->trellis->log( 'admin', "User Deleted &#039;". $u['name'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Do Output
		#=============================

		$this->list_users( 'user_deleted' );
	}

	#=======================================
	# @ Do Edit Signature
	#=======================================

	private function do_signature()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_perm( 'manage', 'users', 'edit' );

		#=============================
		# Grab User
		#=============================

		if ( ! $u = $this->trellis->users->get_single_by_id( array( 'id', 'name', 'ugroup', 'ugroup_sub' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_user');

		#=============================
		# More Security Checks
		#=============================

		if ( $u['id'] == 1 ) $this->trellis->check_perm( 'manage', 'users', 'root' );

		if ( $this->trellis->core->cache['groups'][ $u['ugroup'] ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );

		if ( $u['ugroup_sub'] )
		{
			$u['ugroup_sub'] = unserialize( $u['ugroup_sub'] );

			if ( ! empty( $u['ugroup_sub'] ) )
			{
				foreach ( $u['ugroup_sub'] as $gid )
				{
					if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $this->trellis->check_perm( 'manage', 'users', 'acp' );
				}
			}
		}

		#=============================
		# Update User
		#=============================

		$db_array = array(
						  'signature'	=> $this->trellis->input['signature'],
						  'sig_auto'	=> $this->trellis->input['sig_auto'],
						  );

		$this->trellis->users->edit( $db_array, $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "User Signature Updated &#039;". $u['name'] ."&#039;", 1, $this->trellis->input['id'] );

		#=============================
		# Do Output
		#=============================

		$this->view_user( 'signature_updated' );
	}

}

?>