<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Admin Source: Settings
#======================================================
*/

class ad_settings {

	private $output = "";

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		$this->trellis->check_perm( 'manage', 'settings' );

		$this->trellis->load_functions('settings');
		$this->trellis->ad_load_lang('settings');

		$this->trellis->skin->set_active_link( 4 );

		switch( $this->trellis->input['act'] )
	    {
	    	case 'list':
				$this->list_settings();
	    	break;
	    	case 'edit':
	    		$this->edit_settings();
	    	break;

	    	case 'doedit':
	    		$this->do_edit();
	    	break;
	    	case 'dorevert':
	    		$this->do_revert();
	    	break;
	    	case 'dodefault':
	    		$this->do_default();
	    	break;
	    	case 'dodefaultall':
	    		$this->do_default_all();
	    	break;

	    	default:
	    		$this->list_settings();
	    	break;
		}
	}

	#=======================================
	# @ List Settings
	#=======================================

	private function list_settings()
	{
		#=============================
		# Grab Settings
		#=============================

		$setting_rows = "";

		if ( ! $settings = $this->trellis->settings->get_groups( array( 'select' => array( 'cg_id', 'cg_key', 'cg_name', 'cg_name', 'cg_description', 'cg_set_count' ), 'where' => array( 'cg_hide', '!=', 1 ), 'order' => array( 'cg_name' => 'asc' ) ) ) )
		{
			$setting_rows .= "<tr><td class='bluecell-light' colspan='3'><strong>{lang.no_settings}</strong></td></tr>";
		}
		else
		{
			foreach( $settings as $cgid => $cg )
			{
				$setting_rows .= "<tr>
									<td class='bluecellthin-dark'><a href='<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group={$cg['cg_key']}'>{$cg['cg_name']}</a></td>
									<td class='bluecellthin-light' style='font-weight: normal'>{$cg['cg_description']}</td>
									<td class='bluecellthin-light' align='center'>{$cg['cg_set_count']}</td>
									<td class='bluecellthin-light' align='center'><a href='<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=edit&amp;group={$cg['cg_key']}'><img src='<! IMG_DIR !>/button_edit.gif' alt='{lang.edit}' /></a></td>
								</tr>";
			}
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_group_table( '{lang.settings_list}' ) ."
						<tr>
							<th class='bluecellthin-th' width='22%' align='left'>{lang.name}</th>
							<th class='bluecellthin-th' width='72%' align='left'>{lang.description}</th>
							<th class='bluecellthin-th' width='3%' align='left'>{lang.settings}</th>
							<th class='bluecellthin-th' width='3%' align='center'>{lang.edit}</th>
						</tr>
						". $setting_rows ."
						". $this->trellis->skin->end_group_table() ."
						</div>";

		$menu_items = array(
							array( 'compile', '{lang.menu_cache}', '<! HD_URL !>/admin.php?section=tools&amp;page=cache&amp;act=rebuild&amp;id=settings' ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_settings_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.help_about_settings_title}', '{lang.help_about_settings_msg}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Edit Settings
	#=======================================

	private function edit_settings($alert='')
	{
		#=============================
		# Grab Settings
		#=============================

		if ( ! $cg = $this->trellis->settings->get_single_group( array( 'cg_key', 'cg_name' ), array( 'cg_key', '=', $this->trellis->input['group'] ) ) ) $this->trellis->skin->error('no_settings');

		if ( ! $settings = $this->trellis->settings->get_settings( array( 'select' => array( 'cf_id', 'cf_name', 'cf_description', 'cf_type', 'cf_default', 'cf_extra', 'cf_value', 'cf_value_old' ), 'where' => array( 'cf_group', '=', $cg['cg_key'] ), 'order' => array( 'cf_position' => 'asc' ) ) ) ) $this->trellis->skin->error('no_settings');

		#=============================
		# Do Output
		#=============================

		if ( $alert )
		{
			$this->output .= $this->trellis->skin->alert_wrap( '{lang.alert_'. $alert .'}' );
		}

		$this->output .= "<div id='ticketroll'>
						". $this->trellis->skin->start_form( "<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=doedit&amp;group={$cg['cg_key']}", 'edit_setting', 'post' ) ."
						". $this->trellis->skin->start_group_table( '{lang.editing_settings} '. $cg['cg_name'], 'a' );

		foreach( $settings as $cf )
		{
			if ( $cf['cf_type'] == 'textfield' )
			{
				$cf_html = $this->trellis->skin->textfield( array( 'name' => 'cf_'. $cf['cf_id'], 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}
			elseif ( $cf['cf_type'] == 'textarea' )
			{
				$cf_html = $this->trellis->skin->textarea( array( 'name' => 'cf_'. $cf['cf_id'], 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}
			elseif ( $cf['cf_type'] == 'yes_no' )
			{
				$cf_html = $this->trellis->skin->yes_no_radio( array( 'name' => 'cf_'. $cf['cf_id'], 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}
			elseif ( $cf['cf_type'] == 'enabled_disabled' )
			{
				$cf_html = $this->trellis->skin->enabled_disabled_radio( array( 'name' => 'cf_'. $cf['cf_id'], 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}
			elseif ( $cf['cf_type'] == 'dropdown' )
			{
				$cf_html = $this->trellis->skin->textarea( array( 'name' => 'cf_'. $cf['cf_id'], 'options' => unserialize( $cf['cf_extra'] ), 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}
			elseif ( $cf['cf_type'] == 'radio' )
			{
				$cf_html = $this->trellis->skin->custom_radio( array( 'name' => 'cf_'. $cf['cf_id'], 'options' => unserialize( $cf['cf_extra'] ), 'value' => $cf['cf_value'], 'revert' => $cf['cf_value_old'], 'default' => $cf['cf_default'], 'id' => $cf['cf_id'] ) );
			}

			if ( $cf['cf_description'] )
			{
				$this->output .= $this->trellis->skin->group_table_row( $cf['cf_name'] .' '. $this->trellis->skin->help_tip( $cf['cf_description'] ), $cf_html, 'a', '35%', '65%' );
			}
			else
			{
				$this->output .= $this->trellis->skin->group_table_row( $cf['cf_name'], $cf_html, 'a', '35%', '65%' );
			}
		}

		$this->output .= $this->trellis->skin->end_group_table( 'a' ) ."
						". $this->trellis->skin->end_form( $this->trellis->skin->submit_button( 'edit', '{lang.button_edit_settings}' ) ) ."
						</div>";

		$menu_items = array(
							array( 'arrow_back', '{lang.menu_back}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings' ),
							array( 'arrow_circle', '{lang.menu_default}', '<! HD_URL !>/admin.php?section=tools&amp;page=settings&amp;act=dodefaultall&amp;group='. $cg['cg_key'] ),
							);

		$this->trellis->skin->add_sidebar_menu( '{lang.menu_settings_options}', $menu_items );
		$this->trellis->skin->add_sidebar_help( '{lang.random_title}', '{lang.random_text}' );

		$this->trellis->skin->add_output( $this->output );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ Do Edit Settings
	#=======================================

	private function do_edit()
	{
		#=============================
		# Update Settings
		#=============================

		if ( ! $cg = $this->trellis->settings->get_single_group( array( 'cg_key', 'cg_name' ), array( 'cg_key', '=', $this->trellis->input['group'] ) ) ) $this->trellis->skin->error('no_settings');

		if ( ! $settings = $this->trellis->settings->get_settings( array( 'select' => array( 'cf_id', 'cf_value' ), 'where' => array( 'cf_group', '=', $cg['cg_key'] ) ) ) ) $this->trellis->skin->error('no_settings');

		foreach( $settings as $cf )
		{
			if ( $cf['cf_value'] != $this->trellis->input[ 'cf_'. $cf['cf_id'] ] )
			{
				$this->trellis->settings->edit( array( 'cf_value' => $this->trellis->input[ 'cf_'. $cf['cf_id'] ], 'cf_value_old' => $cf['cf_value'] ), $cf['cf_id'] );
			}
		}

		$this->trellis->log( 'admin', "Settings Updated &#039;". $cg['cg_name'] ."&#039;", 1, $cg['cg_key'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->settings_cache();

		#=============================
		# Do Output
		#=============================

		$this->edit_settings( 'settings_updated' );
	}

	#=======================================
	# @ Do Revert Setting
	#=======================================

	private function do_revert()
	{
		#=============================
		# Revert Setting
		#=============================

		if ( ! $cf = $this->trellis->settings->get_single_setting( array( 'cf_id', 'cf_name', 'cf_group', 'cf_value_old' ), array( 'cf_id', '=', $this->trellis->input['id'] ) ) ) $this->trellis->skin->error('no_settings');

		$this->trellis->settings->edit( array( 'cf_value' => $cf['cf_value_old'] ), $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "Setting Reverted &#039;". $cf['cf_name'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->settings_cache();

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['group'] = $cf['cf_group'];

		$this->edit_settings( 'setting_reverted' );
	}

	#=======================================
	# @ Do Default Setting
	#=======================================

	private function do_default()
	{
		#=============================
		# Default Setting
		#=============================

		if ( ! $cf = $this->trellis->settings->get_single_setting( array( 'cf_id', 'cf_name', 'cf_group', 'cf_default' ), array( 'cf_id', '=', $this->trellis->input['id'] ) ) ) $this->trellis->skin->error('no_settings');

		$this->trellis->settings->edit( array( 'cf_value' => $cf['cf_default'] ), $this->trellis->input['id'] );

		$this->trellis->log( 'admin', "Setting Defaulted &#039;". $cf['cf_name'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->settings_cache();

		#=============================
		# Do Output
		#=============================

		$this->trellis->input['group'] = $cf['cf_group'];

		$this->edit_settings( 'setting_defaulted' );
	}

	#=======================================
	# @ Do Default Settings
	#=======================================

	private function do_default_all()
	{
	    #=============================
		# Default Setting
		#=============================

		if ( ! $cg = $this->trellis->settings->get_single_group( array( 'cg_key', 'cg_name' ), array( 'cg_key', '=', $this->trellis->input['group'] ) ) ) $this->trellis->skin->error('no_settings');

		if ( ! $settings = $this->trellis->settings->get_settings( array( 'select' => array( 'cf_id', 'cf_value', 'cf_default' ), 'where' => array( 'cf_group', '=', $cg['cg_key'] ) ) ) ) $this->trellis->skin->error('no_settings');

		foreach( $settings as $cf )
		{
			if ( $cf['cf_value'] != $cf['cf_default'] )
			{
				$this->trellis->settings->edit( array( 'cf_value' => $cf['cf_default'], 'cf_value_old' => $cf['cf_value'] ), $cf['cf_id'] );
			}
		}

		$this->trellis->log( 'admin', "Settings Defaulted &#039;". $cg['cg_name'] ."&#039;", 2, $this->trellis->input['id'] );

		#=============================
		# Rebuild Cache
		#=============================

		$this->trellis->load_functions('rebuild');

		$this->trellis->rebuild->settings_cache();

		#=============================
		# Do Output
		#=============================

		$this->edit_settings( 'settings_defaulted' );
	}

}

?>