<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Session Class :: Session Handler
#======================================================
*/

class session {

	var $user	= array();

	#=======================================
	# @ Load Session
	# Loads the session.  What else? :D
	#=======================================

	function load_session()
	{
		$authorized = 0; // Initialize for Security

		#=============================
		# Kill Any Bad Sessions
		#=============================

		$this->kill_old_tokens();

		#=============================
		# Get Information
		#=============================

		$cookie_sid = $this->trellis->get_cookie('tdsid');
		$cookie_uid = intval( $this->trellis->get_cookie('tduid') );
		$cookie_hash = $this->trellis->get_cookie('tdrmhash');

		#=============================
		# If We Have A Session Cookie
		#=============================

		if ( $cookie_sid )
		{
			#=============================
			# Load User
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 's' => 'all',
												  	 					  'm' => array( 'id', 'name', 'email', 'login_key', 'ugroup', 'title', 'joined', 'signature', 'sig_html', 'sig_auto', 'lang', 'skin', 'time_zone', 'time_dst', 'rte_enable', 'email_enable', 'email_ticket', 'email_reply', 'email_news', 'email_type', 'tickets_total', 'tickets_open' ),
												  	 					  'g' => 'all',
												  	 					 ),
												  	 'from'		=> array( 's' => 'sessions' ),
												  	 'join'		=> array( array( 'from' => array( 'm' => 'users' ), 'where' => array( 's' => 's_uid', '=', 'm' => 'id' ) ), array( 'from' => array( 'g' => 'groups' ), 'where' => array( 'g' => 'g_id', '=', 'm' => 'ugroup' ) ) ),
								 				  	 'where'	=> array( array( 's' => 's_id' ), '=', sha1( $cookie_sid . $this->trellis->config['session_key'] ) ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() == 1 )
			{
				$this->user = $this->trellis->core->db->fetch_row();
				
				if ( $this->user['s_time'] <= time() - ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) )
				{
					$this->kill_old_sessions();
				}
				else
				{
					#=============================
					# Update Session
					#=============================
	
					$this->trellis->core->db->construct( array(
														  	 'update'	=> 'sessions',
														  	 'set'		=> array( 's_location' => $this->trellis->input['act'], 's_time'	=> time() ),
										 				  	 'where'	=> array( 's_id', '=', $this->user['s_id'] ),
										 				  	 'limit'	=> array( 1 ),
										 		  	  ) 	);
	
					$this->trellis->core->db->next_shutdown();
					$this->trellis->core->db->execute();
	
					$this->trellis->set_cookie( 'tdsid', $cookie_sid, time() + ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) );
	
					if ( $this->user['s_guest'] )
					{
						$this->user['id']	= 0;
						$this->user['name'] = $this->trellis->lang['guest'];
						$this->user['ugroup'] = 2;
	
						$this->user = array_merge( $this->user, $this->trellis->core->cache['groups'][2] );
					}
	
					$authorized = 1;
				}
			}
		}

		#=============================
		# If We Have A Remember Cookie
		#=============================

		if ( $cookie_uid && $cookie_hash && ! $authorized )
		{
			#=============================
			# Load User
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'm' => array( 'id', 'name', 'email', 'login_key', 'ugroup', 'title', 'joined', 'signature', 'sig_html', 'sig_auto', 'lang', 'skin', 'time_zone', 'time_dst', 'rte_enable', 'email_enable', 'email_ticket', 'email_reply', 'email_news', 'email_type', 'tickets_total', 'tickets_open' ),
												  	 					  'g' => 'all',
												  	 					 ),
												  	 'from'		=> array( 'm' => 'users' ),
												  	 'join'		=> array( array( 'from' => array( 'g' => 'groups' ), 'where' => array( 'g' => 'g_id', '=', 'm' => 'ugroup' ) ) ),
								 				  	 'where'	=> array( array( 'm' => 'id' ), '=', $cookie_uid ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			$this->user = $this->trellis->core->db->fetch_row();

			#=============================
			# Checkie Checkie
			#=============================

			if ( $this->user['login_key'] == hash( 'whirlpool', $cookie_hash . $this->trellis->config['cookie_key'] ) )
			{
				#=============================
				# Create Session
				#=============================
				
				$session_hash = 's'. $this->user['id'] . uniqid( rand(), true );

				$new_session = sha1( $session_hash . $this->trellis->config['session_key'] );

				$db_array = array(
								  's_id'			=> $new_session,
								  's_uid'			=> $this->user['id'],
								  's_uname'			=> $this->user['name'],
								  's_email'			=> $this->user['email'],
								  's_ipadd'			=> $this->trellis->input['ip_address'],
								  's_location'		=> $this->trellis->input['act'],
								  's_time'			=> time(),
								  );

				$this->trellis->core->db->construct( array(
													  	 'insert'	=> 'sessions',
													  	 'set'		=> $db_array,
									 		  	  ) 	);

				$this->trellis->core->db->execute();
				
				#=============================
				# New Login Key
				#=============================
				
				$rmsalt = '';
		
				while( strlen( $rmsalt ) < 8 ) $rmsalt .= chr(rand( 32,126 ) );
		
				$rmsalt .= uniqid( rand(), true );
				
				$rmhash = str_replace( "=", "", base64_encode( sha1( $rmsalt . $this->user['id'] ) ) );
				
				$lk_hash = hash( 'whirlpool', $rmhash . $this->trellis->config['cookie_key'] );
				
				$this->trellis->core->db->construct( array(
													  	 'update'	=> 'users',
													  	 'set'		=> array( 'login_key' => $lk_hash ),
									 				  	 'where'	=> array( 'id', '=', $this->user['id'] ),
									 				  	 'limit'	=> array( 1 ),
									 		  	  ) 	);

				$this->trellis->core->db->execute();

				$this->trellis->set_cookie( 'tdrmhash', $rmhash );
				$this->trellis->set_cookie( 'tdsid', $session_hash, time() + ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) );
				
				$this->user['login_key'] = $rmhash;

				$authorized = 1;
			}
			else
			{
				$this->trellis->delete_cookie('tduid');
				$this->trellis->delete_cookie('tdrmhash');
			}
		}

		#=============================
		# If We Are Not Authorized
		#=============================

		if ( ! $authorized )
		{
			$this->user['id']	= 0;
			$this->user['name'] = $this->trellis->lang['guest'];
			$this->user['ugroup'] = 2;

			$this->user['guest'] = 1;

			#=============================
			# Create Session
			#=============================
				
			$session_hash = 's'. $this->user['id'] . uniqid( rand(), true );

			$new_session = sha1( $session_hash . $this->trellis->config['session_key'] );

			$db_array = array(
							  's_id'			=> $new_session,
							  's_uid'			=> $this->user['id'],
							  's_uname'			=> $this->user['name'],
							  's_ipadd'			=> $this->trellis->input['ip_address'],
							  's_location'		=> $this->trellis->input['act'],
							  's_time'			=> time(),
							  's_guest'			=> 1,
							  );

			$this->trellis->core->db->construct( array(
												  	 'insert'	=> 'sessions',
												  	 'set'		=> $db_array,
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			$this->trellis->set_cookie( 'tdsid', $session_hash, time() + ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) );

			$this->user['s_id'] = $new_session;

			$this->user = array_merge( $this->user, $this->trellis->core->cache['groups'][2] );
		}

		return $this->user;
	}

	#=======================================
	# @ Do Login
	# Attempt to login.
	#=======================================

	function do_login()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_token('login');

		if ( ! $this->trellis->input['username'] || ! $this->trellis->input['password'] )
		{
			$this->error('fill_form_completely', 1);
		}

		#=============================
		# Select User
		#=============================

		$this->trellis->core->db->construct( array(
												   'select'	=> array(
												    				 'm' => array( 'id', 'name', 'email', 'pass_hash', 'pass_salt', 'login_key', 'ugroup', 'title', 'joined', 'signature', 'sig_html', 'sig_auto', 'lang', 'skin', 'time_zone', 'time_dst', 'rte_enable', 'email_enable', 'email_ticket', 'email_reply', 'email_news', 'email_type', 'tickets_total', 'tickets_open', 'val_email', 'val_admin' ),
												    				 'g' => 'all',
												  	 				 ),
												   'from'	=> array( 'm' => 'users' ),
												   'join'	=> array( array( 'from' => array( 'g' => 'groups' ), 'where' => array( 'g' => 'g_id', '=', 'm' => 'ugroup' ) ) ),
												   'where'	=> array( array( 'm' => 'name|lower' ), '=', strtolower( $this->trellis->input['username'] ) ),
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->error('login_no_user', 1);
		}

		$mem = $this->trellis->core->db->fetch_row();

		#=============================
		# Compare Password
		#=============================

		if ( hash( 'whirlpool', $mem['pass_salt'] . $this->trellis->input['password'] . $this->trellis->config['pass_key'] ) == $mem['pass_hash'] )
		{			
			#=============================
			# Validation Check
			#=============================
			
			if ( ! $mem['val_email'] ) $this->error('login_must_val');
			
			if ( ! $mem['val_admin'] ) $this->error('login_must_val_admin');
			
			#=============================
			# Delete Old Sessoin
			#=============================

			if ( $this->user['s_id'] )
			{
				$this->trellis->core->db->construct( array(
													  	 'delete'	=> 'sessions',
									 				  	 'where'	=> array( 's_id', '=', $this->user['s_id'] ),
									 				  	 'limit'	=> array( 1 ),
									 		  	  ) 	);

				$this->trellis->core->db->execute();
			}

			#=============================
			# Create Session
			#=============================
				
			$session_hash = 's'. $this->user['id'] . uniqid( rand(), true );

			$new_session = sha1( $session_hash . $this->trellis->config['session_key'] );

			$db_array = array(
							  's_id'			=> $new_session,
							  's_uid'			=> $mem['id'],
							  's_uname'			=> $mem['name'],
							  's_email'			=> $mem['email'],
							  's_ipadd'			=> $this->trellis->input['ip_address'],
							  's_location'		=> $this->trellis->input['act'],
							  's_time'			=> time(),
							  );

			$this->trellis->core->db->construct( array(
												  	 'insert'	=> 'sessions',
												  	 'set'		=> $db_array,
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			$this->trellis->set_cookie( 'tdsid', $session_hash, time() + ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) );

			#=============================
			# Remember Me?
			#=============================

			if ( $this->trellis->input['remember'] )
			{
				#=============================
				# New Login Key
				#=============================
				
				$rmsalt = '';
		
				while( strlen( $rmsalt ) < 8 ) $rmsalt .= chr(rand( 32,126 ) );
		
				$rmsalt .= uniqid( rand(), true );
				
				$rmhash = str_replace( "=", "", base64_encode( sha1( $rmsalt . $mem['id'] ) ) );
				
				$lk_hash = hash( 'whirlpool', $rmhash . $this->trellis->config['cookie_key'] );
				
				$this->trellis->core->db->construct( array(
													  	 'update'	=> 'users',
													  	 'set'		=> array( 'login_key' => $lk_hash ),
									 				  	 'where'	=> array( 'id', '=', $mem['id'] ),
									 				  	 'limit'	=> array( 1 ),
									 		  	  ) 	);

				$this->trellis->core->db->execute();

				$this->trellis->set_cookie( 'tduid', $mem['id'] );
				$this->trellis->set_cookie( 'tdrmhash', $rmhash );
				
				$mem['login_key'] = $lk_hash;
			}

			#=============================
			# Return
			#=============================
			
			// Play It Safe
			$mem['pass_hash'] = $mem['pass_salt'] = "";
			
			$mem = array_merge( $mem, $db_array );
			
			$this->user = $mem;
			
			return $this->user;
		}
		else
		{
			$this->error('login_no_pass', 1);
		}
	}

	#=======================================
	# @ Do Guest Login
	# Attempt to login a guest.
	#=======================================

	function do_guest_login()
	{
		#=============================
		# Security Checks
		#=============================

		if ( $onthefly )
		{
			$this->trellis->input['email_address'] = $this->trellis->input['email'];
			$this->trellis->input['ticket_key'] = $this->trellis->input['key'];
		}
		else
		{
			$this->trellis->check_token('glogin');
		}

		if ( ! $this->trellis->validate_email( $this->trellis->input['email_address'] ) )
		{
			$this->error('no_valid_email');
		}

		if ( strlen( $this->trellis->input['ticket_key'] ) != 11 )
		{
			$this->error('no_valid_tkey');
		}

		#=============================
		# Select Ticket
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'uname', 'email' ),
											  	 'from'		=> 'tickets',
							 				  	 'where'	=> array( array( 'tkey', '=', $this->trellis->input['ticket_key'] ), array( 'email', '=', $this->trellis->input['email_address'], 'and' ), array( 'guest', '=', 1, 'and' ) ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() != 1 )
		{
			$this->error('no_ticket_guest');
		}

		$ticket = $this->trellis->core->db->fetch_row();

		#=============================
		# Update Session
		#=============================

		$new_session = sha1( 's'. time() . $mem['id'] . uniqid( rand(), true ) . $this->trellis->config['session_key'] );

		$db_array = array( 's_uname' => $ticket['uname'], 's_email' => $ticket['email'], 's_tkey' => $this->trellis->input['ticket_key'] );

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'sessions',
											  	 'set'		=> $db_array,
											  	 'where'	=> array( 's_id', '=', $this->user['s_id'] ),
											  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();
			
		$mem = array_merge( $mem, $db_array );
			
		$this->user = $mem;
			
		return $this->user;
	}

	#=======================================
	# @ Do Logout
	# Attempt to logout.
	#=======================================

	function do_logout()
	{
		if ( $this->trellis->user['id'] )
		{
			#=============================
			# Security Checks
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id' ),
												  	 'from'		=> 'users',
								 				  	 'where'	=> array( 'login_key', '=', $this->trellis->input['key'] ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			if ( ! $this->trellis->core->db->get_num_rows() )
			{
				$this->error('logout_no_key');
			}

			$lk = $this->trellis->core->db->fetch_row();

			if ( $this->trellis->user['id'] != $lk['id'] )
			{
				$this->error('logout_no_key');
			}
		}

		#=============================
		# Delete Cookies
		#=============================

		$this->trellis->delete_cookie('tdsid');
		$this->trellis->delete_cookie('tduid');
		$this->trellis->delete_cookie('tdrmhash');

		#=============================
		# Delete Session
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'delete'	=> 'sessions',
							 				  	 'where'	=> array( 's_id', '=', $this->user['s_id'] ),
							 				  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();
		
		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'users',
											  	 'set'		=> array( 'login_key' => '' ),
									 		  	 'where'	=> array( 'id', '=', $this->user['s_id'] ),
									 		  	 'limit'	=> array( 1 ),
									 		   ) 	);

		$this->trellis->core->db->execute();

		#=============================
		# Back to Guest
		#=============================
		
		$this->user = array();
		
		$this->user['id']	= 0;
		$this->user['name'] = $this->trellis->lang['guest'];
		$this->user['ugroup'] = 2;
		$this->user['guest'] = 1;

		#=============================
		# Create Session
		#=============================
				
		$session_hash = 's'. $this->user['id'] . uniqid( rand(), true );

		$new_session = sha1( $session_hash . $this->trellis->config['session_key'] );

		$db_array = array(
						  's_id'			=> $new_session,
						  's_uid'			=> $this->user['id'],
						  's_uname'			=> $this->user['name'],
						  's_ipadd'			=> $this->trellis->input['ip_address'],
						  's_location'		=> $this->trellis->input['act'],
						  's_time'			=> time(),
						  's_guest'			=> 1,
						  );

		$this->trellis->core->db->construct( array(
											  	 'insert'	=> 'sessions',
											  	 'set'		=> $db_array,
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->set_cookie( 'tdsid', $session_hash, time() + ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 ) );

		$this->user['s_id'] = $new_session;

		$this->user = array_merge( $this->user, $this->trellis->core->cache['groups'][2] );

		return $this->user;
	}

	#=======================================
	# @ Kill Old Sessions
	# Kills sessions older than the session
	# timeout (defined in ACP).
	#=======================================

	function kill_old_sessions()
	{
		$timeout = time() - ( $this->trellis->core->cache['settings']['security']['session_timeout'] * 60 );

		$this->trellis->core->db->construct( array(
											  	 'delete'	=> 'sessions',
							 				  	 'where'	=> array( 's_time', '<=', $timeout ),
							 		  	  ) 	);

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		$num_killed = $this->trellis->core->db->get_num_rows();

		return $num_killed;
	}

	#=======================================
	# @ Kill Old Tokens
	# Kills tokens older than 1 hour.
	#=======================================

	function kill_old_tokens()
	{
		if ( $this->trellis->core->cache['settings']['security']['form_tokens'] )
		{
			$timeout = time() - ( 60 * 60 );

			$this->trellis->core->db->construct( array(
												  	 'delete'	=> 'tokens',
								 				  	 'where'	=> array( 'date', '<=', $timeout ),
								 		  	  ) 	);

			$this->trellis->core->db->next_shutdown();
			$this->trellis->core->db->execute();

			$num_killed = $this->trellis->core->db->get_num_rows();

			return $num_killed;
		}
	}
	
	#=======================================
	# @ Error
	#=======================================

	function error($msg, $login=0)
	{
		$this->trellis->load_skin();
		
		$this->trellis->skin->error($msg, $login);
	}
}

?>