<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Skin Class
#======================================================
*/

class skin {

	var $data = array();

	#=======================================
	# @ Load Skin
	#=======================================

	function load_skin()
	{
		header('Content-Type: text/html; charset=utf-8');

		#=============================
		# Do We Have A Skin ID?
		#=============================

		if ( ! $this->trellis->user['skin'] )
		{
			if ( ! $this->trellis->user['skin'] = $this->trellis->core->cache['misc']['default_skin'] )
			{
				$this->trellis->user['skin'] = $this->trellis->config['fallback_skin'];
			}
		}

		#=============================
		# Load Functions
		#=============================

		$this->trellis->core->template->smarty->register_function( 'lv_field', array( 'skin', 'lv_add_field' ) );
		$this->trellis->core->template->smarty->register_function( 'lv_rule', array( 'skin', 'lv_add_rule' ) );
		$this->trellis->core->template->smarty->register_function( 'focus', array( 'skin', 'focus_js' ) );

		#=============================
		# Load Skin
		#=============================

		$this->data = $this->trellis->core->cache['skins'][ $this->trellis->user['skin'] ];

		$this->trellis->core->template->initialize( HD_SKIN .'s'. $this->trellis->user['skin'] .'/' );

		#=============================
		# Load Globals
		#=============================

		$this->trellis->load_lang('global');

		return $this->data;
	}

	#=======================================
	# @ Do Output
	#=======================================

	function do_output($extra='', $type='')
	{
		#=============================
		# Initialize
		#=============================

		$footer = "";
		$nav_links = "";

		if ( $type == 'redirect' )
		{
			$this->trellis->load_lang('redirect');

			$extra['redirect_url'] = $this->trellis->config['hd_url'] .'/index.php'. $extra['redirect_url'];

			$this->trellis->core->template->set_var( 'redirect_url', str_replace( "&", '&amp;', $extra['redirect_url'] ) );
			$this->trellis->core->template->set_var( 'redirect_msg', $this->trellis->lang[ $extra['redirect_msg'] ] );

			$this->trellis->core->template->set_var( 'title', $this->trellis->core->cache['settings']['general']['hd_name'] .' :: '. $this->trellis->lang['please_wait'] );

			$nav_tree = ' &rsaquo; '. $this->trellis->lang['redirect'];
		}
		elseif ( $type == 'error' )
		{
			$this->trellis->load_lang('error');
echo $extra['error_msg'];
			$this->trellis->core->template->set_var( 'error_msg', $this->trellis->lang[ $extra['error_msg'] ] );

			if ( $extra['error_login'] ) $this->trellis->core->template->set_var( 'token_e_login', $this->trellis->create_token('login') );

			$this->trellis->core->template->set_var( 'title', $this->trellis->core->cache['settings']['general']['hd_name'] .' :: '. $this->trellis->lang['error'] );

			$nav_tree = ' &rsaquo; '. $this->trellis->lang['error'];
		}
		else
		{
			#=============================
			# Something Extra 4 ME? :O
			#=============================

			if ( is_array( $extra ) )
			{
				if ( isset( $extra['title'] ) )
				{
					$title = $extra['title'];
				}

				if ( isset( $extra['footer'] ) )
				{
					$footer = $extra['footer'];
				}

				if ( isset( $extra['nav'] ) )
				{
					$nav_links = $extra['nav'];
				}
			}

			#=============================
			# Do We Have A Title?
			#=============================

			if ( ! isset( $title ) )
			{
				$title = $this->trellis->core->cache['settings']['general']['hd_name'];
			}
			else
			{
				$title = $this->trellis->core->cache['settings']['general']['hd_name'] .' :: '. $title;
			}

			$this->trellis->core->template->set_var( 'title', $title );

			#=============================
			# Navigation
			#=============================

			$nav_tree = ""; // Initialize for Security

			if ( is_array( $nav_links ) )
			{
				while ( list( , $nlink ) = each( $nav_links ) )
				{
					$nav_tree .= ' &rsaquo; '. $nlink;
				}
			}
		}

		if ( $type != 'redirect' )
		{
			#=============================
			# Sidebar
			#=============================
		}

		$this->trellis->core->template->set_var( 'nav_links', $nav_tree );

		/**********************************************************************/
		/* REMOVAL OF THE COPYRIGHT WITHOUT PURCHASING COPYRIGHT REMOVAL WILL */
		/* VIOLATE THE LICENSE YOU AGREED TO WHEN DOWNLOADING AND REGISTERING */
		/* THIS PORDUCT.  IF THIS HAPPENS, IT COULD RESULT IN REMOVAL OF THIS */
		/* SYSTEM AND POSSIBLY CRIMINAL CHARGES.  THANK YOU FOR UNDERSTANDING */
		/***********************************************************************/

		$query_count = $this->trellis->core->db->get_query_count();
		$query_s_count = $this->trellis->core->db->get_query_s_count();
		$exe_time = $this->trellis->end_timer();

		$copyright = "<div id='copyright'>Powered By <a href='http://www.accord5.com/products/trellis/'>Trellis Desk</a> {$this->trellis->vername} &copy; ". date('Y') ." <a href='http://www.accord5.com/'>ACCORD5</a><br /><span title='". $query_count ." Normal | ". $query_s_count ." Shutdown'>". $query_count ." Queries</span> // ". $exe_time ." Seconds</div>";

		#=============================
		# Global Variables
		#=============================

		$this->trellis->core->template->set_var( 'tpl_url', $this->trellis->config['hd_url'] .'/skin/s'. $this->trellis->user['skin'] );
		$this->trellis->core->template->set_var( 'td_url', $this->trellis->config['hd_url'] );
		$this->trellis->core->template->set_var( 'td_name', $this->trellis->core->cache['settings']['general']['hd_name'] );
		$this->trellis->core->template->set_var( 'img_url', $this->trellis->config['hd_url'] .'/images/'. $this->data['img_dir'] );
		$this->trellis->core->template->set_var( 'upld_url', $this->trellis->core->cache['settings']['general']['upload_url'] );
		$this->trellis->core->template->set_var( 'copyright', $copyright );
		$this->trellis->core->template->set_var( 'extra_l', $this->trellis->input['extra_l'] );

		$this->trellis->core->template->set_var( 'user', &$this->trellis->user );
		$this->trellis->core->template->set_var( 'cache', &$this->trellis->core->cache );
		$this->trellis->core->template->set_var( 'input', &$this->trellis->input );

		$this->trellis->core->template->set_var( 'lang', &$this->trellis->lang );

		$self = $this->trellis->config['hd_url'] .'/index.php';

		if ( $this->trellis->input['act'] != 'logout' && $_SERVER['QUERY_STRING'] ) $self .= '?'. $this->trellis->sanitize_data( $_SERVER['QUERY_STRING'] );

		$this->trellis->core->template->set_var( 'self', &$self );

		$this->trellis->core->template->set_var( 'enable_disable_radio', array( 1 => $this->trellis->lang['enabled'], 0 => $this->trellis->lang['disabled'] ) );
		$this->trellis->core->template->set_var( 'yes_no_radio', array( 1 => $this->trellis->lang['yes'], 0 => $this->trellis->lang['no'] ) );

		#=============================
		# Output
		#=============================

		if ( $type == 'print' )
		{
			$this->trellis->core->template->display( 'print.tpl' );
		}
		elseif ( $type == 'redirect' )
		{
			$this->trellis->core->template->set_var( 'wrapper_type', 2 );

			$this->trellis->core->template->display( 'wrapper.tpl' );
		}
		elseif ( $type == 'error' )
		{
			if ( $extra['error_login'] )
			{
				$this->trellis->core->template->set_var( 'wrapper_type', 4 );
			}
			else
			{
				$this->trellis->core->template->set_var( 'wrapper_type', 3 );
			}

			$this->trellis->core->template->display( 'wrapper.tpl' );
		}
		else
		{
			$this->trellis->core->template->set_var( 'wrapper_type', 1 );

			$this->trellis->core->template->display( 'wrapper.tpl' );
		}

		$this->trellis->core->shut_down_q();
		$this->trellis->shut_down();
		$this->trellis->core->shut_down();

		if ( $type == 'redirect' ) header('Refresh: 3; URL='. $extra['redirect_url']);

		if ( HD_DEBUG )
		{
			echo "<br /><br />------------------<br /><br />". $this->trellis->core->db->queries_ran;
		}

		exit();
	}

	#=======================================
	# @ Do Print
	#=======================================

	function do_print($extra="")
	{
		$this->do_output( $extra, 'print' );
	}

	#=======================================
	# Redirect
	#=======================================

	function redirect($url, $msg)
	{
		$this->do_output( array( 'redirect_url' => $url, 'redirect_msg' => $msg ), 'redirect' );
	}

	#=======================================
	# Error
	#=======================================

	function error($msg, $login=0)
	{
		$this->do_output( array( 'error_msg' => $msg, 'error_login' => $login ), 'error' );
	}

	#=======================================
	# @ Live Validation Add Field
	#=======================================

	public function lv_add_field($params, &$smarty)
	{
		return "var F{$params['name']} = new LiveValidation( '{$params['name']}', { validMessage: ' ' } );\n";
	}

	#=======================================
	# @ Live Validation Add Rule
	#=======================================

	public function lv_add_rule($params, &$smarty)
	{
		if ( $params['type'] == 'presence' )
		{
			return skin::lv_presence( $params );
		}
		elseif ( $params['type'] == 'format' )
		{
			return skin::lv_format( $params );
		}
		elseif ( $params['type'] == 'number' )
		{
			return skin::lv_number( $params );
		}
		elseif ( $params['type'] == 'email' )
		{
			return skin::lv_email( $params );
		}
		elseif ( $params['type'] == 'match' )
		{
			return skin::lv_match( $params );
		}
		elseif ( $params['type'] == 'custom' )
		{
			return skin::lv_custom( $params );
		}
	}

	#=======================================
	# @ Live Validation Presence
	#=======================================

	private function lv_presence($raw_params)
	{
		$params = "";

		if ( $raw_params['fail_msg'] )
		{
			$params .= "failureMessage: '{$raw_params['fail_msg']}', ";
		}
		else
		{
			$params .= "failureMessage: ' ', ";
		}

		return "F{$raw_params['name']}.add( Validate.Presence, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Live Validation Format
	#=======================================

	private function lv_format($raw_params)
	{
		$params = "";

		if ( $raw_params['fail_msg'] ) 	$params .= "failureMessage: '{$raw_params['fail_msg']}', ";
		if ( $raw_params['pattern'] ) 	$params .= "pattern: {$raw_params['pattern']}, ";
		if ( $raw_params['negate'] ) 	$params .= "negate: true, ";

		if ( ! $raw_params['fail_msg'] ) $params .= "failureMessage: ' ', ";

		return "F{$raw_params['name']}.add( Validate.Format, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Live Validation Number
	#=======================================

	private function lv_number($raw_params)
	{
		$params = "";

		if ( $raw_params['not_num_msg'] ) 	$params .= "notANumberMessage: '{$raw_params['not_num_msg']}', ";
		if ( $raw_params['not_int_msg'] ) 	$params .= "notAnIntegerMessage: '{$raw_params['not_int_msg']}', ";
		if ( $raw_params['wrong_num_msg'] ) $params .= "wrongNumberMessage: '{$raw_params['wrong_num_msg']}', ";
		if ( $raw_params['too_low_msg'] ) 	$params .= "tooLowMessage: '{$raw_params['too_low_msg']}', ";
		if ( $raw_params['too_high_msg'] ) 	$params .= "tooHighMessage: '{$raw_params['too_high_msg']}', ";
		if ( $raw_params['is'] ) 			$params .= "is: '{$raw_params['is']}', ";
		if ( $raw_params['minimum'] ) 		$params .= "minimum: '{$raw_params['not_num_msg']}', ";
		if ( $raw_params['maximum'] ) 		$params .= "maximum: '{$raw_params['maximum']}', ";
		if ( $raw_params['int_only'] ) 		$params .= "onlyInteger: true, ";

		if ( ! $raw_params['not_num_msg'] ) $params .= "notANumberMessage: ' ', ";

		return "F{$raw_params['name']}.add( Validate.Numericality, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Live Validation Email
	#=======================================

	private function lv_email($raw_params)
	{
		$params = "";

		if ( $raw_params['fail_msg'] )
		{
			$params .= "failureMessage: '{$raw_params['fail_msg']}', ";
		}
		else
		{
			$params .= "failureMessage: ' ', ";
		}

		return "F{$raw_params['name']}.add( Validate.Email, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Live Validation Match
	#=======================================

	private function lv_match($raw_params)
	{
		$params = "";

		if ( $raw_params['fail_msg'] ) 	$params .= "failureMessage: '{$raw_params['fail_msg']}', ";
		if ( $raw_params['against'] ) 	$params .= 'against: function(value,args) { return value == $("#'. $raw_params['against'] .'").val(); }, ';
		if ( $raw_params['args'] ) 		$params .= "args: {$raw_params['wrong_num_msg']}, ";

		if ( ! $raw_params['fail_msg'] ) $params .= "failureMessage: ' ', ";

		return "F{$raw_params['name']}.add( Validate.Custom, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Live Validation Custom
	#=======================================

	private function lv_custom($raw_params)
	{
		$params = "";

		if ( $raw_params['fail_msg'] ) 	$params .= "failureMessage: '{$raw_params['fail_msg']}', ";
		if ( $raw_params['against'] ) 	$params .= "against: function(value,args) { {$raw_params['against']} }, ";
		if ( $raw_params['args'] ) 		$params .= "args: {$raw_params['wrong_num_msg']}, ";

		if ( ! $raw_params['fail_msg'] ) $params .= "failureMessage: ' ', ";

		return "F{$raw_params['name']}.add( Validate.Custom, { ". substr( $params, 0, -2 ) ." } );\n";
	}

	#=======================================
	# @ Focus JavaScript
	#=======================================

	public function focus_js($params, &$smarty)
	{
		return '$("#'. $params['name'] .'").focus();';
	}
}

?>