<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Articles
#======================================================
*/

class func_articles {

	public $error = '';

	#=======================================
	# @ Get Articles
	#=======================================

	public function get($input)
	{
		$return = array();

		if ( ! $input['from'] ) $input['from'] = 'articles';

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> $input['from'],
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $a = $this->trellis->core->db->fetch_row() )
		{
			$return[ $a['id'] ] = $a;
		}

		return $return;
	}

	#=======================================
	# @ Get Single Article
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'articles',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Article By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Get Comments
	#=======================================

	public function get_comments($input)
	{
		$input['from'] = 'article_comments';

		return $this->get($input);
	}

	#=======================================
	# @ Get Single Comment
	#=======================================

	public function get_single_comment($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'article_comments',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Comment By ID
	#=======================================

	public function get_single_comment_by_id($select, $id)
	{
		return $this->get_single_comment( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Get Ratings
	#=======================================

	public function get_ratings($input)
	{
		$input['from'] = 'article_rate';

		return $this->get($input);
	}

	#=======================================
	# @ Get Single Rating
	#=======================================

	public function get_single_rating($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'article_rate',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Rating By ID
	#=======================================

	public function get_single_rating_by_id($select, $id)
	{
		return $this->get_single_rating( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add Article
	#=======================================

	public function add($data)
	{
		$fields = array(
						'id'				=> 'int',
						'cid'				=> 'int',
						'title'				=> 'string',
						'description'		=> 'string',
						'content'			=> 'string',
						'html'		        => 'int',
						'allow_comments'	=> 'int',
						'allow_rating'		=> 'int',
						'date'				=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'articles',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Add Comment
	#=======================================

	public function add_comment($data, $aid)
	{
		$fields = array(
						'aid'		=> 'int',
						'uid'		=> 'int',
						'message'	=> 'string',
						'staff'		=> 'int',
						'html'		=> 'int',
						'date'		=> 'int',
						'ipadd'		=> 'string',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'article_comments',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		$id = $this->trellis->core->db->get_insert_id();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'articles',
												   'set'	=> array( 'comments' => array( '+', 1 ) ),
												   'where'	=> array( 'id', '=', $aid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $id;
	}

	#=======================================
	# @ Edit Article
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'id'				=> 'int',
						'cid'				=> 'int',
						'title'				=> 'string',
						'description'		=> 'string',
						'content'			=> 'string',
						'html'		        => 'int',
						'allow_comments'	=> 'int',
						'allow_rating'		=> 'int',
						'modified'			=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'articles',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Edit Comment
	#=======================================

	public function edit_comment($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'message'	=> 'string',
						'staff'		=> 'int',
						'html'		=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'article_comments',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Article
	#=======================================

	public function delete($id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'article_comments',
												   'where'	=> array( 'aid', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'article_rate',
												   'where'	=> array( 'aid', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'articles',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Comment
	#=======================================

	public function delete_comment($id, $params=array())
	{
		if ( ! $id = intval( $id ) ) return false;

		if ( ! isset( $params['aid'] ) )
		{
			if ( ! $c = $this->get_single_comment_by_id( array( 'aid' ), $id ) ) return false;

			 $params['aid'] = $c['aid'];
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'article_comments',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$dc = $this->trellis->core->db->get_affected_rows();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'articles',
												   'set'	=> array( 'comments' => array( '-', 1 ) ),
												   'where'	=> array( 'id', '=', $params['aid'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		return $dc;
	}

}

?>