<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Categories
#======================================================
*/

class func_categories {

	public $error = '';

	#=======================================
	# @ Get Categories
	#=======================================

	public function get($input)
	{
		$return = array();

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> 'categories',
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $c = $this->trellis->core->db->fetch_row() )
		{
			$return[ $c['id'] ] = $c;
		}

		return $return;
	}

	#=======================================
	# @ Get Single Category
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'categories',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Category By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add Category
	#=======================================

	public function add($data)
	{
		$fields = array(
						'parent_id'			=> 'int',
						'name'				=> 'string',
						'description'		=> 'string',
						'allow_rating'		=> 'int',
						'allow_comments'	=> 'int',
						'position'			=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'categories',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Edit Category
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;
		
		$fields = array(
						'parent_id'			=> 'int',
						'name'				=> 'string',
						'description'		=> 'string',
						'allow_rating'		=> 'int',
						'allow_comments'	=> 'int',
						'position'			=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'categories',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Category
	#=======================================

	public function delete($id, $action=0, $mvid=0)
	{
		if ( ! $id = intval( $id ) ) return false;
		
		if ( $action == 1 )
		{
			if ( ! $mvid = intval( $mvid ) ) return false;
			
			$this->trellis->core->db->construct( array(
													   'update'	=> 'articles',
													   'set'	=> array( 'cat_id' => $mvid, 'cat_name' => $this->trellis->core->cache['categories'][ $mvid ]['name'] ),
													   'where'	=> array( 'cat_id', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
			
			$num_articles = $this->trellis->core->db->get_affected_rows();
			
			if ( $num_articles )
			{
				$this->trellis->core->db->next_no_quotes('set'); # THIS MAKES ME NERVOUS

				$this->trellis->core->db->construct( array(
														   'update'	=> 'categories',
														   'set'	=> array( 'articles' => 'articles+'. $num_articles ),
														   'where'	=> array( 'id', '=', $mvid ),
													)	   );

				$this->trellis->core->db->execute();
			}
		}
		elseif ( $action == 2 )
		{
			$this->trellis->core->db->construct( array(
													   'select'	=> array( 'id' ),
													   'from'	=> 'articles',
													   'where'	=> array( 'cat_id', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
			
			if ( $this->trellis->core->db->get_num_rows() )
			{
				$articles = array();
			
				while( $a = $this->trellis->core->db->fetch_row() )
				{
					$articles[] = $a['id'];
				}
			
				$this->trellis->core->db->construct( array(
														   'delete'	=> 'article_comments',
														   'where'	=> array( 'aid', 'in', $articles ),
													)	   );

				$this->trellis->core->db->execute();
			
				$this->trellis->core->db->construct( array(
														   'delete'	=> 'article_rate',
														   'where'	=> array( 'aid', 'in', $articles ),
													)	   );

				$this->trellis->core->db->execute();
			}
			
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'articles',
													   'where'	=> array( 'cat_id', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'categories',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

}

?>