<?php

/*
#======================================================
|	Trellis Desk
|	=====================================
|	By DJ Tarazona (dj@accord5.com)
|	(c) 2010 ACCORD5
|	http://www.trellisdesk.com/
|	=====================================
|	Email: sales@accord5.com
#======================================================
|	@ Version: v2.0 Aplha 1 Build 20011028
|	@ Version Int: 200.1.1.028
|	@ Version Num: 20011028
|	@ Build: 0028
#======================================================
|	| Functions: Groups
#======================================================
*/

class func_groups {

	public $error = '';

	#=======================================
	# @ Get Groups
	#=======================================

	public function get($input)
	{
		$return = array();

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> 'groups',
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $g = $this->trellis->core->db->fetch_row() )
		{
			$return[ $g['g_id'] ] = $g;
		}

		return $return;
	}

	#=======================================
	# @ Get Single Group
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'groups',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Group By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'g_id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add Group
	#=======================================

	public function add($data)
	{
		$fields = array(
						'g_name'				=> 'string',
						'g_ticket_access'		=> 'int',
						'g_ticket_create'		=> 'int',
						'g_ticket_edit'			=> 'int',
						'g_ticket_escalate'		=> 'int',
						'g_ticket_close'	    => 'int',
						'g_ticket_reopen'	    => 'int',
						'g_reply_edit'			=> 'int',
						'g_reply_delete'		=> 'int',
						'g_reply_rate'			=> 'int',
						'g_ticket_attach'		=> 'int',
						'g_upload_size_max'		=> 'int',
						'g_kb_access'			=> 'int',
						'g_kb_comment'			=> 'int',
						'g_kb_com_edit'			=> 'int',
						'g_kb_com_delete'		=> 'int',
						'g_kb_rate'				=> 'int',
						'g_news_comment'		=> 'int',
						'g_news_com_edit'		=> 'int',
						'g_news_com_delete'		=> 'int',
						'g_change_skin'			=> 'int',
						'g_change_lang'			=> 'int',
						'g_ticket_msg_edit'		=> 'int',
						'g_reply_edit_all'		=> 'int',
						'g_kb_com_edit_all'		=> 'int',
						'g_kb_com_delete_all'	=> 'int',
						'g_news_com_edit_all'	=> 'int',
						'g_news_com_delete_all'	=> 'int',
						'g_depart_perm'			=> 'serialize',
						'g_acp_access'			=> 'int',
						'g_acp_perm'			=> 'serialize',
						'g_acp_depart_perm'		=> 'serialize',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'groups',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Edit Group
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'g_name'				=> 'string',
						'g_ticket_access'		=> 'int',
						'g_ticket_create'		=> 'int',
						'g_ticket_edit'			=> 'int',
						'g_ticket_escalate'		=> 'int',
						'g_ticket_close'	    => 'int',
						'g_ticket_reopen'	    => 'int',
						'g_reply_edit'			=> 'int',
						'g_reply_delete'		=> 'int',
						'g_reply_rate'			=> 'int',
						'g_ticket_attach'		=> 'int',
						'g_upload_size_max'		=> 'int',
						'g_kb_access'			=> 'int',
						'g_kb_comment'			=> 'int',
						'g_kb_com_edit'			=> 'int',
						'g_kb_com_delete'		=> 'int',
						'g_kb_rate'				=> 'int',
						'g_news_comment'		=> 'int',
						'g_news_com_edit'		=> 'int',
						'g_news_com_delete'		=> 'int',
						'g_change_skin'			=> 'int',
						'g_change_lang'			=> 'int',
						'g_ticket_msg_edit'		=> 'int',
						'g_reply_edit_all'		=> 'int',
						'g_kb_com_edit_all'		=> 'int',
						'g_kb_com_delete_all'	=> 'int',
						'g_news_com_edit_all'	=> 'int',
						'g_news_com_delete_all'	=> 'int',
						'g_depart_perm'			=> 'serialize',
						'g_acp_access'			=> 'int',
						'g_acp_perm'			=> 'serialize',
						'g_acp_depart_perm'		=> 'serialize',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'groups',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'g_id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Group
	#=======================================

	public function delete($id, $action=0, $mvid=0)
	{
		if ( ! $id = intval( $id ) ) return false;

		if ( $action == 1 )
		{
			if ( ! $mvid = intval( $mvid ) ) return false;

			$this->trellis->core->db->construct( array(
													   'update'	=> 'users',
													   'set'	=> array( 'ugroup' => $mvid ),
													   'where'	=> array( 'ugroup', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();

			$num_users = $this->trellis->core->db->get_affected_rows();

			if ( $num_users )
			{
				$this->trellis->core->db->next_no_quotes('set'); # THIS MAKES ME NERVOUS

				$this->trellis->core->db->construct( array(
														   'update'	=> 'groups',
														   'set'	=> array( 'g_users' => 'g_users+'. $num_users ),
														   'where'	=> array( 'g_id', '=', $mvid ),
													)	   );

				$this->trellis->core->db->execute();
			}
		}
		elseif ( $action == 2 )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'users',
													   'where'	=> array( 'ugroup', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'groups',
												   'where'	=> array( 'g_id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

}

?>