<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: News
#======================================================
*/

class func_news {

	public $error = '';

	#=======================================
	# @ Get News
	#=======================================

	public function get($input)
	{
		$return = array();

		if ( ! $input['from'] ) $input['from'] = 'news';

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> $input['from'],
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $n = $this->trellis->core->db->fetch_row() )
		{
			$return[ $n['id'] ] = $n;
		}

		return $return;
	}

	#=======================================
	# @ Get Single News Item
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'news',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single News Item By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Get Comments
	#=======================================

	public function get_comments($input)
	{
		$input['from'] = 'news_comments';

		return $this->get($input);
	}

	#=======================================
	# @ Get Single Comment
	#=======================================

	public function get_single_comment($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'news_comments',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Comment By ID
	#=======================================

	public function get_single_comment_by_id($select, $id)
	{
		return $this->get_single_comment( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add News
	#=======================================

	public function add($data)
	{
		$fields = array(
						'uid'				=> 'int',
						'title'				=> 'string',
						'excerpt'			=> 'string',
						'content'			=> 'string',
						'email'				=> 'int',
						'allow_comments'	=> 'int',
						'html'		        => 'int',
						'date'				=> 'int',
						'ipadd'				=> 'string',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'news',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Add Comment
	#=======================================

	public function add_comment($data, $nid)
	{
	    # $nid can be pulled from $data!

		$fields = array(
						'nid'		=> 'int',
						'uid'		=> 'int',
						'message'	=> 'string',
						'staff'		=> 'int',
						'html'		=> 'int',
						'date'		=> 'int',
						'ipadd'		=> 'string',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'news_comments',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		$id = $this->trellis->core->db->get_insert_id();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'news',
												   'set'	=> array( 'comments' => array( '+', 1 ) ),
												   'where'	=> array( 'id', '=', $nid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $id;
	}

	#=======================================
	# @ Edit News
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'uid'				=> 'int',
						'title'				=> 'string',
						'excerpt'			=> 'string',
						'content'			=> 'string',
						'email'				=> 'int',
						'allow_comments'	=> 'int',
						'html'		        => 'int',
						'date'				=> 'int',
						'ipadd'				=> 'string',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'news',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Edit Comment
	#=======================================

	public function edit_comment($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'message'	=> 'string',
						'staff'		=> 'int',
						'html'		=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'news_comments',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete News
	#=======================================

	public function delete($id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'news_comments',
												   'where'	=> array( 'nid', '=', $id ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'news',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Comment
	#=======================================

	public function delete_comment($id, $params=array())
	{
		if ( ! $id = intval( $id ) ) return false;

		if ( ! isset( $params['nid'] ) )
		{
			if ( ! $c = $this->get_single_comment_by_id( array( 'nid' ), $id ) ) return false;

			 $params['nid'] = $c['nid'];
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'news_comments',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$dc = $this->trellis->core->db->get_affected_rows();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'news',
												   'set'	=> array( 'comments' => array( '-', 1 ) ),
												   'where'	=> array( 'id', '=', $params['nid'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		return $dc;
	}

}

?>