<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Pages
#======================================================
*/

class func_pages {

	public $error = '';

	#=======================================
	# @ Get Pages
	#=======================================

	public function get($input)
	{
		$return = array();

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> 'pages',
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $p = $this->trellis->core->db->fetch_row() )
		{
			$return[ $p['id'] ] = $p;
		}

		return $return;
	}

	#=======================================
	# @ Get Single Page
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'pages',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Page By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add Page
	#=======================================

	public function add($data)
	{
		$fields = array(
						'id'			=> 'int',
						'title'			=> 'string',
						'alias'			=> 'string',
						'description'	=> 'string',
						'content'		=> 'string',
						'date'			=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'pages',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Edit Page
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;
		
		$fields = array(
						'id'			=> 'int',
						'title'			=> 'string',
						'alias'			=> 'string',
						'description'	=> 'string',
						'content'		=> 'string',
						'modified'		=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'pages',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Page
	#=======================================

	public function delete($id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'pages',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

}

?>