<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Rebuild
#======================================================
*/

class func_rebuild {

	#=======================================
	# @ Rebuild Settings Cache
	#=======================================

	public function settings_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'cf_key', 'cf_group', 'cf_value' ),
												   'from'	=> 'settings',
												   'where'	=> array( 'cf_cache', '=', 1 ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $cf = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $cf['cf_group'] ][ $cf['cf_key'] ] = $cf['cf_value'];
		}

		$this->trellis->core->add_cache( 'settings', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Departments Cache
	#=======================================

	public function departs_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id', 'name', 'description', 'assign_auto', 'assign_move', 'escalate_enable', 'escalate_wait', 'escalate_depart', 'escalate_assign', 'close_auto', 'allow_attach', 'close_own', 'reopen_own', 'position' ),
												   'from'	=> 'departments',
												   'order'	=> array( 'position' => 'asc' ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $d = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $d['id'] ] = $d;
		}

		$this->trellis->core->add_cache( 'departs', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Categories Cache
	#=======================================

	public function categories_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'categories',
											)	   );

		$this->trellis->core->db->execute();

		while ( $c = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $c['id'] ] = $c;
		}
		$this->trellis->core->add_cache( 'categories', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Groups Cache
	#=======================================

	public function groups_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'g_id', 'g_name', 'g_acp_access' ),
												   'from'	=> 'groups',
											)	   );

		$this->trellis->core->db->execute();

		while ( $g = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $g['g_id'] ] = $g;
		}

		$this->trellis->core->add_cache( 'groups', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild News Cache
	#=======================================

	public function news_cache($limit=0)
    {
    	$to_cache = array();

    	if ( ! $limit ) $limit = $this->trellis->core->cache['settings']['news']['portal_amount'];

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id', 'title', 'excerpt', 'content', 'date' ),
												   'from'	=> 'news',
												   'order'	=> array( 'date' => 'desc' ),
												   'limit'	=> array( 0, $limit ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $a = $this->trellis->core->db->fetch_row() )
		{
			if ( ! $a['excerpt'] )
			{
				if ( $this->trellis->core->cache['settings']['news']['rte'] )
				{
					if ( $this->trellis->core->cache['settings']['news']['excerpt_trim'] )
					{
						$a['excerpt'] = $this->trellis->shorten_str( $this->trellis->remove_html( $this->trellis->remove_dbl_spaces( $this->trellis->convert_html( $a['content'] ) ) ), $this->trellis->core->cache['settings']['news']['excerpt_trim'], 1 );
					}
					else
					{
						$a['excerpt'] = $this->trellis->remove_html( $this->trellis->remove_dbl_spaces( $this->trellis->convert_html( $a['content'] ) ) );
					}
				}
				else
				{
					if ( $this->trellis->core->cache['settings']['news']['excerpt_trim'] )
					{
						$a['excerpt'] = $this->trellis->shorten_str( $a['content'], $this->trellis->core->cache['settings']['news']['excerpt_trim'], 1 );
					}
					else
					{
						$a['excerpt'] = $a['content'];
					}
				}
			}

			unset( $a['content'] );

			$to_cache[ $a['id'] ] = $a;
		}

		$this->trellis->core->add_cache( 'news', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Languages Cache
	#=======================================

	public function langs_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'languages',
											)	   );

		$this->trellis->core->db->execute();

		while ( $l = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $l['lkey'] ] = $l;

			if ( $l['default'] )
			{
				$this->trellis->core->add_cache( 'misc', array( 'default_lang' => $l['lkey'] ) );
			}
		}

		$this->trellis->core->add_cache( 'langs', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Skins Cache
	#=======================================

	public function skins_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id', 'name', 'img_dir', 'users' ),
												   'from'	=> 'skins',
											)	   );

		$this->trellis->core->db->execute();

		while ( $s = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $s['id'] ] = $s;

			if ( $s['default'] )
			{
				$this->trellis->core->add_cache( 'misc', array( 'default_skin' => $s['id'] ) );
			}
		}

		$this->trellis->core->add_cache( 'skins', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Profile Fields Cache
	#=======================================

	public function pfields_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'profile_fields',
											)	   );

		$this->trellis->core->db->execute();

		while ( $f = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $f['id'] ] = $f;
		}

		$this->trellis->core->add_cache( 'pfields', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Deparmtnet Fields Cache
	#=======================================

	public function dfields_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'depart_fields',
											)	   );

		$this->trellis->core->db->execute();

		while ( $f = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $f['id'] ] = $f;
		}

		$this->trellis->core->add_cache( 'dfields', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Reply Templates Cache
	#=======================================

	public function rtemplates_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id', 'name', 'description' ),
												   'from'	=> 'reply_templates',
												   'order'	=> array( 'position' => 'asc' ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $rt = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $rt['id'] ] = $rt;
		}

		$this->trellis->core->add_cache( 'rtemplates', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Priorities Cache
	#=======================================

	public function priorities_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'priorities',
												   'order'	=> array( 'position' => 'asc' ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $p = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $p['id'] ] = $p;
		}

		$this->trellis->core->add_cache( 'priorities', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Flags Cache
	#=======================================

	public function flags_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'flags',
												   'order'	=> array( 'position' => 'asc' ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $f = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $f['id'] ] = $f;
		}

		$this->trellis->core->add_cache( 'flags', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Staff Cache
	#=======================================

	public function staff_cache()
    {
    	$to_cache = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> array( 'u' => array( 'id', 'name' ), 'g' => array( 'g_acp_depart_perm' ) ),
												   'from'	=> array( 'u' => 'users' ),
												   'join'	=> array( array( 'from' => array( 'g' => 'groups' ), 'where' => array( 'u' => 'ugroup', '=', 'g' => 'g_id' ) ) ),
												   'where'	=> array( array( 'g' => 'g_acp_access' ), '=', 1 ),
												   'order'	=> array( 'name' => array( 'u' => 'desc' ) ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $s = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $s['id'] ] = $s;
		}

		$this->trellis->core->add_cache( 'staff', $to_cache, 1 );
    }

	#=======================================
	# @ Rebuild Statuses Cache
	#=======================================

	public function statuses_cache()
    {
    	$to_cache = array();
    	$to_cache_defaults = array();

    	$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'statuses',
												   'order'	=> array( 'position' => 'asc' ),
											)	   );

		$this->trellis->core->db->execute();

		while ( $s = $this->trellis->core->db->fetch_row() )
		{
			$to_cache[ $s['id'] ] = $s;

			if ( $s['default'] ) $to_cache_defaults[ $s['type'] ] = $s['id'];
		}

		$this->trellis->core->add_cache( 'statuses', $to_cache, 1 );
		$this->trellis->core->add_cache( 'status_defaults', $to_cache_defaults, 1 );
    }

}

?>