<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Recount
#======================================================
*/

class func_recount {

	#=======================================
	# @ Recount: Tickets per User
	# Recounts the number of tickets per
	# user.
	#=======================================

	function r_tickets_per_user($shutdown=0)
	{
		if ( $shutdown == 1 )
		{
			$this->trellis->shutdown_funcs[] = 'r_tickets_per_user';
			return TRUE;
		}

		#=============================
		# Grab Tickets
		#=============================

		$this->trellis->core->db->construct( array(
									  	  'select'	=> array( 'id', 'uid', 'status' ),
									  	  'from'	=> 'tickets',
					 		  	   ) 	 );

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			while( $t = $this->trellis->core->db->fetch_row() )
			{
				if ( $t['status'] != 6 )
				{
					$o_tickets[ $t['uid'] ] ++;
				}

				$tickets[ $t['uid'] ] ++;
			}
		}

		#=============================
		# Grab Users
		#=============================

		$this->trellis->core->db->construct( array(
										  'select'	=> array( 'id' ),
									  	  'from'	=> 'users',
							   	   ) 	 );

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			while( $m = $this->trellis->core->db->fetch_row() )
			{
				$users[ $m['id'] ] = 1;
			}
		}

		#=============================
		# Update Users
		#=============================

		while ( list( $uid, ) = each( $users ) )
		{
			$this->trellis->core->db->construct( array(
											  'update'	=> 'users',
											  'set'		=> array( 'open_tickets' => $o_tickets[ $uid ], 'tickets' => $tickets[ $uid ] ),
										  	  'where'	=> array( 'id', '=', $uid ),
										  	  'limit'	=> array( 1 ),
								  	   ) 	 );

			$this->trellis->core->db->execute();
		}

		$this->trellis->log( 'admin', "Recounted Tickets Per User" );
	}

	#=======================================
	# @ Recount: Tickets per Department
	# Recounts the number of tickets per
	# department.
	#=======================================

	function r_tickets_per_dept($shutdown=0)
	{
		if ( $shutdown == 1 )
		{
			$this->trellis->shutdown_funcs[] = 'r_tickets_per_dept';
			return TRUE;
		}

		#=============================
		# Grab Tickets
		#=============================

		$this->trellis->core->db->construct( array(
									  	  'select'	=> array( 'id', 'did' ),
									  	  'from'	=> 'tickets',
					 		  	   ) 	 );

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			while( $t = $this->trellis->core->db->fetch_row() )
			{
				$tickets[ $t['did'] ] ++;
			}
		}

		#=============================
		# Grab Departments
		#=============================

		$this->trellis->core->db->construct( array(
									  	  'select'	=> array( 'id' ),
									  	  'from'	=> 'departments',
							  	   ) 	 );

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			while( $d = $this->trellis->core->db->fetch_row() )
			{
				$departs[ $d['id'] ] = 1;
			}
		}

		#=============================
		# Update Departments
		#=============================

		while ( list( $did, ) = each( $departs ) )
		{
			$this->trellis->core->db->construct( array(
										  	  'update'	=> 'departments',
										  	  'set'		=> array( 'tickets' => $tickets[ $did ] ),
										  	  'where'	=> array( 'id', '=', $did ),
										  	  'limit'	=> array( 1 ),
						 		  	   ) 	 );

			$this->trellis->core->db->execute();
		}

		$this->trellis->log( 'admin', "Recounted Tickets Per Department" );
	}
}

?>