<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Tickets
#======================================================
*/

class func_tickets {

	public $error = '';

	#=======================================
	# @ Get Tickets
	#=======================================

	public function get($input)
	{
		$return = array();

		# This is almost just like the construct() function. Necessary?

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> $input['from'],
												   'join'	=> $input['join'],
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $t = $this->trellis->core->db->fetch_row() )
		{
			$return[ $t['id'] ] = $t;
		}

		return $return;
	}

	#=======================================
	# @ Get Single Ticket
	#=======================================

	public function get_single($input)
	{
		# This is almost just like the construct() function. Necessary?

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> $input['from'],
												   'join'	=> $input['join'],
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single Ticket By ID
	#=======================================

	public function get_single_by_id($input, $id)
	{
		if ( $input['join'] )
		{
			$input['where'] = array( array( 't' => 'id' ), '=', intval( $id ) );
		}
		else
		{
			$input['where'] = array( 'id', '=', intval( $id ) );
		}

		return $this->get_single( $input );
	}

	#=======================================
	# @ Get Id From Mask
	#=======================================

	public function get_id_from_mask($mask)
	{
	    $t = $this->get_single( array( 'select' => array( 'id' ), 'from' => 'tickets', 'where' => array( 'mask', '=', $mask ) ) );

		return $t['id'];
	}

	#=======================================
	# @ Get Ticket Assignments
	#=======================================

	public function get_assignments($tid)
	{
		$return = array();

		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'select'	=> array(
												   					 'a' => array( 'id', 'uid' ),
												   					 'u' => array( array( 'name' => 'uname') ),
												   					 ),
												   'from'	=> array( 'a' => 'assign_map' ),
												   'where'	=> array( array( 'a' => 'tid' ), '=', $tid ),
												   'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'a' => 'uid', '=', 'u' => 'id' ) ) ),
												   'group'	=> array( 'a' => 'uid' ),
												   'order'	=> array( 'name' => array( 'u' => 'asc' ) ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $a = $this->trellis->core->db->fetch_row() )
		{
			$return[ $a['id'] ] = $a;
		}

		return $return;
	}

	#=======================================
	# @ Get Ticket Flags
	#=======================================

	public function get_flags($tid)
	{
		$return = array();

		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'select'	=> array(
												   					 'm' => array( 'id', 'fid' ),
												   					 'f' => array( 'name', 'icon' ),
												   					 ),
												   'from'	=> array( 'm' => 'flags_map' ),
												   'join'	=> array( array( 'from' => array( 'f' => 'flags' ), 'where' => array( 'm' => 'fid', '=', 'f' => 'id' ) ) ),
												   'where'	=> array( array( 'm' => 'tid' ), '=', $tid ),
												   'group'	=> array( 'm' => 'fid' ),
												   'order'	=> array( 'position' => array( 'f' => 'asc' ) ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $f = $this->trellis->core->db->fetch_row() )
		{
			$return[ $f['id'] ] = $f;
		}

		return $return;
	}

	#=======================================
	# @ Add Ticket
	#=======================================

	public function add($data, $params=array())
	{
		$fields = array(
						'mask'			=> 'string',
						'tkey'			=> 'string',
						'did'			=> 'int',
						'uid'			=> 'int',
						'email'			=> 'string',
						'subject'		=> 'string',
						'priority'		=> 'int',
						'message'		=> 'string',
						'date'			=> 'int',
						'last_reply'	=> 'int',
						'last_uid'		=> 'int',
						'notes'			=> 'string',
						'status'		=> 'int',
						'accepted'		=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'tickets',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		$id = $this->trellis->core->db->get_insert_id();

		$mask = $this->generate_mask( $id );

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> array( 'mask' => $mask ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$assign_auto = unserialize( $this->trellis->core->cache['departs'][ $data['did'] ]['assign_auto'] );

		if ( ! empty( $assign_auto ) )
		{
			foreach( $assign_auto as $uid )
			{
				$this->add_assignment( $uid, $id, 1 );
			}
		}

		# update depart, user, stats, send emails, feed, etc

		if ( $params['return'] == 'mask' )
		{
		    return array( 'id' => $id, 'mask' => $mask );
		}
		else
		{
		    return $id;
		}
	}

	#=======================================
	# @ Add Reply
	#=======================================

	public function add_reply($data, $tid, $params=array())
	{
		$fields = array(
						'tid'		=> 'int',
						'uid'		=> 'int',
						'message'	=> 'string',
						'signature'	=> 'int',
						'staff'		=> 'int',
						'html'		=> 'string',
						'secret'	=> 'int',
						'date'		=> 'int',
						'ipadd'		=> 'string',
						);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'replies',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
											)	   );

		$this->trellis->core->db->execute();

		$id = $this->trellis->core->db->get_insert_id();

		if ( ! $data['secret'] )
		{
		    if ( $data['staff'] ) // Only care about accepted / hold status if we are staff
		    {
    			$sql_select = array();

    			if ( ! isset( $params['accepted'] ) ) $sql_select[] = 'accepted';
    			if ( ! isset( $params['onhold'] ) ) $sql_select[] = 'onhold';

    			if ( ! empty( $sql_select ) )
    			{
    				if ( ! $t = $this->get_single_by_id( array( 'select' => $sql_select, 'from' => 'tickets' ), $tid ) ) return false;
    			}

    			if ( ! isset( $params['accepted'] ) ) $params['accepted'] = $t['accepted'];
    			if ( ! isset( $params['onhold'] ) ) $params['onhold'] = $t['onhold'];
		    }

			$db_array = array(
							  'last_reply'			=> time(),
							  'last_uid'			=> $this->trellis->user['id'],
							  'replies' 			=> array( '+', 1 ),
							  );

			if ( $data['staff'] ) // " " ^^^
			{
				$db_array['last_reply_staff'] = time();

    			if ( ! $params['accepted'] )
    			{
    				$db_array['accepted'] = 1;
    			}

    			if ( ! $params['onhold'] )
    			{
    				$db_array['status'] = $this->trellis->core->cache['status_defaults'][5];
    				$db_array['aua'] = 1;
    			}
			}

			$this->trellis->core->db->construct( array(
													   'update'	=> 'tickets',
													   'set'	=> $db_array,
													   'where'	=> array( 'id', '=', $tid ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->execute();
		}

		return $id;
	}

	#=======================================
	# @ Add Ticket Assignment
	#=======================================

	public function add_assignment($uid, $tid, $skip_check=0, $return_name=0)
	{
		if ( ! $uid = intval( $uid ) ) return false;
		if ( ! $tid = intval( $tid ) ) return false;

		if ( ! $skip_check )
		{
			$this->trellis->core->db->construct( array(
													   'select'	=> array( 'id' ),
													   'from'	=> 'assign_map',
													   'where'	=> array( array( 'tid', '=', $tid ), array( 'uid', '=', $uid, 'and' ) ),
													   'limit'	=> array( 0, 1 ),
												)	   );

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() ) return false;
		}

		if ( $return_name )
		{
    		$this->trellis->core->db->construct( array(
    												   'select'	=> array( 'name' ),
    												   'from'	=> 'users',
    												   'where'	=> array( 'id', '=', $uid ),
    												   'limit'	=> array( 0, 1 ),
    											)	   );

    		$this->trellis->core->db->execute();

    		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

    		$result = $this->trellis->core->db->fetch_row();
		}

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'assign_map',
												   'set'	=> array( 'tid' => $tid, 'uid' => $uid ),
											)	   );

		$this->trellis->core->db->execute();

		if ( $return_name )
		{
		    return $result['name'];
		}
		else
		{
		    return true;
		}
	}

	#=======================================
	# @ Add Ticket Flag
	#=======================================

	public function add_flag($fid, $tid)
	{
		if ( ! $fid = intval( $fid ) ) return false;
		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id' ),
												   'from'	=> 'flags_map',
												   'where'	=> array( array( 'tid', '=', $tid ), array( 'fid', '=', $fid, 'and' ) ),
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() ) return false;

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'flags_map',
												   'set'	=> array( 'tid' => $tid, 'fid' => $fid ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_insert_id();
	}

	#=======================================
	# @ Edit Ticket
	#=======================================

	public function edit($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'did'			=> 'int',
						'subject'		=> 'string',
						'priority'		=> 'int',
						'message'		=> 'string',
						'last_reply'	=> 'int',
						'last_uid'		=> 'int',
						'replies'		=> 'int',
						'notes'			=> 'string',
						'status'		=> 'int',
						'close_uid'		=> 'int',
						'close_reason'	=> 'string',
						'close_date'	=> 'int',
						'accepted'		=> 'int',
						'aua'			=> 'int',
						'escalated'		=> 'int',
						'onhold'		=> 'int',
						'closed'		=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Edit Reply
	#=======================================

	public function edit_reply($data, $id)
	{
		if ( ! $id = intval( $id ) ) return false;

		$fields = array(
						'message'	=> 'string',
						'signature'	=> 'int',
						'staff'		=> 'int',
						'html'		=> 'string',
						'secret'	=> 'int',
						);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'replies',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Ticket
	#=======================================

	public function delete($id, $params=array())
	{
		if ( ! $id = intval( $id ) ) return false;

		$sql_select = array();

		if ( ! isset( $params['did'] ) ) $sql_select[] = 'did';
		if ( ! isset( $params['uid'] ) ) $sql_select[] = 'uid';
		if ( ! isset( $params['closed'] ) ) $sql_select[] = 'closed';

		if ( ! empty( $sql_select ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => $sql_select, 'from' => 'tickets' ), $id ) ) return false;
		}

		if ( ! isset( $params['did'] ) ) $params['did'] = $t['did'];
		if ( ! isset( $params['uid'] ) ) $params['uid'] = $t['uid'];
		if ( ! isset( $params['closed'] ) ) $params['closed'] = $t['closed'];

		$this->trellis->core->db->construct( array(
												   'update'	=> 'departments',
												   'set'	=> array( 'tickets_total' => array( '-', 1 ) ),
												   'where'	=> array( 'id', '=', $params['did'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		$db_array = array( 'tickets_total' => array( '-', 1 ) );

		if ( ! $params['closed'] )
		{
			$db_array['tickets_open'] = array( '-', 1 );
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'users',
												   'set'	=> $db_array,
												   'where'	=> array( 'id', '=', $params['uid'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		$this->clear_assignments( $id );

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'depart_fields_data',
												   'where'	=> array( 'tid', '=', $id ),
											)	   );

		$this->trellis->core->db->execute();

		$this->clear_flags( $id );

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'replies',
												   'where'	=> array( 'tid', '=', $id ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'tickets',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Reply
	#=======================================

	public function delete_reply($id, $params=array())
	{
		if ( ! $id = intval( $id ) ) return false;

		$sql_select = array();

		if ( ! isset( $params['tid'] ) ) $sql_select['r'][] = 'tid';
		if ( ! isset( $params['date'] ) ) $sql_select['r'][] = 'date';
		if ( ! isset( $params['last_reply'] ) ) $sql_select['t'][] = 'last_reply';

		if ( ! isset( $params['staff'] ) )  // Only care about secret and last staff reply if we are staff
		{
    		if ( ! isset( $params['staff'] ) ) $sql_select['r'][] = 'staff';
    		if ( ! isset( $params['secret'] ) ) $sql_select['r'][] = 'secret';
    		if ( ! isset( $params['last_reply_staff'] ) ) $sql_select['t'][] = 'last_reply_staff';
		}
		elseif ( $params['staff'] )
		{
    		if ( ! isset( $params['secret'] ) ) $sql_select['r'][] = 'secret';
    		if ( ! isset( $params['last_reply_staff'] ) ) $sql_select['t'][] = 'last_reply_staff';
		}

		if ( ! empty( $sql_select ) )
		{
			if ( ! $r = $this->get_single( array( 'select' => $sql_select, 'from' => array( 'r' => 'replies' ), 'join' => array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ), 'where' => array( array( 'r' => 'id', '=', $id ) ), 'limit' => array( 0, 1 ) ) ) ) return false;
		}

		if ( ! isset( $params['tid'] ) ) $params['tid'] = $r['tid'];
		if ( ! isset( $params['date'] ) ) $params['date'] = $r['date'];
		if ( ! isset( $params['last_reply'] ) ) $params['last_reply'] = $r['last_reply'];
		if ( ! isset( $params['staff'] ) ) $params['staff'] = $r['staff'];

		if ( $params['staff'] )  // " " ^^^
		{
    		if ( ! isset( $params['secret'] ) ) $params['secret'] = $r['secret'];
    		if ( ! isset( $params['last_reply_staff'] ) ) $params['last_reply_staff'] = $r['last_reply_staff'];
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'replies',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$dr = $this->trellis->core->db->get_affected_rows();

		if ( ! $params['secret'] )
		{
			$db_array = array( 'replies' => array( '-', 1 ) );

			if ( $params['last_reply'] == $params['date'] || $params['last_reply_staff'] == $params['date'] ) $lr = $this->get_single( array( 'select' => array( 'uid', 'date' ), 'from' => 'replies', 'where' => array( array( 'tid', '=', $params['tid'] ), array( 'secret', '!=', 1, 'and' ) ), 'order' => array( 'date' => 'desc' ) ) );

			if ( empty( $lr ) ) $lr = $this->get_single( array( 'select' => array( 'uid', 'date' ), 'from' => 'tickets', 'where' => array( 'id', '=', $params['tid'] ) ) );

			if ( $params['last_reply'] == $params['date'] )
			{
				$db_array['last_reply'] = $lr['date'];
				$db_array['last_uid'] = $lr['uid'];
			}

			if ( $params['last_reply_staff'] == $params['date'] )
			{
				$db_array['last_reply_staff'] = $lr['date'];
			}

			$this->trellis->core->db->construct( array(
													   'update'	=> 'tickets',
													   'set'	=> $db_array,
													   'where'	=> array( 'id', '=', $params['tid'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->next_shutdown();
			$this->trellis->core->db->execute();
		}

		return $dr;
	}

	#=======================================
	# @ Delete Ticket Assignment
	#=======================================

	public function delete_assignment($uid, $tid)
	{
		if ( ! $uid = intval( $uid ) ) return false;
		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'assign_map',
												   'where'	=> array( array( 'tid', '=', $tid ), array( 'uid', '=', $uid, 'and' ) ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Delete Ticket Flag
	#=======================================

	public function delete_flag($fid, $tid)
	{
		if ( ! $fid = intval( $fid ) ) return false;
		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'flags_map',
												   'where'	=> array( array( 'tid', '=', $tid ), array( 'fid', '=', $fid, 'and' ) ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Clear Ticket Assignments
	#=======================================

	public function clear_assignments($tid)
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'assign_map',
												   'where'	=> array( 'tid', '=', $tid ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Clear Ticket Flags
	#=======================================

	public function clear_flags($tid)
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'flags_map',
												   'where'	=> array( 'tid', '=', $tid ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Move Ticket
	#=======================================

	public function move($ndid, $tid, $odid=0)
	{
		if ( ! $tid = intval( $tid ) ) return false;
		if ( ! $ndid = intval( $ndid ) ) return false;

		if ( ! $odid )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => array( 'did' ), 'from' => 'tickets' ), $tid ) ) return false;

			$odid = $t['did'];
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'departments',
												   'set'	=> array( 'tickets_total' => array( '+', 1 ) ),
												   'where'	=> array( 'id', '=', $ndid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'departments',
												   'set'	=> array( 'tickets_total' => array( '-', 1 ) ),
												   'where'	=> array( 'id', '=', $odid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> array( 'did' => $ndid ),
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Escalate Ticket
	#=======================================

	public function escalate($tid, $params=array())
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$sql_select = array();

		if ( ! isset( $params['did'] ) ) $sql_select[] = 'did';

		if ( $params['staff'] && ! isset( $params['accepted'] ) ) $sql_select[] = 'accepted'; // Only care about auto-accepting if staff

		if ( ! empty( $sql_select ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => $sql_select, 'from' => 'tickets' ), $tid ) ) return false;
		}

		if ( ! isset( $params['did'] ) ) $params['did'] = $t['did'];
		if ( $params['staff'] && ! isset( $params['accepted'] ) ) $params['accepted'] = $t['accepted']; // " " ^^^

		if ( $this->trellis->core->cache['settings']['ticket']['clear_assign_escalate'] ) $this->clear_assignments( $tid );

		$escalate_assign = unserialize( $this->trellis->core->cache['departs'][ $params['did'] ]['escalate_assign'] );

		if ( ! empty( $escalate_assign ) )
		{
			foreach( $escalate_assign as $uid )
			{
				$this->add_assignment( $uid, $tid );
			}
		}

		if ( $this->trellis->core->cache['departs'][ $params['did'] ]['escalate_depart'] ) $this->move( $tid, $this->trellis->core->cache['departs'][ $params['did'] ]['escalate_depart'], $params['did'] );

		$db_array = array( 'escalated' => 1 );

		if ( $params['staff'] && ! $params['accepted'] ) // " " ^^^
		{
			$db_array['status'] = $this->trellis->core->cache['status_defaults'][2];
			$db_array['accepted'] = 1;
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> $db_array,
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Hold Ticket
	#=======================================

	public function hold($tid, $params=array())
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$sql_select = array();

		if ( ! isset( $params['accepted'] ) ) $sql_select[] = 'accepted';
		if ( ! isset( $params['aua'] ) ) $sql_select[] = 'aua';

		if ( ! empty( $sql_select ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => $sql_select, 'from' => 'tickets' ), $tid ) ) return false;
		}

		$db_array = array( 'status' => $this->trellis->core->cache['status_defaults'][4], 'onhold' => 1 );

		if ( ! isset( $params['accepted'] ) ) $params['accepted'] = $t['accepted'];
		if ( ! isset( $params['aua'] ) ) $params['aua'] = $t['aua'];

		if ( ! $params['accepted'] )
		{
			$db_array['accepted'] = 1;
		}

		if ( $params['aua'] )
		{
			$db_array['aua'] = 0;
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> $db_array,
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Remove Hold Ticket
	#=======================================

	public function rmvhold($tid, $params=array())
	{
		if ( ! $tid = intval( $tid ) ) return false;

		if ( ! isset( $parmas['aua'] ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => array( 'aua' ), 'from' => 'tickets' ), $tid ) ) return false;

			$parmas['aua'] = $t['aua'];
		}

		$db_array = array( 'onhold' => 0 );

		if ( $parmas['aua'] )
		{
			$db_array['status'] = $this->trellis->core->cache['status_defaults'][5];
		}
		else
		{
			$db_array['status'] = $this->trellis->core->cache['status_defaults'][2];
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> $db_array,
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Close Ticket
	#=======================================

	public function close($tid, $params=array())
	{
		if ( ! $tid = intval( $tid ) ) return false;

		if ( ! isset( $params['uid'] ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => array( 'uid' ), 'from' => 'tickets' ), $tid ) ) return false;

			$params['uid'] = $t['uid'];
		}

		if ( $params['uid'] )
		{
			$this->trellis->core->db->construct( array(
													   'update'	=> 'users',
													   'set'	=> array( 'tickets_open' => array( '-', 1 ) ),
													   'where'	=> array( 'id', '=', $params['uid'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->next_shutdown();
			$this->trellis->core->db->execute();
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> array( 'status' => $this->trellis->core->cache['status_defaults'][6], 'close_uid' => $this->trellis->user['id'], 'close_date' => time(), 'closed' => 1 ),
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Reopen Ticket
	#=======================================

	public function reopen($tid, $params=array())
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$sql_select = array();

		if ( ! isset( $params['uid'] ) ) $sql_select[] = 'uid';

		if ( $params['staff'] ) // Only care about previous status if staff
		{
    		if ( ! isset( $params['aua'] ) ) $sql_select[] = 'aua';
    		if ( ! isset( $params['accepted'] ) ) $sql_select[] = 'accepted';
		}

		if ( ! empty( $sql_select ) )
		{
			if ( ! $t = $this->get_single_by_id( array( 'select' => $sql_select, 'from' => 'tickets' ), $tid ) ) return false;
		}

		$db_array = array( 'close_uid' => 0, 'close_date' => 0, 'closed' => 0 );

		if ( ! isset( $params['uid'] ) ) $params['uid'] = $t['uid'];

		if ( $params['staff'] ) // " " ^^^
		{
    		if ( ! isset( $params['aua'] ) ) $params['uid'] = $t['aua'];
    		if ( ! isset( $params['accepted'] ) ) $params['accepted'] = $t['accepted'];

    		if ( $params['aua'] )
    		{
    			$db_array['status'] = $this->trellis->core->cache['status_defaults'][5];
    		}
    		else
    		{
    			$db_array['status'] = $this->trellis->core->cache['status_defaults'][2];
    		}

    		if ( ! $params['accepted'] )
    		{
    			$db_array['accepted'] = 1;
    		}
		}
		else
		{
		    $db_array['accepted'] = 0;
		    $db_array['aua'] = 0;
		    $db_array['escalated'] = 0;
		    $db_array['onhold'] = 0;
		    $db_array['status'] = $this->trellis->core->cache['status_defaults'][1];
		}

		if ( $params['uid'] )
		{
			$this->trellis->core->db->construct( array(
													   'update'	=> 'users',
													   'set'	=> array( 'tickets_open' => array( '+', 1 ) ),
													   'where'	=> array( 'id', '=', $params['uid'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->next_shutdown();
			$this->trellis->core->db->execute();
		}

		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> $db_array,
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Remove Escalated Status
	#=======================================

	public function rmvescalate($tid)
	{
		$this->trellis->core->db->construct( array(
												   'update'	=> 'tickets',
												   'set'	=> array( 'escalated' => 0 ),
												   'where'	=> array( 'id', '=', $tid ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

	#=======================================
	# @ Generate Mask
	#=======================================

	private function generate_mask($tid)
	{
		if ( ! $tid = intval( $tid ) ) return false;

		$mask = $this->trellis->core->cache['settings']['ticket']['mask'];

		$mask = preg_replace_callback( '/\%A/', array( &$this, 'rand_upper' ), $mask );
		$mask = preg_replace_callback( '/\%a/', array( &$this, 'rand_lower' ), $mask );
		$mask = preg_replace_callback( '/\%n/', array( &$this, 'rand_num' ), $mask );
		$mask = str_replace( '%i', $tid, $mask, $count );

		if ( ! $count )
		{
			$this->trellis->core->db->construct( array(
													   'select'	=> array( 'id' ),
													   'from'	=> 'tickets',
													   'where'	=> array( 'mask', '=', $mask ),
													   'limit'	=> array( 0, 1 ),
												)	   );

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() ) return $this->generate_mask( $tid );
		}

		return $mask;
	}

	#=======================================
	# @ Random Uppercase Letter
	#=======================================

	private function rand_upper()
	{
		return chr( 65 + mt_rand( 0, 25 ) );
	}

	#=======================================
	# @ Random Lowercase Letter
	#=======================================

	private function rand_lower()
	{
		return chr( 97 + mt_rand( 0, 25 ) );
	}

	#=======================================
	# @ Random Number
	#=======================================

	private function rand_num()
	{
		return mt_rand( 0, 9 );
	}

}

?>