<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Functions: Users
#======================================================
*/

class func_users {

	private $default_columns_tm = array( 'id' => '6%', 'subject' => '31%', 'priority' => '14%', 'department' => '19%', 'reply' => '17%', 'status' => '13%' );

	#=======================================
	# @ Get User
	#=======================================

	public function get($input)
	{
		if ( ! is_array( $input['select'] ) ) return false;

		// Security
		if ( $input['bypass_security'] )
		{
			if ( in_array( 'password', $input['select'] ) ) return false;
			if ( in_array( 'pass_salt', $input['select'] ) ) return false;
			if ( in_array( 'login_key', $input['select'] ) ) return false;
		}

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> 'users',
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $u = $this->trellis->core->db->fetch_row() )
		{
			$return[ $u['id'] ] = $u;
		}

		return $return;
	}

	#=======================================
	# @ Get Single User
	#=======================================

	public function get_single($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'users',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single User By ID
	#=======================================

	public function get_single_by_id($select, $id)
	{
		return $this->get_single( $select, array( 'id', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Get Single User By Username
	#=======================================

	public function get_single_by_username($select, $username)
	{
		return $this->get_single( $select, array( 'name|lower', '=', strtolower( $username ) ) );
	}

	#=======================================
	# @ Get Single User By Email
	#=======================================

	public function get_single_by_email($select, $email)
	{
		return $this->get_single( $select, array( 'email|lower', '=', strtolower( $email ) ) );
	}

	#=======================================
	# @ Get User
	#=======================================

	public function get_staff($input)
	{
		if ( ! is_array( $input['select'] ) ) return false;

		// Security
		if ( $input['bypass_security'] )
		{
			if ( in_array( 'password', $input['select'] ) ) return false;
			if ( in_array( 'pass_salt', $input['select'] ) ) return false;
			if ( in_array( 'login_key', $input['select'] ) ) return false;
		}

		$this->trellis->core->db->construct( array(
												   'select'	=> $input['select'],
												   'from'	=> 'users_staff',
												   'where'	=> $input['where'],
												   'order'	=> $input['order'],
												   'limit'	=> $input['limit'],
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		while ( $u = $this->trellis->core->db->fetch_row() )
		{
			$return[ $u['uid'] ] = $u;
		}

		return $return;
	}

	#=======================================
	# @ Get Single User Staff
	#=======================================

	public function get_single_staff($select, $where='')
	{
		$this->trellis->core->db->construct( array(
												   'select'	=> $select,
												   'from'	=> 'users_staff',
												   'where'	=> $where,
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		return $this->trellis->core->db->fetch_row();
	}

	#=======================================
	# @ Get Single User By ID Staff
	#=======================================

	public function get_single_by_id_staff($select, $id)
	{
		return $this->get_single_staff( $select, array( 'uid', '=', intval( $id ) ) );
	}

	#=======================================
	# @ Add User
	#=======================================

	public function add($data, $params=array())
    {
    	$pwsalt = '';
		$lksalt = '';
		$rksalt = '';

		while( strlen( $pwsalt ) < 16 ) $pwsalt .= chr( rand( 32, 126 ) );
		while( strlen( $lksalt ) < 8 ) $lksalt .= chr( rand( 32, 126 ) );
		while( strlen( $rksalt ) < 8 ) $rksalt .= chr( rand( 32, 126 ) );

		$lksalt .= uniqid( rand(), true );
		$rksalt .= uniqid( rand(), true );

		$pwhash = hash( 'whirlpool', $pwsalt . $data['password'] . $this->trellis->config['pass_key'] );
		$lkhash = str_replace( "=", "", base64_encode( strrev( hash( 'whirlpool', $lksalt . $this->trellis->config['cookie_key'] ) ) ) );
		$rkhash = md5( $rksalt . $this->trellis->config['rss_key'] );

		$db_array = array(
						  'pass_hash'		=> $pwhash,
						  'pass_salt'		=> $pwsalt,
						  'login_key'		=> $lkhash,
						  'rss_key'			=> $rkhash,
						  );

		unset( $data['password'] );

		$result = array_merge( $data, $db_array );

		if ( ! isset( $params['staff'] ) && $this->trellis->core->cache['groups'][ $data['ugroup'] ]['g_acp_acces'] ) $params['staff'] = 1;

		if ( ! isset( $params['staff'] ) )
		{
			if ( $data['ugroup_sub'] )
			{
				$data['ugroup_sub'] = unserialize( $data['ugroup_sub'] );

				if ( ! empty( $data['ugroup_sub'] ) )
				{
					foreach ( $data['ugroup_sub'] as $gid )
					{
						if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $params['staff'] = 1;
					}
				}
			}
		}

    	$fields = array(
						'name'					=> 'string',
						'email'					=> 'string',
						'pass_hash'				=> 'string',
						'pass_salt'				=> 'string',
						'login_key'				=> 'string',
    					'ugroup'				=> 'int',
						'ugroup_sub'			=> 'string',
						'title'					=> 'string',
						'joined'				=> 'string',
						'signature'				=> 'string',
						'sig_auto'				=> 'string',
						'rss_key'				=> 'string',
						'lang'					=> 'int',
						'skin'					=> 'int',
						'time_zone'				=> 'string',
						'time_dst'				=> 'int',
						'rte_enable'			=> 'int',
    					'email_enable'			=> 'int',
						'email_ticket'			=> 'int',
						'email_reply'			=> 'int',
						'email_news'			=> 'int',
						'email_type'			=> 'int',
						'val_email'				=> 'int',
						'val_admin'				=> 'int',
						'ipadd'					=> 'string',
    					);

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'users',
												   'set'	=> $this->trellis->process_data( $fields, $result ),
											)	   );

		$this->trellis->core->db->execute();

		$uid = $this->trellis->core->db->get_insert_id();

		if ( $params['staff'] )
		{
	    	$fields = array(
							'uid'					=> 'int',
							'email_staff_enable'	=> 'int',
							'email_staff_ticket'	=> 'int',
							'email_staff_reply'		=> 'int',
							'email_staff_assign'	=> 'int',
							'esn_unassigned'		=> 'int',
							'esn_assigned'			=> 'int',
							'esn_assigned_to_me'	=> 'int',
							'columns_tm'			=> 'string',
							'sort_tm'				=> 'string',
							'order_tm'				=> 'int',
	    					);

	    	$data['uid'] = $uid;
	    	$data['columns_tm'] = serialize( $this->default_columns_tm );
	    	$data['sort_tm'] = 'reply';

			$this->trellis->core->db->construct( array(
													   'insert'	=> 'users_staff',
													   'set'	=> $this->trellis->process_data( $fields, $data ),
												)	   );

			$this->trellis->core->db->execute();
		}

		return $uid;
    }

	#=======================================
	# @ Edit User
	#=======================================

	public function edit($data, $id, $params=array())
    {
    	if ( ! $id = intval( $id ) ) return false;

		if ( ! isset( $params['staff'] ) && $this->trellis->core->cache['groups'][ $data['ugroup'] ]['g_acp_acces'] ) $params['staff'] = 1;

		if ( ! isset( $params['staff'] ) )
		{
			if ( $data['ugroup_sub'] )
			{
				$data['ugroup_sub'] = unserialize( $data['ugroup_sub'] );

				if ( ! empty( $data['ugroup_sub'] ) )
				{
					foreach ( $data['ugroup_sub'] as $gid )
					{
						if ( $this->trellis->core->cache['groups'][ $gid ]['g_acp_access'] ) $params['staff'] = 1;
					}
				}
			}
		}

		if ( $params['staff'] && ! isset( $params['oldstaff'] ) )
		{
			$this->trellis->core->db->construct( array(
													   'select'	=> array( 'uid' ),
													   'from'	=> 'users_staff',
													   'where'	=> array( 'uid', '=', $id ),
													   'limit'	=> array( 0, 1 ),
												)	   );

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() ) $params['oldstaff'] = 1;
		}

    	$fields = array(
						'name'					=> 'string',
						'email'					=> 'string',
    					'ugroup'				=> 'int',
						'ugroup_sub'			=> 'string',
						'title'					=> 'string',
						'joined'				=> 'string',
						'signature'				=> 'string',
						'sig_auto'				=> 'string',
						'rss_key'				=> 'string',
						'lang'					=> 'int',
						'skin'					=> 'int',
						'time_zone'				=> 'string',
						'time_dst'				=> 'int',
						'rte_enable'			=> 'int',
    					'email_enable'			=> 'int',
						'email_ticket'			=> 'int',
						'email_reply'			=> 'int',
						'email_news'			=> 'int',
						'email_type'			=> 'int',
						'val_email'				=> 'int',
						'val_admin'				=> 'int',
    					);

		$this->trellis->core->db->construct( array(
												   'update'	=> 'users',
												   'set'	=> $this->trellis->process_data( $fields, $data ),
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$ar = $this->trellis->core->db->get_affected_rows();

		if ( $params['staff'] )
		{
	    	$fields = array(
							'uid'					=> 'int',
							'email_staff_enable'	=> 'int',
							'email_staff_ticket'	=> 'int',
							'email_staff_reply'		=> 'int',
							'email_staff_assign'	=> 'int',
							'esn_unassigned'		=> 'int',
							'esn_assigned'			=> 'int',
							'esn_assigned_to_me'	=> 'int',
							'columns_tm'			=> 'string',
							'sort_tm'				=> 'string',
							'order_tm'				=> 'int',
	    					);

			if ( $params['oldstaff'] )
			{
				$this->trellis->core->db->construct( array(
														   'update'	=> 'users_staff',
														   'set'	=> $this->trellis->process_data( $fields, $data ),
														   'where'	=> array( 'uid', '=', $id ),
														   'limit'	=> array( 1 ),
													)	   );
			}
			else
			{
				$data['uid'] = $id;
	    		$data['columns_tm'] = serialize( $this->default_columns_tm );
	    		$data['sort_tm'] = 'reply';

				$this->trellis->core->db->construct( array(
														   'insert'	=> 'users_staff',
														   'set'	=> $this->trellis->process_data( $fields, $data ),
													)	   );
			}

			$this->trellis->core->db->execute();
		}

		return $ar;
    }

	#=======================================
	# @ Delete User
	#=======================================

	public function delete($id, $delete=array())
	{
		if ( ! $id = intval( $id ) ) return false;

		if ( $delete['tickets'] )
		{
			$this->trellis->core->db->construct( array(
													   'select'	=> array( 'id' ),
													   'from'	=> 'tickets',
													   'where'	=> array( array( 'uid', '=', $id ), array( 'replies', '>', 0, 'and' ) ),
												)	   );

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() )
			{
				$tickets = array();

				while( $t = $this->trellis->core->db->fetch_row() )
				{
					$tickets[] = $t['id'];
				}

				$this->trellis->core->db->construct( array(
														   'delete'	=> 'replies',
														   'where'	=> array( 'tid', 'in', $tickets ),
													)	   );

				$this->trellis->core->db->execute();
			}

			$this->trellis->core->db->construct( array(
													   'delete'	=> 'tickets',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		if ( $delete['replies'] )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'replies',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		if ( $delete['comments'] )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'article_comments',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();

			$this->trellis->core->db->construct( array(
													   'delete'	=> 'news_comments',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		if ( $delete['ratings'] )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'article_rate',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();

			$this->trellis->core->db->construct( array(
													   'delete'	=> 'reply_rate',
													   'where'	=> array( 'uid', '=', $id ),
												)	   );

			$this->trellis->core->db->execute();
		}

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'depart_fields_data',
												   'where'	=> array( 'uid', '=', $id ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'profile_fields_data',
												   'where'	=> array( 'uid', '=', $id ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'users',
												   'where'	=> array( 'id', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'users_staff',
												   'where'	=> array( 'uid', '=', $id ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return $this->trellis->core->db->get_affected_rows();
	}

    #=======================================
	# @ Check Password
	#=======================================

	public function check_password($passwd, $id)
    {
    	if ( ! $id = intval( $id ) ) return false;

		$u = $this->get_single_by_id( array( 'pass_hash', 'pass_salt' ), $id );

		if ( hash( 'whirlpool', $u['pass_salt'] . $passwd . $this->trellis->config['pass_key'] ) == $u['pass_hash'] )
		{
			return true;
		}

		return false;
    }

    #=======================================
	# @ Change Password
	#=======================================

	public function change_password($new_passwd, $id)
    {
    	$pwsalt = '';
		$lksalt = '';
		$rksalt = '';

		while( strlen( $pwsalt ) < 16 ) $pwsalt .= chr( rand( 32, 126 ) );
		while( strlen( $lksalt ) < 8 ) $lksalt .= chr( rand( 32, 126 ) );
		while( strlen( $rksalt ) < 8 ) $rksalt .= chr( rand( 32, 126 ) );

		$lksalt .= uniqid( rand(), true ) . $id;
		$rksalt .= uniqid( rand(), true ) . $id;

		$pwhash = hash( 'whirlpool', $pwsalt . $new_passwd . $this->trellis->config['pass_key'] );
		$lkhash = hash( 'whirlpool', $lksalt . $this->trellis->config['cookie_key'] );
		$rkhash = str_replace( "=", "", base64_encode( strrev( md5( $rksalt . $this->trellis->config['rss_key'] ) ) ) );

		$db_array = array(
						  'pass_hash'		=> $pwhash,
						  'pass_salt'		=> $pwsalt,
						  'login_key'		=> $lkhash,
						  'rss_key'			=> $rkhash,
						  );

		$this->trellis->core->db->construct( array(
												   'update'	=> 'users',
											  	   'set'	=> $db_array,
											  	   'where'	=> array( 'id', '=', $id ),
											  	   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return true;
    }

    #=======================================
	# @ Change Email
	#=======================================

	function change_email($new_email, $id, $skip_val=0)
    {
    	if ( ! $id = intval( $id ) ) return false;

    	if ( ! $this->trellis->validate_email( $new_email ) ) return false;

    	if ( $skip_val || ! $this->trellis->core->cache['settings']['security']['validation_email'] )
    	{
			#=============================
			# Update Database
			#=============================

			$this->trellis->core->db->construct( array(
													   'update'	=> 'users',
													   'set'	=> array( 'email' => $new_email ),
													   'where'	=> array( 'id', '=', $id ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->execute();

			return 2;
    	}
    	else
    	{
			#=============================
			# Insert Validation
			#=============================

			$val_code = md5 ( 'ce'. $new_email . uniqid( rand(), true ) );

			$db_array = array(
							  'id'			=> $val_code,
							  'uid'			=> $this->trellis->user['id'],
							  'new_email'	=> $new_email,
							  'date'		=> time(),
							  'type'		=> 2,
							 );

			$this->trellis->core->db->construct( array(
													   'insert'	=> 'validation',
													   'set'	=> $db_array,
												)	   );

			$this->trellis->core->db->execute();

			#=============================
			# Send Email
			#=============================

			$replace = array();

			$replace['{VAL_LINK}'] = $this->trellis->config['hd_url'] ."/index.php?act=myaccount&code=valemail&key=". $val_code;

			$this->trellis->send_email( $id, 'change_email_val', $replace, array( 'over_email' => $new_email ) );

			return 1;
		}
    }

    #=======================================
	# @ Validate Email
	#=======================================

	function validate_email($key)
    {
    	$this->trellis->core->db->construct( array(
											  	   'select'	=> 'all',
											  	   'from'	=> 'validation',
											  	   'where'	=> array( array( 'id', '=', $key ), array( 'type', '=', 2, 'and' ) ),
											  	   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		$v = $this->trellis->core->db->fetch_row();

		if ( $v['date'] < time() - ( 60 * 60 * $this->trellis->core->cache['settings']['security']['email_expire'] ) )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'validation',
													   'where'	=> array( 'id', '=', $v['id'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->execute();

			return false;
		}

		#=============================
		# Update User
		#=============================

		$this->trellis->core->db->construct( array(
												   'update'	=> 'users',
												   'set'	=> array( 'email' => $v['new_email'] ),
												   'where'	=> array( 'id', '=', $v['uid'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		#=============================
		# Delete Validation
		#=============================

		$this->trellis->core->db->construct( array(
												   'delete'	=> 'validation',
												   'where'	=> array( 'id', '=', $v['id'] ),
												   'limit'	=> array( 1 ),
											)	   );

		$this->trellis->core->db->execute();

		return true;
    }

    #=======================================
	# @ Forgot Password
	#=======================================

	function forgot_password($id)
    {
    	if ( ! $id = intval( $id ) ) return false;

		#=============================
		# Insert Validation
		#=============================

		$val_code = md5( 'fp' . $id . uniqid( rand(), true ) );

		$db_array = array(
						  'id'			=> $val_code,
						  'uid'			=> $id,
						  'date'		=> time(),
						  'type'		=> 3,
						 );

		$this->trellis->core->db->construct( array(
												   'insert'	=> 'validation',
												   'set'	=> $db_array,
											)	   );

		$this->trellis->core->db->execute();

		#=============================
		# Send Email
		#=============================

		$replace = array();

		$replace['{VAL_LINK}'] = $this->trellis->config['hd_url'] ."/index.php?act=register&code=reset&key=". $val_code;

		$this->trellis->send_email( $id, 'reset_pass_val', $replace );

		return true;
    }

    #=======================================
	# @ Check Reset Password Key
	#=======================================

	function check_reset_pswd_key($key, $delete=0)
    {
		$this->trellis->core->db->construct( array(
												   'select'	=> 'all',
												   'from'	=> 'validation',
												   'where'	=> array( array( 'id', '=', $key ), array( 'type', '=', 3, 'and' ) ),
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		$v = $this->trellis->core->db->fetch_row();

		if ( $v['date'] < time() - ( 60 * 60 * $this->trellis->core->cache['settings']['security']['password_expire'] ) )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'validation',
													   'where'	=> array( 'id', '=', $v['id'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->execute();

			return false;
		}

		$this->trellis->core->db->construct( array(
												   'select'	=> array( 'id', 'name' ),
												   'from'		=> 'users',
												   'where'	=> array( 'id', '=', $v['uid'] ),
												   'limit'	=> array( 0, 1 ),
											)	   );

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() ) return false;

		$u =  $this->trellis->core->db->fetch_row();

		if ( $delete )
		{
			$this->trellis->core->db->construct( array(
													   'delete'	=> 'validation',
													   'where'	=> array( 'id', '=', $v['id'] ),
													   'limit'	=> array( 1 ),
												)	   );

			$this->trellis->core->db->execute();
		}

		return $u;
    }

}

?>