<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Trellis Desk Main Class
#======================================================
*/

class trellis {

	var $vername = '2.0 Alpha 1';
	var $vershort = '2.0 a1';
	var $vernum = '20011028';
	var $shutdown_funcs = "";
	var $lang;

	var $xml_lang_abbr = "";
	var $xml_lang_name = "";
	var $xml_lang_file = "";
	var $xml_lang_key = "";
	var $xml_lang_replace = "";
	var $xml_current_element = "";
	var $xml_lang_bits = array();

	#=======================================
	# @ A5 Help Desk :: Common Stuff
	# This function is automatically run so
	# all of our common stuff goes here.
	#=======================================

	function trellis($api=0)
	{
		$this->start_timer();

		#=============================
		# Get Incoming
		#=============================

		$this->input = $this->get_post();

		#=============================
		# Captcha
		#=============================

		if ( $this->input['act'] == 'captcha' )
		{
			if ( $this->input['code'] == 'create' )
			{
				$this->captcha_create();
			}

			exit();
		}

		#=============================
		# Call The Core!
		#=============================

		require_once HD_PATH ."core/a5.php";

		$this->core = new a5core();

		#=============================
		# Lets Play Nice With Output
		#=============================

		if ( ! $api )
		{
			if ( $this->core->cache['settings']['general']['gzip'] )
			{
				ob_start("ob_gzhandler");
			}
			else
			{
				ob_start();
			}
		}

		#=============================
		# Load Configuration
		#=============================

		if ( ! file_exists( HD_PATH ."config.php" ) )
		{
			header('Location: install/');
		}

		# installer is creating a require_once conflict
		require HD_PATH ."config.php";

		$this->config = $config;

		#=============================
		# Load Our Database
		#=============================

		$this->core->load_db_module( $config['driver'] );

		#=============================
		# Connect to DB
		#=============================

		if ( $this->core->cache['config']['shutdown_queries'] )
		{
			$config['shutdown'] = 1;
		}

		$this->core->db->connect( $config );

		#=============================
		# Check Cache
		#=============================

		$this->check_cache();

		#=============================
		# Full Initialization?
		#=============================

		if ( ! $api )
		{
			#=============================
			# Checks
			#=============================

			$this->check_tasks();

			#=============================
			# Load Session
			#=============================

			require_once HD_INC ."class_session.php";

			$session = new session();
			$session->trellis = &$this;

			if ( $this->input['do_login'] )
			{
				$this->user = $session->do_login();
			}
			elseif ( $this->input['do_glogin'] )
			{
				$this->user = $session->do_guest_login();
			}
			else
			{
				$this->user = $session->load_session();
			}

			#=============================
			# Logout
			#=============================

			if ( $this->input['act'] == 'logout' )
			{
				$this->user = $session->do_logout();
			}

			#=============================
			# Load Skin
			#=============================

			$this->load_skin();
		}
	}

	#=======================================
	# @ Load Skin
	#=======================================

	function load_skin()
	{
		$this->core->load_module('template');

		require_once HD_INC ."class_skin.php";

		$this->skin = new skin();
		$this->skin->trellis = &$this;
		$this->skin->trellis->shutdown_funcs =& $this->shutdown_funcs;

		$this->skin->load_skin();
	}

	#=======================================
	# @ Load Functions
	# Loads the defined functions file.
	#=======================================

	function load_functions($nameb)
	{
		if ( ! is_array( $nameb ) )
		{
			$nameb = array( $nameb );
		}

		while( list( , $name ) = each( $nameb ) )
		{
			if ( file_exists( HD_INC .'functions/func_'. $name .'.php' ) )
			{
				require_once HD_INC .'functions/func_'. $name .'.php';

				$class_name = 'func_'. $name;

				$this->$name = new $class_name();
				$this->$name->trellis = &$this;
			}
			else
			{
				$this->log( 'error', 'Function file not found: &#039;functions/func_'. $name .'.php&#039;');
			}
		}
	}

	#=======================================
	# @ Load Language
	# Loads the defined language file.
	#=======================================

	function load_lang($name)
	{
		if ( ! $this->user['lang'] )
		{
			if( ! $this->user['lang'] = $this->core->cache['misc']['default_lang'] )
			{
				$this->user['lang'] = $this->config['fallback_lang'];
			}
		}

		require_once HD_PATH. "language/". $this->user['lang'] ."/lang_". $name .".php";

		$this->skin->trellis->lang = array_merge( (array)$lang , (array)$this->skin->trellis->lang );
		$this->lang = array_merge( (array)$lang , (array)$this->lang );
	}

	#=======================================
	# @ Time Functions
	# Tick Tock. :P
	#=======================================

   	function start_timer()
	{
		$temp_time = explode(" ", microtime() );

		$this->start_time = $temp_time[1] + $temp_time[0];
	}

	function end_timer()
	{
		$temp_time = explode(" ", microtime() );

		$this->end_time = $temp_time[1] + $temp_time[0];

		return round( ( $this->end_time - $this->start_time ) ,5 );
	}

	#=======================================
	# @ Get Post
	# Combines incoming $_GET and $_POST
	# plus sanitizes data.
	#=======================================

	function get_post()
	{
		$data = array();

		#=============================
		# $_GET Data
		#=============================

		if ( is_array( $_GET ) )
		{
			while ( list( $n, $v ) = each( $_GET ) )
			{
				if ( is_array( $_GET[$n] ) )
				{
					while ( list( $n2, $v2 ) = each( $_GET[$n] ) )
					{
						  $data[ $this->sanitize_data($n)][ $this->sanitize_data($n2) ] = $this->sanitize_data($v2);
					}
				}
				else
				{
					$data[ $this->sanitize_data($n) ] = $this->sanitize_data($v);
				}
			}
		}

		#=============================
		# $_POST Data
		#=============================

		if ( is_array( $_POST ) )
		{
			while ( list( $n, $v ) = each( $_POST ) )
			{
				if ( is_array( $_POST[$n] ) )
				{
					while ( list( $n2, $v2 ) = each( $_POST[$n] ) )
					{
						  $data[ $this->sanitize_data($n) ][ $this->sanitize_data($n2) ] = $this->sanitize_data($v2);
					}
				}
				else
				{
					$data[ $this->sanitize_data($n) ] = $this->sanitize_data($v);
				}
			}
		}

		#=============================
		# Other Junk
		#=============================

		$data['ip_address'] = $this->sanitize_data( $_SERVER['REMOTE_ADDR'] );

		return $data;
	}

	#=======================================
	# @ Sanitize Data
	# Cleans incoming data (HTML Characters,
	# backslashes, etc).
	#=======================================

	function sanitize_data($data, $noquotes=0, $notrim=0)
    {
    	if ( ! $data ) return false;

    	if ( $noquotes )
    	{
    		if ( get_magic_quotes_gpc() )
    		{
	    		$data = htmlentities( $data, ENT_COMPAT, 'UTF-8' );
    		}
			else
			{
				$data = htmlentities( addslashes( $data ), ENT_COMPAT, 'UTF-8' );
			}
    	}
    	else
    	{
    		if ( get_magic_quotes_gpc() )
    		{
    			$data = stripslashes( htmlentities( $data, ENT_QUOTES, 'UTF-8' ) );
    		}
    		else
    		{
	    		$data = htmlentities( $data, ENT_QUOTES, 'UTF-8' );
    		}
    	}

    	if ( ! $notrim ) $data = trim( $data );

    	// Other :)
    	$data = str_replace( "(", '&#40;', $data );
    	$data = str_replace( ")", '&#41;', $data );

    	// Unicode
    	$data = preg_replace( "/&amp;#([0-9]+);/s", "&#\\1;", $data );

    	return $data;
    }

	#=======================================
	# @ Validate Email
	# Checks to make sure the supplied email
	# address is valid.
	#=======================================

	function validate_email($email)
	{
		if( ereg( "^([0-9,a-z,A-Z]+)([.,_,-,+]([0-9,a-z,A-Z]+))*[@]([0-9,a-z,A-Z]+)([.,_,-]([0-9,a-z,A-Z]+))*[.]([0-9,a-z,A-Z]){2}([0-9,a-z,A-Z])*$", $email ) )
		{
			return $email;
		}
		else
		{
			return FALSE;
		}
	}

	#=======================================
	# @ Shorten String
	# Takes a string and shortens it to the
	# specified length.
	#=======================================

	function shorten_str($txt, $length, $add=1)
	{
		if ( strlen( $txt ) > $length )
		{
			if ( $add == 1 )
			{
				$txt = substr( $txt, 0, ( $length - 3) ) . "...";
				$txt = preg_replace( "/&(#(\d+;?)?)?\.\.\.$/", "...", $txt );
			}
			else
			{
				$txt = substr( $txt, 0, $length );
			}
		}

		return $txt;
	}

	#=======================================
	# @ Convert HTML
	# Converts HTML tags.
	#=======================================

	function convert_html($txt)
	{
		$txt = html_entity_decode( $txt );

		$txt = str_replace( '&#40;', '(', $txt );
    	$txt = str_replace( '&#41;', ')', $txt );

		return $txt;
	}

	#=======================================
	# @ Remove Extra Line Breaks
	#=======================================

	function remove_extra_lbs($txt)
	{
		$txt = preg_replace( '#(&lt;br /&gt;)*$#', "", $txt );

		return $txt;
	}

	#=======================================
	# @ Remove HTML
	#=======================================

	function remove_html($txt, $strip=0)
	{
		$txt = str_replace( '<br />', "\n", $txt );
		$txt = str_replace( '<br>', "\n", $txt );

		$txt = strip_tags($txt);

		return $txt;
	}

	#=======================================
	# @ Prepare Output
	#=======================================

	function prepare_output($data, $params=array())
	{
		if ( $params['html'] ) $data = $this->convert_html($data);

		if ( $params['nl2br'] ) $data = nl2br( $data );

		if ( $params['rmv_dbl_sp'] ) $data = $this>remove_dbl_spaces( $data );

		return $data;
	}

	#=======================================
	# @ Remove Double Spaces
	# Removes double spaces from TinyMCE.
	#=======================================

	function remove_dbl_spaces($txt)
	{
		$txt = str_replace( '&nbsp; ', " ", $txt );

		return $txt;
	}

	#=======================================
	# @ Check Cache
	# Checks to make sure all cache files
	# are present.  If they aren't, then
	# the cache is rebuilt.
	#=======================================

	public function check_cache()
	{
		$check = array( 'settings', 'departs', 'categories', 'groups', 'news', 'langs', 'skins', 'pfields', 'dfields', 'rtemplates', 'priorities', 'staff', 'flags', 'statuses' );
		$to_cache = array();

		foreach ( $check as $ck )
		{
			if ( ! is_array( $this->core->cache[ $ck ] ) ) $to_cache[] = $ck;
		}

		if ( ! empty( $to_cache ) )
		{
			$this->load_functions( 'rebuild' );

			foreach( $to_cache as $cache )
			{
				$func_name = $cache .'_cache';

				$this->rebuild->$func_name();
			}
		}
	}

	#=======================================
	# @ Check / Run Tasks
	# Checks to see if any tasks need to be
	# run and runs them if so.
	#=======================================

	function check_tasks()
    {
		if ( $this->core->cache['tasks']['close_auto'] < time() - ( 60 * 60 ) )
		{
			#$this->check_close_auto();
		}
    }

	#=======================================
	# @ Check Fields
	# Checks input fields for the required
	# length defined in array.
	#=======================================

	function check_fields($required)
	{
		while ( list( $req, $length ) = each( $required ) )
		{
			if ( $length )
			{
				if ( strlen( $this->input[ $req ] ) < $length )
				{
					$this->skin->error('fill_form_lengths');
				}
			}
			else
			{
				if ( ! $this->input[ $req ] )
				{
					$this->skin->error('fill_form_completely');
				}
			}
		}
	}

	#=======================================
	# @ TD Date
	# Applies format and offsets to date.
	#=======================================

	function td_timestamp($params=array())
	{
		$return = '';

		#=============================
		# Relative
		#=============================

		if ( $params['format'] == 'relative' )
		{
			$time_diff = time() - $params['time'];

			if ( ! $params['cutoff'] || $time_diff < $params['cutoff'] )
			{
				if ( $time_diff < 60 )
				{
					return $this->lang['less_than_a_minute_ago'];
				}
				elseif ( $time_diff < 3600 )
				{
					return floor( $time_diff / 60 ) .' '. $this->lang['minutes_ago'];
				}
				elseif ( $time_diff < 86400 )
				{
					return floor( $time_diff / 3600 ) .' '. $this->lang['hours_ago'];
				}
				elseif ( $time_diff < 604800 )
				{
					return floor( $time_diff / 86400 ) .' '. $this->lang['days_ago'];
				}
				elseif ( $time_diff < 2629743 )
				{
					return floor( $time_diff / 604800 ) .' '. $this->lang['weeks_ago'];
				}
				elseif ( $time_diff < 31556926 )
				{
					return floor( $time_diff / 2629743 ) .' '. $this->lang['months_ago'];
				}
			}
		}

		#=============================
		# Human Friendly
		#=============================

		if ( $params['human'] )
		{
			$today = mktime( 0, 0, 0, date('n'), date('j'), date('Y') );

			$today_diff = $today - $params['time'];

			if ( $today_diff < ( 60 * 60 * 24 ) )
			{
				$return .= $this->lang['today'];
			}
			elseif ( $today_diff < ( 60 * 60 * 48 ) )
			{
				$return .= $this->lang['yesterday'];
			}
		}

		#=============================
		# Time Adjustments
		#=============================

		if ( ! isset( $params['time_zone'] ) ) $params['time_zone'] = $this->user['time_zone'];
		if ( ! isset( $params['dst'] ) ) $params['dst'] = $this->user['time_dst'];

		$params['time'] += ( $this->core->cache['settings']['general']['time_offset'] * 60 );  // General Configuration Offset

		if ( $params['offset'] ) $params['time'] += ( $params['offset'] );  // Specific

		$params['time'] += ( $params['time_zone'] * 60 * 60 ); // User Time Zone

		if ( $params['dst'] == 1 ) // User DST
		{
			$params['time'] += ( 60 * 60 );
		}
		elseif ( $params['dst'] == 2 )
		{
			if ( gmdate('I') ) $params['time'] += ( 60 * 60 );
		}

		#=============================
		# Continue Human Friendly
		#=============================

		if ( $params['human'] )
		{
			if ( $today_diff < ( 60 * 60 * 48 ) ) return $return .', '. gmdate( $this->core->cache['settings']['general']['tformat_time'], $params['time'] );
		}

		#=============================
		# Format
		#=============================

		if ( $params['format'] == 'short' )
		{
			$params['format'] = $this->core->cache['settings']['general']['tformat_short'];
		}
		elseif ( $params['format'] == 'long' )
		{
			$params['format'] = $this->core->cache['settings']['general']['tformat_long'];
		}
		elseif ( $params['format'] == 'date' )
		{
			$params['format'] = $this->core->cache['settings']['general']['tformat_date'];
		}
		elseif ( $params['format'] == 'time' )
		{
			$params['format'] = $this->core->cache['settings']['general']['tformat_time'];
		}
		elseif ( ! $params['format'] )
		{
			$params['format'] = $this->core->cache['settings']['general']['tformat_short'];
		}

		return gmdate( $params['format'], $params['time'] );
	}

	#=======================================
	# @ Send Email
	# Sends an email.
	#=======================================

	function send_email($recipients, $message, $replace=array(), $extra=array())
	{
		if ( is_array( $recipients ) )
		{
			$where = array( 'id', 'in', $recipients );
		}
		else
		{
			$where = array( 'id', '=', $recipients );
		}

		if ( ! $extra['ignore_notify'] ) $where = array( $where, array( 'email_notify', '=', 1, 'and' ) );

		$this->core->db->construct( array(
									  	  'select'	=> array( 'id', 'name', 'email', 'lang' ),
									  	  'from'	=> 'users',
									  	  'where'	=> $where,
							  	   ) 	 );

		$this->core->db->execute();

		if ( ! $this->core->db->get_num_rows() ) return false;

		$this->core->load_module('email');

		if ( $this->core->cache['settings']['email']['method'] == 'native' )
		{
			$email_int = array( 'method' => 'native' );
		}
		elseif ( $this->core->cache['settings']['email']['method'] == 'smtp' )
		{
			$email_int = array( 'method' => 'smtp' );
		}
		elseif ( $this->core->cache['settings']['email']['method'] == 'native' )
		{
			$email_int = array( 'method' => 'sendmail' );
		}

		$this->core->email->initialize( $email_int );
		$this->core->email->load_decorator();

		$languages = array();
		$replacements = array();

		while ( $m = $this->core->db->fetch_row() )
		{
			if ( ! $m['lang'] ) $m['lang'] = $this->core->cache['lang']['default'];

			$languages[ $m['lang'] ][ $m['id'] ] = $m;
		}

		while ( list( $langid, $mdata ) = each( $languages ) )
		{
			require_once HD_PATH. "language/". $langid ."/lang_email_content.php";

			$this->core->email->set_subject( $lang[ $message ."_sub" ] );

			$email_msg = $lang['header'] . $lang[ $message ] . $lang['footer'];

			if ( $this->core->cache['settings']['email']['html'] ) $email_msg_html = $lang['header_html'] . $lang[ $message .'_html' ] . $lang['footer_html'];

			while ( list( $langkey, $langvalue ) = each( $lang ) )
			{
				$email_msg = str_replace( '{lang.'. $langkey .'}', $langvalue, $email_msg );
				if ( $this->core->cache['settings']['email']['html'] )  $email_msg_html = str_replace( '{lang.'. $langkey .'}', $langvalue, $email_msg_html );
			}

			$email_msg = str_replace( '{HD_NAME}', $this->core->cache['config']['hd_name'], $email_msg );
			$email_msg = str_replace( '{HD_URL}', $this->core->cache['config']['hd_url'], $email_msg );

			if ( $this->core->cache['settings']['email']['html'] )
			{
				$email_msg_html = str_replace( '{HD_NAME}', $this->core->cache['config']['hd_name'], $email_msg_html );
				$email_msg_html = str_replace( '{HD_URL}', $this->core->cache['config']['hd_url'], $email_msg_html );
			}

			while ( list( $uid, $md ) = each( $mdata ) )
			{
				$replacements[ $md['email'] ] = array( '{USER_NAME}' => $md['name'], '{USER_ID}' => $md['id'] );

				if ( is_array( $recipients ) )
				{
					if ( $replace[ $md['id'] ] )
					{
						$replacements[ $md['email'] ] = array_merge( $replacements[ $md['email'] ], $replace[ $md['id'] ] );
					}
				}
				else
				{
					$replacements[ $md['email'] ] = array_merge( $replacements[ $md['email'] ], $replace );
				}

				if ( $extra['over_email'] )
				{
					$this->core->email->add_recipient( $extra['over_email'] );
				}
				else
				{
					$this->core->email->add_recipient( $md['email'] );
				}
			}

			$config = array(
							'from_email'	=> $this->core->cache['settings']['email']['out_address'],
							'from_name'		=> $this->core->cache['config']['hd_name'],
							);

			if ( $extra['from_email'] )
			{
				$config['from_email'] = $extra['from_email'];
			}

			$this->core->email->update_config( $config );

			if ( $this->core->cache['settings']['email']['html'] )
			{
				$this->core->email->add_message( $email_msg );

				$this->core->email->add_message( $this->convert_html( $email_msg_html ), 'text/html' );
			}
			else
			{
				$this->core->email->add_message( $email_msg );
			}

			$this->core->email->set_replacements( $replacements );

			if ( ! $this->core->email->send_email() ) return false;
		}
    }

	#=======================================
	# @ Send Guest Email
	# Sends an email to a guest.
	#=======================================

	function send_guest_email($recipients, $message, $replacements=array(), $extra=array())
	{
		if ( ! is_array( $recipients ) )
		{
			$old_recp = $recipients;
			$recipients = array();

			$recipients[] = $old_recp;
		}

		$this->core->load_module('email');

		if ( $this->core->cache['settings']['email']['method'] == 'native' )
		{
			$email_int = array( 'method' => 'native' );
		}
		elseif ( $this->core->cache['settings']['email']['method'] == 'smtp' )
		{
			$email_int = array( 'method' => 'smtp' );
		}
		elseif ( $this->core->cache['settings']['email']['method'] == 'native' )
		{
			$email_int = array( 'method' => 'sendmail' );
		}

		$this->core->email->initialize( $email_int );
		$this->core->email->load_decorator();

		require_once HD_PATH. "language/". $this->core->cache['lang']['default'] ."/lang_email_content.php";

		$this->core->email->set_subject( $lang[ $message ."_sub" ] );

		$email_msg = $lang['header'] . $lang[ $message ] . $lang['footer'];

		if ( $this->core->cache['settings']['email']['html'] ) $email_msg_html = $lang['header_html'] . $lang[ $message .'_html' ] . $lang['footer_html'];

		while ( list( $langkey, $langvalue ) = each( $lang ) )
		{
			$email_msg = str_replace( '{lang.'. $langkey .'}', $langvalue, $email_msg );
			if ( $this->core->cache['settings']['email']['html'] )  $email_msg_html = str_replace( '{lang.'. $langkey .'}', $langvalue, $email_msg_html );
		}

		$email_msg = str_replace( '{HD_NAME}', $this->core->cache['config']['hd_name'], $email_msg );
		$email_msg = str_replace( '{HD_URL}', $this->core->cache['config']['hd_url'], $email_msg );

		if ( $this->core->cache['settings']['email']['html'] )
		{
			$email_msg_html = str_replace( '{HD_NAME}', $this->core->cache['config']['hd_name'], $email_msg_html );
			$email_msg_html = str_replace( '{HD_URL}', $this->core->cache['config']['hd_url'], $email_msg_html );
		}

		while ( list( $search, $replace ) = each( $replacements ) )
		{
			$email_msg = str_replace( '{'. $search .'}', $replaceb, $email_msg );
			if ( $this->core->cache['settings']['email']['html'] ) $email_msg_html = str_replace( '{'. $search .'}', $replaceb, $email_msg_html );
		}

		while ( list( , $da_email ) = each( $recipients ) )
		{
			$this->core->email->add_recipient( $da_email );
		}

		$config = array(
						'fromemail'		=> $this->core->cache['settings']['email']['out_address'],
						'frouname'		=> $this->core->cache['config']['hd_name'],
						);

		if ( $extra['from_email'] )
		{
			$config['fromemail'] = $extra['from_email'];
		}

		$this->core->email->update_config( $config );

		if ( $this->core->cache['settings']['email']['html'] )
		{
			$this->core->email->add_message( $email_msg );

			$this->core->email->add_message( $this->convert_html( $email_msg_html ), 'text/html' );
		}
		else
		{
			$this->core->email->add_message( $email_msg );
		}

		if ( ! $this->core->email->send_email() ) return false;
    }

	#=======================================
	# @ Set Cookie
	# Sets a cookie. :P
	#=======================================

	function set_cookie($name, $value, $time='')
	{
		if ( ! $time )
        {
        	$time = time() + 60*60*24*365; // Sec*Min*Hrs*Days
        }

        if ( $this->core->cache['settings']['general']['cookie_prefix'] ) $name = $this->core->cache['settings']['general']['cookie_prefix'] . $name;

        @setcookie( $name, $value, $time, $this->core->cache['settings']['general']['cookie_path'], $this->core->cache['settings']['general']['cookie_domain'] );
    }

	#=======================================
	# @ Get Cookie
	# Safely gets a cookie.
	#=======================================

	function get_cookie($name)
	{
		$cookie_data = ""; // Initialize for Security

		if ( $this->core->cache['settings']['general']['cookie_prefix'] ) $name = $this->core->cache['settings']['general']['cookie_prefix'] . $name;

		if ( isset( $_COOKIE[$name] ) )
		{
			$cookie_data = $this->sanitize_data( $_COOKIE[$name] );
		}

		return $cookie_data;
    }

	#=======================================
	# @ Delete Cookie
	# Deletes a cookie. :P
	#=======================================

	function delete_cookie($name)
	{
        @setcookie( $name, 0, time() - ( 60*60*24*365 ), $this->core->cache['settings']['general']['cookie_path'], $this->core->cache['settings']['general']['cookie_domain'] );
    }

	#=======================================
	# @ Log
	# Log an action into the database.
	#=======================================

	function log($type, $action, $level=1, $extra='', $uid=0)
	{
		if ( $type == 'mod' )
		{
			$type_id = 1;
		}
		elseif ( $type == 'admin' )
		{
			$type_id = 2;
		}
		elseif ( $type == 'error' )
		{
			$type_id = 3;
		}
		elseif ( $type == 'security' )
		{
			$type_id = 4;
		}
		elseif ( $type == 'email' )
		{
			$type_id = 5;
		}
		elseif ( $type == 'user' )
		{
			$type_id = 6;
		}
		elseif ( $type == 'ticket' )
		{
			$type_id = 7;
		}
		else
		{
			$type_id = 9;
		}

		$db_array = array(
						  'uid'		=> $this->user['id'],
						  'action'	=> $action,
						  'extra'	=> $extra,
						  'type'	=> $type_id,
						  'level'	=> $level,
						  'date'	=> time(),
						  'ipadd'	=> $this->input['ip_address'],
						 );

		if ( $uid ) $db_array['uid'] = $uid;

		$this->core->db->construct( array(
									  	  'insert'	=> 'logs',
										  'set'		=> $db_array,
							 		) 	 );

		$this->core->db->next_shutdown();
		$this->core->db->execute();
	}

	#=======================================
	# @ Process Data
	#=======================================

	function process_data($fields, $data)
	{
		$return = array();

		if ( is_array( $fields ) && is_array( $data ) )
		{
			while( list( $name, $type ) = each( $fields ) )
    		{
    			if ( array_key_exists( $name, $data ) )
    			{
    				if ( $type == 'int' )
    				{
    					$return[ $name ] = intval( $data[ $name ] );
    				}
    				elseif ( $type == 'serialize' )
    				{
    					$return[ $name ] = serialize( $data[ $name ] );
    				}
    				elseif ( $type == 'string' )
    				{
    					$return[ $name ] = $data[ $name ];
    				}
    			}
    		}
    	}

    	return $return;
	}

	#=======================================
	# @ Page Links
	# Generates pagination links. :)
	#=======================================

	function page_links($params=array())
	{
		if ( ! $params['start'] ) $params['start'] = $this->input['st'];

		if ( ! $params['start'] ) $params['start'] = 0;

		if ( $params['total'] > $params['per_page'] )
		{
			$total_pages = ceil( $params['total'] / $params['per_page'] );
		}
		else
		{
   			$total_pages = 1;
		}

		$current_page = ( $params['start'] / $params['per_page'] ) + 1;

		$html = "Page {$current_page} of {$total_pages} &nbsp; ";

		if ( $total_pages > 5 ) $over = 1;

		// Display First Page Link
		if ( $current_page > 3 && $total_pages > 5 )
		{
			if ( ( $current_page - 3 ) == 1 )
			{
				$html .= "<a href='{$params['url']}&amp;st=0'>1</a>&nbsp;";
			}
			else
			{
				$html .= "<a href='{$params['url']}&amp;st=0'>1...</a>&nbsp;";
			}
		}

		// Show Page Numbers
		for ( $i = 1; $i <= $total_pages; $i++ )
		{
			if ( $i != $current_page )
			{
				if ( $over )
				{
					if ( $i >= ( $current_page - 2 ) && $i <= ( $current_page + 2 ) )
					{
						$html .= "<a href='{$params['url']}&amp;st=". ( $params['per_page'] * ( $i - 1 ) ) ."'>{$i}</a>&nbsp;";
					}
				}
				else
				{
					$html .= "<a href='{$params['url']}&amp;st=". ( $params['per_page'] * ( $i - 1 ) ) ."'>{$i}</a>&nbsp;";
				}
			}
			else
			{
				$html .= "<a href='{$params['url']}&amp;st={$params['start']}' class='thispage'>{$i}</a>&nbsp;";
			}
		}

		// Display Last Page Link
		if ( ( $current_page + 2 ) < $total_pages && $total_pages > 5 )
		{
			if ( ( $current_page + 3 ) == $total_pages )
			{
				$html .= "<a href='{$params['url']}&amp;st=". ( $params['per_page'] * ( ( $i - 1 ) - 1 ) ) ."'>{$total_pages}</a>&nbsp;";
			}
			else
			{
				$html .= "<a href='{$params['url']}&amp;st=". ( $params['per_page'] * ( ( $i - 1 ) - 1 ) ) ."'>...{$total_pages}</a>&nbsp;";
			}
		}

		return $html;
	}

	#=======================================
	# @ startElement
	# Start element handler.
	#=======================================

	function startElement($parser, $name, $attr)
	{
		$this->xml_current_element = $name;

		$my_var = 'xml_'. $name;
		$this->$my_var = "";

		if( strcmp( $name, "language_pack" ) == 0 )
		{
			$this->xml_lang_abbr = base64_decode( preg_replace( "/\s/", "", $attr["abbr"] ) );
			$this->xml_lang_name = base64_decode( preg_replace( "/\s/", "", $attr["name"] ) );
		}

		if( strcmp( $name, "lang_file" ) == 0 )
		{
			$this->xml_lang_file = $attr["name"];
		}
	}

	#=======================================
	# @ endElement
	# End element handler.
	#=======================================

	function endElement($parser, $name)
	{
		$elements = array( 'lang_file', 'lang_key', 'lang_replace' );

		if( strcmp( $name, "lang_bit" ) == 0 )
		{
			while ( list( , $element ) = each( $elements ) )
			{
				$my_var = 'xml_'. $element;
				$temp[ $element ] = base64_decode( preg_replace( "/\s/", "", $this->$my_var ) );
			}

			$this->xml_lang_bits[] = $temp;

			$this->xml_lang_key = "";
			$this->xml_lang_replace = "";
		}

		if( strcmp( $name, "lang_file" ) == 0 )
		{
			#$this->xml_lang_file = "";
		}
	}

	#=======================================
	# @ characterData
	# Character data handler.
	#=======================================

	function characterData($parser, $data)
	{
		$elements = array( 'lang_key', 'lang_replace' );

		while ( list( , $element ) = each( $elements ) )
		{
			if( $this->xml_current_element == $element )
			{
				$my_var = 'xml_'. $element;
				#$data = trim($data);
				$this->$my_var .= $data;
			}
		}
	}

	#=======================================
	# @ startElementB
	# Start element handler.
	#=======================================

	function startElementB($parser, $name, $attr)
	{
		$this->xml_current_element = $name;

		/*if( strcmp( $name, "skin_file" ) == 0 )
		{
			$this->xml_skin_file = base64_decode( $attr["name"] );
		}*/

		$my_var = 'xml_'. $name;
		$this->$my_var = "";
	}

	#=======================================
	# @ endElementB
	# End element handler.
	#=======================================

	function endElementB($parser, $name)
	{
		$elements = array( 'tname', 'tcontent' );
		$elementsb = array( 'sk_name', 'sk_img_dir', 'sk_author', 'sk_author_email', 'sk_author_web', 'sk_notes', 'sk_css' );
		$elementsc = array( 'filename', 'content', 'path' );

		if( strcmp( $name, "template" ) == 0 )
		{
			while ( list( , $element ) = each( $elements ) )
			{
				$my_var = 'xml_'. $element;
				$temp[ $element ] = base64_decode( preg_replace( "/\s/", "", $this->$my_var ) );
			}

			$this->xml_templates[] = $temp;

			$this->xml_tname = "";
			$this->xml_tcontent = "";
		}

		if( strcmp( $name, "image" ) == 0 )
		{
			while ( list( , $element ) = each( $elementsc ) )
			{
				$my_var = 'xml_'. $element;
				$tempb[ $element ] = base64_decode( preg_replace( "/\s/", "", $this->$my_var ) );
			}

			$this->xml_skin_images[] = $tempb;

			$this->xml_filename = "";
			$this->xml_content = "";
			$this->xml_path = "";
		}

		if( strcmp( $name, "skin_info" ) == 0 )
		{
			while ( list( , $element ) = each( $elementsb ) )
			{
				$my_var = 'xml_'. $element;
				$this->xml_skin_info[ $element ] = base64_decode( preg_replace( "/\s/", "", $this->$my_var ) );
			}
		}
	}

	#=======================================
	# @ characterDataB
	# Character data handler.
	#=======================================

	function characterDataB($parser, $data)
	{
		$elements = array( 'tname', 'tcontent', 'sk_name', 'sk_img_dir', 'sk_author', 'sk_author_email', 'sk_author_web', 'sk_notes', 'sk_css', 'filename', 'content', 'path' );

		while ( list( , $element ) = each( $elements ) )
		{
			if( $this->xml_current_element == $element )
			{
				$my_var = 'xml_'. $element;
				#$data = trim($data);
				$this->$my_var .= $data;
			}
		}
	}

	#=======================================
	# @ parseFile
	# Finally, lets parse the XML file.
	#=======================================

	function parseFile($xml_file, $type=1)
	{
		$xml_parser = xml_parser_create();

		xml_set_object( $xml_parser, $this );

		if ( $type == 1 )
		{
			xml_set_element_handler($xml_parser, "startElement", "endElement");
			xml_set_character_data_handler($xml_parser, "characterData");
		}
		elseif ( $type == 2 )
		{
			xml_set_element_handler($xml_parser, "startElementB", "endElementB");
			xml_set_character_data_handler($xml_parser, "characterDataB");
		}

		xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, false);

		if( !( $fp = fopen( $xml_file, "r" ) ) )
		{
			die("Cannot open ". $xml_file);
		}

		while( ( $data = fread( $fp, 4096 ) ) )
		{
			if( !xml_parse( $xml_parser, $data, feof($fp) ) )
			{
				die( sprintf("XML error at line %d column %d ", xml_get_current_line_number($xml_parser), xml_get_current_column_number($xml_parser) ) );
			}
		}

		xml_parser_free($xml_parser);

		if ( $type == 1 )
		{
			return $this->xml_lang_bits;
		}
		else
		{
			return array( $this->xml_skin_info, $this->xml_templates, $this->xml_skin_images );
		}
	}

	#=======================================
	# @ Shut Down
	# Runs final processes such as last
	# minute functions.
	#=======================================

	function shut_down()
	{
		if ( is_array( $this->shutdown_funcs ) )
		{
			while ( list( , $func ) = each( $this->shutdown_funcs ) )
			{
				$this->$func();
			}
		}
	}

	#=======================================
	# @ Implode Keys
	# Similar to implode() function except
	# uses keys instead of values
	#=======================================

	function implode_keys($glue, $array)
	{
		foreach( $array as $key => $value )
		{
			$ret[] = $key;
		}

		return implode($glue, $ret);
	}

	#=======================================
	# @ Captcha Create
	# Create a captcha image.
	#=======================================

	function captcha_create()
	{
		require_once HD_INC .'captcha/php-captcha.inc.php';

		$fonts = array( HD_INC .'captcha/VeraBd.ttf',  HD_INC .'captcha/VeraIt.ttf',  HD_INC .'captcha/Vera.ttf' );

		$this->captcha = new PhpCaptcha( $fonts, $this->input['width'], $this->input['height'] );

		if ( $this->input['fontsize'] )
		{
			$this->captcha->SetMaxFontSize( $this->input['fontsize'] );
		}

		$this->captcha->Create();
	}

	#=======================================
	# @ Captcha Validate
	# Validate code with captcha.
	#=======================================

	function captcha_validate($input)
	{
		require_once HD_INC .'captcha/php-captcha.inc.php';

		if ( PhpCaptcha::Validate( $input ) )
		{
			return TRUE;
		}

		return FALSE;
	}

	#=======================================
	# @ Create Token
	# Create form token hash.
	#=======================================

	function create_token($type)
	{
		if ( $this->core->cache['settings']['security']['form_tokens'] )
		{
			$token = strrev( md5( 't'. uniqid( rand(), true ) ) );

			$db_array = array(
							  'token'	=> $token,
							  'type'	=> $type,
							  'ipadd'	=> $this->input['ip_address'],
							  'date'	=> time(),
							 );

			$this->core->db->construct( array(
										  	  'insert'	=> 'tokens',
											  'set'		=> $db_array,
								 		) 	 );

			$this->core->db->next_shutdown();
			$this->core->db->execute();

			return "<input type='hidden' name='token' value='{$token}' />";
		}
		else
		{
			return "";
		}
	}

	#=======================================
	# @ Check Token
	# Check form token with database.
	#=======================================

	function check_token($type)
	{
		if ( $this->core->cache['settings']['security']['form_tokens'] )
		{
			if ( $this->core->cache['settings']['security']['token_ip_check'] )
			{
				$sql_where = array( array( 'token', '=', $this->input['token'] ), array( 'type', '=', $type, 'and' ), array( 'ipadd', '=', $this->input['ip_address'], 'and' ) );
			}
			else
			{
				$sql_where = array( array( 'token', '=', $this->input['token'] ), array( 'type', '=', $type, 'and' ) );
			}

			$this->core->db->construct( array(
										  	  'select'	=> array( 'id' ),
										  	  'from'	=> 'tokens',
										  	  'where'	=> $sql_where,
										  	  'limit'	=> array( 0, 1 ),
								 	   ) 	);

			$this->core->db->execute();

			if ( $this->core->db->get_num_rows() )
			{
				$this->core->db->construct( array(
											  	  'delete'	=> 'tokens',
											  	  'where'	=> array( 'token', '=', $this->input['token'] ),
											  	  'limit'	=> array( 1 ),
									 	   ) 	);

				$this->core->db->next_shutdown();
				$this->core->db->execute();

				return TRUE;
			}
			else
			{
				$this->skin->error('token_mismatch');
			}
		}
		else
		{
			return TRUE;
		}
	}

	#=======================================
	# @ Check Ticket Auto Close
	# Check tickets for ones that need to
	# be auto closed.
	#=======================================

	function check_close_auto()
	{
		$this->core->db->construct( array(
									  	  'select'	=> array( 'id', 'uid' ),
									  	  'from'	=> 'tickets',
									  	  'where'	=> array( array( 'close_date', '<=', time() ), array( 'close_date', '!=', 0, 'and' ), array( 'status', '=', 4, 'and' ) ),
							 	   ) 	);

		$this->core->db->execute();

		if ( $this->core->db->get_num_rows() )
		{
			while( $t = $this->core->db->fetch_row() )
			{
				$users[ $t['uid'] ] ++;

				$tickets[] = $t['id'];
			}

			$this->core->db->construct( array(
										  	  'update'	=> 'tickets',
										  	  'set'		=> array( 'close_reason' => 'No response from customer.', 'status' => 6 ),
										  	  'where'	=> array( 'id', 'in', $tickets ),
								 	   ) 	);

			$this->core->db->next_shutdown();
			$this->core->db->execute();

			while( list( $uid, $mtickets ) = each( $users ) )
			{
				$this->core->db->next_no_quotes('set');

				$this->core->db->construct( array(
											  	  'update'	=> 'users',
											  	  'set'		=> array( 'open_tickets' => 'open_tickets-'. $mtickets ),
							 				  	  'where'	=> "id = '". $uid ."'",
							 				  	  'limit'	=> array( 1 ),
								 	  	  ) 	);

				$this->core->db->next_shutdown();
				$this->core->db->execute();
			}

			$this->r_ticket_stats(1);
		}

		$to_cache = array(); // Initialize for Security

		$to_cache['close_auto'] = time();

		$this->core->add_cache( 'tasks', $to_cache );
	}

	#=======================================
	# @ Format Size
	# Convert size into appropriate format.
	#=======================================

	function format_size($bytes)
	{
		if ( $bytes < 1024 )
		{
			return $bytes .' '. $this->lang['bytes'];
		}

		$kb = $bytes / 1024;

		if ( $kb < 1024 )
		{
			return round( $kb, 2 ) .' '. $this->lang['kb'];
		}

		$mb = $kb / 1024;

		if ( $mb < 1024 )
		{
			return round( $mb, 2 ) .' '. $this->lang['mb'];
		}
	}

	#=======================================
	# @ Check To See If We Are Banned
	#=======================================

	function ban_check( $data=array() )
	{
		while ( list( $type, $value ) = each( $data ) )
		{
			if ( $type == 'username' )
			{
				return false; // TO BE COMPLETED
			}
		}

		return false;
	}

	#=======================================
	# @ Get Username
	#=======================================

	function get_username($id)
	{
		if ( ! intval( $id ) ) return false;

		if ( intval( $id ) == $this->user['id'] ) return $this->user['name'];

		$this->core->db->construct( array(
											  	 'select'	=> array( 'name' ),
											  	 'from'		=> 'users',
							 				  	 'where'	=> array( 'id', '=', intval( $id ) ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->core->db->execute();

		$m = $this->core->db->fetch_row();

		return $m['name'];
	}

	#=======================================
	# @ Generate SQL Sort
	#=======================================

	public function generate_sql_sort( $params=array() )
	{
		$return = array();

		if ( $params['default_sort'] )
		{
			if ( ! $this->input['sort'] ) $this->input['sort'] = $params['default_sort'];
			if ( ! $this->input['order'] ) $this->input['order'] = $params['default_order'];
		}

		$gen_url = $params['base_url'];

		foreach ( $params['options'] as $id => $name )
		{
			if ( $id == $this->input['sort'] )
			{
				if ( $this->input['order'] == 'desc' )
				{
					$link_order = 'asc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_up.gif" alt="{lang.up}" />';
				}
				else
				{
					$link_order = 'desc';
					$img_order = '&nbsp;<img src="<! IMG_DIR !>/arrow_down.gif" alt="{lang.down}" />';
				}
			}
			else
			{
				$link_order = 'asc';
				$img_order = '';
			}

			$url = $gen_url .'&amp;sort='. $id .'&amp;order='. $link_order;

			$return[ 'link_'. $id ] = '<a href="'. $url .'">'. $name . $img_order .'</a>';
		}

		$return['sort'] = $this->input['sort'];

		( $this->input['order'] == 'desc' ) ? $return['order'] = 'DESC' : $return['order'] = 'ASC';

		return $return;
	}
}

?>