<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Trellis Destk Admin Class
#======================================================
*/

class trellis_admin extends trellis {

	public $config	= array();

	#=======================================
	# @ A5 Help Desk Admin :: Common Stuff
	# This function is automatically run so
	# all of our common stuff goes here.
	#=======================================

	function trellis_admin()
	{
		$this->start_timer();

		#=============================
		# Get Incoming
		#=============================

		$this->input = $this->get_post();

		#=============================
		# I'm Hungry
		#=============================

		if ( ! isset( $this->input['section'] ) )
		{
			$this->input['section'] = 'admin';
		}

		#=============================
		# Call The Core!
		#=============================

		require_once HD_PATH ."core/a5.php";

		$this->core = new a5core();

		#=============================
		# Load Configuration
		#=============================

		if ( ! file_exists( HD_PATH ."config.php" ) )
		{
			header('Location: install/');
		}

		require_once HD_PATH ."config.php";

		$this->config = $config;

		#=============================
		# Load Our Database
		#=============================

		$this->core->load_db_module( $config['driver'] );

		#=============================
		# Connect to DB
		#=============================

		if ( $this->core->cache['config']['shutdown_queries'] )
		{
			$config['shutdown'] = 1;
		}

		$this->core->db->connect( $config );
		
		#=============================
		# Check Cache
		#=============================

		$this->check_cache();
		
		define( 'ACP_HELP', $this->core->cache['config']['acp_help'] );

		#=============================
		# Check / Run Tasks
		#=============================

		$this->check_tasks();

		#=============================
		# Load Skin
		#=============================

		require_once HD_INC ."class_askin.php";

		$this->skin = new askin();
		$this->skin->trellis = &$this;

		$this->skin->load_skin();

		#=============================
		# Load Session
		#=============================

		require_once HD_INC ."class_asession.php";

		$session = new asession();
		$session->trellis = &$this;

		#=============================
		# Login / Logout
		#=============================

		if ( $this->input['do_login'] )
		{
			$this->user = $session->do_login();
		}
		else
		{
			$this->user = $session->load_session();
		}

		if ( $this->input['act'] == 'logout' )
		{
			$session->do_logout();
		}

		#=============================
		# Other Actions
		#=============================
		
		if ( $this->input['act'] == 'lookup' )
		{
			if ( $this->input['type'] == 'staff' )
			{
				$this->ajax_staff_lookup();
			}
			elseif ( $this->input['type'] == 'user' )
			{
				$this->ajax_user_lookup();
			}
		}
	}

	#=======================================
	# @ Admin Load Language
	# Loads the defined admin language file.
	#=======================================

	function ad_load_lang($name)
	{
		if ( ! $this->user['lang'] )
		{
			if( ! $this->user['lang'] = $this->core->cache['misc']['default_lang'] )
			{
				$this->user['lang'] = $this->config['fallback_lang'];
			}
		}

		require_once HD_PATH. "language/". $this->user['lang'] ."/ad_lang_". $name .".php";

		$this->skin->trellis->lang = array_merge( (array)$lang , (array)$this->skin->trellis->lang );
		#$this->lang = $this->skin->trellis->lang;
	}

	#=======================================
	# @ Check Permission
	#=======================================

	function check_perm($section, $page='', $action='', $error=1)
	{
		if ( $this->user['id'] == 1 ) return true;
		
		$no_perm = 1;
		
		return true; # TO BE COMPLETED
		
		if ( $no_perm && $error ) $this->skin->error('no_perm');
		
		return true;
	}

	#=======================================
	# @ AJAX Staff Lookup
	#=======================================

	function ajax_staff_lookup()
	{
		$staff = array();
		
		if ( $this->input['assign'] )
		{
			( $this->check_perm( 'manage', 'tickets', 'assign_outside', 0 ) ) ? $check_perm = 0 : $check_perm = 1;
		}
		
		foreach( $this->core->cache['staff'] as $s )
		{
			if ( $check_perm )
			{
				$s['g_acp_depart_perm'] = unserialize( $s['g_acp_depart_perm'] );
				
				if ( ! $s['g_acp_depart_perm'][ $this->input['assign'] ]['v'] ) continue;
			}
			
			if ( preg_match( '/^'. $this->input['q'] .'/i', $s['name'] ) ) $staff[] = array( 'caption' => $s['name'], 'value' => $s['id'] );
		}
		
		$this->skin->ajax_output( json_encode( $staff ) );
	}

	#=======================================
	# @ AJAX User Lookup
	#=======================================

	function ajax_user_lookup()
	{
		$users = array();
		
		$this->core->db->construct( array(
									  	  'select'	=> array( 'id', 'name' ),
									  	  'from'	=> 'users',
									  	  'where'	=> array( 'name', 'like', addcslashes( $this->input['q'], '%_' ) .'%' ),
							 	   )	  );

		$this->core->db->execute();
		
		while( $u = $this->core->db->fetch_row() )
		{
			$users[] = array( 'caption' => $u['name'], 'value' => $u['id'] );
		}
		
		$this->skin->ajax_output( json_encode( $users ) );
	}

	#=======================================
	# @ TD Info
	# Display Trellis Desk Info page. :)
	#=======================================

	function tdinfo()
	{
		$this->skin->set_section( 'Administration Control Panel' );		
		$this->skin->set_description( 'Need some technically information regarding Trellis Desk?  Chances are you can find it here.' );
		
		$this->output = "<!-- REMOVAL OF THE COPYRIGHT WITHOUT PURCHASING COPYRIGHT REMOVAL WILL
						VIOLATE THE LICENSE YOU AGREED TO WHEN DOWNLOADING AND REGISTERING
						THIS PORDUCT.  IF THIS HAPPENS, IT COULD RESULT IN REMOVAL OF THIS
						SYSTEM AND POSSIBLY CRIMINAL CHARGES.  THANK YOU FOR UNDERSTANDING -->
						
						<div class='groupbox'>Version Information</div>
						<div class='option1'>
							Build: {$this->vernum} | PHP Version: ". phpversion() ." | MySQL Version: ". mysql_get_server_info() ."<br /><a href='http://www.accord5.com/products/trellis/'>Trellis Desk</a> {$this->vername} &copy; ". date('Y') ." <a href='http://www.accord5.com/'>ACCORD5</a>
						</div>
						
						<br />
						
						<div class='groupbox'>About</div>
						<div class='option1'>
							Trellis Desk is a free help desk system that is designed to be easy to use, powerful, and clean.  <a href='http://forums.accord5.com/index.php?showuser=9'>someotherguy</a> codes Trellis Desk during his free time, his goal to make a free help desk system just as good as many commercial systems.  <a href='http://www.accord5.com/products/trellis/license'>Click here</a> for License Agreement.
						</div>
						
						<br />
						
						<div class='groupbox'>Credits</div>
						<div class='option1'>
							Head Developer / Project Manager - <a href='http://forums.accord5.com/index.php?showuser=9'>someotherguy</a><br />
							Coding - <a href='http://forums.accord5.com/index.php?showuser=9'>someotherguy</a><br />
							A5 Core - <a href='http://forums.accord5.com/index.php?showuser=9'>someotherguy</a><br />
							Design &amp; Layout - <a href='http://forums.accord5.com/index.php?showuser=2'>Aaron</a> and <a href='http://www.a5omatoes.com/forums/index.php?showuser=1'>Charles</a><br />
							Documentation - <a href='http://forums.accord5.com/index.php?showuser=2'>Aaron</a><br /><br />
							Rich Text Editor - <a href='http://tinymce.moxiecode.com/'>TinyMCE</a> by <a href='http://www.moxiecode.com/'>Moxiecode Systems</a><br />
							Captcha - <a href='http://www.ejeliot.com/pages/php-captcha'>PhpCaptcha</a> by <a href='http://www.ejeliot.com/'>Edward Eliot</a><br />
							SQL Backup Function - <a href='http://www.programmingtalk.com/user.php?userid=141445'>Unreal Ed</a> modified by <a href='http://forums.accord5.com/index.php?showuser=9'>someotherguy</a><br />
							Zip Class - <a href='mailto:eric@themepark.com'>Eric Mueller</a>, <a href='mailto:webmaster@atlant.ru'>Denis125</a>, and <a href='mailto:mlady@users.sourceforge.net'>Peter Listiak</a><br />
							Javascript Libraries / Frameworks - <a href='http://script.aculo.us/'>script.aculo.us</a> and <a href='http://prototypejs.org/'>Prototype</a>
						</div>
						
						<br />
						
						<div class='groupbox'>Special Thanks</div>
						<div class='option1'>
							<a href='http://forums.accord5.com/index.php?showuser=2'>Aaron</a> <span class='desc'>- I can't thank you enough for all the help you've given me and your kindness.  I really love working with you.</span><br />
							<a href='http://forums.accord5.com/index.php?showuser=3'>James</a> - <span class='desc'>Thanks a bunch for introducing me to ACCORD5.  You opened up a wonderful door of opportunities for me.</span><br />
							<a href='http://forums.accord5.com/index.php?showuser=1'>Chris</a> - <span class='desc'>I didn't see you around much.  But I know you were always there backing me up 100%.</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=1'>Charles</a> - <span class='desc'>Your my idol.  I would have never gotten this far without you.</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=3'>Neil</a> - <span class='desc'>You kept pushing me and look where I am now.</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=2'>Biomech</a> - <span class='desc'>You learning PHP is forcing me to stay on top so you don't get ahead of me. :P</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=802'>Chuck</a> - <span class='desc'>What would I do without your sense of humor to cheer me up?</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=254'>Ali</a> - <span class='desc'>I have learned much from your high standards and excellent <strike>grammer</strike> grammar. :P</span><br />
							<a href='http://www.a5omatoes.com/forums/index.php?showuser=3017'>thatphpguy</a> - <span class='desc'>Yay! I've met a new PHP friend.  Our geek talk is great. :D</span>
						</div>
						
						<br />
						
						<div class='groupbox'>Other</div>
						<div class='option1'>
							<a href='http://www.php.net/'><img src='<! IMG_DIR !>/logos/php.png' alt='PHP' /></a> <a href='http://www.mysql.com/'><img src='<! IMG_DIR !>/logos/mysql.png' alt='MySQL' /></a> <a href='http://www.zend.com/'><img src='<! IMG_DIR !>/logos/zend.png' alt='Zend' /></a> <a href='http://tinymce.moxiecode.com/'><img src='<! IMG_DIR !>/logos/tinymce.png' alt='TinyMCE' /></a> <a href='http://validator.w3.org/check?uri=referer'><img src='<! IMG_DIR !>/logos/xhtml10.png' alt='XHML' /></a> <a href='http://jigsaw.w3.org/css-validator/'><img src='<! IMG_DIR !>/logos/vcss.png' alt='CSS' /></a><br />
							<a href='http://www.feedvalidator.org/'><img src='<! IMG_DIR !>/logos/vrss.png' alt='Valid RSS' /></a> <img src='<! IMG_DIR !>/logos/feed.png' alt='Feed' />
						</div>";

		$this->skin->add_output( $this->output );

		$this->nav = array(
						   "Trellis Desk Info",
						   );

		$this->skin->do_output( array( 'nav' => $this->nav, 'title' => 'Trellis Desk Information' ) );
	}

}

?>