<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Dashboard :: Sources
#======================================================
*/

class dashboard {

	#=======================================
	# @ Auto Run
	#=======================================

	public function auto_run()
	{
		#=============================
		# Grab News
		#=============================

		if ( $this->trellis->core->cache['settings']['news']['enable'] && $this->trellis->core->cache['settings']['news']['portal'] )
		{
			$final_a = array();
			$row_count = 0;
			$news = 0;

			if ( ! empty( $this->trellis->core->cache['news'] ) )
			{
				while ( list( $id, $a ) = each( $this->trellis->core->cache['news'] ) )
				{
					#=============================
					# Fix Up Information
					#=============================

					$row_count ++;

					( $row_count & 1 ) ? $a['class'] = 1 : $a['class'] = 2;

					$a['date'] = $this->trellis->td_timestamp( array( 'time' => $a['date'], 'format' => 'short' ) );

					$final_a[] = $a;
				}

				$this->trellis->core->template->set_var( 'news', $final_a );
			}
		}

		#=============================
		# Grab Tickets
		#=============================

		if ( $this->trellis->user['g_ticket_access'] )
		{
			$this->trellis->load_functions('tickets');

			if ( $this->trellis->user['id'] || $this->trellis->user['s_tkey'] )
			{
				if ( $this->trellis->user['id'] )
				{
					$tickets = $this->trellis->tickets->get( array(
																   'select'	=> array(
																   					 't' => array( 'id', 'mask', 'subject', 'priority', 'last_reply', 'escalated', 'status' ),
																   					 'd' => array( array( 'name' => 'dname' ) ),
																   					 'p' => array( array( 'name' => 'pname' ), 'icon_regular', 'icon_assigned' ),
															    					 's' => array( array( 'name_user' => 'status_name' ), array( 'abbr_user' => 'status_abbr' ) ),
															    					 ),
																   'from'	=> array( 't' => 'tickets' ),
																   'join'	=> array(
																    				 array( 'from' => array( 'd' => 'departments' ), 'where' => array( 't' => 'did', '=', 'd' => 'id' ) ),
																    				 array( 'from' => array( 'p' => 'priorities' ), 'where' => array( 't' => 'priority', '=', 'p' => 'id' ) ),
																    				 array( 'from' => array( 's' => 'statuses' ), 'where' => array( 't' => 'status', '=', 's' => 'id' ) ),
																    				 ),
																   'where'	=> array( array( 't' => 'uid' ), '=', $this->trellis->user['id'] ),
																   'order'	=> array( 'last_reply' => array( 't' => 'desc' ) ),
																   'limit'	=> array( 0, 8 ),
															)	   );
				}
				elseif ( $this->trellis->user['s_tkey'] )
				{
					$this->trellis->core->db->construct( array(
														  	 'select'	=> array( 'id', 'dname', 'subject', 'priority', 'date', 'status' ),
														  	 'from'		=> 'tickets',
										 				  	 'where'	=> array( array( 'email', '=', $this->trellis->user['s_email'] ), array( 'guest', '=', 1, 'and' ) ),
										 				  	 'order'	=> array( 'date' => 'DESC' ),
										 				  	 'limit'	=> array( 0, 8 ),
										 		  	  ) 	);
				}

				$ticket_rows = array();
				$row_count = 0;

				if ( $tickets )
				{
					foreach ( $tickets as $t )
					{
						#=============================
						# Fix Up Information
						#=============================

						$row_count ++;

						( $row_count & 1 ) ? $t['class'] = 1 : $t['class'] = 2;

						if ( $t['date'] ) $t['date'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'short' ) );
						if ( $t['last_reply'] ) $t['last_reply'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'short' ) );

				        if ( ! $t['status_abbr'] ) $t['status_abbr'] = $t['status_name'];

						$ticket_rows[] = $t;
					}

					$this->trellis->core->template->set_var( 'tickets', $ticket_rows );
				}
			}
		}

		if ( $this->trellis->core->cache['settings']['kb']['enable'] && $this->trellis->user['g_kb_access'] )
		{
			#=============================
			# Grab Recent Articles
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id', 'title', 'description' ),
												  	 'from'		=> 'articles',
												  	 'order'	=> array( 'date' => 'desc' ),
												  	 'limit'	=> array( 0, $this->trellis->core->cache['settings']['kb']['recent_articles_count'] ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() )
			{
				$recent = array();

				while( $a = $this->trellis->core->db->fetch_row() )
				{
					$recent[] = $a;
				}

				$this->trellis->core->template->set_var( 'recent_articles', $recent );
			}

			#=============================
			# Grab Most Popular
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id', 'title', 'description' ),
												  	 'from'		=> 'articles',
												  	 'order'	=> array( 'rating' => 'desc' ),
												  	 'limit'	=> array( 0, $this->trellis->core->cache['settings']['kb']['popular_articles_count'] ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() )
			{
				$popular = array();

				while( $a = $this->trellis->core->db->fetch_row() )
				{
					$popular[] = $a;
				}

				$this->trellis->core->template->set_var( 'popular_articles', $popular );
			}
		}

		#=============================
		# Do Output
		#=============================

		$this->trellis->core->template->set_var( 'sub_tpl', 'dashboard.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => array( '<a href="'. $this->trellis->config['hd_url'] .'/index.php?page=dashboard">'. $this->trellis->lang['dashboard'] .'</a>' ) ) );
	}

}

?>