<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ "someotherguy" (sog@accord5.com)
|     2007 ACCORD5
|    http://www.accord.com/products/trellis/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v1.0 RC 1 Build 10031234
|    @ Version Int: 100.3.1.234
|    @ Version Num: 10031234
|    @ Build: 0234
#======================================================
|    | News :: Sources
#======================================================
*/

class news {

	#=======================================
	# @ Auto Run
	#=======================================

	function auto_run()
	{
		#=============================
		# Initialize
		#=============================

		if ( ! $this->trellis->core->cache['settings']['news']['enable'] || ! $this->trellis->core->cache['settings']['news']['page'] )
		{
			$this->trellis->skin->error( 'news_disabled');
		}

		$this->trellis->load_functions('news');
		$this->trellis->load_lang('news');

		switch( $this->trellis->input['act'] )
    	{
    		case 'view':
				$this->view_news();
    		break;
    		case 'doaddcomment':
				$this->do_add_comment();
    		break;
    		case 'editcomment':
				$this->edit_comment();
    		break;

    		case 'doeditcomment':
				$this->do_edit_comment();
    		break;
    		case 'dodeletecomment':
				$this->do_delete_comment();
    		break;

    		default:
    			$this->news_portal();
    		break;
		}
	}

	#=======================================
	# @ News Portal
	#=======================================

	function news_portal()
	{
		#=============================
		# Grab Annoucements
		#=============================

		$final_a = array();
		$row_count = 0;

		if ( $news = $this->trellis->news->get( array( 'select' => 'all', 'order' => array( 'date' => 'DESC' ), 'limit' => array( 0, $this->trellis->core->cache['settings']['news']['page_amount'] ) ) ) )
		{
			while ( list( , $a ) = each ( $news ) )
			{
				#=============================
				# Fix Up Information
				#=============================

				$row_count ++;

				( $row_count & 1 ) ? $a['class'] = 1 : $a['class'] = 2;

				$a['date'] = $this->trellis->td_timestamp( array( 'time' => $a['date'], 'format' => 'long' ) );

				if ( $this->trellis->core->cache['settings']['news']['rte'] )
				{
					$a['content'] = $this->trellis->prepare_output( $this->trellis->remove_dbl_spaces( $this->trellis->convert_html( $a['content'] ) ), 0, 0, 1 );
				}
				else
				{
					$a['content'] = $this->trellis->prepare_output( $a['content'], 0, 0, 1 );
				}

				$final_a[] = $a;
			}

			$this->trellis->core->template->set_var( 'news', $final_a );
		}

		#=============================
		# Do Output
		#=============================

		$this->trellis->core->template->set_var( 'sub_tpl', 'news.tpl' );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news'>{$this->trellis->lang['news']}</a>",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['news'] ) );
	}

	#=======================================
	# @ Show News
	#=======================================

	function view_news($error="", $type="")
	{
		#=============================
		# Grab Annoucement
		#=============================

		if ( ! $a = $this->trellis->news->get_single_by_id( 'all', $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_news');

		#=============================
		# Fix Up Information
		#=============================

		$a['date'] = $this->trellis->td_timestamp( array( 'time' => $a['date'], 'format' => 'long' ) );

		$aoutput_params = array( 'urls' => 1 );

		( $a['html'] ) ? $aoutput_params['html'] = 1 : $aoutput_params['nl2br'] = 1;

		$a['content'] = $this->trellis->prepare_output( $a['content'], $aoutput_params );

		$this->trellis->core->template->set_var( 'n', $a );

		#=============================
		# Grab Comments
		#=============================

		$row_count = 0;

		$coms = $this->trellis->core->db->get( array(
														 'select'	=> array(
													   				    	 'c' => 'all',
												   					    	 'u' => array( array( 'name' => 'uname' ) ),
													   			    		 ),
														 'from'	    => array( 'c' => 'news_comments' ),
														 'join'	    => array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'c' => 'uid', '=', 'u' => 'id' ) ) ),
														 'where'	=> array( array( 'c' => 'nid' ), '=', $a['id'] ),
														 'order'    => array( 'date' => array( 'c' => 'asc' ) ),
                                                  ), 'id' );

		if ( $coms )
		{
			$comments = array();

			while( list( , $c ) = each( $coms ) )
			{
				#=============================
				# Fix Up Information
				#=============================

				$row_count ++;

				( $row_count & 1 ) ? $c['class'] = 1 : $c['class'] = 2;

				if ( $c['staff'] ) $c['class_staff'] = 'staff';

				$c['time_ago'] = $this->trellis->td_timestamp( array( 'time' => $c['date'], 'format' => 'relative' ) );

				$c['date'] = $this->trellis->td_timestamp( array( 'time' => $c['date'], 'format' => 'short' ) );

        		$coutput_params = array( 'urls' => 1 );

        		( $c['html'] ) ? $coutput_params['html'] = 1 : $coutput_params['nl2br'] = 1;

        		$c['message'] = $this->trellis->prepare_output( $c['message'], $coutput_params );

				$comments[] = $c;
			}

			$this->trellis->core->template->set_var( 'comments', $comments );
		}

		#=============================
		# Do Output
		#=============================

		if ( $this->trellis->core->cache['settings']['news']['comments'] && $this->trellis->user['g_news_comment'] && $a['allow_comments'] && $this->trellis->user['id'] )
		{
			$this->trellis->core->template->set_var( 'show_comment_form', 1 );

			if ( $error )
			{
				$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
			}
		}

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news'>{$this->trellis->lang['news']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news&amp;act=view&amp;id={$a['id']}'>{$a['title']}</a>",
						   );

		if ( $type == 'print' )
		{
			$this->trellis->core->template->set_var( 'sub_tpl', 'news_print.tpl' );

			$this->trellis->skin->do_print( array( 'title' => $this->trellis->lang['news'] .' :: '. $a['title'] ) );
		}
		else
		{
			$this->trellis->core->template->set_var( 'sub_tpl', 'news_show.tpl' );

			$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['news'] .' :: '. $a['title'] ) );
		}
	}

	#=======================================
	# @ Submit Comment
	#=======================================

	function do_add_comment()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['message'] ) $this->view_news( array( 'comment_error' => 'no_message' ) );

		if ( ! $a = $this->trellis->news->get_single_by_id( array( 'id', 'title', 'allow_comments' ), $this->trellis->input['id'] ) ) $this->trellis->skin->error('no_article');

		if ( ! $this->trellis->core->cache['settings']['news']['comments'] || ! $this->trellis->user['g_news_comment'] || ! $a['allow_comments'] ) $this->trellis->skin->error('no_perm');

		#=============================
		# Add Comment
		#=============================

		$db_array = array(
						  'nid'			=> $a['id'],
						  'uid'			=> $this->trellis->user['id'],
						  'message'		=> $this->trellis->input['message'],
						  'date'		=> time(),
						  'ipadd'		=> $this->trellis->input['ip_address'],
						 );

		$comment_id = $this->trellis->news->add_comment( $db_array, $a['id'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?page=news&act=view&id='. $this->trellis->input['id'] .'#com'. $comment_id, 'do_add_comment_success' );
	}

	#=======================================
	# @ Edit Comment
	#=======================================

	function edit_comment($error="")
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'news_comments',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Comment Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_comment');
		}

		$c = $this->trellis->core->db->fetch_row();

		if ( ! $this->trellis->user['g_news_com_edit'] || $c['uid'] != $this->trellis->user['id'] )
		{
			$this->trellis->log( 'security', "Blocked Editing of Comment" );

			$this->trellis->skin->error('no_perm_com_edit');
		}

		$this->trellis->core->template->set_var( 'comment', $c );

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news'>{$this->trellis->lang['news']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news&amp;act=edit&amp;id={$c['id']}'>{$this->trellis->lang['edit_comment']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'news_edit_comment.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['news'] .' :: '. $this->trellis->lang['edit_comment'] ) );
	}

	#=======================================
	# @ Do Edit Comment
	#=======================================

	function do_edit_comment()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'news_comments',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Comment Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_comment');
		}

		$c = $this->trellis->core->db->fetch_row();

		if ( ! $this->trellis->user['g_news_com_edit'] || $c['uid'] != $this->trellis->user['id'] )
		{
			$this->trellis->log( 'security', "Blocked Editing of Comment" );

			$this->trellis->skin->error('no_perm_com_edit');
		}

		#=============================
		# Update Comment
		#=============================

		$this->trellis->news->edit_comment( array( 'message' => $this->trellis->input['message'] ), $c['id'] );

		$this->trellis->log( 'user', "News Comment Edited ID #". $c['id'], 1, $c['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=news&act=view&id='. $c['nid'] .'#com'. $this->trellis->input['id'], 'edit_comment_success' );
	}

	#=======================================
	# @ Do Delete Comment
	# Delete comment. :(
	#=======================================

	function do_delete_comment()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'news_comments',
							 				  	 'where'	=> array( 'id', '=', $this->trellis->input['id'] ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Comment Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_comment');
		}

		$c = $this->trellis->core->db->fetch_row();

		if ( ! $this->trellis->user['g_news_com_delete'] || $c['uid'] != $this->trellis->user['id'] )
		{
			$this->trellis->log( 'security', "Blocked Deleting of Comment" );

			$this->trellis->skin->error('no_perm_com_delete');
		}

		#=============================
		# Delete Comment
		#=============================

		$this->trellis->news->delete_comment( $c['id'], array( 'nid' => $c['nid'] ) );

		$this->trellis->log( 'user', "News Comment Deleted ID #". $c['id'], 2, $c['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=news&act=view&id='. $c['nid'], 'delete_comment_success' );
	}

}

?>