<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Register :: Sources
#======================================================
*/

class register {

	#=======================================
	# @ Auto Run
	# Function that is run automatically
	# when the file is required.
	#=======================================

	function auto_run()
	{
	        die('not ready');
		#=============================
		# Initialize
		#=============================

		$this->trellis->load_lang('register');

		#=============================
		# Security Checks
		#=============================

		if ( $this->trellis->user['id'] )
		{
			$this->trellis->skin->error( 'must_be_guest' );
		}

		switch( $this->trellis->input['code'] )
    	{
    		case 'upgrade':
				$this->register_form('upgrade');
    		break;
    		case 'new':
				$this->create_account('new');
    		break;
    		case 'doupgrade':
				$this->create_account('upgrade');
    		break;
    		case 'validate':
				$this->validate_email();
    		break;
    		case 'sendval':
				$this->resend_val_form();
    		break;
    		case 'forgot':
				$this->forgot_pass_form();
    		break;
    		case 'reset':
				$this->reset_pass_form();
    		break;

    		case 'dosendval':
				$this->resend_val();
    		break;
    		case 'doforgot':
				$this->do_forgot_pass();
    		break;
    		case 'doreset':
				$this->do_reset_pass();
    		break;

    		default:
    			$this->register_form('new');
    		break;
		}
	}

	#=======================================
	# @ Register Form
	# Show registration form.
	#=======================================

	function register_form($type='new', $error="", $extra="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( $type == 'upgrade' && ! $this->trellis->core->cache['settings']['user']['guest_upgrade'] )
		{
			$this->trellis->skin->error('no_perm_access');
		}

		#=============================
		# Custom Profile Fields
		#=============================

		$cpfields = array(); // Initialize for Security
		$row_count = 0; // Initialize for Security

		if ( is_array( $this->trellis->core->cache['pfields'] ) )
		{
			foreach( $this->trellis->core->cache['pfields'] as $id => $f )
			{
				if ( $f['reg'] )
				{
					$row_count ++;

					( $row_count & 1 ) ? $f['class'] = 1 : $f['class'] = 2;

					if ( ! $f['required'] )
					{
						$f['optional'] = $this->trellis->lang['optional'];
					}

					$f['value'] = $this->trellis->input[ 'cpf_'. $f['fkey'] ];

					if ( $f['type'] == 'textfield' )
					{
						$cpfields[] = $f;
					}
					elseif ( $f['type'] == 'textarea' )
					{
						$cpfields[] = $f;
					}
					elseif ( $f['type'] == 'dropdown' )
					{
						$options = explode( "\n", $f['extra'] );

						while ( list( , $opt ) = each( $options ) )
						{
							$our_opt = explode( "=", $opt );

							if ( $our_opt[0] == $f['value'] )
							{
								$f['options'] .= "<option value='". $our_opt[0] ."' selected='selected'>". $our_opt[1] ."</option>";
							}
							else
							{
								$f['options'] .= "<option value='". $our_opt[0] ."'>". $our_opt[1] ."</option>";
							}
						}

						$cpfields[] = $f;
					}
					elseif ( $f['type'] == 'checkbox' )
					{
						$cpfields[] = $f;
					}
					elseif ( $f['type'] == 'radio' )
					{
						$options = explode( "\n", $f['extra'] );

						while ( list( , $opt ) = each( $options ) )
						{
							$our_opt = explode( "=", $opt );

							if ( $our_opt[0] == $f['value'] )
							{
								$f['options'] .= "<label for='cpf_". $f['fkey'] ."_". $our_opt[0] ."'><input type='radio' name='cpf_". $f['fkey'] ."' id='cpf_". $f['fkey'] ."_". $our_opt[0] ."' value='". $our_opt[0] ."' class='radio' checked='checked' /> ". $our_opt[1] ."</label>&nbsp;&nbsp;";
							}
							else
							{
								$f['options'] .= "<label for='cpf_". $f['fkey'] ."_". $our_opt[0] ."'><input type='radio' name='cpf_". $f['fkey'] ."' id='cpf_". $f['fkey'] ."_". $our_opt[0] ."' value='". $our_opt[0] ."' class='radio' /> ". $our_opt[1] ."</label>&nbsp;&nbsp;";
							}
						}

						$cpfields[] = $f;
					}
				}

				$optional = ""; // Reset
				$f['options'] = ""; // Reset
			}

			$this->trellis->core->template->set_var( 'cpfields', $cpfields );
		}

		#=============================
		# Do Output
		#=============================

		$row_count ++;
		( $row_count & 1 ) ? $class_captcha = 1 : $class_captcha = 2;

		$this->trellis->core->template->set_var( 'class_captcha', $class_captcha );

		if ( ! $this->trellis->core->cache['settings']['security']['registration'] )
		{
			$this->trellis->skin->error('registration_disabled');
		}

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		if ( $type == 'upgrade' )
		{
			$this->nav = array( "<a href='{$this->trellis->config['hd_url']}/index.php?act=upgrade'>{$this->trellis->lang['register']}</a>" );
		}
		else
		{
			$this->nav = array( "<a href='{$this->trellis->config['hd_url']}/index.php?act=register'>{$this->trellis->lang['register']}</a>" );
		}

		if ( $type == 'new' )
		{
			$this->trellis->core->template->set_var( 'token_register', $this->trellis->create_token('register') );

			$this->trellis->core->template->set_var( 'sub_tpl', 'register.tpl' );
		}
		elseif ( $type == 'upgrade' )
		{
			$this->trellis->core->template->set_var( 'token_upgrade', $this->trellis->create_token('upgrade') );

			$this->trellis->core->template->set_var( 'sub_tpl', 'reg_upgrade.tpl' );
		}

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['register'] ) );
	}

	#=======================================
	# @ Create Account
	# Creates a new account.
	#=======================================

	function create_account($type='new')
	{
		#=============================
		# Security Checks
		#=============================

		if ( $type == 'upgrade' && ! $this->trellis->core->cache['settings']['user']['guest_upgrade'] )
		{
			$this->trellis->skin->error('no_perm_access');
		}

		if ( ! $this->trellis->core->cache['settings']['security']['registration'] )
		{
			$this->trellis->skin->error('registration_disabled');
		}

		if ( $type == 'new' )
		{
			$this->trellis->check_token('register');
		}
		elseif ( $type == 'upgrade' )
		{
			$this->trellis->check_token('upgrade');
		}

		if ( ! $this->trellis->input['user'] )
		{
			$this->register_form( $type, 'no_user_short' );
		}

		if ( $type == 'upgrade' ) $this->trellis->input['email'] = $this->trellis->user['s_email'];

		if ( ! $this->trellis->validate_email( $this->trellis->input['email'] ) )
		{
				$this->register_form( $type, 'no_email_valid' );
		}

		if ( $this->trellis->input['pass'] != $this->trellis->input['passb'] )
		{
			$this->register_form( $type, 'no_pass_match' );
		}

		if ( ! $this->trellis->input['pass'] )
		{
			$this->register_form( $type, 'no_pass_short' );
		}

		if ( $this->trellis->core->cache['settings']['security']['captcha'] )
		{
			if ( ! $this->trellis->captcha_validate( $this->trellis->input['captcha'] ) )
			{
				$this->register_form( $type, 'captcha_mismatch' );
			}
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id' ),
											  	 'from'		=> 'users',
											  	 'where'	=> array( 'email|lower', '=', strtolower( $this->trellis->input['email'] ) ),
											  	 'limit'	=> array( 0, 1 ),
									  	  ) 	);

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			$this->register_form( $type, 'email_in_use' );
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id' ),
											  	 'from'		=> 'users',
											  	 'where'	=> array( 'name|lower', '=', strtolower( $this->trellis->input['user'] ) ),
											  	 'limit'	=> array( 0, 1 ),
									  	  ) 	);

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			$this->register_form( $type, 'user_in_use' );
		}

		#=============================
		# Custom Profile Fields
		#=============================

		$cpfvalues = ""; // Initialize for Security

		while ( list( $id, $f ) = each( $this->trellis->core->cache['pfields'] ) )
		{
			$f_perm = unserialize( $f['perms'] );

			if ( $f['reg'] )
			{
				if ( $f['required'] && $f['type'] != 'checkbox' )
				{
					if ( ! $this->trellis->input[ 'cpf_'. $f['fkey'] ] )
					{
						$this->register_form(  $type, 'no_cpfield', $f['name'] );
					}
				}

				$cpfvalues[ $f['fkey'] ] = $this->trellis->input[ 'cpf_'. $f['fkey'] ];
			}
		}

		#=============================
		# Insert User
		#=============================

		$pass_salt = substr( md5( 'ps'. uniqid( rand(), true ) ), 0, 9 );
		$pass_hash = sha1( md5( $this->trellis->input['pass'] . $pass_salt ) );

		$db_array = array(
						  'name'						=> $this->trellis->input['user'],
						  'email'						=> $this->trellis->input['email'],
						  'password'					=> $pass_hash,
						  'pass_salt'					=> $pass_salt,
						  'login_key'					=> str_replace( "=", "", base64_encode( strrev( crypt( $this->trellis->input['pass'] ) ) ) ),
						  'joined'						=> time(),
						  'ipadd'						=> $this->trellis->input['ip_address'],
						  'email_notify'				=> 1,
						  'email_new_ticket'			=> 1,
						  'email_ticket_reply'			=> 1,
						  'email_announce'				=> 1,
						  'email_staff_new_ticket'		=> 1,
						  'email_staff_ticket_reply'	=> 1,
						  'rte_enable'						=> 1,
						  'cpfields'					=> serialize($cpfvalues),
						  'rss_key'						=> md5( 'rk'. uniqid( rand(), true ) ),
						 );

		if ( $this->trellis->core->cache['settings']['security']['validation_email'] || $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$db_array['ugroup'] = 3;
		}
		else
		{
			$db_array['ugroup'] = 1;
		}

		if ( ! $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$db_array['admin_val'] = 1;
		}
		if ( ! $this->trellis->core->cache['settings']['security']['validation_email'] )
		{
			$db_array['email_val'] = 1;
		}

		$this->trellis->core->db->construct( array(
											  	 'insert'	=> 'users',
											  	 'set'		=> $db_array,
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$user_id = $this->trellis->core->db->get_insert_id();

		#=============================
		# Upgrade Account
		#=============================

		if ( $type == 'upgrade' )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id' ),
												  	 'from'		=> 'tickets',
												  	 'where'	=> array( array( 'email', '=', $this->trellis->input['email'] ), array( 'guest', '=', 1, 'and' ) ),
										  	  ) 	);

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() )
			{
				$tickets = array(); // Initialize for Security

				while( $t = $this->trellis->core->db->fetch_row() )
				{
					$tickets[] = $t['id'];
				}

				// Update Tickets
				$this->trellis->core->db->construct( array(
													  	 'update'	=> 'tickets',
													  	 'set'		=> array( 'tkey' => "", 'uid' => $user_id, 'uname' => $this->trellis->input['user'], 'guest' => 0 ),
													  	 'where'	=> array( array( 'email', '=', $this->trellis->input['email'] ), array( 'guest', '=', 1, 'and' ) ),
									 		  	  ) 	);

				$this->trellis->core->db->execute();

				// Update Replies
				$this->trellis->core->db->construct( array(
													  	 'update'	=> 'replies',
													  	 'set'		=> array( 'uid' => $user_id, 'uname' => $this->trellis->input['user'], 'guest' => 0 ),
													  	 'where'	=> array( array( 'tid', 'in', $tickets ), array( 'guest', '=', 1, 'and' ) ),
									 		  	  ) 	);

				$this->trellis->core->db->execute();
			}

			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'sessions',
												  	 'set'		=> array( 's_tkey' => "" ),
												  	 'where'	=> array( 's_id', '=', $this->trellis->user['s_id'] ),
												  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();
		}

		#=============================
		# Update New Group
		#=============================

		$this->trellis->core->db->next_no_quotes('set');

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'groups',
											  	 'set'		=> array( 'g_users' => 'g_users+1' ),
							 				  	 'where'	=> array( 'g_id', '=', $db_array['ugroup'] ),
							 				  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		#=============================
		# Update Stats
		#=============================

		$this->trellis->r_user_stats(1);

		#=============================
		# Insert Validation
		#=============================

		if ( $this->trellis->core->cache['settings']['security']['validation_email'] )
		{
			$val_code = md5( 'vc' . $this->trellis->input['email'] . uniqid( rand(), true ) );

			$db_array = array(
							  'id'			=> $val_code,
							  'uid'			=> $user_id,
							  'uname'		=> $this->trellis->input['user'],
							  'date'		=> time(),
							  'type'		=> 1,
							 );

			$this->trellis->core->db->construct( array(
												  	 'insert'	=> 'validation',
												  	 'set'		=> $db_array,
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			#=============================
			# Send Email
			#=============================

			$replace = ""; // Initialize for Security

			$replace['USER_NAME'] = $this->trellis->input['user'];
			$replace['VAL_LINK'] = $this->trellis->config['hd_url'] ."/index.php?act=register&code=validate&key=". $val_code;

			if ( $this->trellis->core->cache['settings']['security']['validation_admin'] )
			{
				$this->trellis->send_email( $user_id, 'new_user_val_both', $replace );
			}
			else
			{
				$this->trellis->send_email( $user_id, 'new_user_val_email', $replace );
			}
		}
		elseif ( $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			#=============================
			# Send Email
			#=============================

			$replace = ""; // Initialize for Security

			$replace['USER_NAME'] = $this->trellis->input['user'];

			$this->trellis->send_email( $user_id, 'new_user_val_admin', $replace );
		}

		$this->trellis->log( 'user', "New User Registration &#039;". $this->trellis->input['user'] ."&#039;", 1, $user_id );

		#=============================
		# Send Email to Admin
		#=============================

		if ( $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id', 'time_zone', 'dst_active' ),
												  	 'from'		=> 'users',
								 				  	 'where'	=> array( 'ugroup', '=', 4 ),
								 		  	  ) 	);

			$admin_sql = $this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows($admin_sql) )
			{
				while( $am = $this->trellis->core->db->fetch_row($admin_sql) )
				{
					$mem_offset = ( $am['time_zone'] * 60 * 60 ) + ( $am['dst_active'] * 60 * 60 );

					$replace = ""; // Initialize for Security

					$replace['USER_NAME'] = $this->trellis->input['user'];
					$replace['USER_EMAIL'] = $this->trellis->input['email'];
					$replace['JOIN_DATE'] = $this->trellis->a5_date( time(), '', 0, 0, 1, $mem_offset, 1 );
					$replace['APPROVE_LINK'] = $this->trellis->config['hd_url'] .'/admin.php?section=manage&act=user&code=mod';

					$this->trellis->send_email( $am['id'], 'new_user_admin_val', $replace );
				}
			}
		}

		#=============================
		# Redirect
		#=============================

		if ( $this->trellis->core->cache['settings']['security']['validation_email'] && $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$this->trellis->skin->redirect( '?act=portal', 'new_user_val_both' );
		}
		elseif ( $this->trellis->core->cache['settings']['security']['validation_email'] )
		{
			$this->trellis->skin->redirect( '?act=portal', 'new_user_val_email' );
		}
		elseif ( $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$this->trellis->skin->redirect( '?act=portal', 'new_user_val_admin' );
		}
		else
		{
			$this->trellis->skin->redirect( '?act=portal', 'new_user_no_val' );
		}
	}

	#=======================================
	# @ Validate Email
	# Validates the user's new email.
	#=======================================

	function validate_email()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! isset( $this->trellis->input['key'] ) )
		{
			$this->trellis->skin->error('no_email_val_key');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'validation',
							 				  	 'where'	=> array( array( 'id', '=', $this->trellis->input['key'] ), array( 'type', '=', 1, 'and' ) ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Validation Key Not Found &#039;". $this->trellis->input['key'] ."&#039;" );

			$this->trellis->skin->error('no_email_val_key');
		}

		$v = $this->trellis->core->db->fetch_row();

		if ( $v['new_email'] )
		{
			$this->trellis->log( 'error', "Incorrect Use of Validation Key &#039;". $this->trellis->input['key'] ."&#039;" );

			$this->trellis->skin->error('no_email_val_key');
		}

		if ( $v['date'] < time() - ( 60 * 60 * $this->trellis->core->cache['settings']['security']['email_expire'] ) )
		{
			$this->trellis->core->db->construct( array(
												  	 'delete'	=> 'validation',
								 				  	 'where'	=> array( 'id', '=', $this->trellis->input['key'] ),
								 				  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			$this->trellis->log( 'error', "Validation Key Expired &#039;". $this->trellis->input['key'] ."&#039;", 1, $v['uid'] );

			$this->trellis->skin->error('no_email_val_key');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'name', 'email_val', 'admin_val' ),
											  	 'from'		=> 'users',
							 				  	 'where'	=> array( 'id', '=', $v['uid'] ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "User #". $v['uid'] ." Not Found" );

			$this->trellis->skin->error('no_user');
		}

		$m = $this->trellis->core->db->fetch_row();

		if ( $m['email_val'] )
		{
			$this->trellis->skin->error('already_validated');
		}

		#=============================
		# Check Admin Validation
		#=============================

		if ( ! $m['admin_val'] )
		{
			#=============================
			# Update User
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'users',
												  	 'set'		=> array( 'email_val' => 1 ),
								 				  	 'where'	=> array( 'id', '=', $v['uid'] ),
								 				  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();
		}
		else
		{
			#=============================
			# Update User
			#=============================

			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'users',
												  	 'set'		=> array( 'ugroup' => 1, 'email_val' => '1' ),
								 				  	 'where'	=> array( 'id', '=', $v['uid'] ),
								 				  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			#=============================
			# Update Old Group
			#=============================

			$this->trellis->core->db->next_no_quotes('set');

			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'groups',
												  	 'set'		=> array( 'g_users' => 'g_users-1' ),
								 				  	 'where'	=> array( 'g_id', '=', 3 ),
								 				  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			#=============================
			# Update New Group
			#=============================

			$this->trellis->core->db->next_no_quotes('set');

			$this->trellis->core->db->construct( array(
												  	 'update'	=> 'groups',
												  	 'set'		=> array( 'g_users' => 'g_users+1' ),
								 				  	 'where'	=> array( 'g_id', '=', 1 ),
								 				  	 'limit'	=> array( 1 ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();
		}

		#=============================
		# Delete Validation
		#=============================

		$this->trellis->core->db->construct( array(
											  	 'delete'	=> 'validation',
							 				  	 'where'	=> array( 'id', '=', $v['id'] ),
							 				  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		#=============================
		# Send Email
		#=============================

		$replace = ""; // Initialize for Security

		if ( ! $m['admin_val'] )
		{
			$this->trellis->send_email( $m['id'], 'acc_almost_accivated', $replace );
		}
		else
		{
			$this->trellis->send_email( $m['id'], 'acc_accivated', $replace );
		}

		$this->trellis->log( 'user', "Email Validated &#039;". $m['name'] ."&#039;", 1, $m['id'] );

		#=============================
		# Redirect
		#=============================

		if ( ! $m['admin_val'] )
		{
			$this->trellis->skin->redirect( '?act=portal', 'almost_acc_activate' );
		}
		else
		{
			$this->trellis->skin->redirect( '?act=portal', 'success_acc_activate' );
		}
	}

	#=======================================
	# @ Resend Validation Form
	# Show resend validation form.
	#=======================================

	function resend_val_form($error='')
	{
		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->trellis->core->template->set_var( 'token_resend_val', $this->trellis->create_token('resend_val') );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?act=register&amp;code=sendval'>{$this->trellis->lang['resend_val']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'reg_resend_val.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['resend_val'] ) );
	}

	#=======================================
	# @ Resend Validation
	# Resends an account validation email.
	#=======================================

	function resend_val()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_token('resend_val');

		if ( ! $this->trellis->input['user'] && ! $this->trellis->input['email'] )
		{
			$this->resend_val_form('no_user_or_email');
		}

		if ( ! $this->trellis->validate_email( $this->trellis->input['email'] ) && ! $this->trellis->input['user'] )
		{
			$this->resend_val_form('no_email_valid');
		}

		$username = ""; // Initialize for Security
		$email = ""; // Initialize for Security

		if ( $this->trellis->input['user'] )
		{
			$username = $this->trellis->input['user'];
		}
		elseif ( $this->trellis->input['email'] )
		{
			$email = $this->trellis->input['email'];
		}

		if ( $username )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id', 'name', 'email_val', 'admin_val' ),
												  	 'from'		=> 'users',
								 				  	 'where'	=> array( 'name|lower', '=', strtolower( $username ) ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);
		}
		elseif( $email )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'id', 'name', 'email_val', 'admin_val' ),
												  	 'from'		=> 'users',
								 				  	 'where'	=> array( 'email|lower', '=', strtolower( $email ) ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);
		}

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->resend_val_form('user_not_found');
		}

		$m = $this->trellis->core->db->fetch_row();

		if ( $m['email_val'] )
		{
			$this->resend_val_form('user_already_active');
		}

		#=============================
		# Insert Validation
		#=============================

		$val_code = md5( 'vc' . $m['email'] . uniqid( rand(), true ) );

		$db_array = array(
						  'id'			=> $val_code,
						  'uid'			=> $m['id'],
						  'date'		=> time(),
						  'type'		=> 1,
						 );

		$this->trellis->core->db->construct( array(
											  	 'insert'	=> 'validation',
											  	 'set'		=> $db_array,
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->log( 'security', "Email Validation Resent &#039;". strtolower( $email ) ."&#039;", 1, $m['id'] );

		#=============================
		# Send Email
		#=============================

		$replace = ""; // Initialize for Security

		$replace['USER_NAME'] = $m['name'];
		$replace['VAL_LINK'] = $this->trellis->config['hd_url'] ."/index.php?act=register&code=validate&key=". $val_code;

		if ( $this->trellis->core->cache['settings']['security']['validation_admin'] )
		{
			$this->trellis->send_email( $m['id'], 'new_user_val_both', $replace );
		}
		else
		{
			$this->trellis->send_email( $m['id'], 'new_user_val_email', $replace );
		}

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?act=portal', 'new_user_val_resend' );
	}

	#=======================================
	# @ Forgot Password Form
	# Show forgot password form.
	#=======================================

	function forgot_pass_form($error='')
	{
		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->trellis->core->template->set_var( 'token_forgot_pass', $this->trellis->create_token('forgot_pass') );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?act=register&amp;code=forgot'>{$this->trellis->lang['forgot_password']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'reg_forgot_pass.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['forgot_password'] ) );
	}

	#=======================================
	# @ Do Forgot Password
	# Sends a validation email to reset pass.
	#=======================================

	function do_forgot_pass()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_token('forgot_pass');

		if ( ! $this->trellis->input['user'] && ! $this->trellis->input['email'] )
		{
			$this->forgot_pass_form('no_user_or_email');
		}

		if ( ! $this->trellis->validate_email( $this->trellis->input['email'] ) && ! $this->trellis->input['user'] )
		{
			$this->forgot_pass_form('no_email_valid');
		}

		$this->trellis->load_functions('users');

		if ( $this->trellis->input['user'] )
		{
			if ( ! $m = $this->trellis->users->get_info( array( 'id', 'name' ), 'username', $this->trellis->input['user'] ) )
			{
				$this->forgot_pass_form('user_not_found');
			}

			$reference = $this->trellis->input['user'];
		}
		elseif( $this->trellis->input['email'] )
		{
			if ( ! $m = $this->trellis->users->get_info( array( 'id', 'name' ), 'email', $this->trellis->input['email'] ) )
			{
				$this->forgot_pass_form('user_not_found');
			}

			$reference = $this->trellis->input['email'];
		}

		#=============================
		# Send Email
		#=============================

		$this->trellis->users->forgot_password( $m['id'] );

		$this->trellis->log( 'security', "Password Reset Validation Sent &#039;". $reference ."&#039;", 1, $m['id'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?act=portal', 'reset_pass_email_sent' );
	}

	#=======================================
	# @ Reset Password Form
	# Show reset password form.
	#=======================================

	function reset_pass_form($error="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['key'] )
		{
			$this->trellis->skin->error('no_email_val_key');
		}

		$this->trellis->load_functions('users');

		if ( ! $m = $this->trellis->users->check_reset_pswd_key( $this->trellis->input['key'] ) )
		{
			$this->trellis->skin->error('no_email_val_key');
		}

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->trellis->core->template->set_var( 'token_reset_pass', $this->trellis->create_token('reset_pass') );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?act=register&amp;code=reset'>{$this->trellis->lang['reset_password']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'reg_reset_pass.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['reset_password'] ) );
	}

	#=======================================
	# @ Do Reset Password
	# Reset password.
	#=======================================

	function do_reset_pass()
	{
		#=============================
		# Security Checks
		#=============================

		$this->trellis->check_token('reset_pass');

		if ( ! $this->trellis->input['key'] )
		{
			$this->trellis->skin->error('no_email_val_key');
		}

		if ( $this->trellis->input['new_pass'] != $this->trellis->input['new_pass_b'] )
		{
			$this->reset_pass_form('no_pass_match');
		}

		if ( ! $this->trellis->input['new_pass'] )
		{
			$this->reset_pass_form('no_pass_short');
		}

		$this->trellis->load_functions('users');

		#=============================
		# Update User
		#=============================

		if ( ! $this->trellis->users->change_password( NULL, $this->trellis->input['new_pass'], 0, $this->trellis->input['key'] ) )
		{
			$this->trellis->skin->error('no_email_val_key');
		}

		$this->trellis->log( 'user', "Password Reset &#039;". $v['uname'] ."&#039;" );
		$this->trellis->log( 'security', "Password Reset &#039;". $v['uname'] ."&#039;" );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?act=portal', 'reset_pass_success' );
	}

}

?>