<?php

/*
#======================================================
|    Trellis Desk
|    =====================================
|    By DJ Tarazona (dj@accord5.com)
|    (c) 2010 ACCORD5
|    http://www.trellisdesk.com/
|    =====================================
|    Email: sales@accord5.com
#======================================================
|    @ Version: v2.0 Aplha 1 Build 20011028
|    @ Version Int: 200.1.1.028
|    @ Version Num: 20011028
|    @ Build: 0028
#======================================================
|    | Tickets :: Sources
#======================================================
*/

class tickets {

	#=======================================
	# @ Auto Run
	# Function that is run automatically
	# when the file is required.
	#=======================================

	function auto_run()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['g_ticket_access'] )
		{
			if ( $this->trellis->user['id'] )
			{
				$this->trellis->log( 'security', "Blocked Access Ticket Center" );

				$this->trellis->skin->error('banned_ticket');
			}
		}

		# Guest Support Coming Soon
		if ( ! $this->trellis->user['id'] )
		{
			$this->trellis->log( 'security', "Blocked Guest Access Ticket Center" );

			$this->trellis->skin->error( 'must_be_user', 1 );
		}

		#=============================
		# Initialize
		#=============================

		$this->trellis->load_functions('tickets');
		$this->trellis->load_lang('tickets');

		switch( $this->trellis->input['act'] )
    	{
    		case 'list':
				$this->list_tickets();
			break;
			case 'view':
				$this->view_ticket();
			break;
			case 'add':
				$this->add_ticket();
			break;
			case 'edit':
				$this->edit_ticket();
			break;

			case 'doescalate':
				$this->do_escalate();
			break;
			case 'doclose':
				$this->do_close();
			break;
			case 'doreopen':
				$this->do_reopen();
			break;

			case 'doadd':
				$this->do_add();
			break;
			case 'doedit':
				$this->do_edit();
			break;
			case 'dodel':
				$this->do_delete();
			break;

			case 'editreply':
				$this->edit_reply();
			break;

			case 'doaddreply':
				$this->do_add_reply();
			break;
			case 'doeditreply':
				$this->do_edit_reply();
			break;
			case 'dodelreply':
				$this->do_delete_reply();
			break;

			default:
				$this->list_tickets();
			break;
		}
	}

	#=======================================
	# @ List Tickets
	#=======================================

	private function list_tickets($params=array())
	{
		#=============================
		# Get Tickets
		#=============================

		$tickets = $this->trellis->tickets->get( array(
													   'select'	=> array(
													   					 't' => array( 'id', 'mask', 'subject', 'priority', 'last_reply', 'escalated', 'status' ),
													   					 'd' => array( array( 'name' => 'dname' ) ),
													   					 'p' => array( array( 'name' => 'pname' ), 'icon_regular', 'icon_assigned' ),
												    					 's' => array( array( 'name_user' => 'status_name' ), array( 'abbr_user' => 'status_abbr' ) ),
												    					 ),
													   'from'	=> array( 't' => 'tickets' ),
													   'join'	=> array(
													    				 array( 'from' => array( 'd' => 'departments' ), 'where' => array( 't' => 'did', '=', 'd' => 'id' ) ),
													    				 array( 'from' => array( 'p' => 'priorities' ), 'where' => array( 't' => 'priority', '=', 'p' => 'id' ) ),
													    				 array( 'from' => array( 's' => 'statuses' ), 'where' => array( 't' => 'status', '=', 's' => 'id' ) ),
													    				 ),
													   'where'	=> array( array( 't' => 'uid' ), '=', $this->trellis->user['id'] ),
													   'order'	=> array( 'last_reply' => array( 't' => 'desc' ) ),
													   'limit'	=> array( 0, 8 ),
												)	   );

		#=============================
		# Prepare Output
		#=============================

		if ( $params['error'] )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['error'] ] );
		}
		elseif ( $params['alert'] )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['alert'] ] );
		}

		#=============================
		# Fix Up Information
		#=============================

		$row_count = 0;

		if ( $tickets )
		{
			foreach ( $tickets as $t )
			{
				$row_count ++;

				( $row_count & 1 ) ? $tickets[ $t['id'] ]['class'] = 1 : $tickets[ $t['id'] ]['class'] = 2;

				if ( $t['date'] ) $tickets[ $t['id'] ]['date_human'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'short' ) );
				if ( $t['last_reply'] ) $tickets[ $t['id'] ]['last_reply_human'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'short' ) );

				if ( ! $t['status_abbr'] ) $tickets[ $t['id'] ]['status_abbr'] = $t['status_name'];
			}

			$this->trellis->core->template->set_var( 'tickets', $tickets );
		}

		#=============================
		# Do Output
		#=============================

		$this->trellis->core->template->set_var( 'sub_tpl', 'tickets.tpl' );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=news'>{$this->trellis->lang['news']}</a>",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['news'] ) );
	}

	#=======================================
	# @ View Ticket
	#=======================================

	function view_ticket($params=array())
	{
		#=============================
		# Grab Ticket
		#=============================

	    # Do we really need this extra query?

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

	    # Do we really want to grab ALL ticket fields? Same with reply fields?

		$t = $this->trellis->tickets->get_single_by_id( array(
															  'select'	=> array(
												   								 't' => 'all',
												   								 'u' => array( array( 'name' => 'uname' ), array( 'email' => 'uemail' ), 'ugroup' ),
												   								 'lr' => array( array( 'name' => 'last_uname' ) ),
												   								 ),
															  'from'	=> array( 't' => 'tickets' ),
															  'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 't' => 'uid', '=', 'u' => 'id' ) ), array( 'from' => array( 'lr' => 'users' ), 'where' => array( 't' => 'last_uid', '=', 'lr' => 'id' ) ) ),
													   ), $ticket_id );

		if ( ! $t || $t['uid'] != $this->trellis->user['id'] ) $this->trellis->skin->error('no_ticket');

		#=============================
		# Grab Replies
		#=============================

		$replies = $this->trellis->tickets->get( array(
													   'select'	=> array(
													   					 'r' => 'all',
												   						 'u' => array( array( 'name' => 'uname' ), array( 'signature' => 'usignature' ), 'sig_html' ),
													   					 ),
													   'from'	=> array( 'r' => 'replies' ),
													   'join'	=> array( array( 'from' => array( 'u' => 'users' ), 'where' => array( 'r' => 'uid', '=', 'u' => 'id' ) ) ),
													   'where'	=> array( array( array( 'r' => 'tid' ), '=', $t['id'] ), array( array( 'r' => 'secret' ), '!=', 1, 'and' ) ),
													   'order'	=> array( 'date' => array( 'r' => 'asc' ) ),
												)	   );

		#=============================
		# Custom Department Fields
		#=============================

		$custom_fields = array();
		$custom_fields_html = '';

		$this->trellis->load_functions('cdfields');

		if ( $cdfields = $this->trellis->cdfields->grab( $t['did'] ) )
		{
			$row_count = 0;

			$fdata = $this->trellis->cdfields->get_data( $t['id'] );

			foreach( $cdfields as $fid => $f )
			{
				( ++$row_count & 1 ) ? $cdfields[ $f['id'] ]['class'] = 1 : $cdfields[ $f['id'] ]['class'] = 2;

				if ( $f['type'] == 'checkbox' )
				{
					$cdfields[ $f['id'] ]['extra'] = unserialize( $f['extra'] );
				}
				elseif ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
				{
					$cdfields[ $f['id'] ]['extra'] = unserialize( $f['extra'] );
				}
			}

			$this->trellis->core->template->set_var( 'cdfields', $cdfields );
			$this->trellis->core->template->set_var( 'cdfdata', $fdata );
		}

		#=============================
		# Format Ticket
		#=============================

		$t['status_name'] = $this->trellis->core->cache['statuses'][ $t['status'] ]['name_user'];
		$t['dname'] = $this->trellis->core->cache['departs'][ $t['did'] ]['name'];

		$t['date_human'] = $this->trellis->td_timestamp( array( 'time' => $t['date'], 'format' => 'long' ) );
		$t['last_reply_human'] = $this->trellis->td_timestamp( array( 'time' => $t['last_reply'], 'format' => 'long' ) );

		$toutput_params = array( 'urls' => 1 );

		( $t['html'] ) ? $toutput_params['html'] = 1 : $toutput_params['nl2br'] = 1;

		$t['message'] = $this->trellis->prepare_output( $t['message'], $toutput_params );

		# Code below links into skin template!

		$t['links'] = ""; // Initialize for Security

		if ( ! $t['escalated'] && ! $t['closed'] && $t['last_reply_staff'] && ( $t['last_reply_staff'] < ( time() - ( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_wait'] * 60 * 60 ) ) ) && $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_enable'] && $this->trellis->user['g_ticket_escalate'] )
		{
			$t['links'] .= "<a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=doescalate&amp;id=". $t['mask'] ."' onclick='return sure_escalate()'>". $this->trellis->lang['escalate'] ."</a> | ";
		}

		if ( ! $t['closed'] && $this->trellis->user['g_ticket_close'] && $this->trellis->core->cache['departs'][ $t['did'] ]['close_own'] )
		{
			$t['links'] .= "<a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=doclose&amp;id=". $t['mask'] ."' onclick='return sure_close()'>". $this->trellis->lang['close'] ."</a>";
		}
		elseif ( $t['closed'] && $this->trellis->user['g_ticket_reopen'] && $this->trellis->core->cache['departs'][ $t['did'] ]['reopen_own'] )
		{
			$t['links'] .= "<a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=doreopen&amp;id=". $t['mask'] ."' onclick='return sure_reopen()'>". $this->trellis->lang['reopen'] ."</a>";
		}
		else
		{
		    $t['links'] = substr( $t['links'], 0, -3 );
		}

		#=============================
		# Grab Ratings?
		#=============================

		/*if ( $this->trellis->user['id'] && $this->trellis->core->cache['settings']['tickets']['rating'] && $this->trellis->user['g_reply_rate'] )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> 'all',
												  	 'from'		=> 'reply_rate',
								 				  	 'where'	=> array( 'tid', '=', $t['id'] ),
								 		  	  ) 	);

			$this->trellis->core->db->execute();

			if ( $this->trellis->core->db->get_num_rows() )
			{
				while ( $rt = $this->trellis->core->db->fetch_row() )
				{
					$ratings[ $rt['rid'] ] = $rt['rating'];
				}
			}
		}*/

		#=============================
		# Format Replies
		#=============================

		if ( $replies )
		{
			$row_count = 0;

			foreach ( $replies as $r )
			{
				#=============================
				# Fix Up Information
				#=============================

				$replies[ $r['id'] ]['time_ago'] = $this->trellis->td_timestamp( array( 'time' => $r['date'], 'format' => 'relative' ) );

				$replies[ $r['id'] ]['date_human'] = $this->trellis->td_timestamp( array( 'time' => $r['date'], 'format' => 'short' ) );

        		$routput_params = array( 'urls' => 1 );

        		( $r['html'] ) ? $routput_params['html'] = 1 : $routput_params['nl2br'] = 1;

        		$replies[ $r['id'] ]['message'] = $this->trellis->prepare_output( $r['message'], $routput_params );

			    if ( $r['signature'] )
				{
					$replies[ $r['id'] ]['message'] .= '<br /><br />'. $this->trellis->prepare_output( $r['usignature'], array( 'html' => $r['sig_html'] ) );
				}

				/*if ( $this->trellis->user['id'] && $this->trellis->core->cache['settings']['tickets']['rating'] && $this->trellis->user['g_reply_rate'] && $r['staff'] && ! $this->trellis->user['ban_ticket_rate'] )
				{
					if ( $ratings[ $r['id'] ] )
					{
						$r['rate_imgs'] = $this->rate_thumbs_already( $ratings[ $r['id'] ] );
						$r['rate_imgs_solo'] = $this->rate_thumbs_already( $ratings[ $r['id'] ] );
					}
					else
					{
						$r['rate_imgs'] = $this->rate_thumbs( $t['id'], $r['id'] );
						$r['rate_imgs_solo'] = $this->rate_thumbs( $t['id'], $r['id'] );
					}
				}

				$reply_edit_icon = 0;
				$reply_delete_icon = 0;

				if ( $this->trellis->user['g_reply_edit'] && $r['uid'] == $this->trellis->user['id'] && ! $r['staff'] )
				{
					$r['rate_imgs'] = "&nbsp;&nbsp;<span class='response_imgs'><a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=editreply&amp;id={$r['id']}'><img src='images/". $this->trellis->skin->data['img_dir'] ."/edit_icon.gif' /></a>";

					$reply_edit_icon = 1;
				}

				if ( $this->trellis->user['g_reply_delete'] && $r['uid'] == $this->trellis->user['id'] && ! $r['staff'] )
				{
					if ( $reply_edit_icon )
					{
						$r['rate_imgs'] .= '&nbsp;&nbsp;&nbsp;';
					}
					else
					{
						$r['rate_imgs'] = "&nbsp;&nbsp;<span class='response_imgs'>";
					}

					$r['rate_imgs'] .= "<a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=dodelreply&amp;id={$r['id']}' onclick='return sure_delete_reply()'><img src='images/". $this->trellis->skin->data['img_dir'] ."/delete_icon.gif' /></a>";

					$reply_delete_icon = 1;
				}

				if ( $reply_edit_icon || $reply_delete_icon ) $r['rate_imgs'] .= '</span>';*/
			}

			$this->trellis->core->template->set_var( 'replies', $replies );
		}

		#=============================
		# Do Output
		#=============================

		if ( $params['error'] )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['error'] ] );
		}
		if ( $params['reply_error'] )
		{
			$this->trellis->core->template->set_var( 'reply_error', $this->trellis->lang[ 'err_'. $params['reply_error'] ] );
		}

		$this->trellis->core->template->set_var( 't', $t );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets'>{$this->trellis->lang['tickets']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=view&amp;id={$t['mask']}'>{$t['subject']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_view.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['tickets'] .' :: '. $t['subject'] ) );
	}

	#=======================================
	# @ Add Ticket
	#=======================================

	private function add_ticket()
	{
	    # better error messages / perms check

		if ( ! $this->trellis->core->cache['settings']['ticket']['new_tickets'] )
		{
			$this->trellis->skin->error('new_tickets_disabled');
		}

		if ( ! $this->trellis->user['g_ticket_create'] )
		{
			$this->trellis->skin->error('no_perm');
		}

		switch( $this->trellis->input['step'] )
    	{
    		case 1:
				$this->add_ticket_step_1();
    		break;
    		case 2:
				$this->add_ticket_step_2();
    		break;

    		default:
    			$this->add_ticket_step_1();
    		break;
		}
	}

	#=======================================
	# @ Add Ticket Step 1
	#=======================================

	function add_ticket_step_1($params=array())
	{
		#=============================
		# Do Output
		#=============================

        if ( $params['error'] )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['error'] ] );
		}

		$this->trellis->core->template->set_var( 'perms', unserialize( $this->trellis->user['g_depart_perm'] ) );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_submit_1.tpl' );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets'>{$this->trellis->lang['tickets']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=add'>{$this->trellis->lang['open_ticket']}</a>",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['tickets'] .' :: '. $this->trellis->lang['open_ticket'] ) );
	}

	#=======================================
	# @ Add Ticket Step 2
	#=======================================

	function add_ticket_step_2($params=array())
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['did'] ) $this->add_ticket_step_1( array( 'error' => 'no_depart' ) );

		$perms = unserialize( $this->trellis->user['g_depart_perm'] );

		if ( ! $perms[ $this->trellis->input['did'] ] ) $this->add_ticket_step_1( array( 'error' => 'no_depart' ) ); // use more detailed msg

		#=============================
		# Custom Profile Fields
		#=============================

		$this->trellis->load_functions('cdfields');

		if ( $cdfields = $this->trellis->cdfields->grab( $this->trellis->input['did'] ) )
		{
			$row_count = 0;

			foreach( $cdfields as $f )
			{
				( ++$row_count & 1 ) ? $cdfields[ $f['id'] ]['class'] = 1 : $cdfields[ $f['id'] ]['class'] = 2;

				if ( $f['type'] == 'checkbox' )
				{
					$cdfields[ $f['id'] ]['extra'] = unserialize( $f['extra'] );
				}
				elseif ( $f['type'] == 'dropdown' || $f['type'] == 'radio' )
				{
					$cdfields[ $f['id'] ]['extra'] = unserialize( $f['extra'] );
				}
			}

			$this->trellis->core->template->set_var( 'cdfields', $cdfields );
		}

		#=============================
		# Do Output
		#=============================

		if ( $params['error'] )
		{
			if ( $params['field'] )
			{
			    $this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['error'] ] .' '. $params['field'] );
			}
			else
			{
			    $this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $params['error'] ] );
			}
		}

		$priority_options = array();

		foreach ( $this->trellis->core->cache['priorities'] as $p )
		{
		    $priority_options[ $p['id'] ] = $p['name'];
		}

		$this->trellis->core->template->set_var( 'priority_options', $priority_options );

		( ++$row_count & 1 ) ? $class_msg = 1 : $class_msg = 2;
		$this->trellis->core->template->set_var( 'class_msg', $class_msg );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_submit_2.tpl' );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets'>{$this->trellis->lang['tickets']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=add'>{$this->trellis->lang['open_ticket']}</a>",
						   );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['tickets'] .' :: '. $this->trellis->lang['open_ticket'] ) );
	}

	#=======================================
	# @ Do Add
	#=======================================

	function do_add()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['did'] ) $this->add_ticket_step_1( array( 'error' => 'no_depart' ) );
		if ( ! $this->trellis->input['subject'] ) $this->add_ticket_step_2( array( 'error' => 'no_subject' ) );
		if ( ! $this->trellis->input['priority'] ) $this->add_ticket_step_2( array( 'error' => 'no_priority' ) );
		if ( ! $this->trellis->input['message'] ) $this->add_ticket_step_2( array( 'error' => 'no_message' ) );

		if ( ! $this->trellis->core->cache['departs'][ $this->trellis->input['did'] ] ) $this->trellis->skin->error('no_depart');

		$perms = unserialize( $this->trellis->user['g_depart_perm'] );

		if ( ! $perms[ $this->trellis->input['did'] ] ) $this->add_ticket_step_1( array( 'error' => 'no_depart' ) );

		#=============================
		# Add Ticket
		#=============================

		$db_array = array(
						  'did'			=> $this->trellis->input['did'],
						  'uid'			=> $this->trellis->user['id'],
						  'email'		=> $this->trellis->user['email'],
						  'subject'		=> $this->trellis->input['subject'],
						  'priority'	=> $this->trellis->input['priority'],
						  'message'		=> $this->trellis->input['message'],
						  'date'		=> time(),
						  'last_reply'	=> time(),
						  'last_uid'	=> $this->trellis->user['id'],
						  'ipadd'		=> $this->trellis->input['ip_address'],
						  'status'		=> $this->trellis->core->cache['status_defaults'][1],
						 );

		$this->trellis->load_functions('cdfields');

		if( ! $fdata = $this->trellis->cdfields->process_input( $this->trellis->input['did'] ) )
		{
			if ( $this->trellis->cdfields->required_field ) $this->add_ticket_step_2( array( 'error' => 'no_field', 'field' => $this->trellis->cdfields->required_field ) );
		}

		$ticket = $this->trellis->tickets->add( $db_array, array( 'return' => 'mask' ) );

		if ( $fdata ) $this->trellis->cdfields->set_data( $fdata, $ticket['id'], 1 );

		$this->trellis->log( 'user', "Ticket Created &#039;". $this->trellis->input['subject'] ."&#039;", 1, $ticket['id'] );
		$this->trellis->log( 'ticket', "Ticket Created &#039;". $this->trellis->input['subject'] ."&#039;", 1, $ticket['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $ticket['mask'], 'submit_ticket_success' );
	}

	#=======================================
	# @ Do Add Reply
	#=======================================

	function do_add_reply()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['message'] ) $this->view_ticket( array( 'reply_error' => 'no_message' ) );

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'uid', 'did', 'subject', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( $t['uid'] != $this->trellis->user['id'] ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Add Reply
		#=============================

		$db_array = array(
						  'tid'			=> $t['id'],
						  'uid'			=> $this->trellis->user['id'],
						  'message'		=> $this->trellis->input['message'],
						  'date'		=> time(),
						  'ipadd'		=> $this->trellis->input['ip_address'],
						 );

		$reply_id = $this->trellis->tickets->add_reply( $db_array, $t['id'] );

		$this->trellis->log( 'user', "Ticket Reply Added &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Reply Added &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $t['mask'] .'#reply'. $reply_id, 'submit_reply_success' );
	}

	#=======================================
	# @ Do Escalate
	#=======================================

	function do_escalate()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->core->cache['settings']['ticket']['escalate'] || ! $this->trellis->user['g_ticket_escalate'] ) $this->trellis->skin->error('no_perm');

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'did', 'uid', 'subject', 'last_reply_staff', 'escalated', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		if ( $t['uid'] != $this->trellis->user['id'] || $t['escalated'] || ! $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_enable'] || ( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_wait'] && ( $t['last_reply_staff'] >= ( time() - ( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_wait'] * 60 * 60 ) ) ) ) ) $this->trellis->skin->error('no_perm');

		#=============================
		# Escalate Ticket
		#=============================

		$this->trellis->tickets->escalate( $t['id'], array( 'did' => $t['did'], 'staff' => 0 ) );

		$this->trellis->log( 'user', "Ticket Escalated &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Escalated &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Move Ticket
		#=============================

		if ( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_depart'] ) $this->trellis->tickets->move( $this->trellis->core->cache['departs'][ $t['did'] ]['escalate_depart'], $t['id'], $t['did'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $t['mask'], 'ticket_escalate_success' );
	}

	#=======================================
	# @ Do Close
	#=======================================

	function do_close()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['g_ticket_close'] ) $this->trellis->skin->error('no_perm');

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'did', 'uid', 'subject', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( $t['uid'] != $this->trellis->user['id'] || ! $this->trellis->core->cache['departs'][ $t['did'] ]['close_own'] ) $this->trellis->skin->error('no_perm');

		if ( $t['closed'] ) $this->trellis->skin->error('ticket_closed');

		#=============================
		# Close Ticket
		#=============================

		$this->trellis->tickets->close( $t['id'], $t['uid'] );

		$this->trellis->log( 'user', "Ticket Closed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Closed &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $t['mask'], 'ticket_close_success' );
	}

	#=======================================
	# @ Do Reopen
	#=======================================

	function do_reopen()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['g_ticket_reopen'] ) $this->trellis->skin->error('no_perm');

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'did', 'uid', 'subject', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( $t['uid'] != $this->trellis->user['id'] || ! $this->trellis->core->cache['departs'][ $t['did'] ]['reopen_own'] ) $this->trellis->skin->error('no_perm');

		if ( ! $t['closed'] ) $this->trellis->skin->error('ticket_open'); // Write error message

		#=============================
		# Close Ticket
		#=============================

		$this->trellis->tickets->reopen( $t['id'], array( 'uid' => $t['uid'], 'staff' => 0 ) );

		$this->trellis->log( 'admin', "Ticket Reopened &#039;". $t['subject'] ."&#039;", 1, $t['id'] );
		$this->trellis->log( 'ticket', "Ticket Reopened &#039;". $t['subject'] ."&#039;", 1, $t['id'] );

		#=============================
		# Do Output
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $t['mask'], 'ticket_reopen_success' );
	}

	#=======================================
	# @ Edit Reply
	# Display edit ticket reply form.
	#=======================================

	function edit_reply($error="")
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['g_reply_edit'] )
		{
			$this->trellis->log( 'security', "Blocked Ticket Reply Edit Attempt" );

			$this->trellis->skin->error('no_perm_reply_edit');
		}

		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => 'all',
												   							 't' => array( 'closed' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( $t['closed'] ) $this->trellis->skin->error('no_perm_reply_edit');

		if ( ! $r )
		{
			$this->trellis->log( 'error', "Reply Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_reply');
		}

		if ( $r['uid'] != $this->trellis->user['id'] ) $this->trellis->skin->error('no_perm_reply_edit');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->trellis->core->template->set_var( 'r', $r );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets'>{$this->trellis->lang['tickets']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=editreply&amp;id={$r['id']}'>{$this->trellis->lang['edit_reply']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_reply_edit.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['tickets'] .' :: '. $this->trellis->lang['edit_reply'] ) );
	}

	#=======================================
	# @ Edit Ticket
	# Show edit ticket screen.
	#=======================================

	function edit_ticket($error='')
	{
		#=============================
		# Security Checks
		#=============================

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'uid', 'subject', 'message', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->trellis->user['g_ticket_edit'] || $t['uid'] != $this->trellis->user['id'] || $t['closed'] ) $this->trellis->skin->error('no_perm_ticket_edit');

		#=============================
		# Do Output
		#=============================

		if ( $error )
		{
			$this->trellis->core->template->set_var( 'error', $this->trellis->lang[ 'err_'. $error ] );
		}

		$this->trellis->core->template->set_var( 't', $t );

		$this->nav = array(
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets'>{$this->trellis->lang['tickets']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=view&amp;id={$t['mask']}'>{$t['subject']}</a>",
						   "<a href='{$this->trellis->config['hd_url']}/index.php?page=tickets&amp;act=edit&amp;id={$t['mask']}'>{$this->trellis->lang['edit']}</a>",
						   );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_edit.tpl' );

		$this->trellis->skin->do_output( array( 'nav' => $this->nav, 'title' => $this->trellis->lang['tickets'] .' :: '. $t['subject'] .' :: '. $this->trellis->lang['edit'] ) );
	}

	#=======================================
	# @ Do Edit Ticket
	# Edit the damn ticket.
	#=======================================

	function do_edit()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['message'] ) $this->edit_ticket('no_message');

	    $ticket_id = $this->trellis->tickets->get_id_from_mask( $this->trellis->input['id'] );

		if ( ! $t = $this->trellis->tickets->get_single_by_id( array( 'select' => array( 'id', 'mask', 'uid', 'subject', 'message', 'closed' ), 'from' => 'tickets' ), $ticket_id ) ) $this->trellis->skin->error('no_ticket');

		if ( ! $this->trellis->user['g_ticket_edit'] || $t['uid'] != $this->trellis->user['id'] || $t['closed'] ) $this->trellis->skin->error('no_perm_ticket_edit');

		#=============================
		# Edit Ticket
		#=============================

		$this->trellis->tickets->edit( array( 'message' => $this->trellis->input['message'] ), $t['id'] );

		$this->trellis->log( 'user', "Edited Ticket ID #". $t['id'], 1, $t['id'] );
		$this->trellis->log( 'ticket', "Edited Ticket ID #". $t['id'], 1, $t['tid'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $t['mask'], 'ticket_edit_success' );
	}

	#=======================================
	# @ Do Edit Reply
	# Edit ticket reply.
	#=======================================

	function do_edit_reply()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->input['message'] )
		{
			$this->edit_reply('no_reply');
		}

		if ( ! $this->trellis->user['g_reply_edit'] )
		{
			$this->trellis->log( 'security', "Blocked Ticket Reply Edit Attempt" );

			$this->trellis->skin->error('no_perm_reply_edit');
		}

		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => 'all',
												   							 't' => array( 'mask', 'closed' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( $r['closed'] ) $this->trellis->skin->error('no_perm_reply_edit');

		if ( ! $r )
		{
			$this->trellis->log( 'error', "Reply Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_reply');
		}

		#=============================
		# Edit Reply
		#=============================

		$this->trellis->tickets->edit_reply( array( 'message' => $this->trellis->input['message'] ), $r['id'] );

		$this->trellis->log( 'user', "Edited Ticket Reply ID #". $r['id'], 1, $r['id'] );
		$this->trellis->log( 'ticket', "Edited Ticket Reply ID #". $r['id'], 1, $r['tid'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $r['mask'] .'#reply'. $r['id'], 'reply_edit_success' );
	}

	#=======================================
	# @ Do Delete Reply
	# Delete ticket reply.
	#=======================================

	function do_delete_reply()
	{
		#=============================
		# Security Checks
		#=============================

		$r = $this->trellis->tickets->get_single( array(
														'select'	=> array(
												   							 'r' => array( 'id', 'tid', 'uid', 'date' ),
												   							 't' => array( 'mask', 'subject', 'last_reply', 'closed' ),
												   							 ),
														'from'		=> array( 'r' => 'replies' ),
														'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'r' => 'tid', '=', 't' => 'id' ) ) ),
														'where'		=> array( array( 'r' => 'id' ), '=', $this->trellis->input['id'] ),
												 )		);

		if ( ! $r ) $this->trellis->skin->error('no_reply');

		if ( $r['uid'] != $this->trellis->user['id'] || ! $this->trellis->user['g_reply_delete'] || $r['closed'] ) $this->trellis->skin->error('no_perm_reply_delete');

		#=============================
		# DELETE Reply
		#=============================

		$this->trellis->tickets->delete_reply( $r['id'], array( 'tid' => $r['tid'], 'date' => $r['date'], 'last_reply' => $r['last_reply'], 'staff' => 0 ) );

		$this->trellis->log( 'admin', "Ticket Reply Deleted &#039;". $r['subject'] ."&#039;", 2, $r['tid'] );
		$this->trellis->log( 'ticket', "Ticket Reply Deleted &#039;". $r['subject'] ."&#039;", 2, $r['tid'] );

		#=============================
		# Redirect
		#=============================

		$this->trellis->skin->redirect( '?page=tickets&act=view&id='. $r['mask'], 'reply_delete_success' );
	}

	#=======================================
	# @ Do Rate
	# Adding rating to reply.
	#=======================================

	/*function do_rate()
	{
		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );
		$this->trellis->input['rid'] = intval( $this->trellis->input['rid'] );

		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['id'] )
		{
			$this->trellis->skin->error( 'must_be_user', 1 );
		}

		if ( ! $this->trellis->core->cache['settings']['tickets']['rating'] )
		{
			$this->trellis->skin->error('reply_rating_disabled');
		}

		if ( ! $this->trellis->user['g_reply_rate'] || $this->trellis->user['ban_ticket_rate'] )
		{
			$this->trellis->log( 'security', "Blocked Reply Rating" );

			$this->trellis->skin->error('banned_ticket_rate');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'tickets',
							 				  	 'where'	=> array( array( 'id', '=', $this->trellis->input['id'] ), array( 'uid', '=', $this->trellis->user['id'], 'and' ) ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Ticket Not Found ID: ". $this->trellis->input['id'] );

			$this->trellis->skin->error('no_ticket');
		}

		$t = $this->trellis->core->db->fetch_row();

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'replies',
							 				  	 'where'	=> array( array( 'id', '=', $this->trellis->input['rid'] ), array( 'tid', '=', $this->trellis->input['id'], 'and' ) ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "Reply Not Found ID: ". $this->trellis->input['rid'] );

			$this->trellis->skin->error('no_reply');
		}

		$r = $this->trellis->core->db->fetch_row();

		if ( ! $r['staff'] )
		{
			$this->trellis->log( 'security', "Reply Rating Blocked Not Staff &#039;". $t['subject'] ."&#039;", 1, $r['id'] );

			$this->trellis->skin->error('no_staff_rate_reply');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> array( 'id', 'votes', 'rating', 'rating_total' ),
											  	 'from'		=> 'users',
							 				  	 'where'	=> array( 'id', '=', $r['uid'] ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'error', "User Not Found ID: ". $r['uid'] );

			$this->trellis->skin->error('no_user');
		}

		$s = $this->trellis->core->db->fetch_row();

		if ( ! $this->trellis->user['id'] )
		{
			$this->trellis->log( 'security', "Reply Rating Blocked From Guest &#039;". $t['subject'] ."&#039;", 1, $r['id'] );

			$this->trellis->skin->error( 'must_be_user', 1 );
		}

		$allowed_ratings = array( 1, 5 );

		if ( ! in_array( $this->trellis->input['amount'], $allowed_ratings ) )
		{
			$this->trellis->log( 'security', "Invalid Reply Rating Amount &#039;". $t['subject'] ."&#039;", 1, $r['id'] );

			$this->trellis->skin->error('invalid_rate_value_reply');
		}

		$this->trellis->core->db->construct( array(
											  	 'select'	=> 'all',
											  	 'from'		=> 'reply_rate',
							 				  	 'where'	=> array( array( 'tid', '=', $this->trellis->input['id'] ), array( 'rid', '=', $this->trellis->input['rid'], 'and' ), array( 'uid', '=', $this->trellis->user['id'], 'and' ) ),
							 				  	 'limit'	=> array( 0, 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		if ( $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->log( 'security', "Already Rated Reply By User &#039;". $t['subject'] ."&#039;", 1, $r['id'] );

			$this->trellis->skin->error('already_rated_reply');
		}

		#=============================
		# Add Rating
		#=============================

		$db_array = array(
						  'tid'			=> $this->trellis->input['id'],
						  'rid'			=> $this->trellis->input['rid'],
						  'uid'			=> $this->trellis->user['id'],
						  'rating'		=> $this->trellis->input['amount'],
						  'date'		=> time(),
						  'ipadd'		=> $this->trellis->input['ip_address'],
						 );

		$this->trellis->core->db->construct( array(
											  	 'insert'	=> 'reply_rate',
											  	 'set'		=> $db_array,
							 		  	  ) 	);

		$this->trellis->core->db->execute();

		$this->trellis->log( 'user', "Reply Rating Value ". $this->trellis->input['amount'] ." Added &#039;". $t['subject'] ."&#039;", 1, $r['id'] );

		#=============================
		# Update Ticket Rating
		#=============================

		$new_ticket_rating = round( ( $t['rating_total'] + $this->trellis->input['amount'] ) / ( $t['votes'] + 1 ), 2 );

		$this->trellis->core->db->next_no_quotes('set');

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'tickets',
											  	 'set'		=> array( 'votes' => 'votes+1', 'rating' => $new_ticket_rating, 'rating_total' => 'rating_total+'. $this->trellis->input['amount'] ),
							 				  	 'where'	=> array( 'id', '=', $t['id'] ),
							 				  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

		#=============================
		# Update Staff User
		#=============================

		$new_rating = round( ( $s['rating_total'] + $this->trellis->input['amount'] ) / ( $s['votes'] + 1 ), 2 );

		$this->trellis->core->db->next_no_quotes('set');

		$this->trellis->core->db->construct( array(
											  	 'update'	=> 'users',
											  	 'set'		=> array( 'votes' => 'votes+1', 'rating' => $new_rating, 'rating_total' => 'rating_total+'. $this->trellis->input['amount'] ),
							 				  	 'where'	=> array( 'id', '=', $s['id'] ),
							 				  	 'limit'	=> array( 1 ),
							 		  	  ) 	);

		$this->trellis->core->db->next_shutdown();
		$this->trellis->core->db->execute();

	    #=============================
		# Do Output
		#=============================

		$this->view_ticket();
	}

	#=======================================
	# @ Show Guest Login
	# Show the guest ticket login form.
	#=======================================

	function show_guest_login()
	{
		#=============================
		# Do Output
		#=============================

		$this->trellis->core->template->set_var( 'token_gt_login', $this->trellis->create_token('glogin') );

		$this->trellis->core->template->set_var( 'sub_tpl', 'tck_guest_login.tpl' );

		$this->trellis->skin->do_output();
	}

	#=======================================
	# @ rate_thumbs_already()
	#=======================================

	function rate_thumbs_already($choice)
	{
		if ( $choice == 1 )
		{
			$a5_html = "&nbsp;&nbsp;<span class='response_imgs'><img src='images/". $this->trellis->skin->data['img_dir'] ."/thumbs_down_hover.gif' alt='". $this->trellis->lang['thumbs_down'] ."' style='vertical-align:middle' /></span>";
		}
		elseif ( $choice == 5 )
		{
			$a5_html = "&nbsp;&nbsp;<span class='response_imgs'><img src='images/". $this->trellis->skin->data['img_dir'] ."/thumbs_up_hover.gif' alt='". $this->trellis->lang['thumbs_up'] ."' style='vertical-align:middle' /></span>";
		}

		return $a5_html;
	}

	#=======================================
	# @ rate_thumbs()
	#=======================================

	function rate_thumbs($tid, $rid)
	{
		$a5_html = "&nbsp;&nbsp;<span class='response_imgs'><a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=rate&amp;amount=5&amp;id={$tid}&amp;rid={$rid}'><img src='images/". $this->trellis->skin->data['img_dir'] ."/thumbs_up.gif' alt='". $this->trellis->lang['thumbs_up'] ."' id='thumbsup_{$rid}' style='vertical-align:middle' onmouseover='amithumbsup({$rid})' onmouseout='unamithumbsup({$rid})' /></a>&nbsp;&nbsp;<a href='". $this->trellis->config['hd_url'] ."/index.php?page=tickets&amp;act=rate&amp;amount=1&amp;id={$tid}&amp;rid={$rid}'><img src='images/". $this->trellis->skin->data['img_dir'] ."/thumbs_down.gif' alt='". $this->trellis->lang['thumbs_down'] ."' id='thumbsdown_{$rid}' style='vertical-align:middle' onmouseover='amithumbsdown({$rid})' onmouseout='unamithumbsdown({$rid})' /></a></span>";

		return $a5_html;
	}

	#=======================================
	# @ Download Attachment
	# Send the attachment to the browser.
	#=======================================

	function download_attachment()
	{
		#=============================
		# Security Checks
		#=============================

		if ( ! $this->trellis->user['id'] && ! $this->trellis->user['s_tkey'] )
		{
			$this->show_guest_login();
		}

		$this->trellis->input['id'] = intval( $this->trellis->input['id'] );

		if ( $this->trellis->user['id'] )
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'a' => 'all',
												  	 					  't' => array( 'subject' ),
												  	 					 ),
												  	 'from'		=> array( 'a' => 'attachments' ),
												  	 'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'a' => 'tid', '=', 't' => 'id' ) ) ),
								 				  	 'where'	=> array( array( array( 'a' => 'id' ), '=', $this->trellis->input['id'] ), array( array( 't' => 'uid' ), '=', $this->trellis->user['id'], 'and' ) ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);
		}
		else
		{
			$this->trellis->core->db->construct( array(
												  	 'select'	=> array( 'a' => 'all',
												  	 					  't' => array( 'subject' ),
												  	 					 ),
												  	 'from'		=> array( 'a' => 'attachments' ),
												  	 'join'		=> array( array( 'from' => array( 't' => 'tickets' ), 'where' => array( 'a' => 'tid', '=', 't' => 'id' ) ) ),
								 				  	 'where'	=> array( array( array( 'a' => 'id' ), '=', $this->trellis->input['id'] ), array( array( 't' => 'email' ), '=', $this->trellis->user['s_email'], 'and' ), array( array( 't' => 'guest' ), '=', 1, 'and' ) ),
								 				  	 'limit'	=> array( 0, 1 ),
								 		  	  ) 	);
		}

		$this->trellis->core->db->execute();

		if ( ! $this->trellis->core->db->get_num_rows() )
		{
			$this->trellis->skin->error('no_attachment');
		}

		$a = $this->trellis->core->db->fetch_row();

		$file_path = $this->trellis->core->cache['settings']['general']['upload_dir'] .'/'. $a['real_name'];

		if ( ! file_exists( $file_path ) )
		{
			$this->trellis->skin->error('no_attachment');

			$this->trellis->log( 'error', "Attachment File Not Found ID #". $a['id'], 2, $a['id'] );
		}

		#=============================
		# Send Download
		#=============================

		if ( $a['mime'] )
		{
			header("Content-type: {$a['mime']}");
		}
		else
		{
			header("Content-type: application/force-download");
		}

		$show_types = array( 'image/gif', 'image/jpeg', 'image/jpg', 'image/png', 'text/plain', 'text/html' );

		if ( ! in_array( $a['mime'], $show_types ) )
		{
			header("Content-Disposition: attachment; filename={$a['original_name']}");
		}

		#header("Content-length: ".filesize( $file_path ));

		readfile( $file_path );
	}*/

}

?>